//---------------------------------------------------------------------------
//
// clock - a Kylix BCB demo
//
// This demo shows you how to do a masked form and how to use command line
// params.
//
// Ported by Chee Wee
//

#include <clx.h>
#include <math.h>
#pragma hdrstop

#include "CircularForms.h"
#include "ShapedForms.h"
#include "ClockDisplay.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TCircularForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  // Do we have at least two params?
  if (ParamCount() > 2)
  {
    Top = StrToIntDef(ParamStr(1), Top);
    Left = StrToIntDef(ParamStr(2), Left);
  }
  else
  {  // Is the user asking for help?
    if ((ParamCount() == 1) && (ParamStr(1) == 'h'))
    {
      // Can't assume that in Windows it is compiled with {$APPTYPE CONSOLE}
      #ifdef LINUX
      WriteLn('clock - A demo application for Kylix.');
      WriteLn('');
      WriteLn('Usage: clock [X Y]');
      WriteLn('where X and Y are screen cordinates.');
      Application->Terminate;
      #endif
    }
  }
}
//---------------------------------------------------------------------------

void DrawHand(TCanvas* Canvas, TPoint* Center, signed Radius, signed BackRadius,
              signed AWidth, const TColor AColor, float Angle)
{
  signed X, Y;

  Canvas->Pen->Width = AWidth;
  Canvas->Pen->Color = AColor;
  Angle = (Angle + 3 * M_PI / 2);
  X = Center->x - (BackRadius * cos(Angle));
  Y = Center->y - (BackRadius * sin(Angle));
  Canvas->MoveTo(Center->x, Center->y);
  Canvas->LineTo(X, Y);
  X = Center->x + (Radius * cos(Angle));
  Y = Center->y + (Radius * sin(Angle));
  Canvas->MoveTo(Center->x, Center->y);
  Canvas->LineTo(X, Y);
}

void __fastcall TForm1::FormPaint(TObject *Sender)
{
 TRect R;
 float Angle;
 TPoint Center;

  R = BoundsRect;
  AdjustForClient(R);
  // Draw the clock face
  Canvas->CopyRect(R, Image1->Canvas, R);

  // Calculate the center of the clock
  Center = Point(Width / 2, Height / 2);

  // Calculate the angles of the hands
  Angle = 2 * M_PI * (FHours + FMins / 60) / 12;
  DrawHand(Canvas, &Center, Center.x * 70 / 100, 0, 2, clBlack, Angle);
  Angle = 2 * M_PI * FMins / 60;
  DrawHand(Canvas, &Center, Center.x * 90 / 100, 0, 2, clBlack, Angle);
  Angle = 2 * M_PI * FSecs / 60;

  DrawHand(Canvas, &Center, Center.x, 10, 1, clRed, Angle);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
  DecodeTime(Now(), FHours, FMins, FSecs, FMsecs);
  Invalidate();
}
//---------------------------------------------------------------------------

