//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "ShapedForms.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TShapedForm::TShapedForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TShapedForm::DrawMask(Qgraphics::TCanvas* Canvas)
{
  TRect R;

  // Initially we don't mask anything. In CircularForms we actually do a mask
  R = ClientRect;
  Canvas->Brush->Color = clDontMask;
  Canvas->FillRect(R);
}
//---------------------------------------------------------------------------

void __fastcall TShapedForm::InitWidget(void)

// Note the use of namespaces and casting.  For the most part, anything dealing
// with CLX will want the Qt namespace type, whereas anything dealing with the
// Qt binding layer will want the global namespace type.  The types Qt::Q<Foo>H*
// and ::Q<Foo>H are functionally equivalent -- they both hold pointers
// used within the Qt libraries -- so it's safe to cast back and forth.

{
  ::QBitmapH QB;
  ::QPainterH QP;
  TCanvas* VCanvas;

  inherited::InitWidget();
  // Setup our DrawMask
  QB = QBitmap_create2(Width, Height, True, QPixmapOptimization_DefaultOptim);
  try
  {
    using ::QPaintDeviceH;
    using ::QWidgetH;
    QP = QPainter_create3(reinterpret_cast<QPaintDeviceH>(QB), reinterpret_cast<QWidgetH>(Handle));
    try
    {
      VCanvas = new TCanvas();
      try
      {
        VCanvas->Start(False);
        VCanvas->Handle = reinterpret_cast<Qt::QPainterH*>(QP);
        DrawMask(VCanvas);
        VCanvas->Stop();
      }
      __finally
      {
        VCanvas->Free();
      }
      QWidget_setMask(reinterpret_cast<QWidgetH>(Handle), QB);
    }
    __finally
    {
      QPainter_destroy(QP);
    }
  }
  __finally
  {
    QBitmap_destroy(QB);
  }
}
//---------------------------------------------------------------------------

int __fastcall TShapedForm::WidgetFlags(void)
{
  return inherited::WidgetFlags() && !(WidgetFlags_WRepaintNoErase);
}
//---------------------------------------------------------------------------
