//---------------------------------------------------------------------------
// Convertit - a Kylix BCB demo
//
// Ported by Chee Wee
//

#include <clx.h>
#pragma hdrstop

#include "ConvertItUnit.h"
#include "System.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#include <ConvUtils.hpp>
#include <StdConvs.hpp>

#pragma resource "*.xfm"

Tfrm_Main *frm_Main;
//---------------------------------------------------------------------------
__fastcall Tfrm_Main::Tfrm_Main(TComponent* Owner)
  : TForm(Owner)
{
  InitStdConvs();  // Recommended way to make sure StdConvs gets linked in.
}
//---------------------------------------------------------------------------
void __fastcall Tfrm_Main::FormShow(TObject *Sender)
{
  TConvFamilyArray LFamilies;

  ConvFamilies->Tabs->Clear();
  GetConvFamilies(LFamilies);
  for(int i=0;i<LFamilies.Length;i++)
    ConvFamilies->Tabs->Add(ConvFamilyToDescription(LFamilies[i]));
  ConvFamiliesChange(Sender);

}
//---------------------------------------------------------------------------

void __fastcall Tfrm_Main::ConvFamiliesChange(TObject *Sender)
{
  TConvFamily LFamily;
  TConvTypeArray LTypes;

  if (DescriptionToConvFamily(AnsiString(ConvFamilies->Tabs->Items[ConvFamilies->TabIndex]->Caption), LFamily))
  {
    ConvTypes->Items->BeginUpdate();
    ConvTypes->Items->Clear();
    GetConvTypes(LFamily, LTypes);
    for(int I=0;I<LTypes.Length;I++)
      ConvTypes->Items->AddObject(ConvTypeToDescription(LTypes[I]),
                                  reinterpret_cast <TObject *> (LTypes[I]) );
    ConvTypes->ItemIndex = 0;
    ConvTypes->Items->EndUpdate();
  }
  ConvTypesClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_Main::ConvTypesClick(TObject *Sender)
{
  ConvValueChange(Sender);
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_Main::ConvValueChange(TObject *Sender)
{
  double LValue;
  TConvType LBaseType, LTestType;

  try
  {
    ConvResults->Items->BeginUpdate();
    ConvResults->Items->Clear();
    try
    {
      LValue = StrToFloatDef(AnsiString(ConvValue->Text), 0);
      if (ConvTypes->ItemIndex != -1)
      {
        LBaseType = TConvType(ConvTypes->Items->Objects[ConvTypes->ItemIndex]);
        for(int I = 0;I<ConvTypes->Items->Count;I++)
        {
          LTestType = TConvType(ConvTypes->Items->Objects[I]);
          ConvResults->Items->Add(Format("%n %s",
          ARRAYOFCONST(  (Convert(LValue, LBaseType, LTestType),
                          ConvTypeToDescription(LTestType))) ));
        }
      }
      else
        ConvResults->Items->Add("No base type");
    }
    catch(...)
    {
      ConvResults->Items->Add("Cannot parse value");
    }
  }
  __finally
  {
    ConvResults->Items->EndUpdate();
  }
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_Main::ConvValueKeyPress(TObject *Sender, char &Key)
{
  const char backspace = 0x8;

  Set<char, 0, 255> CharSet;
  CharSet << DecimalSeparator << backspace;
  CharSet << '0' << '1' << '2' << '3' << '4' << '5' << '6' << '7' << '8' << '9';
  if (!(CharSet.Contains(Key)))
    Key = 0;
  else
    if ((Key == DecimalSeparator) && (ConvValue->Text.Pos(""+DecimalSeparator)))
      Key = 0;
}
//---------------------------------------------------------------------------



