//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::IdleLoop(TObject *Sender, bool &Done)
{
  int choice;
  int SideDef, TopDef, PaddleDifference;


  //keeps loop going
  Done = false;
  //slows down action
  Sleep(1);

  if (spriteImage)
  {
    changeRect = spriteRect;
    spriteRect.Left = x;
    spriteRect.Top = y;
    spriteRect.Right = x + spriteImage->Picture->Width;
    spriteRect.Bottom = y + spriteImage->Picture->Height;

    workCanvas->CopyRect(paddleRect, backgroundCanvas, paddleRect);

    changePaddleRect = paddleRect;
    paddleRect.Left = paddleCenter - int(paddle->Picture->Width / 2);
    paddleX = paddleRect.Left;
    paddleRect.Top = paddleY;
    paddleRect.Right = paddleX + paddle->Picture->Width;
    paddleRect.Bottom = paddleY + paddle->Picture->Height;

    SideDef = changeRect.Left - spriteRect.Left;
    // If SideDiff < 0 the paddle is to the right
    if(SideDef < 0)
    {
      changeRect.Right = spriteRect.Right;
    }
    else
    {
      changeRect.Left = spriteRect.Left;
    }

    TopDef = changeRect.Top - spriteRect.Top;
    // If SideDiff < 0 the paddle is to the Down
    if(TopDef < 0)
    {
      changeRect.Bottom = spriteRect.Bottom;
    }
    else
    {
      changeRect.Top = spriteRect.Top;
    }

    workCanvas->CopyRect(spriteRect, backgroundCanvas, spriteRect);

    //ChangeRectCalcs
    if (y <= 0)
    {
      yDir = 5;
    }
    if (y >= ClientHeight - 16)
    {
      FGameOver = true;
      Cursor = crArrow;
      Application->OnIdle = 0;
      choice = MessageDlg("You lost Earth", "Try Again?", mtConfirmation, TMsgDlgButtons() <<mbRetry<< mbCancel, 0);
      if(choice == mrRetry)
      {
        x = 0;
        y = 0;
        Cursor = crNone;
        Application->OnIdle = IdleLoop;
      }
      else
        Application->Terminate();
    }

    if ( (spriteRect.Bottom - 16) >= paddleRect.Top
     &&  (spriteRect.Bottom - 16) <= (paddleRect.Top + 5)
     &&  spriteRect.Right >= paddleRect.Left
     &&  spriteRect.Left <= paddleRect.Right )
    {
      yDir = -5;
    }

    if (x <= 0)
    {
      xDir = 5;
    }

    if(x >= ClientWidth - 16)
    {
      xDir = -5;
    }

    x += xDir;
    y += yDir;

    PaddleDifference = changePaddleRect.Left - paddleRect.Left;
    // If PaddleDiff < 0 the paddle is to the right
    if(PaddleDifference < 0)
    {
      changePaddleRect.Right = paddleRect.Right;
    }
    else
    {
      changePaddleRect.Left = paddleRect.Left;
    }

    //Perform dirty rectangle animation on memory and Form canvas
    workCanvas->Draw(x, y, spriteImage->Picture->Icon);
    workCanvas->Draw(paddleX, paddleY, paddle->Picture->Icon);
    Canvas->CopyRect(changeRect, workCanvas, changeRect);
    Canvas->CopyRect(changePaddleRect, workCanvas, changePaddleRect);
  }

  Application->ProcessMessages();
};



void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  FreeAndNil(bmp);
  FreeAndNil(backbmp);
  FreeAndNil(backgroundImage);
  FreeAndNil(spriteImage);
  FreeAndNil(paddle);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //Assign idle time function
  Application->OnIdle = IdleLoop;

  if(Application->MessageBox("Would you like to play with Earth?", "Hello Earthling", TMessageButtons() << smbOK << smbCancel) == smbOK)
  {
      x = 0;
      y = 0;
      FGameOver = false;
      Cursor = crNone;
  }
  else
      Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
  backgroundImage = new TImage(this);
  spriteImage = new TImage( this );
  paddle = new TImage( this );
  workCanvas = new TControlCanvas;
  backgroundCanvas = new TControlCanvas;

  Angle = 1;

  spriteImage->Picture->LoadFromFile("earth.ico");
  backgroundImage->Picture->LoadFromFile("androm.bmp");
  paddle->Picture->LoadFromFile("paddle.ico");

  backgroundRect.Top = 0;
  backgroundRect.Left = 0;
  backgroundRect.Right =  ClientWidth;
  backgroundRect.Bottom =  ClientHeight;


  spriteRect.Top = 0;
  spriteRect.Left = 0;
  spriteRect.Right = spriteImage->Picture->Width;
  spriteRect.Bottom = spriteImage->Picture->Height;

  //Set up backgroundCanvas
  backbmp = new TBitmap;
  backbmp->Width = ClientWidth;
  backbmp->Height = ClientHeight;
  backgroundCanvas = backbmp->Canvas;
  backgroundCanvas->StretchDraw(backgroundRect, backgroundImage->Picture->Bitmap);


  //Set up workCanvas
  bmp = new TBitmap;
  bmp->Width = ClientWidth;
  bmp->Height = ClientHeight;

  workCanvas = bmp->Canvas;
  workCanvas->CopyRect(backgroundRect,  backgroundCanvas, backgroundRect);
  workCanvas->Draw( 0, 0, spriteImage->Picture->Icon);
  paddleX = int (ClientWidth / 2);
  paddleY = ClientHeight - 50;
  workCanvas->Draw( paddleX, paddleY, paddle->Picture->Icon);

  paddleRect.Left = paddleX - paddle->Width;
  paddleRect.Right = paddleX + paddle->Width;
  paddleRect.Top	= paddleY;
  paddleRect.Bottom = paddleY + paddle->Height;

  Canvas->CopyRect(backgroundRect, workCanvas, backgroundRect);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  //Animates and moves paddle
  paddleCenter = X;
  if(paddleCenter < int (paddle->Picture->Width / 2))
      paddleCenter = int (paddle->Picture->Width / 2);
  if(paddleCenter > ClientWidth - int(paddle->Picture->Width / 2))
      paddleCenter = ClientWidth - int(paddle->Picture->Width / 2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
  Canvas->CopyRect(backgroundRect, workCanvas, backgroundRect);
}
//---------------------------------------------------------------------------
