//---------------------------------------------------------------------------

#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QExtCtrls.hpp>
#include <QMenus.hpp>
#include <QTypes.hpp>
#include <QComCtrls.hpp>
#include <QGraphics.hpp>

struct
  spot {
    TLabel *player;
    bool rb;
  };

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TTimer *Timer;
        TTimer *Clock;
        TMenuItem *File1;
        TMenuItem *Exit1;
        TMenuItem *Help1;
        TMenuItem *About1;
        TLabel *YTGLabel;
        TLabel *YTGDisplay;
        TLabel *VisitorLabel;
        TLabel *VisitorDisplay;
        TLabel *TimeLabel;
        TLabel *TimeDisplay;
        TLabel *HomeLabel;
        TLabel *HomeDisplay;
        TLabel *FieldPosLabel;
        TLabel *FieldPosDisplay;
        TLabel *DownLabel;
        TLabel *DownDisplay;
        TLabel *Runningback;
        TLabel *Tackler1;
        TLabel *Tackler2;
        TLabel *Tackler3;
        TLabel *Tackler4;
        TLabel *Tackler5;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TImage *kick;
        TImage *MoveUp;
        TImage *MoveDown;
        TImage *MoveBack;
        TImage *MoveForward;
        TImage *score;
        TImage *Image7;
        TTrackBar *OnOffSwitch;
        TButton *Computer;
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall FormKeyPress(TObject *Sender, char &Key);
        void __fastcall MoveUpClick(TObject *Sender);
        void __fastcall MoveBackClick(TObject *Sender);
        void __fastcall MoveForwardClick(TObject *Sender);
        void __fastcall MoveDownClick(TObject *Sender);
        void __fastcall ComputerClick(TObject *Sender);
        void __fastcall ClockTimer(TObject *Sender);
        void __fastcall TimerTimer(TObject *Sender);
        void __fastcall ScoreMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall ScoreMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall KickClick(TObject *Sender);
        void __fastcall OnOffSwitchChange(TObject *Sender);
private:	// User declarations
    spot field[10][3];  // the X and Y coordinates of the field
    int rbx, rby ;      // the X and Y coordinates of the runningback
    bool running  ;
    TLabel *LastSack  ;
    int YardsToGo ;
    int Down ;
    int FieldPosition ;
    int Home ;
    int Visitor ;
    int Quarter ;
    double TimeLeft;
    void __fastcall ShowField(bool visible);
    void __fastcall ResetField();
    void __fastcall Sacked(TLabel *Player );
    void __fastcall ShowDisplay(bool visible);
    void __fastcall TogglePlay( bool toggle);
    void __fastcall ResetGame();
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
