//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "GraphicForm.h"
#include "BmpDlg.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DrawShape(TPoint TopLeft, TPoint BottomRight, TPenMode AMode)
{
  Image1->Canvas->Pen->Mode = AMode;
  switch (MDrawShape)
  {
    case dsLine:
      Image1->Canvas->MoveTo(TopLeft.x,TopLeft.y);
      Image1->Canvas->LineTo(BottomRight.x,BottomRight.y);
      break;
    case dsRect:
      Image1->Canvas->Rectangle(TopLeft.x,TopLeft.y,BottomRight.x,BottomRight.y);
      break;
    case dsCircle:
      Image1->Canvas->Ellipse(TopLeft.x,TopLeft.y,BottomRight.x,BottomRight.y);
      break;
    case dsRoundRect:
      Image1->Canvas->RoundRect(TopLeft.x,TopLeft.y,BottomRight.x,BottomRight.y,
        abs((TopLeft.x-BottomRight.x)/2),abs((TopLeft.y-BottomRight.y)/2));
      break;
  }
  StatusBar1->Panels->operator [](2)->Text = "Modified";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetOriginal(void)
{
  LineSpeedBtn->Down = true;
  LineSpeedBtn->Click();
  SolidLineSpeedBtn->Down = true;
  SolidLineSpeedBtn->Click();
  SolidRectSpeedBtn->Down = true;
  SolidRectSpeedBtn->Click();
  LineSpinEdit->Value = 1;
  Image1->Canvas->Pen->Width = 1;
  Image1->Canvas->Brush->Color = BrushColor;
  Image1->Canvas->Pen->Color = PenColor;
  StatusBar1->Panels->operator [](0)->Text = EmptyStr;
  StatusBar1->Panels->operator [](1)->Text = EmptyStr;
  StatusBar1->Panels->operator [](2)->Text = EmptyStr;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetDrawShape(TObject *Sender)
{
  if (Sender == LineSpeedBtn) MDrawShape = dsLine;
  else if (Sender == RectSpeedBtn) MDrawShape = dsRect;
  else if (Sender == CircleSpeedBtn) MDrawShape = dsCircle;
  else if (Sender == RoundRectSpeedBtn) MDrawShape = dsRoundRect;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetPenStyle(TObject *Sender)
{
  if (Sender == SolidLineSpeedBtn) Image1->Canvas->Pen->Style = psSolid;
  else if (Sender == DashLineSpeedBtn) Image1->Canvas->Pen->Style = psDash;
  else if (Sender == DotLineSpeedBtn) Image1->Canvas->Pen->Style = psDot;
  else if (Sender == DashDotLineSpeedBtn) Image1->Canvas->Pen->Style = psDashDot;
  else if (Sender == DashDot2LineSpeedBtn) Image1->Canvas->Pen->Style = psDashDotDot;
  else if (Sender == ClearLineSpeedBtn) Image1->Canvas->Pen->Style = psClear;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetBrushStyle(TObject *Sender)
{
  if (Sender == SolidRectSpeedBtn) Image1->Canvas->Brush->Style = bsSolid;
  else if (Sender == ClearRectSpeedBtn) Image1->Canvas->Brush->Style = bsClear;
  else if (Sender == HoriRectSpeedBtn) Image1->Canvas->Brush->Style = bsHorizontal;
  else if (Sender == VertRectSpeedBtn) Image1->Canvas->Brush->Style = bsVertical;
  else if (Sender == FDiagRectSpeedBtn) Image1->Canvas->Brush->Style = bsFDiagonal;
  else if (Sender == BDiagRectSpeedBtn) Image1->Canvas->Brush->Style  = bsBDiagonal;
  else if (Sender == CrossRectSpeedBtn) Image1->Canvas->Brush->Style = bsCross;
  else if (Sender == DiagCrossRectSpeedBtn) Image1->Canvas->Brush->Style = bsDiagCross;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SetColor(TObject *Sender)
{
  if (Sender == ColorLineSpeedBtn)
  {
    ColorDialog1->Color = Image1->Canvas->Pen->Color;
    if (ColorDialog1->Execute())
      Image1->Canvas->Pen->Color = ColorDialog1->Color;
  }
  else if (Sender == ColorRectSpeedBtn)
  {
    ColorDialog1->Color = Image1->Canvas->Brush->Color;
    if (ColorDialog1->Execute())
      Image1->Canvas->Brush->Color = ColorDialog1->Color;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PenSpeedBtnClick(TObject *Sender)
{
  PenPanel->Visible = !PenPanel->Visible;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::BrushSpeedBtnClick(TObject *Sender)
{
  BrushPanel->Visible = !BrushPanel->Visible;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LineSpinEditChanged(TObject *Sender,
      int NewValue)
{
  Image1->Canvas->Pen->Width = NewValue;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  if (MDrawing)
  {
    DrawShape(Origin,MovePt,pmNotXor);
    MovePt = Point(X,Y);
    DrawShape(Origin,MovePt,pmNotXor);
  }
  StatusBar1->Panels->operator [](1)->Text = Format("Current: (%d, %d)", ARRAYOFCONST((X,Y)));
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  MDrawing = true;
  Image1->Canvas->MoveTo(X,Y);
  Origin = Point(X,Y);
  MovePt = Origin;
  StatusBar1->Panels->operator [](0)->Text = Format("Origin: (%d, %d)", ARRAYOFCONST((X,Y)));
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  if (MDrawing)
  {
    DrawShape(Origin,Point(X,Y),pmCopy);
    MDrawing = false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  TBitmap *FBitmap;
  FBitmap = NULL;
  try
  {
    FBitmap = new TBitmap;
    FBitmap->Width = 200;
    FBitmap->Height = 200;
    FBitmap->Canvas->DrawPoint(-1,-1);
    Image1->Picture->Graphic = FBitmap;
  } __finally {
    FBitmap->Free();
  }
  BrushColor = Image1->Canvas->Brush->Color;
  PenColor = Image1->Canvas->Pen->Color;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SaveAs1Click(TObject *Sender)
{
  if (SaveDialog1->Execute())
  {
    CurrentFile = SaveDialog1->FileName;
    Save1Click(Sender);
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Save1Click(TObject *Sender)
{
  if (CurrentFile != EmptyStr)
    Image1->Picture->SaveToFile(CurrentFile);
  else
    SaveAs1Click(Sender);
  StatusBar1->Panels->operator [](2)->Text = EmptyStr;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
  TMessageButton FButton;
  if (StatusBar1->Panels->operator [](2)->Text != WideString(EmptyStr))
  {
    FButton = Application->MessageBox("Do you want to save before exiting?", "Unsaved Data",
                TMessageButtons() << smbCancel << smbNo << smbYes,smsInformation,smbNo,smbCancel);
    if (FButton == smbCancel) exit;
    else if (FButton == smbYes) SaveAs1Click(Sender);
  }
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Open1Click(TObject *Sender)
{
  TMessageButton FButton;
  if (OpenDialog1->Execute())
  {
    CurrentFile = OpenDialog1->FileName;
    if (StatusBar1->Panels->operator [](2)->Text != WideString(EmptyStr))
    {
      FButton = Application->MessageBox("Modified: Do you want to save?", "Unsaved Data",
                TMessageButtons() << smbCancel << smbNo << smbYes,smsInformation,smbNo,smbCancel);
      if (FButton == smbCancel) exit;
      else if (FButton == smbYes) SaveAs1Click(Sender);
    }
    Image1->Picture->LoadFromFile(CurrentFile);
    SetOriginal();
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::New1Click(TObject *Sender)
{
  TBitmap *FBitmap;
  TMessageButton FButton;

  if (StatusBar1->Panels->operator [](2)->Text != WideString(EmptyStr))
  {
    FButton = Application->MessageBox("Modified: Do you want to save?", "Unsaved Data",
              TMessageButtons() << smbCancel << smbNo << smbYes,smsInformation,smbNo,smbCancel);
    if (FButton == smbCancel) exit;
    else if (FButton == smbYes) SaveAs1Click(Sender);
  }
  BmpDimForm->ActiveControl = BmpDimForm->WidthEdit;
  BmpDimForm->WidthEdit->Text = IntToStr(Image1->Picture->Graphic->Width);
  BmpDimForm->HeightEdit->Text = IntToStr(Image1->Picture->Graphic->Height);
  if (BmpDimForm->ShowModal() == 1)
  {
    FBitmap = NULL;
    try
    {
      FBitmap = new TBitmap;
      FBitmap->Width = StrToInt(AnsiString(BmpDimForm->WidthEdit->Text));
      FBitmap->Height = StrToInt(AnsiString(BmpDimForm->HeightEdit->Text));
      FBitmap->Canvas->DrawPoint(-1,-1);
      Image1->Picture->Graphic = FBitmap;
      CurrentFile = EmptyStr;
      SetOriginal();
    } __finally {
      FBitmap->Free();
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Paste1Click(TObject *Sender)
{
  TBitmap *FBitmap = new TBitmap;

  try
  {
    FBitmap->Assign(Clipboard());
    Image1->Canvas->Draw(0, 0, FBitmap);
  } __finally {
    FBitmap->Free();
  }
  StatusBar1->Panels->operator [](2)->Text = "Modified";
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Copy1Click(TObject *Sender)
{
  Clipboard()->Assign(Image1->Picture);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Cut1Click(TObject *Sender)
{
  TRect ARect;

  Copy1Click(Sender);
  Image1->Canvas->CopyMode = cmWhiteness;
  ARect = Rect(0, 0, Image1->Width, Image1->Height);
  Image1->Canvas->CopyRect(ARect, Image1->Canvas, ARect);
  Image1->Canvas->CopyMode = cmSrcCopy;
  StatusBar1->Panels->operator [](2)->Text = "Modified";
}
//---------------------------------------------------------------------------

