//---------------------------------------------------------------------------

#ifndef GraphicFormH
#define GraphicFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QButtons.hpp>
#include <QComCtrls.hpp>
#include <QDialogs.hpp>
#include <QExtCtrls.hpp>
#include <QImgList.hpp>
#include <QMenus.hpp>
#include <QTypes.hpp>
#include <QClipbrd.hpp> QGraphics.hpp
//---------------------------------------------------------------------------
enum TDrawShape { dsLine, dsRect, dsCircle, dsRoundRect };

class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *MainPanel;
        TSpeedButton *LineSpeedBtn;
        TSpeedButton *RectSpeedBtn;
        TSpeedButton *CircleSpeedBtn;
        TSpeedButton *RoundRectSpeedBtn;
        TSpeedButton *PenSpeedBtn;
        TSpeedButton *BrushSpeedBtn;
        TPanel *PenPanel;
        TSpeedButton *SolidLineSpeedBtn;
        TSpeedButton *DashLineSpeedBtn;
        TSpeedButton *DotLineSpeedBtn;
        TSpeedButton *DashDotLineSpeedBtn;
        TSpeedButton *DashDot2LineSpeedBtn;
        TSpeedButton *ClearLineSpeedBtn;
        TSpeedButton *ColorLineSpeedBtn;
        TSpinEdit *LineSpinEdit;
        TPanel *BrushPanel;
        TSpeedButton *SolidRectSpeedBtn;
        TSpeedButton *ClearRectSpeedBtn;
        TSpeedButton *ColorRectSpeedBtn;
        TSpeedButton *HoriRectSpeedBtn;
        TSpeedButton *VertRectSpeedBtn;
        TSpeedButton *FDiagRectSpeedBtn;
        TSpeedButton *BDiagRectSpeedBtn;
        TSpeedButton *CrossRectSpeedBtn;
        TSpeedButton *DiagCrossRectSpeedBtn;
        TScrollBox *ScrollBox1;
        TImage *Image1;
        TStatusBar *StatusBar1;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TMenuItem *New1;
        TMenuItem *Open1;
        TMenuItem *Save1;
        TMenuItem *SaveAs1;
        TMenuItem *N1;
        TMenuItem *Exit1;
        TMenuItem *Edit1;
        TMenuItem *Paste1;
        TMenuItem *Copy1;
        TMenuItem *Cut1;
        TColorDialog *ColorDialog1;
        TSaveDialog *SaveDialog1;
        TOpenDialog *OpenDialog1;
        TImageList *ImageList1;
        void __fastcall SetDrawShape(TObject *Sender);
        void __fastcall SetPenStyle(TObject *Sender);
        void __fastcall SetBrushStyle(TObject *Sender);
        void __fastcall SetColor(TObject *Sender);
        void __fastcall PenSpeedBtnClick(TObject *Sender);
        void __fastcall BrushSpeedBtnClick(TObject *Sender);
        void __fastcall LineSpinEditChanged(TObject *Sender, int NewValue);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall SaveAs1Click(TObject *Sender);
        void __fastcall Save1Click(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall New1Click(TObject *Sender);
        void __fastcall Paste1Click(TObject *Sender);
        void __fastcall Copy1Click(TObject *Sender);
        void __fastcall Cut1Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        Boolean MDrawing;
        TPoint Origin,MovePt;
        TColor BrushColor,PenColor;
        String CurrentFile;
        TDrawShape MDrawShape;
        void __fastcall DrawShape(TPoint TopLeft, TPoint BottomRight, TPenMode AMode);
        void __fastcall SetOriginal(void);
        __fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
