//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "ImageFileDialog.h"
#include "ViewImage.h"
#include "CreateLinkDialog.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TImageViewForm *ImageViewForm;
//---------------------------------------------------------------------------
__fastcall TImageViewForm::TImageViewForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TImageViewForm::ViewAsGlyph(const String FileExt)
{
  if ((ViewAsGlyphCBox->Checked) & (FileExt != ".ico"))
  {
    SpeedButton1->Glyph = Image1->Picture->Bitmap;
    SpeedButton2->Glyph = Image1->Picture->Bitmap;
    UpDownSEdit->Value = SpeedButton1->NumGlyphs;
    BitBtn1->Glyph = Image1->Picture->Bitmap;
    BitBtn2->Glyph = Image1->Picture->Bitmap;
  } else {
    SpeedButton1->Glyph = NULL;
    SpeedButton2->Glyph = NULL;
    BitBtn1->Glyph = NULL;
    BitBtn2->Glyph = NULL;
  }
  UpDownSEdit->Enabled = ViewAsGlyphCBox->Checked;
  Label2->Enabled = ViewAsGlyphCBox->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::SetCompEvent(TObject *Sender)
{
  FCompEvent = Sender;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FormCreate(TObject *Sender)
{
  FormCaption = Caption + " - ";
  UpDownSEdit->Min = 1;
  UpDownSEdit->Max = 4;
  Label2->Enabled = ViewAsGlyphCBox->Checked;
  UpDownSEdit->Enabled = ViewAsGlyphCBox->Checked;
  DirectoryTreeView1->Directory = getenv("HOME");
  // This will call the FileHistoryComboBox OnChange event
  FileHistoryComboBox1->Add(AnsiString(DirectoryTreeView1->Directory));
  FileListView1->Directory->Location = DirectoryTreeView1->Directory;
  FileListView1->Directory->FileMask = FilterComboBox1->Mask;
  // This will call the FileEdit OnDirectoryChange event
  FileEdit1->Directory->Location = DirectoryTreeView1->Directory;
  FileEdit1->Directory->FileMask = FilterComboBox1->Mask;
  FirstRan = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FormLoaded(TObject *Sender)
{
  FirstRan = true;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FileEdit1DirectoryChange(TObject *Sender,
      const WideString NewDir)
{
  int I;
  Boolean Cont;
  if (! FirstRan)
  {
    if ((FCompEvent != FileHistoryComboBox1) && (FCompEvent != DirectoryTreeView1))
    {
      Cont = false;
      for (I=0; I < FileHistoryComboBox1->Items->Count; I++)
      {
        if (FileHistoryComboBox1->Files[I]->SR.PathOnly+FileHistoryComboBox1->Files[I]->SR.Name != NewDir)
          Cont = true;
        else {
          Cont = false;
          break;
        }
      }
      FCompEvent = FileEdit1;
      if (Cont)
        // This will call the FileHistoryComboBox OnChange event
        FileHistoryComboBox1->Add(AnsiString(NewDir));
      else
        // This will call the FileHistoryComboBox OnChange event
        FileHistoryComboBox1->ItemIndex = FileHistoryComboBox1->Items->IndexOf(AnsiString(NewDir));
      // This will explicitly call the FileHistoryComboBox OnChange event
      FileHistoryComboBox1Change(Sender);
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FileEdit1ReturnPressed(TObject *Sender)
{
  int I,SlashStr;
  String NewDir,FName;

  NewDir = FileEdit1->Directory->Location;
  NewDir.SetLength(NewDir.Length()-1);
  // This will explicitly call the FileEdit OnDirectoryChange event
  FileEdit1DirectoryChange(Sender,NewDir);
  for (I=FileEdit1->Text.Length(); I >= 0; I--)
  {
    if (String(char(FileEdit1->Text[I])) == "/")
    {
      SlashStr = I;
      break;
    } else
      SlashStr = 0;
  }
  FName = FileEdit1->Text;
  FName.Delete(1,SlashStr);
  for (I=0; I < FileListView1->Items->Count; I++)
  {
    if (FileListView1->Items->Item[I]->Caption == WideString(FName))
    {
      FileListView1->Items->Item[I]->Selected = true;
      FileListView1->Items->Item[I]->MakeVisible();
      // This will explicitly call the FileListView OnSelectItem event
      FileListView1SelectItem(Sender,FileListView1->Items->Item[I],true);
      break;
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::DirectoryTreeView1Change(TObject *Sender,
      TTreeNode *Node)
{
  Boolean Cont;
  int I;
  Cont = false;
  for (I=0; I < FileHistoryComboBox1->Items->Count; I++)
  {
    if (FileHistoryComboBox1->Files[I]->SR.PathOnly+FileHistoryComboBox1->Files[I]->SR.Name != PFileInfo(Node->Data)->SR.PathOnly+PFileInfo(Node->Data)->SR.Name)
      Cont = true;
    else {
      Cont = false;
      break;
    }
  }
  FCompEvent = DirectoryTreeView1;
  if (Cont)
    // This will call FileHistoryComboBox OnChange event
    FileHistoryComboBox1->Add(PFileInfo(Node->Data)->SR.PathOnly+PFileInfo(Node->Data)->SR.Name);
  else
    // This will call FileHistoryComboBox OnChange event
    FileHistoryComboBox1->ItemIndex = FileHistoryComboBox1->Items->IndexOf(PFileInfo(Node->Data)->SR.PathOnly+PFileInfo(Node->Data)->SR.Name);
  // This will call DirectoryTreeView OnChange event
  FileListView1->Directory->Location = PFileInfo(Node->Data)->SR.PathOnly+PFileInfo(Node->Data)->SR.Name;
  // This will call FileEdit OnDirectoryChange event
  FileEdit1->Directory->Location = PFileInfo(Node->Data)->SR.PathOnly+PFileInfo(Node->Data)->SR.Name;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FileHistoryComboBox1Change(TObject *Sender)
{
  if (!FirstRan)
  {
    if ((FCompEvent != DirectoryTreeView1) && (FCompEvent != FileEdit1))
    {
      DirectoryTreeView1->Directory = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
      // This will call FileEdit OnDirectoryChange event
      FCompEvent = FileHistoryComboBox1;
      FileEdit1->Directory->Location = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
      FileListView1->Directory->Location = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
    } else if (Sender == FileEdit1)
    {
      DirectoryTreeView1->Directory = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
      // This will call FileEdit OnDirectoryChange event
      FCompEvent = FileHistoryComboBox1;
      FileEdit1->Directory->Location = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
      FileListView1->Directory->Location = FileHistoryComboBox1->Items->Strings[FileHistoryComboBox1->ItemIndex];
      DirectoryTreeView1->Selected->Expand(false);
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FilterComboBox1Change(TObject *Sender)
{
  FileListView1->Directory->FileMask = FilterComboBox1->Mask;
  FileEdit1->Directory->FileMask = FilterComboBox1->Mask;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FileListView1SelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
  String FileExt;
  if ((FileListView1->Focused()) || (Sender == FileEdit1))
  {
    if ((PFileInfo(Item->Data)->SR.Attr & faDirectory) == 0)
    {
      FileExt = AnsiLowerCase(ExtractFileExt(PFileInfo(Item->Data)->SR.Name));
      if ((FileExt == ".bmp") || (FileExt == ".ico") || (FileExt == ".jpg") ||
         (FileExt == ".png") || (FileExt == ".xpm"))
      {
        Image1->Picture->LoadFromFile(PFileInfo(Item->Data)->SR.PathOnly+PFileInfo(Item->Data)->SR.Name);
        Caption = FormCaption + PFileInfo(Item->Data)->SR.Name;
        FileEdit1->Text = PFileInfo(Item->Data)->SR.Name;
        if (FileExt != ".ico")
        {
          Caption = Caption +" ("+WideString(Image1->Picture->Width)+" x "+WideString(Image1->Picture->Height)+")";
          ImageForm->Image1->Picture = Image1->Picture;
          ImageForm->Caption = Caption;
          if (ViewAsGlyphCBox->Checked) ViewAsGlyph(FileExt);
        } else
          ViewAsGlyphCBox->Checked = false;
        if (FileExt == ".ico")
        {
          Icon = Image1->Picture->Icon;
          ImageForm->Image1->Picture->Icon = Icon;
        }
      }
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::ViewAsGlyphCBoxClick(TObject *Sender)
{
  if (FileListView1->Selected != NULL)
    ViewAsGlyph(AnsiLowerCase(ExtractFileExt(PFileInfo(FileListView1->Selected->Data)->SR.Name)));
  else
    ViewAsGlyph("");
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FullViewBtnClick(TObject *Sender)
{
  ImageForm->HorzScrollBar->Range = Image1->Picture->Width;
  ImageForm->VertScrollBar->Range = Image1->Picture->Height;
  ImageForm->Caption = Caption;
  ImageForm->Show();
  ImageForm->WindowState = wsNormal;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::UpDownSEditChanged(TObject *Sender,
      int NewValue)
{
  SpeedButton1->NumGlyphs = NewValue;
  SpeedButton2->NumGlyphs = NewValue;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::StretchCBoxClick(TObject *Sender)
{
  Image1->Stretch = StretchCBox->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::DirectoryTreeView1ContextPopup(
      TObject *Sender, TPoint &MousePos, bool &Handled)
{
  PopupEvent = peDirectoryTreeView;
  CreateLink1->Enabled = (DirectoryTreeView1->Selected != NULL);
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::FileListView1ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
  PopupEvent = peFileListView;
  CreateLink1->Enabled = (FileListView1->Selected != NULL);
}
//---------------------------------------------------------------------------

void __fastcall TImageViewForm::CreateLink1Click(TObject *Sender)
{
  char OldLocal[255],NewLocal[255];

    if (PopupEvent == peDirectoryTreeView)
    {
      LinkForm->Label1->Caption = " Source DirName:";
      LinkForm->Label2->Caption = " Link DirName";
      LinkForm->SourceFileName->Text = DirectoryTreeView1->Selected->Text;
      LinkForm->LinkFileName->Text = DirectoryTreeView1->Selected->Text;
    } else if (PopupEvent == peFileListView)
    {
      LinkForm->Label1->Caption = " Source FileName:";
      LinkForm->Label2->Caption = " Link FileName:";
      LinkForm->SourceFileName->Text = FileListView1->Selected->Caption;
      LinkForm->LinkFileName->Text = FileListView1->Selected->Caption;
    };
    LinkForm->LinkLocation->Directory->Location = DirectoryTreeView1->Directory;
    LinkForm->LinkLocation->Text = LinkForm->LinkLocation->Directory->Location;
    LinkForm->LinkDirectoryTV->Directory = DirectoryTreeView1->Directory;
    if (LinkForm->ShowModal() == 1)
    {
      if (PopupEvent == peDirectoryTreeView)
        StrPCopy(OldLocal,AnsiString(FileListView1->Directory->Location));
      else if (PopupEvent == peFileListView)
        StrPCopy(OldLocal,AnsiString(FileListView1->Directory->Location)+SourLink);
      StrPCopy(NewLocal,DestLoc+DestLink);
      if (FileExists(NewLocal))
        Application->MessageBox("'"+DestLoc+DestLink+"' FileName Exist!", "Error!");
      else {
        symlink(OldLocal,NewLocal);
        Application->MessageBox("SymLink: "+AnsiString(NewLocal)+" -> "+OldLocal, "Created SymLink");
      }
    }
}
//---------------------------------------------------------------------------

