//---------------------------------------------------------------------------

#ifndef ImageFileDialogH
#define ImageFileDialogH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QButtons.hpp>
#include <QComCtrls.hpp>
#include <QExtCtrls.hpp>
#include <QFileCtrls.hpp>
#include <QTypes.hpp>
#include <Libc.hpp>
#include <QMenus.hpp>
//---------------------------------------------------------------------------
enum TPopupEvent { peDirectoryTreeView, peFileListView };

class TImageViewForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TBevel *Bevel2;
        TFileEdit *FileEdit1;
        TFileListView *FileListView1;
        TFilterComboBox *FilterComboBox1;
        TFileHistoryComboBox *FileHistoryComboBox1;
        TLabel *Label1;
        TPanel *Panel1;
        TImage *Image1;
        TButton *FullViewBtn;
        TCheckBox *StretchCBox;
        TCheckBox *ViewAsGlyphCBox;
        TGroupBox *UpDownGBox;
        TSpeedButton *SpeedButton1;
        TBitBtn *BitBtn1;
        TGroupBox *DisabledGBox;
        TSpeedButton *SpeedButton2;
        TBitBtn *BitBtn2;
        TLabel *Label2;
        TSpinEdit *UpDownSEdit;
        TDirectoryTreeView *DirectoryTreeView1;
        TPopupMenu *PopupMenu1;
        TMenuItem *CreateLink1;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormLoaded(TObject *Sender);
        void __fastcall FileEdit1DirectoryChange(TObject *Sender,
          const WideString NewDir);
        void __fastcall FileEdit1ReturnPressed(TObject *Sender);
        void __fastcall DirectoryTreeView1Change(TObject *Sender,
          TTreeNode *Node);
        void __fastcall FileHistoryComboBox1Change(TObject *Sender);
        void __fastcall FilterComboBox1Change(TObject *Sender);
        void __fastcall FileListView1SelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall ViewAsGlyphCBoxClick(TObject *Sender);
        void __fastcall FullViewBtnClick(TObject *Sender);
        void __fastcall UpDownSEditChanged(TObject *Sender, int NewValue);
        void __fastcall StretchCBoxClick(TObject *Sender);
        void __fastcall SetCompEvent(TObject *Sender);
        void __fastcall DirectoryTreeView1ContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall FileListView1ContextPopup(TObject *Sender,
          TPoint &MousePos, bool &Handled);
        void __fastcall CreateLink1Click(TObject *Sender);
private:	// User declarations
        Boolean FirstRan;
        String FormCaption;
        TPopupEvent PopupEvent;
        TObject *FCompEvent;
        void __fastcall ViewAsGlyph(const String FileExt);
//        void __fastcall SetCompEvent(TObject *Sender);
public:		// User declarations
        String DestLink;
        String SourLink;
        String DestLoc;
        __fastcall TImageViewForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TImageViewForm *ImageViewForm;
//---------------------------------------------------------------------------
#endif
