//---------------------------------------------------------------------------
#pragma hdrstop
#include <iostream.h>
#include <Classes.hpp>
#include <SysUtils.hpp>
//---------------------------------------------------------------------------
const
  PChar AppName = "Borland File Injection Example 1.0";
  PChar CopyrightString = "Copyright 2002";
  PChar UsageString = "Usage: Inject -i[injection file] -f[file list] files";
  PChar NoFileWarning = "Warning: Unable to open file ";
  PChar InjectDelim = "#";

void WriteHeader(void)
{
  cout << AppName << endl;
  cout << CopyrightString << endl;
}

void ReportError(void)
{
  cout << UsageString << endl;
}

TStringList* SetupFileList(const String FileListName)
{
  String Param;
  int I, IsFileName;
  TStringList *TmpString = new TStringList;

  if (FileListName != "")
    TmpString->LoadFromFile(FileListName);
  for (I = 1; I <= ParamCount(); I++)
  {
    Param = ParamStr(I);
    IsFileName = Param.Pos("-");
    if (IsFileName == 0)
     TmpString->Add(Param);
  }
  return(TmpString);
}

String GetDate(const String Buf, int const DelimPos)
{
  String SearchBuf, DateBuf;
  int DatePos;
  /* In the passed-in buffer, find the first occurrance of a year, and
    save it out. If there is no year, then this is the first time that
    file had a header, and it should get 2000 appended. Only pay attention
    to text that exists *prior* to the first occurance of the delimeter */
  SearchBuf = Buf;
  SearchBuf.SetLength(DelimPos);
  DatePos = SearchBuf.Pos("19");
  if (DatePos == 0)
    DatePos = SearchBuf.Pos("2000");
  if (DatePos == 0)
    DatePos = SearchBuf.Pos("2001");
  if (DatePos != 0)
  {
    DateBuf = Buf;
    DateBuf = DateBuf.Delete(1,DatePos-1);
    DateBuf.SetLength(4);
    return(DateBuf);
  } else return("2002");
}

void DoInjections(TStringList *Files, String InjectionFileName)
{
  String FileName, InjBuf, FilBuf, TempFilBuf, OutFilBuf;
  String PreDateBuf, PostDateBuf, StoredDate;
  int I, DatePos, DelimPos;

  TStringList *InjList = new TStringList;
  TStringList *FilList = new TStringList;

  try {
    InjList->LoadFromFile(InjectionFileName);
  } catch (...) {
     cout << NoFileWarning;
     cout << InjectionFileName.c_str() << endl;
     abort();
  }

  /* Get buffers containing the string prior to the first instance of
    a year in the header, and a string starting with the first instance
    of the year. This allows the injection of the existing year into
    the header. */

  InjBuf = InjList->Text;
  DatePos = InjBuf.Pos("20");

  PreDateBuf = InjBuf;
  PreDateBuf.SetLength(DatePos-1);

  PostDateBuf = InjBuf;
  PostDateBuf = PostDateBuf.Delete(1,DatePos-1);
  PostDateBuf.SetLength(InjBuf.Length()-DatePos);

  for (I = 0; I < Files->Count; I++)
  {
    FileName = Files->Strings[I];
    if (FileName != "")
    {
      try {
        FilList->LoadFromFile(FileName);
      }  catch (...) {
        cout << NoFileWarning;
        cout << FileName.c_str() << endl;
        continue;
      }
      FilBuf = FilList->Text;

      // Find the first instance of the delimeter in the header.
      DelimPos = FilBuf.Pos(InjectDelim);
      // Find out what the existing copyright on the unit is.
      StoredDate = GetDate(FilBuf, DelimPos);

      // Build the header for injection by adding the date to the parts
      //  ripped out of the header earlier.
      InjBuf = PreDateBuf+StoredDate+", "+PostDateBuf;

      // Discard anything already in the file before the delimeter, and
      //  then inject the header.
      TempFilBuf = FilBuf;
      TempFilBuf.Delete(1,DelimPos-1);
      TempFilBuf.SetLength(FilBuf.Length()-DelimPos);

      OutFilBuf = InjBuf+"\n\n"+TempFilBuf;
      FilList->Text = OutFilBuf;
      FilList->SaveToFile(FileName);
    }
  }
  FilList->Free();
  InjList->Free();
}

#pragma argsused
int main(int argc, char* argv[])
{
  int I, SubPos;
  TStringList *Files;
  String Param, InjectionFileName, FileListName;

  WriteHeader();
  if (ParamCount() > 3)
  {
    ReportError();
    exit(0);
  }

  for (I = 1; I <= ParamCount(); I++)
  {
    Param = ParamStr(I);
    SubPos = LowerCase(Param).Pos("-i");
    if (SubPos == 1)
    {
    InjectionFileName = Param;
    InjectionFileName = InjectionFileName.Delete(1,2);
    InjectionFileName.SetLength(Param.Length()-2);
    }
    SubPos = LowerCase(Param).Pos("-f");
    if (SubPos == 1)
    {
    FileListName = Param;
    FileListName = FileListName.Delete(1,2);
    FileListName.SetLength(Param.Length()-2);
    }
  }

  if (InjectionFileName != "")
  {
    Files = SetupFileList(FileListName);
    DoInjections(Files, InjectionFileName);
    Files->Free();
  } else {
    ReportError();
    exit(0);
  }
        return 0;
}
//--------------------------------------------------------------------------- 
