//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "main.h"
#include "Libc.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TTextBrowserForm *TextBrowserForm;

const
  char *DefaultDocName = "index.html";
  char *FormCaption = "TTextBrowser Demo Application - ";

//---------------------------------------------------------------------------
__fastcall TTextBrowserForm::TTextBrowserForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::HomeBtnClick(TObject *Sender)
{
  TextBrowser->Home();
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::BackBtnClick(TObject *Sender)
{
  TextBrowser->Backward();
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::ForwardBtnClick(TObject *Sender)
{
  TextBrowser->Forward();
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::UnderlineCheckboxClick(TObject *Sender)
{
  TextBrowser->UnderlineLink =  UnderlineCheckbox->Checked;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::ReloadBtnClick(TObject *Sender)
{
  TextBrowser->LoadFromFile(TextBrowser->FileName);
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::SpeedButton1Click(TObject *Sender)
{
  WideString NewDir ;

  if (SelectDirectory("Select a Directory", getenv("HOME"), NewDir))
    LinkSourceEdit->Text = NewDir;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::LinkSourceEditChange(TObject *Sender)
{
  PathList->Add(String(LinkSourceEdit->Text));
  TextBrowser->Factory->FilePath = PathList;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::FormCreate(TObject *Sender)
{
  PathList = new TStringList;
  LinkSourceEdit->Text = ExtractFilePath(Application->ExeName);
  TextBrowser->FileName = String(LinkSourceEdit->Text + DefaultDocName);
  UnderlineCheckbox->Checked = ! TextBrowser->UnderlineLink;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::FormDestroy(TObject *Sender)
{
  PathList->Free();
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::TextBrowserTextChanged(TObject *Sender)
{
  BackBtn->Enabled = TextBrowser->CanGoBackward();
  ForwardBtn->Enabled = TextBrowser->CanGoForward();
  Caption = FormCaption + TextBrowser->DocumentTitle;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::RadioButton1Click(TObject *Sender)
{
  TextBrowser->LinkColor = clBlue;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::RadioButton2Click(TObject *Sender)
{
  TextBrowser->LinkColor = clRed;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::RadioButton3Click(TObject *Sender)
{
  TextBrowser->TextColor = clBlack;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::RadioButton4Click(TObject *Sender)
{
  TextBrowser->TextColor = clGreen;
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::RadioGroup1Click(TObject *Sender)
{
  switch (RadioGroup1->ItemIndex) {
    case 0: TextBrowser->TextFormat = tfText; break;
    case 1: TextBrowser->TextFormat = tfPlainText; break;
  };
}//---------------------------------------------------------------------------
void __fastcall TTextBrowserForm::TextBrowserHighlightText(
      TObject *Sender, const WideString HighlightedText)
{
  StatusBar->SimpleText = "Link To: " + HighlightedText;
}//---------------------------------------------------------------------------
