unit CircularForms;

interface

uses Qt, Types, Classes, QForms, QGraphics, QControls, ShapedForms;

type
  TCircularForm = class(TShapedForm)
  protected
    procedure DrawMask(ACanvas: TCanvas); override;
  end;

implementation

// Override DrawMask to create a circular form.
procedure TCircularForm.DrawMask(ACanvas: TCanvas);
var
  R: TRect;
begin
  R := ClientRect;
  ACanvas.Brush.Color := clMask;
  ACanvas.FillRect(R);
  ACanvas.Brush.Color := clDontMask;
  ACanvas.Ellipse(R);
end;

end.
