unit CustomSortUnit;

interface

{
  Unit Purpose:
  ============
  Override the call to strcoll made in Libc for some custom or more appropriate
  sorting and collation capabilities
}

function CustomStrColl(S1, S2: PChar): Integer; { Custom sort function }
exports CustomStrColl name 'strcoll';           { Custom sort function exported as "strcoll" } 

implementation

uses
  Libc;

function CustomStrColl(S1, S2: PChar): Integer;
begin
  {
    Custom implementation of strcoll goes here:
    1 - Test locale,
    2 - Normalize input strings,
    3 - Produce an array of collation elements for each strings,
    4 - Form a sort key for each string
    5 - Compare the sort keys
    6 - Return result
  }
  Result := StrCmp(S1, S2);
end;

end.
