unit CreateLinkDialog;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QButtons, QFileCtrls, QComCtrls, QExtCtrls;

type
  TLinkForm = class(TForm)
    ScrollBox1: TScrollBox;
    DirectoryPanel: TPanel;
    LinkDirectoryTV: TDirectoryTreeView;
    MainPanel: TPanel;
    SpeedButton1: TSpeedButton;
    Label3: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    SourceFileName: TEdit;
    LinkFileName: TEdit;
    LinkLocation: TFileEdit;
    OkBtn: TBitBtn;
    BitBtn1: TBitBtn;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure LinkDirectoryTVItemClick(Sender: TObject;
      Button: TMouseButton; Node: TTreeNode; const Pt: TPoint);
    procedure LinkLocationDirectoryChange(Sender: TObject;
      const NewDir: WideString);
    procedure LinkLocationChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure LinkLocationExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LinkForm: TLinkForm;

implementation

{$R *.xfm}

uses ImageFileDialog;

procedure TLinkForm.SpeedButton1Click(Sender: TObject);
begin
  DirectoryPanel.Visible := not SpeedButton1.Down;
  if DirectoryPanel.Visible then
    LinkForm.Height := (MainPanel.Height * 3)
  else
    LinkForm.Height := MainPanel.Height;
end;

procedure TLinkForm.FormShow(Sender: TObject);
begin
  DirectoryPanel.Visible := False;
  SpeedButton1.Down := False;
  LinkForm.Height := MainPanel.Height;
  LinkFileName.SetFocus;
  LinkFileName.SelectAll;
end;

procedure TLinkForm.LinkDirectoryTVItemClick(Sender: TObject;
  Button: TMouseButton; Node: TTreeNode; const Pt: TPoint);
begin
  LinkLocation.Directory.Location := PFileInfo(Node.Data).SR.PathOnly+PFileInfo(Node.Data).SR.Name;
  LinkLocation.Text := LinkLocation.Directory.Location;
end;

procedure TLinkForm.LinkLocationDirectoryChange(Sender: TObject;
  const NewDir: WideString);
begin
  LinkLocation.Text := LinkLocation.Directory.Location;
  LinkDirectoryTV.Directory := LinkLocation.Directory.Location;
end;

procedure TLinkForm.LinkLocationChange(Sender: TObject);
begin
  OkBtn.Enabled := DirectoryExists(LinkLocation.Text);
end;

procedure TLinkForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ImageViewForm.SourLink := SourceFileName.Text;
  ImageViewForm.DestLink := LinkFileName.Text;
  ImageViewForm.DestLoc := LinkLocation.Directory.Location;
end;

procedure TLinkForm.LinkLocationExit(Sender: TObject);
begin
  if (DirectoryExists(LinkLocation.Text)) and (LinkLocation.Text[Length(LinkLocation.Text)] <> '/') then
  begin
    LinkLocation.Text := LinkLocation.Text+'/';
    LinkLocation.Directory.Location := LinkLocation.Text;
  end;
end;

end.
