unit Fontlist;

interface

uses SysUtils, Classes, Types, QGraphics, QForms, QControls, QStdCtrls,
  QComCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    FontLabel: TLabel;
    seFontSize: TSpinEdit;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DrawItem(Sender: TObject; Index: Integer;
      Rect: TRect; State: TOwnerDrawState; var Handled: Boolean);
    procedure ListBox1MeasureItem(Control: TWidgetControl; Index: Integer;
      var Height: Integer);
    procedure seFontSizeChanged(Sender: TObject; NewValue: Integer);
  private
    FontSize: Integer;
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Listbox1.Items := Screen.Fonts;
  FontSize := seFontSize.Value;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  FontLabel.Caption := ListBox1.Items[ListBox1.ItemIndex];
end;


procedure TForm1.ListBox1DrawItem(Sender: TObject; Index: Integer;
  Rect: TRect; State: TOwnerDrawState; var Handled: Boolean);
begin
  with ListBox1.Canvas do
  begin
    FillRect(Rect);
    Font.Name := ListBox1.Items[Index];
    Font.Size := FontSize;
    TextOut(Rect.Left+1, Rect.Top+1, ListBox1.Items[Index]);
  end;
end;

procedure TForm1.ListBox1MeasureItem(Control: TWidgetControl;
  Index: Integer; var Height: Integer);
begin
  with ListBox1.Canvas do
  begin
    Font.Name := Listbox1.Items[Index];
    Font.Size := FontSize;
    Height := TextHeight('Wg') + 2; // measure ascenders and descenders
  end;
end;

procedure TForm1.seFontSizeChanged(Sender: TObject; NewValue: Integer);
begin
  FontSize := seFontSize.Value;
  Listbox1.Items := Screen.Fonts;
end;

end.
