unit MainUnit;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, Libc, Xlib;

type
  TMainForm = class(TForm)
    edCommand: TEdit;
    btExecute: TButton;
    Label1: TLabel;
    meOutput: TMemo;
    btQuit: TButton;
    btClear: TButton;
    procedure btClearClick(Sender: TObject);
    procedure btQuitClick(Sender: TObject);
    procedure btExecuteClick(Sender: TObject);
    procedure edCommandKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.xfm}

procedure TMainForm.btClearClick(Sender: TObject);
begin
  meOutput.Clear;
end;

procedure TMainForm.btQuitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMainForm.btExecuteClick(Sender: TObject);
var
  Output: PIOFile;
  Buffer: PChar;
  TempString: string;
  Line: string;
  rb: Integer;
  Cmd: string;

const
  BufferSize: Integer = 1000;

begin
  Cmd := edCommand.Text;
  Output := popen(PChar(Cmd),'r');
  GetMem(Buffer,BufferSize);

  if Assigned(output) then
  begin
    while feof(Output)=0 do
    begin
      rb := Libc.fread(Buffer, 1,BufferSize, Output);
      SetLength(TempString, Length(TempString)+rb);
      memcpy(@TempString[length(TempString)-(rb-1)],Buffer,rb);

      while Pos(#10, TempString) > 0 do
      begin
        Line := copy(TempString,1,pos(#10,TempString)-1);
        meOutput.Lines.Add(Line);
        TempString := copy(TempString,pos(#10,TempString)+1,length(TempString));
      end;
    end;
  end;

  Libc.pclose(output);
  wait(nil);
  FreeMem(Buffer,BufferSize);
end;

procedure TMainForm.edCommandKeyPress(Sender: TObject; var Key: Char);
var
  Output: PIOFile;
  Buffer: PChar;
  TempString: string;
  Line: string;
  rb: Integer;
  Cmd: string;

const
  BufferSize: Integer = 1000;

begin
  if Key = Char(XK_Return xor $FF00) then
  begin
    Cmd := edCommand.Text;
    Output := popen(PChar(Cmd),'r');
    GetMem(Buffer,BufferSize);

    if Assigned(output) then
    begin
      while feof(Output)=0 do
      begin
        rb := Libc.fread(Buffer, 1,BufferSize, Output);
        SetLength(TempString, Length(TempString)+rb);
        memcpy(@TempString[length(TempString)-(rb-1)],Buffer,rb);

        while Pos(#10, TempString) > 0 do
        begin
          Line := copy(TempString,1,pos(#10,TempString)-1);
          meOutput.Lines.Add(Line);
          TempString := copy(TempString,pos(#10,TempString)+1,length(TempString));
        end;
      end;
    end;

    Libc.pclose(output);
    wait(nil);
    FreeMem(Buffer,BufferSize);
  end;
end;


end.
