/*  stdarg.h

    Definitions for accessing parameters in functions that accept
    a variable number of arguments.

	This header does NOT chain back to the standard GNU version.

*/

/*
 *      C/C++ Run Time Library - Version 1.0
 *
 *      Copyright (c) 2000, 2002 by Borland Software Corporation
 *      All Rights Reserved.
 *
 */

/* $Revision: 1.6.8.1 $ */

#ifndef __STDARG_H
#define __STDARG_H

#ifdef __VARARGS_H
#error Cannot include both STDARG.H and VARARGS.H
#endif

#ifndef ___STDDEF_H
#include <_defs.h>
#endif

#ifdef __cplusplus
namespace std {
#endif /* __cplusplus */

typedef void *va_list;

#define __size(x) ((sizeof(x)+sizeof(int)-1) & ~(sizeof(int)-1))

#define va_start(ap, parmN) ((void)((ap) = (va_list)((char *)(&parmN)+__size(parmN))))
#define va_arg(ap, type) (*(type *)(((*(char **)&(ap))+=__size(type))-(__size(type))))
#define va_end(ap)          ((void)0)

#if !defined(__STDC__)
#define _va_ptr             (...)
#endif

#ifdef __cplusplus
} // std
#endif /* __cplusplus */

#endif  /* __STDARG_H */

#if defined(__GLIBC__) && !defined(__GLIBC_BORLAND_VALIST__)
#define __GLIBC_BORLAND_VALIST__
/** Note: we'll provide equivalent symbols for va_list... that bcc can live
	with so that we don't have to chain back to the GNU version of stdarg.h
*/
#define __gnuc_va_list va_list
#define __GNUC_VA_LIST
#endif

#if defined(__cplusplus) && !defined(__USING_CNAME__) && !defined(__STDARG_H_USING_LIST)
#define __STDARG_H_USING_LIST
     using std::va_list;
#endif /* __USING_CNAME__ */

