/*
	string.h

	Borland include file for definitions of string functions.
*/

/*
 *      C/C++ Run Time Library - Version 1.0
 *
 *      Copyright (c) 2002 by Borland Software Corporation
 *      All Rights Reserved.
 *
 */


#ifndef __STRING_H
#define __STRING_H

#ifndef ___DEFS_H
#include <_defs.h>
#endif

#include _STD_HEADER_(string.h)

/* /usr/include/sys/cdef.h contains "#define __inline " which causes _INLFUNC
   to expand to "static " instead of "static __inline" and breaks PCH.
*/
#if defined(__inline)
# undef __inline
#endif

#ifdef __cplusplus
extern "C" {
#endif

_INLFUNC int stricmp(const char * __a, const char * __b)
{
	return strcasecmp(__a, __b);
}
_INLFUNC int strcmpi(const char * __a, const char * __b)
{
	return strcasecmp(__a, __b);
}
#ifdef _BORLAND_SOURCE
_INLFUNC int strnicmp(const char * __a, const char * __b, size_t __maxlen)
{
	return strncasecmp(__a, __b, __maxlen);
}
_INLFUNC int strncmpi(const char * __a, const char * __b, size_t __maxlen)
{
	return strncasecmp(__a, __b, __maxlen);
}
#endif
char * _stpcpy(char * __a, const char * __b);
char * strupr(char * __str);
char * strlwr(char * __str);
char * strrev(char * __str);

int memicmp(const void  *__s1, const void  *__s2, size_t __n);

#ifdef __cplusplus
} /* "C" */
#endif

/* Windows RTL compatibility */
#define strnset(_x,_y,_z) memset(_x,_y,_z)
#define strset(_x,_y) memset(_x,_y,strlen(_x))

#endif  /* __STRING_H */
