// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QFileCtrls.pas' rev: 6.00

#ifndef QFileCtrlsHPP
#define QFileCtrlsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <QMenus.hpp>	// Pascal unit
#include <Libc.hpp>	// Pascal unit
#include <IniFiles.hpp>	// Pascal unit
#include <QImgList.hpp>	// Pascal unit
#include <Qt.hpp>	// Pascal unit
#include <QComCtrls.hpp>	// Pascal unit
#include <QStdCtrls.hpp>	// Pascal unit
#include <QGraphics.hpp>	// Pascal unit
#include <QControls.hpp>	// Pascal unit
#include <QTypes.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qfilectrls
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TIconSize { isSmall, isLarge, isVeryLarge };
#pragma option pop

class DELPHICLASS TFileIconProvider;
class PASCALIMPLEMENTATION TFileIconProvider : public Qimglist::TCustomImageList 
{
	typedef Qimglist::TCustomImageList inherited;
	
private:
	Inifiles::TStringHash* FIndexes;
	TIconSize FIconSize;
	
protected:
	virtual int __fastcall DoGetImageIndex(Qtypes::PFileInfo Info, const AnsiString CurDir = "");
	virtual void __fastcall DrawLinkOverlay(Qgraphics::TCanvas* Canvas, int X, int Y, Qtypes::PFileInfo Info);
	virtual void __fastcall Init(void);
	
public:
	__fastcall virtual TFileIconProvider(TIconSize Size);
	__fastcall virtual ~TFileIconProvider(void);
	HIDESBASE void __fastcall Clear(void);
	__property TIconSize IconSize = {read=FIconSize, nodefault};
	__property Inifiles::TStringHash* Indexes = {read=FIndexes};
public:
	#pragma option push -w-inl
	/* TCustomImageList.CreateSize */ inline __fastcall TFileIconProvider(int AWidth, int AHeight) : Qimglist::TCustomImageList(AWidth, AHeight) { }
	#pragma option pop
	
};


typedef TMetaClass* TFileIconProviderClass;

#pragma option push -b-
enum TSortDirection { sdAscending, sdDescending };
#pragma option pop

#pragma option push -b-
enum TSortMode { smNone, smName, smSize, smType, smDate, smAttributes, smOwner, smGroup };
#pragma option pop

#pragma option push -b-
enum TFileAttr { ftReadOnly, ftHidden, ftSystem, ftVolumeID, ftDirectory, ftArchive, ftNormal };
#pragma option pop

typedef Set<TFileAttr, ftReadOnly, ftNormal>  TFileType;

typedef void __fastcall (__closure *TDirectoryChangeEvent)(System::TObject* Sender, const WideString NewDir);

typedef void __fastcall (__closure *TFileFoundEvent)(System::TObject* Sender, const Sysutils::TSearchRec &AFile, bool &CanAdd);

typedef void __fastcall (__closure *TMaskChangeEvent)(System::TObject* Sender, const WideString NewMask);

__interface IDirectoryClient;
typedef System::DelphiInterface<IDirectoryClient> _di_IDirectoryClient;
__interface  INTERFACE_UUID("{9EF96257-2736-D611-9E48-00B0D006527D}") IDirectoryClient  : public IInterface 
{
	
public:
	virtual bool __fastcall FileFound(const Sysutils::TSearchRec &SearchRec) = 0 ;
	virtual void __fastcall ListEnd(void) = 0 ;
	virtual bool __fastcall ListStart(void) = 0 ;
	virtual void __fastcall DirectoryChanged(const WideString NewDir) = 0 ;
	virtual void __fastcall MaskChange(const WideString NewMask) = 0 ;
};

class DELPHICLASS TDirectory;
class PASCALIMPLEMENTATION TDirectory : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FAutoUpdate;
	bool FIncludeParentDir;
	TSortMode FSortMode;
	TFileType FFileType;
	bool FSuspendEvents;
	bool FDirChanging;
	_di_IDirectoryClient FClient;
	Classes::TList* FFiles;
	WideString FDir;
	int FDirHandle;
	WideString FMask;
	TSortDirection FSortDirection;
	int FUpdateCount;
	void __fastcall ClearList(void);
	void __fastcall RemoveChangeNotification(void);
	void __fastcall SetChangeNotification(const AnsiString Dir);
	void __fastcall SetIncludeParentDir(const bool Value);
	void __fastcall SetAutoUpdate(const bool Value);
	void __fastcall SetSortMode(const TSortMode Value);
	void __fastcall SetSortDirection(const TSortDirection Value);
	WideString __fastcall GetDir(void);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	DYNAMIC void __fastcall DoFileFound(const Sysutils::TSearchRec &SearchRec);
	DYNAMIC void __fastcall DoListEnd(void);
	DYNAMIC bool __fastcall DoListStart(void);
	DYNAMIC void __fastcall DoDirChange(const WideString NewDir);
	DYNAMIC void __fastcall DoMaskChange(const WideString NewMask);
	virtual void __fastcall SetDir(const WideString Value);
	virtual void __fastcall SetMask(const WideString Value);
	virtual void __fastcall SetFileType(const TFileType Value);
	WideString __fastcall UniqueName(const WideString Name);
	
public:
	__fastcall virtual TDirectory(_di_IDirectoryClient AClient);
	__fastcall virtual ~TDirectory(void);
	void __fastcall BeginUpdate(void);
	int __fastcall Count(void);
	Qtypes::PFileInfo __fastcall CreateDirectory(const WideString DirName);
	int __fastcall Delete(const WideString Filename)/* overload */;
	int __fastcall Delete(Qtypes::PFileInfo AFile)/* overload */;
	void __fastcall EndUpdate(void);
	int __fastcall IndexOf(const WideString Filename);
	virtual void __fastcall ListFiles(bool Reread = true);
	void __fastcall Sort(void);
	WideString __fastcall LinkName(int Index);
	Qtypes::PFileInfo __fastcall Files(int Index);
	int __fastcall Rename(const WideString Filename, const WideString NewName)/* overload */;
	int __fastcall Rename(Qtypes::PFileInfo AFile, const WideString NewName)/* overload */;
	WideString __fastcall Caption(int Index);
	int __fastcall Attributes(int Index);
	unsigned __fastcall Size(int Index);
	int __fastcall Date(int Index);
	WideString __fastcall GroupName(int Index);
	WideString __fastcall OwnerName(int Index);
	
__published:
	__property bool AutoUpdate = {read=FAutoUpdate, write=SetAutoUpdate, default=0};
	__property bool IncludeParentDir = {read=FIncludeParentDir, write=SetIncludeParentDir, default=1};
	__property WideString Location = {read=GetDir, write=SetDir};
	__property TFileType FileType = {read=FFileType, write=SetFileType, default=84};
	__property WideString FileMask = {read=FMask, write=SetMask};
	__property TSortMode SortMode = {read=FSortMode, write=SetSortMode, default=1};
	__property TSortDirection SortDirection = {read=FSortDirection, write=SetSortDirection, default=0};
};


#pragma option push -b-
enum TFileListColumn { flcName, flcSize, flcType, flcDate, flcAttributes, flcOwner, flcGroup };
#pragma option pop

class DELPHICLASS TFileListView;
class PASCALIMPLEMENTATION TFileListView : public Qcomctrls::TCustomListView 
{
	typedef Qcomctrls::TCustomListView inherited;
	
private:
	Qcontrols::TCursor FSaveCursor;
	bool FCreatingDir;
	bool FCreatedDir;
	TDirectory* FDirectory;
	TDirectoryChangeEvent FOnDirChange;
	TFileFoundEvent FOnFileFound;
	TFileIconProvider* FIconProvider;
	TMaskChangeEvent FOnMaskChange;
	Qtypes::TFileInfos __fastcall GetSelections(void);
	void __fastcall SetDirectory(const TDirectory* Value);
	void __fastcall ImageChange(void);
	
protected:
	DYNAMIC void __fastcall ColumnClicked(Qcomctrls::TListColumn* Column);
	virtual Qcomctrls::TItemEditor* __fastcall CreateEditor(void);
	DYNAMIC void __fastcall DblClick(void);
	virtual void __fastcall DoGetImageIndex(Qcomctrls::TCustomViewItem* item);
	virtual bool __fastcall DoCustomDrawViewItem(Qcomctrls::TCustomViewItem* Item, Qgraphics::TCanvas* Canvas, const Types::TRect &Rect, Qcomctrls::TCustomDrawState State, Qcomctrls::TCustomDrawStage Stage);
	virtual bool __fastcall DoCustomDrawViewSubItem(Qcomctrls::TCustomViewItem* Item, int SubItem, Qgraphics::TCanvas* Canvas, const Types::TRect &Rect, Qcomctrls::TCustomDrawState State, Qcomctrls::TCustomDrawStage Stage);
	DYNAMIC bool __fastcall DoCustomHint(Qcontrols::THintInfo &HintInfo);
	DYNAMIC void __fastcall DoEdited(Qcomctrls::TCustomViewItem* AItem, WideString &S);
	DYNAMIC void __fastcall DoEditing(Qcomctrls::TCustomViewItem* AItem, bool &AllowEdit);
	virtual void __fastcall ImageListChanged(void);
	virtual void __fastcall InitWidget(void);
	virtual bool __fastcall IsCustomDrawn(void);
	virtual bool __fastcall IsOwnerDrawn(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyPress(char &Key);
	virtual void __fastcall Loaded(void);
	DYNAMIC bool __fastcall NeedKey(int Key, Classes::TShiftState Shift, const WideString KeyText);
	virtual void __fastcall PositionEditor(int &NewLeft, int &NewTop);
	DYNAMIC bool __fastcall FileFound(const Sysutils::TSearchRec &SearchRec);
	DYNAMIC void __fastcall ListEnd(void);
	DYNAMIC bool __fastcall ListStart(void);
	DYNAMIC void __fastcall DirectoryChanged(const WideString NewDir);
	DYNAMIC void __fastcall MaskChange(const WideString NewMask);
	
public:
	__fastcall virtual TFileListView(Classes::TComponent* AOwner)/* overload */;
	__fastcall virtual ~TFileListView(void);
	void __fastcall CreateDirectory(const WideString DefaultName);
	int __fastcall DeleteFile(const WideString Filename);
	void __fastcall GoDown(void);
	void __fastcall GoUp(void);
	HIDESBASE void __fastcall Refresh(void);
	int __fastcall RenameFile(Qcomctrls::TListItem* Item, const WideString NewName);
	__property Canvas ;
	__property Columns ;
	__property Items ;
	__property SelCount ;
	__property Qtypes::TFileInfos Selections = {read=GetSelections};
	
__published:
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property BorderStyle  = {default=6};
	__property Color  = {default=-10};
	__property ColumnClick  = {default=1};
	__property ColumnResize  = {default=1};
	__property Constraints ;
	__property TDirectory* Directory = {read=FDirectory, write=SetDirectory};
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property Font ;
	__property Height  = {default=150};
	__property Hint ;
	__property Images ;
	__property MultiSelect  = {default=0};
	__property ReadOnly  = {default=1};
	__property RowSelect  = {default=0};
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property ViewStyle  = {default=0};
	__property Visible  = {default=1};
	__property Width  = {default=121};
	__property OnChange ;
	__property OnChanging ;
	__property OnClick ;
	__property OnColumnClick ;
	__property OnColumnDragged ;
	__property OnColumnResize ;
	__property OnContextPopup ;
	__property OnCustomDrawItem ;
	__property OnCustomDrawSubItem ;
	__property OnDblClick ;
	__property OnDeletion ;
	__property TDirectoryChangeEvent OnDirectoryChanged = {read=FOnDirChange, write=FOnDirChange};
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDrawItem ;
	__property OnEdited ;
	__property OnEditing ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property TFileFoundEvent OnFileFound = {read=FOnFileFound, write=FOnFileFound};
	__property OnGetImageIndex ;
	__property OnInsert ;
	__property OnItemClick ;
	__property OnItemDoubleClick ;
	__property OnItemEnter ;
	__property OnItemExitViewportEnter ;
	__property OnItemMouseDown ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property TMaskChangeEvent OnMaskChange = {read=FOnMaskChange, write=FOnMaskChange};
	__property OnMouseDown ;
	__property OnMouseEnter ;
	__property OnMouseLeave ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnResize ;
	__property OnSelectItem ;
	__property OnStartDrag ;
	__property OnViewPortMouseDown ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TFileListView(Qt::QWidgetH* ParentWidget) : Qcomctrls::TCustomListView(ParentWidget) { }
	#pragma option pop
	
private:
	void *__IDirectoryClient;	/* Qfilectrls::IDirectoryClient */
	
public:
	operator IDirectoryClient*(void) { return (IDirectoryClient*)&__IDirectoryClient; }
	
};


class DELPHICLASS TFileIconView;
class PASCALIMPLEMENTATION TFileIconView : public Qcomctrls::TCustomIconView 
{
	typedef Qcomctrls::TCustomIconView inherited;
	
private:
	Qcontrols::TCursor FSaveCursor;
	bool FCreatingDir;
	bool FCreatedDir;
	TIconSize FIconSize;
	TDirectory* FDirectory;
	TDirectoryChangeEvent FOnDirChange;
	TFileFoundEvent FOnFileFound;
	TFileIconProvider* FIconProvider;
	TMaskChangeEvent FOnMaskChange;
	Qtypes::TFileInfos __fastcall GetSelections(void);
	void __fastcall SetIconSize(const TIconSize Value);
	void __fastcall ImageChange(void);
	void __fastcall SetDirectory(const TDirectory* Value);
	
protected:
	virtual Qcomctrls::TItemEditor* __fastcall CreateEditor(void);
	DYNAMIC void __fastcall DblClick(void);
	virtual void __fastcall DoGetImageIndex(Qcomctrls::TIconViewItem* item);
	virtual bool __fastcall DoCustomDrawIconItem(Qcomctrls::TIconViewItem* Item, Qgraphics::TCanvas* Canvas, const Types::TRect &Rect, Qcomctrls::TCustomDrawState State, Qcomctrls::TCustomDrawStage Stage);
	DYNAMIC bool __fastcall DoCustomHint(Qcontrols::THintInfo &HintInfo);
	DYNAMIC void __fastcall DoEdited(Qcomctrls::TIconViewItem* AItem, WideString &S);
	DYNAMIC void __fastcall DoEditing(Qcomctrls::TIconViewItem* AItem, bool &AllowEdit);
	virtual void __fastcall DoGetIconSize(Qcomctrls::TIconViewItem* Item, int &Width, int &Height);
	DYNAMIC void __fastcall ImageListChanged(void);
	virtual void __fastcall InitWidget(void);
	virtual bool __fastcall IsCustomDrawn(void);
	virtual bool __fastcall IsOwnerDrawn(void);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyPress(char &Key);
	virtual void __fastcall Loaded(void);
	DYNAMIC bool __fastcall NeedKey(int Key, Classes::TShiftState Shift, const WideString KeyText);
	virtual void __fastcall PositionEditor(int &NewLeft, int &NewTop);
	DYNAMIC bool __fastcall FileFound(const Sysutils::TSearchRec &SearchRec);
	DYNAMIC void __fastcall ListEnd(void);
	DYNAMIC bool __fastcall ListStart(void);
	DYNAMIC void __fastcall DirectoryChanged(const WideString NewDir);
	DYNAMIC void __fastcall MaskChange(const WideString NewMask);
	
public:
	__fastcall virtual TFileIconView(Classes::TComponent* AOwner);
	__fastcall virtual ~TFileIconView(void);
	void __fastcall CreateDirectory(const WideString DefaultName);
	int __fastcall DeleteFile(const WideString Filename);
	void __fastcall GoDown(void);
	void __fastcall GoUp(void);
	HIDESBASE void __fastcall Refresh(void);
	int __fastcall RenameFile(Qcomctrls::TIconViewItem* Item, const WideString NewName);
	__property Items ;
	__property SelCount ;
	__property Selected ;
	__property Qtypes::TFileInfos Selections = {read=GetSelections};
	
__published:
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property BorderStyle  = {default=6};
	__property Color  = {default=-10};
	__property Constraints ;
	__property TDirectory* Directory = {read=FDirectory, write=SetDirectory};
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property Font ;
	__property Height  = {default=97};
	__property Hint ;
	__property IconOptions ;
	__property TIconSize IconSize = {read=FIconSize, write=SetIconSize, default=1};
	__property Images ;
	__property MultiSelect  = {default=0};
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ReadOnly  = {default=1};
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property TextPosition  = {default=0};
	__property Visible  = {default=1};
	__property Width  = {default=121};
	__property OnChange ;
	__property OnChanging ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnCustomDrawItem ;
	__property OnDblClick ;
	__property TDirectoryChangeEvent OnDirectoryChange = {read=FOnDirChange, write=FOnDirChange};
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDrawItem ;
	__property OnEdited ;
	__property OnEditing ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property TFileFoundEvent OnFileFound = {read=FOnFileFound, write=FOnFileFound};
	__property OnGetImageIndex ;
	__property OnItemClicked ;
	__property OnItemDoubleClick ;
	__property OnItemEnter ;
	__property OnItemExitViewportEnter ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property TMaskChangeEvent OnMaskChange = {read=FOnMaskChange, write=FOnMaskChange};
	__property OnMouseDown ;
	__property OnMouseEnter ;
	__property OnMouseLeave ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnResize ;
	__property OnSelectItem ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TFileIconView(Qt::QWidgetH* ParentWidget) : Qcomctrls::TCustomIconView(ParentWidget) { }
	#pragma option pop
	
private:
	void *__IDirectoryClient;	/* Qfilectrls::IDirectoryClient */
	
public:
	operator IDirectoryClient*(void) { return (IDirectoryClient*)&__IDirectoryClient; }
	
};


class DELPHICLASS TDirectoryNode;
class PASCALIMPLEMENTATION TDirectoryNode : public Qcomctrls::TTreeNode 
{
	typedef Qcomctrls::TTreeNode inherited;
	
private:
	_di_IDirectoryClient FDirClient;
	TDirectory* FDirectory;
	
protected:
	virtual void __fastcall UpdateImages(void);
	
public:
	__fastcall virtual TDirectoryNode(Qcomctrls::TCustomViewItems* AOwner, Qcomctrls::TCustomViewItem* AParent, Qcomctrls::TCustomViewItem* After);
	__fastcall virtual ~TDirectoryNode(void);
	void __fastcall Populate(void);
	virtual bool __fastcall FileFound(const Sysutils::TSearchRec &SearchRec);
	virtual void __fastcall ListEnd(void);
	virtual bool __fastcall ListStart(void);
	virtual void __fastcall DirectoryChanged(const WideString NewDir);
	virtual void __fastcall MaskChange(const WideString NewMask);
};


class DELPHICLASS EDirectoryError;
class PASCALIMPLEMENTATION EDirectoryError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall EDirectoryError(const AnsiString Msg) : Sysutils::Exception(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall EDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall EDirectoryError(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall EDirectoryError(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall EDirectoryError(const AnsiString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall EDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall EDirectoryError(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall EDirectoryError(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~EDirectoryError(void) { }
	#pragma option pop
	
};


class DELPHICLASS ESetDirectoryError;
class PASCALIMPLEMENTATION ESetDirectoryError : public EDirectoryError 
{
	typedef EDirectoryError inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ESetDirectoryError(const AnsiString Msg) : EDirectoryError(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ESetDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : EDirectoryError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ESetDirectoryError(int Ident)/* overload */ : EDirectoryError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ESetDirectoryError(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : EDirectoryError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ESetDirectoryError(const AnsiString Msg, int AHelpContext) : EDirectoryError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ESetDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : EDirectoryError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ESetDirectoryError(int Ident, int AHelpContext)/* overload */ : EDirectoryError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ESetDirectoryError(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : EDirectoryError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ESetDirectoryError(void) { }
	#pragma option pop
	
};


class DELPHICLASS ECreateDirectoryError;
class PASCALIMPLEMENTATION ECreateDirectoryError : public EDirectoryError 
{
	typedef EDirectoryError inherited;
	
public:
	#pragma option push -w-inl
	/* Exception.Create */ inline __fastcall ECreateDirectoryError(const AnsiString Msg) : EDirectoryError(Msg) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmt */ inline __fastcall ECreateDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size) : EDirectoryError(Msg, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateRes */ inline __fastcall ECreateDirectoryError(int Ident)/* overload */ : EDirectoryError(Ident) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmt */ inline __fastcall ECreateDirectoryError(int Ident, const System::TVarRec * Args, const int Args_Size)/* overload */ : EDirectoryError(Ident, Args, Args_Size) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateHelp */ inline __fastcall ECreateDirectoryError(const AnsiString Msg, int AHelpContext) : EDirectoryError(Msg, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateFmtHelp */ inline __fastcall ECreateDirectoryError(const AnsiString Msg, const System::TVarRec * Args, const int Args_Size, int AHelpContext) : EDirectoryError(Msg, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResHelp */ inline __fastcall ECreateDirectoryError(int Ident, int AHelpContext)/* overload */ : EDirectoryError(Ident, AHelpContext) { }
	#pragma option pop
	#pragma option push -w-inl
	/* Exception.CreateResFmtHelp */ inline __fastcall ECreateDirectoryError(System::PResStringRec ResStringRec, const System::TVarRec * Args, const int Args_Size, int AHelpContext)/* overload */ : EDirectoryError(ResStringRec, Args, Args_Size, AHelpContext) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~ECreateDirectoryError(void) { }
	#pragma option pop
	
};


class DELPHICLASS TDirectoryTreeView;
class PASCALIMPLEMENTATION TDirectoryTreeView : public Qcomctrls::TCustomTreeView 
{
	typedef Qcomctrls::TCustomTreeView inherited;
	
private:
	bool FChanging;
	TFileType FFileType;
	TIconSize FIconSize;
	WideString FRootDir;
	WideString FDir;
	TFileIconProvider* FIconProvider;
	Qt::QPixmapH* FakePix;
	void __fastcall SetDir(const WideString Value);
	AnsiString __fastcall GetAbsolutePath(Qcomctrls::TTreeNode* Node);
	void __fastcall SetRootDir(const WideString Value);
	WideString __fastcall GetDir(void);
	void __fastcall SetFileType(const TFileType Value);
	
protected:
	void __fastcall AddDirectories(Qcomctrls::TTreeNode* Node);
	DYNAMIC bool __fastcall CanExpand(Qcomctrls::TTreeNode* Node);
	DYNAMIC void __fastcall Change(Qcomctrls::TTreeNode* Node);
	virtual bool __fastcall DoCustomDrawViewItem(Qcomctrls::TCustomViewItem* Item, Qgraphics::TCanvas* Canvas, const Types::TRect &Rect, Qcomctrls::TCustomDrawState State, Qcomctrls::TCustomDrawStage Stage);
	DYNAMIC bool __fastcall DoCustomHint(Qcontrols::THintInfo &HintInfo);
	virtual void __fastcall DoGetImageIndex(Qcomctrls::TCustomViewItem* item);
	virtual void __fastcall ImageListChanged(void);
	virtual void __fastcall InitWidget(void);
	virtual bool __fastcall IsCustomDrawn(void);
	virtual bool __fastcall IsOwnerDrawn(void);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TDirectoryTreeView(Classes::TComponent* AOwner)/* overload */;
	__fastcall virtual ~TDirectoryTreeView(void);
	
__published:
	__property WideString RootDirectory = {read=FRootDir, write=SetRootDir};
	__property WideString Directory = {read=GetDir, write=SetDir};
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property BorderStyle  = {default=6};
	__property Color  = {default=-10};
	__property Constraints ;
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property TFileType FileType = {read=FFileType, write=SetFileType, default=20};
	__property Font ;
	__property Height  = {default=97};
	__property Hint ;
	__property Images ;
	__property ItemMargin  = {default=1};
	__property Indent  = {default=20};
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ReadOnly  = {default=1};
	__property ShowButtons  = {default=1};
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Visible  = {default=1};
	__property Width  = {default=121};
	__property OnChange ;
	__property OnChanging ;
	__property OnClick ;
	__property OnCollapsed ;
	__property OnCollapsing ;
	__property OnContextPopup ;
	__property OnCustomDrawBranch ;
	__property OnCustomDrawItem ;
	__property OnDblClick ;
	__property OnDeletion ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEdited ;
	__property OnEditing ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnExpanding ;
	__property OnExpanded ;
	__property OnGetImageIndex ;
	__property OnGetSelectedIndex ;
	__property OnInsert ;
	__property OnItemClick ;
	__property OnItemDoubleClick ;
	__property OnItemEnter ;
	__property OnItemExitViewportEnter ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseEnter ;
	__property OnMouseLeave ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
	__property OnItemMouseDown ;
	__property OnViewPortMouseDown ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TDirectoryTreeView(Qt::QWidgetH* ParentWidget) : Qcomctrls::TCustomTreeView(ParentWidget) { }
	#pragma option pop
	
};


class DELPHICLASS TFilterComboBox;
class PASCALIMPLEMENTATION TFilterComboBox : public Qstdctrls::TCustomComboBox 
{
	typedef Qstdctrls::TCustomComboBox inherited;
	
private:
	AnsiString FFilter;
	Classes::TStringList* MaskList;
	bool FEditable;
	bool __fastcall IsFilterStored(void);
	WideString __fastcall GetMask(void);
	void __fastcall SetFilter(const AnsiString NewFilter);
	void __fastcall SetEditable(const bool Value);
	
protected:
	void __fastcall BuildList(void);
	virtual void __fastcall InitWidget(void);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TFilterComboBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TFilterComboBox(void);
	void __fastcall ListMasks(Classes::TStrings* List);
	__property WideString Mask = {read=GetMask};
	__property Text ;
	
__published:
	__property Anchors  = {default=3};
	__property AutoComplete  = {default=0};
	__property Color  = {default=-10};
	__property Constraints ;
	__property DragMode  = {default=0};
	__property bool Editable = {read=FEditable, write=SetEditable, default=0};
	__property Enabled  = {default=1};
	__property AnsiString Filter = {read=FFilter, write=SetFilter, stored=IsFilterStored};
	__property Font ;
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Visible  = {default=1};
	__property OnChange ;
	__property OnClick ;
	__property OnCloseUp ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDropDown ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnHighlighted ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property OnSelect ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TFilterComboBox(Qt::QWidgetH* ParentWidget) : Qstdctrls::TCustomComboBox(ParentWidget) { }
	#pragma option pop
	
};


class DELPHICLASS TFileHistoryComboBox;
class PASCALIMPLEMENTATION TFileHistoryComboBox : public Qstdctrls::TCustomComboBox 
{
	typedef Qstdctrls::TCustomComboBox inherited;
	
private:
	bool FChanging;
	Classes::TStrings* FHistList;
	int FHistIndex;
	TFileIconProvider* FIconProvider;
	Qtypes::PFileInfo __fastcall GetFile(int Index);
	void __fastcall UpdateItems(void);
	HIDESBASE MESSAGE void __fastcall CMKeyDown(Qcontrols::TCMKeyDown &Msg);
	
protected:
	DYNAMIC void __fastcall Click(void);
	void __fastcall RemoveItem(int Index);
	virtual bool __fastcall DrawItem(int Index, const Types::TRect &Rect, Qstdctrls::TOwnerDrawState State);
	virtual void __fastcall InitWidget(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall SaveWidgetState(void);
	virtual void __fastcall RestoreWidgetState(void);
	
public:
	__fastcall virtual TFileHistoryComboBox(Classes::TComponent* AOwner);
	__fastcall virtual ~TFileHistoryComboBox(void);
	bool __fastcall Add(const AnsiString Filename);
	bool __fastcall CanGoBack(void);
	bool __fastcall CanGoForward(void);
	HIDESBASE void __fastcall Clear(void);
	void __fastcall GoBack(void);
	void __fastcall GoForward(void);
	__property Qtypes::PFileInfo Files[int Index] = {read=GetFile};
	__property ItemIndex  = {default=-1};
	
__published:
	__property Anchors  = {default=3};
	__property AutoComplete  = {default=0};
	__property Color  = {default=-10};
	__property Constraints ;
	__property DragMode  = {default=0};
	__property DropDownCount  = {default=8};
	__property Enabled  = {default=1};
	__property Font ;
	__property ItemHeight  = {default=16};
	__property MaxItems  = {default=-1};
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint  = {default=0};
	__property Sorted  = {default=0};
	__property Style  = {default=0};
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Visible  = {default=1};
	__property OnChange ;
	__property OnClick ;
	__property OnCloseUp ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnDropDown ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnHighlighted ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property OnSelect ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TFileHistoryComboBox(Qt::QWidgetH* ParentWidget) : Qstdctrls::TCustomComboBox(ParentWidget) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TResizeType { rtNone, rtHorz, rtVert, rtBoth };
#pragma option pop

class DELPHICLASS TPopupListBox;
class PASCALIMPLEMENTATION TPopupListBox : public Qstdctrls::TCustomListBox 
{
	typedef Qstdctrls::TCustomListBox inherited;
	
private:
	TResizeType FResizeType;
	bool FResized;
	bool FDroppedUp;
	TResizeType __fastcall GetResizeType(const Types::TPoint &P);
	
protected:
	virtual void __fastcall InitWidget(void);
	virtual bool __fastcall EventFilter(Qt::QObjectH* Sender, Qt::QEventH* Event);
	DYNAMIC void __fastcall MouseDown(Qcontrols::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Qcontrols::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual int __fastcall WidgetFlags(void);
	
public:
	__fastcall TPopupListBox(Qt::QWidgetH* ParentWidget);
public:
	#pragma option push -w-inl
	/* TCustomListBox.Create */ inline __fastcall virtual TPopupListBox(Classes::TComponent* AOwner) : Qstdctrls::TCustomListBox(AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomListBox.Destroy */ inline __fastcall virtual ~TPopupListBox(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TFileEditMode { emDropDownList, emAutoComplete };
#pragma option pop

class DELPHICLASS TFileEdit;
class PASCALIMPLEMENTATION TFileEdit : public Qstdctrls::TCustomEdit 
{
	typedef Qstdctrls::TCustomEdit inherited;
	
private:
	bool FDroppedDown;
	TFileEditMode FEditMode;
	TDirectory* FDirectory;
	WideString FListedDir;
	WideString FCurrentDir;
	int FMatchCount;
	int FDropDownCount;
	TPopupListBox* FListBox;
	WideString FOriginalText;
	WideString FPrefix;
	TDirectoryChangeEvent FOnDirChange;
	TFileFoundEvent FOnFileFound;
	TMaskChangeEvent FOnMaskChange;
	bool __fastcall CheckNewDirectory(const WideString Text);
	HIDESBASE MESSAGE void __fastcall CMKeyDown(Qcontrols::TCMKeyDown &Msg);
	void __fastcall ListMouseUp(System::TObject* Sender, Qcontrols::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	void __fastcall ListMouseMove(System::TObject* Sender, Classes::TShiftState Shift, int X, int Y);
	WideString __fastcall MatchText(void);
	int __fastcall PartialMatch(const WideString Str);
	void __fastcall ResizeListBox(int ItemCount);
	void __fastcall SetListIndex(int Value);
	WideString __fastcall GetCurrentDir(void);
	void __fastcall SetDirectory(const TDirectory* Value);
	
protected:
	void __fastcall CloseUp(void);
	void __fastcall DropDown(void);
	virtual void __fastcall InitWidget(void);
	DYNAMIC void __fastcall KeyPress(char &Key);
	DYNAMIC void __fastcall KeyUp(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall MouseDown(Qcontrols::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall PopulateList(const WideString Directory, WideString Prefix = L"");
	DYNAMIC void __fastcall ReturnPressed(bool &Suppress);
	DYNAMIC bool __fastcall FileFound(const Sysutils::TSearchRec &SearchRec);
	virtual void __fastcall Loaded(void);
	DYNAMIC void __fastcall ListEnd(void);
	DYNAMIC bool __fastcall ListStart(void);
	DYNAMIC void __fastcall DirectoryChanged(const WideString NewDir);
	DYNAMIC void __fastcall MaskChange(const WideString NewMask);
	
public:
	__fastcall virtual TFileEdit(Classes::TComponent* AOwner);
	__fastcall virtual ~TFileEdit(void);
	__property WideString CurrentDir = {read=GetCurrentDir};
	__property bool DroppedDown = {read=FDroppedDown, nodefault};
	
__published:
	__property Anchors  = {default=3};
	__property AutoSize  = {default=1};
	__property BorderStyle  = {default=1};
	__property Color  = {default=-10};
	__property Constraints ;
	__property TDirectory* Directory = {read=FDirectory, write=SetDirectory};
	__property DragMode  = {default=0};
	__property int DropDownCount = {read=FDropDownCount, write=FDropDownCount, default=10};
	__property TFileEditMode EditMode = {read=FEditMode, write=FEditMode, default=0};
	__property Enabled  = {default=1};
	__property Font ;
	__property MaxLength  = {default=-1};
	__property ParentColor  = {default=0};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint  = {default=0};
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Text ;
	__property Visible  = {default=1};
	__property OnChange ;
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property TDirectoryChangeEvent OnDirectoryChange = {read=FOnDirChange, write=FOnDirChange};
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property TFileFoundEvent OnFileFound = {read=FOnFileFound, write=FOnFileFound};
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyString ;
	__property OnKeyUp ;
	__property TMaskChangeEvent OnMaskChange = {read=FOnMaskChange, write=FOnMaskChange};
	__property OnMouseDown ;
	__property OnMouseEnter ;
	__property OnMouseLeave ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnReturnPressed ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWidgetControl.CreateParented */ inline __fastcall TFileEdit(Qt::QWidgetH* ParentWidget) : Qstdctrls::TCustomEdit(ParentWidget) { }
	#pragma option pop
	
private:
	void *__IDirectoryClient;	/* Qfilectrls::IDirectoryClient */
	
public:
	operator IDirectoryClient*(void) { return (IDirectoryClient*)&__IDirectoryClient; }
	
};


typedef AnsiString __fastcall (*TGetFileTypeProc)(Qtypes::PFileInfo FileInfo);

//-- var, const, procedure ---------------------------------------------------
static const Shortint RESULT_OK = 0x0;
static const Shortint RESULT_ACCESS_DENIED = 0xffffffff;
static const Shortint RESULT_DIR_NOT_EMPTY = 0xfffffffe;
static const Shortint RESULT_FILE_NOT_FOUND = 0xfffffffd;
static const Shortint RESULT_ALREADY_EXISTS = 0xfffffffc;
extern PACKAGE TGetFileTypeProc GetFileTypeProc;
extern PACKAGE TMetaClass* FileIconProviderClass;
static const char ThisDir = '\x2e';
#define UpDir ".."
static const char AllMask = '\x2a';
extern PACKAGE int __fastcall IconPixels(const TIconSize Size);
extern PACKAGE TFileIconProvider* __fastcall IconProvider16(void);
extern PACKAGE TFileIconProvider* __fastcall IconProvider32(void);
extern PACKAGE TFileIconProvider* __fastcall IconProvider48(void);
extern PACKAGE Qtypes::PFileInfo __fastcall AllocFileInfo(const Sysutils::TSearchRec &SearchRec);
extern PACKAGE bool __fastcall IsRelativePath(AnsiString Filename);
extern PACKAGE AnsiString __fastcall ExpandDirectoryName(AnsiString Directory);
extern PACKAGE bool __fastcall HasSubDirs(const WideString Directory, bool IncludeHidden = false);
extern PACKAGE AnsiString __fastcall GetFileType(Qtypes::PFileInfo Info);

}	/* namespace Qfilectrls */
using namespace Qfilectrls;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QFileCtrls
