// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Types.pas' rev: 6.00

#ifndef TypesHPP
#define TypesHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------
namespace Types
{
  struct TPoint : public POINT
  {
    TPoint() {}
    TPoint(int _x, int _y) { x=_x; y=_y; }
    TPoint(POINT& pt)
    {
      x = pt.x;
      y = pt.y;
    }
  };
 
  typedef TPoint tagPoint;
 
  struct TRect : public RECT
  {
    TRect() {}
    TRect(const TPoint& TL, const TPoint& BR) { left=TL.x; top=TL.y; right=BR.x; bottom=BR.y; }
    TRect(int l, int t, int r, int b)         { left=l;    top=t;    right=r;    bottom=b;    }
    TRect(RECT& r)
    {
      left    = r.left;
      top     = r.top;
      right   = r.right;
      bottom  = r.bottom;
    }
    int Width () const { return right  - left; }
    int Height() const { return bottom - top ; }
    bool operator ==(const TRect& rc) const 
    {
       return left ==  rc.left  && top==rc.top &&     
              right == rc.right && bottom==rc.bottom; 
    }
    bool operator !=(const TRect& rc) const 
    {  return !(rc==*this); }
 
       __property LONG Left    = { read=left,   write=left   }; 
       __property LONG Top     = { read=top,       write=top }; 
       __property LONG Right   = { read=right,  write=right  }; 
       __property LONG Bottom  = { read=bottom, write=bottom }; 
  };
} /* namespace Types */ ;

namespace Types
{
//-- type declarations -------------------------------------------------------
typedef TPoint *PPoint;

typedef TRect *PRect;

typedef tagSIZE *PSize;

typedef tagSIZE  TSize;

struct TSmallPoint;
typedef TSmallPoint *PSmallPoint;

#pragma pack(push, 1)
struct TSmallPoint
{
	short x;
	short y;
} ;
#pragma pack(pop)

typedef void *PDisplay;

typedef void *PEvent;

#pragma pack(push, 1)
struct TXrmOptionDescRec
{
	
} ;
#pragma pack(pop)

typedef TXrmOptionDescRec  XrmOptionDescRec;

typedef TXrmOptionDescRec *PXrmOptionDescRec;

typedef void *Widget;

typedef void *WidgetClass;

typedef void *ArgList;

typedef void *Region;

typedef WideChar TOleChar;

typedef WideChar *POleStr;

typedef WideChar * *PPOleStr;

typedef GUID *PCLSID;

typedef GUID  TCLSID;

#pragma pack(push, 1)
struct _FILETIME
{
	unsigned dwLowDateTime;
	unsigned dwHighDateTime;
} ;
#pragma pack(pop)

typedef _FILETIME *PFileTime;

typedef _FILETIME  TFileTime;

typedef _FILETIME  FILETIME;

struct tagSTATSTG;
typedef tagSTATSTG *PStatStg;

#pragma pack(push, 1)
struct tagSTATSTG
{
	WideChar *pwcsName;
	int dwType;
	__int64 cbSize;
	_FILETIME mtime;
	_FILETIME ctime;
	_FILETIME atime;
	int grfMode;
	int grfLocksSupported;
	GUID clsid;
	int grfStateBits;
	int reserved;
} ;
#pragma pack(pop)

typedef tagSTATSTG  TStatStg;

typedef tagSTATSTG  STATSTG;

__interface IClassFactory;
typedef System::DelphiInterface<IClassFactory> _di_IClassFactory;
__interface  INTERFACE_UUID("{00000001-0000-0000-C000-000000000046}") IClassFactory  : public IInterface 
{
	
public:
	virtual HRESULT __stdcall CreateInstance(const System::_di_IInterface unkOuter, const GUID &iid, /* out */ void *obj) = 0 ;
	virtual HRESULT __stdcall LockServer(BOOL fLock) = 0 ;
};

__interface ISequentialStream;
typedef System::DelphiInterface<ISequentialStream> _di_ISequentialStream;
__interface  INTERFACE_UUID("{0C733A30-2A1C-11CE-ADE5-00AA0044773D}") ISequentialStream  : public IInterface 
{
	
public:
	virtual HRESULT __stdcall Read(void * pv, int cb, PLongint pcbRead) = 0 ;
	virtual HRESULT __stdcall Write(void * pv, int cb, PLongint pcbWritten) = 0 ;
};

__interface IStream;
typedef System::DelphiInterface<IStream> _di_IStream;
__interface  INTERFACE_UUID("{0000000C-0000-0000-C000-000000000046}") IStream  : public ISequentialStream 
{
	
public:
	virtual HRESULT __stdcall Seek(__int64 dlibMove, int dwOrigin, /* out */ __int64 &libNewPosition) = 0 ;
	virtual HRESULT __stdcall SetSize(__int64 libNewSize) = 0 ;
	virtual HRESULT __stdcall CopyTo(_di_IStream stm, __int64 cb, /* out */ __int64 &cbRead, /* out */ __int64 &cbWritten) = 0 ;
	virtual HRESULT __stdcall Commit(int grfCommitFlags) = 0 ;
	virtual HRESULT __stdcall Revert(void) = 0 ;
	virtual HRESULT __stdcall LockRegion(__int64 libOffset, __int64 cb, int dwLockType) = 0 ;
	virtual HRESULT __stdcall UnlockRegion(__int64 libOffset, __int64 cb, int dwLockType) = 0 ;
	virtual HRESULT __stdcall Stat(/* out */ tagSTATSTG &statstg, int grfStatFlag) = 0 ;
	virtual HRESULT __stdcall Clone(/* out */ _di_IStream &stm) = 0 ;
};

typedef Shortint TValueRelationship;

//-- var, const, procedure ---------------------------------------------------
static const Shortint STGTY_STORAGE = 0x1;
static const Shortint STGTY_STREAM = 0x2;
static const Shortint STGTY_LOCKBYTES = 0x3;
static const Shortint STGTY_PROPERTY = 0x4;
static const Shortint STREAM_SEEK_SET = 0x0;
static const Shortint STREAM_SEEK_CUR = 0x1;
static const Shortint STREAM_SEEK_END = 0x2;
static const Shortint LOCK_WRITE = 0x1;
static const Shortint LOCK_EXCLUSIVE = 0x2;
static const Shortint LOCK_ONLYONCE = 0x4;
static const HRESULT E_FAIL = 0x80004005;
static const HRESULT STG_E_INVALIDFUNCTION = 0x80030001;
static const HRESULT STG_E_FILENOTFOUND = 0x80030002;
static const HRESULT STG_E_PATHNOTFOUND = 0x80030003;
static const HRESULT STG_E_TOOMANYOPENFILES = 0x80030004;
static const HRESULT STG_E_ACCESSDENIED = 0x80030005;
static const HRESULT STG_E_INVALIDHANDLE = 0x80030006;
static const HRESULT STG_E_INSUFFICIENTMEMORY = 0x80030008;
static const HRESULT STG_E_INVALIDPOINTER = 0x80030009;
static const HRESULT STG_E_NOMOREFILES = 0x80030012;
static const HRESULT STG_E_DISKISWRITEPROTECTED = 0x80030013;
static const HRESULT STG_E_SEEKERROR = 0x80030019;
static const HRESULT STG_E_WRITEFAULT = 0x8003001d;
static const HRESULT STG_E_READFAULT = 0x8003001e;
static const HRESULT STG_E_SHAREVIOLATION = 0x80030020;
static const HRESULT STG_E_LOCKVIOLATION = 0x80030021;
static const HRESULT STG_E_FILEALREADYEXISTS = 0x80030050;
static const HRESULT STG_E_INVALIDPARAMETER = 0x80030057;
static const HRESULT STG_E_MEDIUMFULL = 0x80030070;
static const HRESULT STG_E_PROPSETMISMATCHED = 0x800300f0;
static const HRESULT STG_E_ABNORMALAPIEXIT = 0x800300fa;
static const HRESULT STG_E_INVALIDHEADER = 0x800300fb;
static const HRESULT STG_E_INVALIDNAME = 0x800300fc;
static const HRESULT STG_E_UNKNOWN = 0x800300fd;
static const HRESULT STG_E_UNIMPLEMENTEDFUNCTION = 0x800300fe;
static const HRESULT STG_E_INVALIDFLAG = 0x800300ff;
static const HRESULT STG_E_INUSE = 0x80030100;
static const HRESULT STG_E_NOTCURRENT = 0x80030101;
static const HRESULT STG_E_REVERTED = 0x80030102;
static const HRESULT STG_E_CANTSAVE = 0x80030103;
static const HRESULT STG_E_OLDFORMAT = 0x80030104;
static const HRESULT STG_E_OLDDLL = 0x80030105;
static const HRESULT STG_E_SHAREREQUIRED = 0x80030106;
static const HRESULT STG_E_NOTFILEBASEDSTORAGE = 0x80030107;
static const HRESULT STG_E_EXTANTMARSHALLINGS = 0x80030108;
static const HRESULT STG_E_DOCFILECORRUPT = 0x80030109;
static const HRESULT STG_E_BADBASEADDRESS = 0x80030110;
static const HRESULT STG_E_INCOMPLETE = 0x80030201;
static const HRESULT STG_E_TERMINATED = 0x80030202;
static const int STG_S_CONVERTED = 0x30200;
static const int STG_S_BLOCK = 0x30201;
static const int STG_S_RETRYNOW = 0x30202;
static const int STG_S_MONITORING = 0x30203;
extern PACKAGE GUID GUID_NULL;
static const Shortint LessThanValue = 0xffffffff;
static const Shortint EqualsValue = 0x0;
static const Shortint GreaterThanValue = 0x1;
extern PACKAGE bool __fastcall EqualRect(const TRect &R1, const TRect &R2);
extern PACKAGE bool __fastcall PtInRect(const TRect &Rect, const TPoint &P);
extern PACKAGE bool __fastcall IntersectRect(/* out */ TRect &Rect, const TRect &R1, const TRect &R2);
extern PACKAGE bool __fastcall UnionRect(/* out */ TRect &Rect, const TRect &R1, const TRect &R2);
extern PACKAGE bool __fastcall IsRectEmpty(const TRect &Rect);
extern PACKAGE bool __fastcall OffsetRect(TRect &Rect, int DX, int DY);
extern PACKAGE TPoint __fastcall CenterPoint(const TRect &Rect);

}	/* namespace Types */
using namespace Types;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Types
