#!/bin/bash

# BEGIN STRING TABLE
# These constants should be translated for international use
#
PALETTE_DBEXPRESS="dbExpress"
FORMT_EMPDATA_NAME="Employee Data"
FORMT_EMPDATA_PAGE="Data Modules"
FORMT_EMPDATA_DESCRIP="Data module that contains Employee Database."
PALETTE_DATA_MODULES="Data Modules"

# END STRING TABLE

# make symlink for dbx package
ln -sf $SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9.0 $SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9
ln -sf $SETUP_INSTALLPATH/bin/dbxres.en.1.0 $SETUP_INSTALLPATH/bin/dbxres.en.1

# move config files
if test -d ~/.borland; then
    if test -e ~/.borland/dbxdrivers; then
	rm $SETUP_INSTALLPATH/bin/dbxdrivers
    else
	mv $SETUP_INSTALLPATH/bin/dbxdrivers ~/.borland/
    fi
    if test -e ~/.borland/dbxconnections; then
	rm $SETUP_INSTALLPATH/bin/dbxconnections
    else
	mv $SETUP_INSTALLPATH/bin/dbxconnections ~/.borland/
    fi
else
    mkdir ~/.borland
    mv $SETUP_INSTALLPATH/bin/dbxdrivers ~/.borland/
    mv $SETUP_INSTALLPATH/bin/dbxconnections ~/.borland/
fi

# if root, then copy the files to /usr/local/etc as well
userid=`id -u`
if [ "$userid" = "0" ]; then
    if [ ! -d /usr/local ]; then
	mkdir /usr/local
    fi
    if [ ! -d /usr/local/etc ]; then
	mkdir /usr/local/etc
    fi
    if [ ! -e /usr/local/etc/dbxdrivers.conf ]; then
	cp ~/.borland/dbxdrivers /usr/local/etc/dbxdrivers.conf
    fi
    if [ ! -e /usr/local/etc/dbxconnections.conf ]; then
	cp ~/.borland/dbxconnections /usr/local/etc/dbxconnections.conf
    fi
fi

# update the delphi.dro file
cat <<EOF > ~/.borland/.tmp$$

[$SETUP_INSTALLPATH/objrepos/clxemployee]
Type=FormTemplate
Name=$FORMT_EMPDATA_NAME
Page=$FORMT_EMPDATA_PAGE
Icon=$SETUP_INSTALLPATH/objrepos/clxemployee.ico
Description=$FORMT_EMPDATA_DESCRIP
Author=Borland
DefaultMainForm=0
DefaultNewForm=0
Ancestor=
Designer=xfm

EOF
cat ~/.borland/.tmp$$ >> ~/.borland/delphi69dro
cat ~/.borland/.tmp$$ >> ~/.borland/bcb69dro
rm -f ~/.borland/.tmp$$

if [ "$userid" = "0" -a -e /usr/local/etc/delphi69dro.conf ]; then
cat <<EOF > ~/.borland/.tmp$$

[$SETUP_INSTALLPATH/objrepos/clxemployee]
Type=FormTemplate
Name=$FORMT_EMPDATA_NAME
Page=$FORMT_EMPDATA_PAGE
Icon=$SETUP_INSTALLPATH/objrepos/clxemployee.ico
Description=$FORMT_EMPDATA_DESCRIP
Author=Borland
DefaultMainForm=0
DefaultNewForm=0
Ancestor=
Designer=xfm

EOF
cat ~/.borland/.tmp$$ >> /usr/local/etc/delphi69dro.conf
cat ~/.borland/.tmp$$ >> /usr/local/etc/bcb69dro.conf
rm -f ~/.borland/.tmp$$
fi

# add it to the IDE
if [ -e setup.data/inimerge ]; then
    inimerge="$HOME/.inimerge$$"
    cp "setup.data/inimerge" "$inimerge"
    chmod 700 "$inimerge"
    . $SETUP_INSTALLPATH/bin/kylixpath $SETUP_INSTALLPATH >/dev/null
    `$inimerge "$HOME/.borland/delphi69rc" "Known Packages" "$SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9" "Borland dbExpress Package"`
    `$inimerge "$HOME/.borland/bcb69rc" "Known Packages" "$SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9" "Borland dbExpress Package"`
    `$inimerge "$HOME/.borland/delphi69rc" "Palette" "$PALETTE_DBEXPRESS" " "`
    `$inimerge "$HOME/.borland/bcb69rc" "Palette" "$PALETTE_DBEXPRESS" " "`
    `$inimerge "$HOME/.borland/delphi69rc" "Palette Defaults" "$PALETTE_DBEXPRESS" " "`
    `$inimerge "$HOME/.borland/bcb69rc" "Palette Defaults" "$PALETTE_DBEXPRESS" " "`

    `$inimerge "$HOME/.borland/delphi69dro" "Repository Pages" "$PALETTE_DATA_MODULES" " "`
    `$inimerge "$HOME/.borland/bcb69dro" "Repository Pages" "$PALETTE_DATA_MODULES" " "`

    userid=`id -u`
    if [ "$userid" = "0" -a -e /usr/local/etc/delphi69rc.conf ]; then
	`$inimerge "/usr/local/etc/delphi69rc.conf" "Known Packages" "$SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9" "Borland dbExpress Package"`
	`$inimerge "/usr/local/etc/bcb69rc.conf" "Known Packages" "$SETUP_INSTALLPATH/bin/dcldbdbx.so.6.9" "Borland dbExpress Package"`
	`$inimerge "/usr/local/etc/delphi69rc.conf" "Palette" "$PALETTE_DBEXPRESS" " "`
	`$inimerge "/usr/local/etc/bcb69rc.conf" "Palette" "$PALETTE_DBEXPRESS" " "`
	`$inimerge "/usr/local/etc/delphi69rc.conf" "Palette Defaults" "$PALETTE_DBEXPRESS" " "`
	`$inimerge "/usr/local/etc/bcb69rc.conf" "Palette Defaults" "$PALETTE_DBEXPRESS" " "`
    fi
    if [ "$userid" = "0" -a -e /usr/local/etc/delphi69dro.conf ]; then
	`$inimerge "/usr/local/etc/delphi69dro.conf" "Repository Pages" "$PALETTE_DATA_MODULES" " "`
	`$inimerge "/usr/local/etc/bcb69dro.conf" "Repository Pages" "$PALETTE_DATA_MODULES" " "`
    fi
    rm -f $inimerge
fi
