{ *************************************************************************** }
{                                                                             }
{ Delphi and Kylix Cross-Platform Visual Component Library                    }
{                                                                             }
{ Copyright (c) 2000-2002 Borland Software Corporation                        }
{                                                                             }
{ This file may be distributed and/or modified under the terms of the GNU     }
{ General Public License (GPL) version 2 as published by the Free Software    }
{ Foundation and appearing at http://www.borland.com/kylix/gpl.html.          }
{                                                                             }
{ Licensees holding a valid Borland No-Nonsense License for this Software may }
{ use this file in accordance with such license, which appears in the file    }
{ license.txt that came with this Software.                                   }
{                                                                             }
{ *************************************************************************** }


unit DirSel;

{R-,T-,H+,X+}

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QExtCtrls, QFileCtrls;

type
  TDirSelDlg = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Panel3: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    DTV: TDirectoryTreeView;
  private
  public
    function GetDirectory(const ACaption, Root: WideString;
      var Directory: WideString; ShowHidden: Boolean = False): Boolean;
  end;

implementation

{$R *.xfm}

{ TDirSelDlg }

function TDirSelDlg.GetDirectory(const ACaption, Root: WideString;
  var Directory: WideString; ShowHidden: Boolean = False): Boolean;
begin
  Caption := ACaption;
  if ShowHidden then
    DTV.FileType := [ftDirectory, ftHidden, ftSystem]
  else
    DTV.FileType := [ftDirectory, ftSystem];
  if Root <> '' then
    DTV.RootDirectory := Root
  else
    DTV.RootDirectory := PathDelim;
  if Directory <> '' then
    DTV.Directory := Directory
  else
    DTV.Directory := GetCurrentDir;
  Result := ShowModal = mrOk;
  if Result then
    Directory := DTV.Directory;
end;

end.
