{ *********************************************************************** }
{                                                                         }
{  Borland Kylix Runtime Library                                          }
{  Linux API Interface Unit (ARPA)                                        }
{                                                                         }
{  This translation is based on glibc 2.2.1,                              }
{  compiled from sources on a Linux 2.2.16 kernel.                        }
{                                                                         }
{  Copyright (C) 2001-2002 Borland Software Corporation                   }
{                                                                         }
{  Translator: Borland Software Corporation                               }
{                                                                         }
{  This file may be distributed and/or modified under the terms of the    }
{  GNU General Public License version 2 as published by the Free Software }
{  Foundation and appearing at http://www.borland.com/kylix/gpl.html.     }
{                                                                         }
{  Licensees holding a valid Borland No-Nonsense License for this         }
{  software may use this file in accordance with such license, which      }
{  appears in the file license.txt which came with this software.         }
{                                                                         }
{ *********************************************************************** }

unit LibcArpa;

{$WEAKPACKAGEUNIT}

{$ALIGN 4}
{$MINENUMSIZE 4}
{$ASSERTIONS OFF}

interface

uses
  Libc;

{$HPPEMIT '#include <arpa/ftp.h>'}
// Translated from arpa/ftp.h

{ Definitions for FTP; see RFC-765. }


{ Reply codes. }
const
  PRELIM          = 1;      { positive preliminary }
  {$EXTERNALSYM PRELIM}
  COMPLETE        = 2;      { positive completion }
  {$EXTERNALSYM COMPLETE}
  CONTINUE        = 3;      { positive intermediate }
  {$EXTERNALSYM CONTINUE}
  TRANSIENT       = 4;      { transient negative completion }
  {$EXTERNALSYM TRANSIENT}
  ERROR_ftp       = 5;      { permanent negative completion }
  {.$EXTERNALSYM ERROR} // Renamed due to identifier conflict

{ Type codes }
  TYPE_A          = 1;      { ASCII }
  {$EXTERNALSYM TYPE_A}
  TYPE_E          = 2;      { EBCDIC }
  {$EXTERNALSYM TYPE_E}
  TYPE_I          = 3;      { image }
  {$EXTERNALSYM TYPE_I}
  TYPE_L          = 4;      { local byte size }
  {$EXTERNALSYM TYPE_L}

const
  typenames: array[0..5-1] of PChar =
    ('0', 'ASCII', 'EBCDIC', 'Image', 'Local');
  {$EXTERNALSYM typenames}

{ Form codes }
  FORM_N          = 1;      { non-print }
  {$EXTERNALSYM FORM_N}
  FORM_T          = 2;      { telnet format effectors }
  {$EXTERNALSYM FORM_T}
  FORM_C          = 3;      { carriage control (ASA) }
  {$EXTERNALSYM FORM_C}

const
  formnames: array[0..4-1] of PChar =
  ('0', 'Nonprint', 'Telnet', 'Carriage-control' );
  {$EXTERNALSYM formnames}

{ Structure codes }
  STRU_F          = 1;      { file (no record structure) }
  {$EXTERNALSYM STRU_F}
  STRU_R          = 2;      { record structure }
  {$EXTERNALSYM STRU_R}
  STRU_P          = 3;      { page structure }
  {$EXTERNALSYM STRU_P}

const
  strunames: array[0..4-1] of PChar =
  ('0', 'File', 'Record', 'Page');
  {$EXTERNALSYM strunames}

{ Mode types }
  MODE_S          = 1;      { stream }
  {$EXTERNALSYM MODE_S}
  MODE_B          = 2;      { block }
  {$EXTERNALSYM MODE_B}
  MODE_C          = 3;      { compressed }
  {$EXTERNALSYM MODE_C}

const
  modenames: array[0..4-1] of PChar =
  ('0', 'Stream', 'Block', 'Compressed' );
  {$EXTERNALSYM modenames}

{ Record Tokens }       
  REC_ESC         = #$FF; { Record-mode Escape }
  {$EXTERNALSYM REC_ESC}
  REC_EOR         = #$01; { Record-mode End-of-Record }
  {$EXTERNALSYM REC_EOR}
  REC_EOF         = #$02; { Record-mode End-of-File }
  {$EXTERNALSYM REC_EOF}

{ Block Header }
  BLK_EOR         = $80;    { Block is End-of-Record }
  {$EXTERNALSYM BLK_EOR}
  BLK_EOF         = $40;    { Block is End-of-File }
  {$EXTERNALSYM BLK_EOF}
  BLK_ERRORS      = $20;    { Block is suspected of containing errors }
  {$EXTERNALSYM BLK_ERRORS}
  BLK_RESTART     = $10;    { Block is Restart Marker }
  {$EXTERNALSYM BLK_RESTART}

  BLK_BYTECOUNT   = 2;      { Bytes in this block }
  {$EXTERNALSYM BLK_BYTECOUNT}


{$HPPEMIT '#include <arpa/nameser.h>'}
// Translated from arpa/nameser.h

{
 * Revision information.  This is the release date in YYYYMMDD format.
 * It can change every day so the right thing to do with it is use it
 * in preprocessor commands such as "#if (__NAMESER > 19931104)".  Do not
 * compare for equality; rather, use it to determine whether your libbind.a
 * contains a new enough lib/nameser/ to support the feature you need.
 }

const
  __NAMESER = 19991006;     { New interface version stamp. }
  {$EXTERNALSYM __NAMESER}

{ Define constants based on RFC 883, RFC 1034, RFC 1035 }
  NS_PACKETSZ    = 512;     { maximum packet size }
  {$EXTERNALSYM NS_PACKETSZ}
  NS_MAXDNAME    = 1025;    { maximum domain name }
  {$EXTERNALSYM NS_MAXDNAME}
  NS_MAXCDNAME   = 255;     { maximum compressed domain name }
  {$EXTERNALSYM NS_MAXCDNAME}
  NS_MAXLABEL    = 63;      { maximum length of domain label }
  {$EXTERNALSYM NS_MAXLABEL}
  NS_HFIXEDSZ    = 12;      { #/bytes of fixed data in header }
  {$EXTERNALSYM NS_HFIXEDSZ}
  NS_QFIXEDSZ    = 4;       { #/bytes of fixed data in query }
  {$EXTERNALSYM NS_QFIXEDSZ}
  NS_RRFIXEDSZ   = 10;      { #/bytes of fixed data in r record }
  {$EXTERNALSYM NS_RRFIXEDSZ}
  NS_INT32SZ     = 4;       { #/bytes of data in a u_int32_t }
  {$EXTERNALSYM NS_INT32SZ}
  NS_INT16SZ     = 2;       { #/bytes of data in a u_int16_t }
  {$EXTERNALSYM NS_INT16SZ}
  NS_INT8SZ      = 1;       { #/bytes of data in a u_int8_t }
  {$EXTERNALSYM NS_INT8SZ}
  NS_INADDRSZ    = 4;       { IPv4 T_A }
  {$EXTERNALSYM NS_INADDRSZ}
  NS_IN6ADDRSZ   = 16;      { IPv6 T_AAAA }
  {$EXTERNALSYM NS_IN6ADDRSZ}
  NS_CMPRSFLGS   = $c0;     { Flag bits indicating name compression. }
  {$EXTERNALSYM NS_CMPRSFLGS}
  NS_DEFAULTPORT = 53;      { For both TCP and UDP. }
  {$EXTERNALSYM NS_DEFAULTPORT}

{
 * These can be expanded with synonyms, just keep ns_parse.c:ns_parserecord()
 * in synch with it.
 }
type
  __ns_sect =
  (
    ns_s_qd = 0,      { Query: Question. }
    {$EXTERNALSYM ns_s_qd}
    ns_s_zn = 0,      { Update: Zone. }
    {$EXTERNALSYM ns_s_zn}
    ns_s_an = 1,      { Query: Answer. }
    {$EXTERNALSYM ns_s_an}
    ns_s_pr = 1,      { Update: Prerequisites. }
    {$EXTERNALSYM ns_s_pr}
    ns_s_ns = 2,      { Query: Name servers. }
    {$EXTERNALSYM ns_s_ns}
    ns_s_ud = 2,      { Update: Update. }
    {$EXTERNALSYM ns_s_ud}
    ns_s_ar = 3,      { Query|Update: Additional records. }
    {$EXTERNALSYM ns_s_ar}
    ns_s_max = 4
    {$EXTERNALSYM ns_s_max}
  );
  {$EXTERNALSYM __ns_sect}
  ns_sect = __ns_sect;
  {$EXTERNALSYM ns_sect}


{
 * This is a message handle.  It is caller allocated and has no dynamic data.
 * This structure is intended to be opaque to all but ns_parse.c, thus the
 * leading _'s on the member names.  Use the accessor functions, not the _'s.
 }
type
  __ns_msg = {packed} record
    _msg, _eom: PByte;
    _id, _flags: u_int16_t;
    _counts: packed array[0..Cardinal(ns_s_max)-1] of u_int16_t;
    _sections: packed array[0..Cardinal(ns_s_max)-1] of PByte;
    _sect: ns_sect;
    _rrnum: Integer;
    _ptr: PByte;
  end;
  {$EXTERNALSYM __ns_msg}
  ns_msg = __ns_msg;
  {$EXTERNALSYM ns_msg}
  TNsMsg = ns_msg;
  PNsMsg = ^TNsMsg;

{ Private data structure - do not use from outside library. }
  _ns_flagdata = {packed} record
    mask, shift: Integer;
  end;
  {.$EXTERNALSYM _ns_flagdata} // Renamed from _ns_flagdata to resolve conflict with function

{ Accessor macros - this is part of the public interface. }

function ns_msg_getflag(const handle: ns_msg; flag: Cardinal): Integer;
{$EXTERNALSYM ns_msg_getflag}
function ns_msg_id(const handle: ns_msg): Integer;
{$EXTERNALSYM ns_msg_id}
function ns_msg_base(const handle: ns_msg): PByte;
{$EXTERNALSYM ns_msg_base}
function ns_msg_end(const handle: ns_msg): PByte;
{$EXTERNALSYM ns_msg_end}
function ns_msg_size(const handle: ns_msg): Integer;
{$EXTERNALSYM ns_msg_size}
function ns_msg_count(const handle: ns_msg; section: Cardinal): u_int16_t;
{$EXTERNALSYM ns_msg_count}

{ This is a parsed record.  It is caller allocated and has no dynamic data. }
type
  __ns_rr = {packed} record
    name: packed array[0..NS_MAXDNAME-1] of Char;
    __type: u_int16_t;
    rr_class: u_int16_t;
    ttl: u_int32_t;
    rdlength: u_int16_t;
    rdata: PByte;
  end;
  {$EXTERNALSYM __ns_rr}
  ns_rr = __ns_rr;
  {$EXTERNALSYM ns_rr}
  TNsRr = ns_rr;
  PNsRr = ^TNsRr;

{ Accessor macros - this is part of the public interface. }
function ns_rr_name(const rr: ns_rr): PChar;
{$EXTERNALSYM ns_rr_name}
function ns_rr_type(const rr: ns_rr): u_int16_t;
{$EXTERNALSYM ns_rr_type}
function ns_rr_class(const rr: ns_rr): u_int16_t;
{$EXTERNALSYM ns_rr_class}
function ns_rr_ttl(const rr: ns_rr): u_int32_t;
{$EXTERNALSYM ns_rr_ttl}
function ns_rr_rdlen(const rr: ns_rr): u_int16_t;
{$EXTERNALSYM ns_rr_rdlen}
function ns_rr_rdata(const rr: ns_rr): PByte;
{$EXTERNALSYM ns_rr_rdata}


{
 * These don't have to be in the same order as in the packet flags word,
 * and they can even overlap in some cases, but they will need to be kept
 * in synch with ns_parse.c:ns_flagdata[].
 }
type
  __ns_flag =
  (
    ns_f_qr      = 0,        { Question/Response. }
    {$EXTERNALSYM ns_f_qr}
    ns_f_opcode  = 1,        { Operation code. }
    {$EXTERNALSYM ns_f_opcode}
    ns_f_aa      = 2,        { Authoritative Answer. }
    {$EXTERNALSYM ns_f_aa}
    ns_f_tc      = 3,        { Truncation occurred. }
    {$EXTERNALSYM ns_f_tc}
    ns_f_rd      = 4,        { Recursion Desired. }
    {$EXTERNALSYM ns_f_rd}
    ns_f_ra      = 5,        { Recursion Available. }
    {$EXTERNALSYM ns_f_ra}
    ns_f_z       = 6,        { MBZ. }
    {$EXTERNALSYM ns_f_z}
    ns_f_ad      = 7,        { Authentic Data (DNSSEC). }
    {$EXTERNALSYM ns_f_ad}
    ns_f_cd      = 8,        { Checking Disabled (DNSSEC). }
    {$EXTERNALSYM ns_f_cd}
    ns_f_rcode   = 9,        { Response code. }
    {$EXTERNALSYM ns_f_rcode}
    ns_f_max     = ns_f_rcode + 1 
    {$EXTERNALSYM ns_f_max}
  );
  {$EXTERNALSYM __ns_flag}
  ns_flag = __ns_flag;
  {$EXTERNALSYM ns_flag}

{ Currently defined opcodes. }

type
  __ns_opcode =
  (
    ns_o_query  = 0,         { Standard query. }
    {$EXTERNALSYM ns_o_query}
    ns_o_iquery = 1,         { Inverse query (deprecated/unsupported). }
    {$EXTERNALSYM ns_o_iquery}
    ns_o_status = 2,         { Name server status query (unsupported). }
    {$EXTERNALSYM ns_o_status}
    { Opcode 3 is undefined/reserved. }
    ns_o_notify = 4,         { Zone change notification. }
    {$EXTERNALSYM ns_o_notify}
    ns_o_update = 5,         { Zone update message. }
    {$EXTERNALSYM ns_o_update}
    ns_o_max = ns_o_update + 1
    {$EXTERNALSYM ns_o_max}
  );
  {$EXTERNALSYM __ns_opcode}
  ns_opcode = __ns_opcode;
  {$EXTERNALSYM ns_opcode}

{ Currently defined response codes. }
type
  __ns_r_code =
  (
    ns_r_noerror = 0,        { No error occurred. }
    {$EXTERNALSYM ns_r_noerror}
    ns_r_formerr = 1,        { Format error. }
    {$EXTERNALSYM ns_r_formerr}
    ns_r_servfail = 2,       { Server failure. }
    {$EXTERNALSYM ns_r_servfail}
    ns_r_nxdomain = 3,       { Name error. }
    {$EXTERNALSYM ns_r_nxdomain}
    ns_r_notimpl = 4,        { Unimplemented. }
    {$EXTERNALSYM ns_r_notimpl}
    ns_r_refused = 5,        { Operation refused. }
    {$EXTERNALSYM ns_r_refused}
    { these are for BIND_UPDATE }
    ns_r_yxdomain = 6,       { Name exists }
    {$EXTERNALSYM ns_r_yxdomain}
    ns_r_yxrrset = 7,        { RRset exists }
    {$EXTERNALSYM ns_r_yxrrset}
    ns_r_nxrrset = 8,        { RRset does not exist }
    {$EXTERNALSYM ns_r_nxrrset}
    ns_r_notauth = 9,        { Not authoritative for zone }
    {$EXTERNALSYM ns_r_notauth}
    ns_r_notzone = 10,       { Zone of record different from zone section }
    {$EXTERNALSYM ns_r_notzone}
    ns_r_max = ns_r_notzone + 1,
    {$EXTERNALSYM ns_r_max}
    { The following are TSIG extended errors }
    ns_r_badsig = 16,
    {$EXTERNALSYM ns_r_badsig}
    ns_r_badkey = 17,
    {$EXTERNALSYM ns_r_badkey}
    ns_r_badtime = 18
    {$EXTERNALSYM ns_r_badtime}
  );
  {$EXTERNALSYM __ns_r_code}
  ns_r_code = __ns_r_code;
  {$EXTERNALSYM ns_r_code}

{ BIND_UPDATE }
type
  __ns_update_operation =
  (
    ns_uop_delete = 0,
    {$EXTERNALSYM ns_uop_delete}
    ns_uop_add = 1,
    {$EXTERNALSYM ns_uop_add}
    ns_uop_max = 2 
    {$EXTERNALSYM ns_uop_max}
  );
  {$EXTERNALSYM __ns_update_operation}
  ns_update_operation = __ns_update_operation;
  {$EXTERNALSYM ns_update_operation}

{ This structure is used for TSIG authenticated messages }
type
  ns_tsig_key = {packed} record
    name: packed array[0..NS_MAXDNAME-1] of Char;
    alg: packed array[0..NS_MAXDNAME-1] of Char;
    data: PByte;
    len: Integer;
  end;
  {$EXTERNALSYM ns_tsig_key}


{ This structure is used for TSIG authenticated TCP messages }
  ns_tcp_tsig_state = {packed} record
    counter: Integer;
    key: Pointer; (* struct dst_key *key: Pdst_key;  --- dst_key nowhere declared *)
    ctx: Pointer;
    sig: packed array[0..NS_PACKETSZ-1] of Byte;
    siglen: Integer;
  end;
  {$EXTERNALSYM ns_tcp_tsig_state}


const
  NS_TSIG_FUDGE = 300;
  {$EXTERNALSYM NS_TSIG_FUDGE}
  NS_TSIG_TCP_COUNT = 100;
  {$EXTERNALSYM NS_TSIG_TCP_COUNT}
  NS_TSIG_ALG_HMAC_MD5 = 'HMAC-MD5.SIG-ALG.REG.INT';
  {$EXTERNALSYM NS_TSIG_ALG_HMAC_MD5}

  NS_TSIG_ERROR_NO_TSIG = -10;
  {$EXTERNALSYM NS_TSIG_ERROR_NO_TSIG}
  NS_TSIG_ERROR_NO_SPACE = -11;
  {$EXTERNALSYM NS_TSIG_ERROR_NO_SPACE}
  NS_TSIG_ERROR_FORMERR = -12;
  {$EXTERNALSYM NS_TSIG_ERROR_FORMERR}

{ Currently defined type values for resources and queries. }

type
  __ns_type =
  (
    ns_t_invalid = 0,     { Cookie. }
    {$EXTERNALSYM ns_t_invalid}
    ns_t_a = 1,           { Host address. }
    {$EXTERNALSYM ns_t_a}
    ns_t_ns = 2,          { Authoritative server. }
    {$EXTERNALSYM ns_t_ns}
    ns_t_md = 3,          { Mail destination. }
    {$EXTERNALSYM ns_t_md}
    ns_t_mf = 4,          { Mail forwarder. }
    {$EXTERNALSYM ns_t_mf}
    ns_t_cname = 5,       { Canonical name. }
    {$EXTERNALSYM ns_t_cname}
    ns_t_soa = 6,         { Start of authority zone. }
    {$EXTERNALSYM ns_t_soa}
    ns_t_mb = 7,          { Mailbox domain name. }
    {$EXTERNALSYM ns_t_mb}
    ns_t_mg = 8,          { Mail group member. }
    {$EXTERNALSYM ns_t_mg}
    ns_t_mr = 9,          { Mail rename name. }
    {$EXTERNALSYM ns_t_mr}
    ns_t_null = 10,       { Null resource record. }
    {$EXTERNALSYM ns_t_null}
    ns_t_wks = 11,        { Well known service. }
    {$EXTERNALSYM ns_t_wks}
    ns_t_ptr = 12,        { Domain name pointer. }
    {$EXTERNALSYM ns_t_ptr}
    ns_t_hinfo = 13,      { Host information. }
    {$EXTERNALSYM ns_t_hinfo}
    ns_t_minfo = 14,      { Mailbox information. }
    {$EXTERNALSYM ns_t_minfo}
    ns_t_mx = 15,         { Mail routing information. }
    {$EXTERNALSYM ns_t_mx}
    ns_t_txt = 16,        { Text strings. }
    {$EXTERNALSYM ns_t_txt}
    ns_t_rp = 17,         { Responsible person. }
    {$EXTERNALSYM ns_t_rp}
    ns_t_afsdb = 18,      { AFS cell database. }
    {$EXTERNALSYM ns_t_afsdb}
    ns_t_x25 = 19,        { X_25 calling address. }
    {$EXTERNALSYM ns_t_x25}
    ns_t_isdn = 20,       { ISDN calling address. }
    {$EXTERNALSYM ns_t_isdn}
    ns_t_rt = 21,         { Router. }
    {$EXTERNALSYM ns_t_rt}
    ns_t_nsap = 22,       { NSAP address. }
    {$EXTERNALSYM ns_t_nsap}
    ns_t_nsap_ptr = 23,   { Reverse NSAP lookup (deprecated). }
    {$EXTERNALSYM ns_t_nsap_ptr}
    ns_t_sig = 24,        { Security signature. }
    {$EXTERNALSYM ns_t_sig}
    ns_t_key = 25,        { Security key. }
    {$EXTERNALSYM ns_t_key}
    ns_t_px = 26,         { X.400 mail mapping. }
    {$EXTERNALSYM ns_t_px}
    ns_t_gpos = 27,       { Geographical position (withdrawn). }
    {$EXTERNALSYM ns_t_gpos}
    ns_t_aaaa = 28,       { Ip6 Address. }
    {$EXTERNALSYM ns_t_aaaa}
    ns_t_loc = 29,        { Location Information. }
    {$EXTERNALSYM ns_t_loc}
    ns_t_nxt = 30,        { Next domain (security). }
    {$EXTERNALSYM ns_t_nxt}
    ns_t_eid = 31,        { Endpoint identifier. }
    {$EXTERNALSYM ns_t_eid}
    ns_t_nimloc = 32,     { Nimrod Locator. }
    {$EXTERNALSYM ns_t_nimloc}
    ns_t_srv = 33,        { Server Selection. }
    {$EXTERNALSYM ns_t_srv}
    ns_t_atma = 34,       { ATM Address }
    {$EXTERNALSYM ns_t_atma}
    ns_t_naptr = 35,      { Naming Authority PoinTeR }
    {$EXTERNALSYM ns_t_naptr}
    ns_t_kx = 36,         { Key Exchange }
    {$EXTERNALSYM ns_t_kx}
    ns_t_cert = 37,       { Certification record }
    {$EXTERNALSYM ns_t_cert}
    ns_t_a6 = 38,         { IPv6 address (deprecates AAAA) }
    {$EXTERNALSYM ns_t_a6}
    ns_t_dname = 39,      { Non-terminal DNAME (for IPv6) }
    {$EXTERNALSYM ns_t_dname}
    ns_t_sink = 40,       { Kitchen sink (experimentatl) }
    {$EXTERNALSYM ns_t_sink}
    ns_t_opt = 41,        { EDNS0 option (meta-RR) }
    {$EXTERNALSYM ns_t_opt}
    ns_t_tsig = 250,      { Transaction signature. }
    {$EXTERNALSYM ns_t_tsig}
    ns_t_ixfr = 251,      { Incremental zone transfer. }
    {$EXTERNALSYM ns_t_ixfr}
    ns_t_axfr = 252,      { Transfer zone of authority. }
    {$EXTERNALSYM ns_t_axfr}
    ns_t_mailb = 253,     { Transfer mailbox records. }
    {$EXTERNALSYM ns_t_mailb}
    ns_t_maila = 254,     { Transfer mail agent records. }
    {$EXTERNALSYM ns_t_maila}
    ns_t_any = 255,       { Wildcard match. }
    {$EXTERNALSYM ns_t_any}
    ns_t_zxfr = 256,      { BIND-specific, nonstandard. }
    {$EXTERNALSYM ns_t_zxfr}
    ns_t_max = 65536
    {$EXTERNALSYM ns_t_max}
  );
  {$EXTERNALSYM __ns_type}
  ns_type = __ns_type;
  {$EXTERNALSYM ns_type}

{ Exclusively a QTYPE? (not also an RTYPE) }

function ns_t_qt_p(Value: ns_type): Boolean;
{$EXTERNALSYM ns_t_qt_p}
{ Some kind of meta-RR? (not a QTYPE, but also not an RTYPE) }
function ns_t_mrr_p(Value: ns_type): Boolean;
{$EXTERNALSYM ns_t_mrr_p}
{ Exclusively an RTYPE? (not also a QTYPE or a meta-RR) }
function ns_t_rr_p(Value: ns_type): Boolean;
{$EXTERNALSYM ns_t_rr_p}
function ns_t_udp_p(Value: ns_type): Boolean;
{$EXTERNALSYM ns_t_udp_p}
function ns_t_xfr_p(Value: ns_type): Boolean;
{$EXTERNALSYM ns_t_xfr_p}


{ Values for class field }
type
  __ns_class =
  (
    ns_c_invalid = 0,     { Cookie. }
    {$EXTERNALSYM ns_c_invalid}
    ns_c_in = 1,          { Internet. }
    {$EXTERNALSYM ns_c_in}
    ns_c_2 = 2,           { unallocated/unsupported. }
    {$EXTERNALSYM ns_c_2}
    ns_c_chaos = 3,       { MIT Chaos-net. }
    {$EXTERNALSYM ns_c_chaos}
    ns_c_hs = 4,          { MIT Hesiod. }
    {$EXTERNALSYM ns_c_hs}
    { Query class values which do not appear in resource records }
    ns_c_none = 254,      { for prereq. sections in update requests }
    {$EXTERNALSYM ns_c_none}
    ns_c_any = 255,       { Wildcard match. }
    {$EXTERNALSYM ns_c_any}
    ns_c_max = 65536
    {$EXTERNALSYM ns_c_max}
  );
  {$EXTERNALSYM __ns_class}
  ns_class = __ns_class;
  {$EXTERNALSYM ns_class}


{ DNSSEC constants. }
type
  __ns_key_types =
  (
    ns_kt_rsa = 1,        { key type RSA/MD5 }
    {$EXTERNALSYM ns_kt_rsa}
    ns_kt_dh  = 2,        { Diffie Hellman }
    {$EXTERNALSYM ns_kt_dh}
    ns_kt_dsa = 3,        { Digital Signature Standard (MANDATORY) }
    {$EXTERNALSYM ns_kt_dsa}
    ns_kt_private = 254   { Private key type starts with OID }
    {$EXTERNALSYM ns_kt_private}
  );
  {$EXTERNALSYM __ns_key_types}
  ns_key_types = __ns_key_types;
  {$EXTERNALSYM ns_key_types}

type
  __ns_cert_types =
  (
    cert_t_pkix = 1,      { PKIX (X.509v3) }
    {$EXTERNALSYM cert_t_pkix}
    cert_t_spki = 2,      { SPKI }
    {$EXTERNALSYM cert_t_spki}
    cert_t_pgp  = 3,      { PGP }
    {$EXTERNALSYM cert_t_pgp}
    cert_t_url  = 253,    { URL private type }
    {$EXTERNALSYM cert_t_url}
    cert_t_oid  = 254     { OID private type }
    {$EXTERNALSYM cert_t_oid}
  );
  {$EXTERNALSYM __ns_cert_types}
  ns_cert_types = __ns_cert_types;
  {$EXTERNALSYM ns_cert_types}


{ Flags field of the KEY RR rdata. }
const
  NS_KEY_TYPEMASK           = $C000;      { Mask for "type" bits }
  {$EXTERNALSYM NS_KEY_TYPEMASK}
  NS_KEY_TYPE_AUTH_CONF     = $0000;      { Key usable for both }
  {$EXTERNALSYM NS_KEY_TYPE_AUTH_CONF}
  NS_KEY_TYPE_CONF_ONLY     = $8000;      { Key usable for confidentiality }
  {$EXTERNALSYM NS_KEY_TYPE_CONF_ONLY}
  NS_KEY_TYPE_AUTH_ONLY     = $4000;      { Key usable for authentication }
  {$EXTERNALSYM NS_KEY_TYPE_AUTH_ONLY}
  NS_KEY_TYPE_NO_KEY        = $C000;      { No key usable for either; no key }
  {$EXTERNALSYM NS_KEY_TYPE_NO_KEY}
{ The type bits can also be interpreted independently, as single bits: }
  NS_KEY_NO_AUTH            = $8000;      { Key unusable for authentication }
  {$EXTERNALSYM NS_KEY_NO_AUTH}
  NS_KEY_NO_CONF            = $4000;      { Key unusable for confidentiality }
  {$EXTERNALSYM NS_KEY_NO_CONF}
  NS_KEY_RESERVED2          = $2000;      { Security is *mandatory* if bit=0 }
  {$EXTERNALSYM NS_KEY_RESERVED2}
  NS_KEY_EXTENDED_FLAGS     = $1000;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_EXTENDED_FLAGS}
  NS_KEY_RESERVED4          = $0800;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED4}
  NS_KEY_RESERVED5          = $0400;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED5}
  NS_KEY_NAME_TYPE          = $0300;      { these bits determine the type }
  {$EXTERNALSYM NS_KEY_NAME_TYPE}
  NS_KEY_NAME_USER          = $0000;      { key is assoc. with user }
  {$EXTERNALSYM NS_KEY_NAME_USER}
  NS_KEY_NAME_ENTITY        = $0200;      { key is assoc. with entity eg host }
  {$EXTERNALSYM NS_KEY_NAME_ENTITY}
  NS_KEY_NAME_ZONE          = $0100;      { key is zone key }
  {$EXTERNALSYM NS_KEY_NAME_ZONE}
  NS_KEY_NAME_RESERVED      = $0300;      { reserved meaning }
  {$EXTERNALSYM NS_KEY_NAME_RESERVED}
  NS_KEY_RESERVED8          = $0080;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED8}
  NS_KEY_RESERVED9          = $0040;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED9}
  NS_KEY_RESERVED10         = $0020;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED10}
  NS_KEY_RESERVED11         = $0010;      { reserved - must be zero }
  {$EXTERNALSYM NS_KEY_RESERVED11}
  NS_KEY_SIGNATORYMASK      = $000F;      { key can sign RR's of same name }
  {$EXTERNALSYM NS_KEY_SIGNATORYMASK}
  NS_KEY_RESERVED_BITMASK = (NS_KEY_RESERVED2 or NS_KEY_RESERVED4 or
                             NS_KEY_RESERVED5 or NS_KEY_RESERVED8 or
                             NS_KEY_RESERVED9 or NS_KEY_RESERVED10 or
                             NS_KEY_RESERVED11 );
  {$EXTERNALSYM NS_KEY_RESERVED_BITMASK}

  NS_KEY_RESERVED_BITMASK2 = $FFFF; { no bits defined here }
  {$EXTERNALSYM NS_KEY_RESERVED_BITMASK2}

{ The Algorithm field of the KEY and SIG RR's is an integer, (1..254) }
  NS_ALG_MD5RSA        = 1;   { MD5 with RSA }
  {$EXTERNALSYM NS_ALG_MD5RSA}
  NS_ALG_DH            = 2;   { Diffie Hellman KEY }
  {$EXTERNALSYM NS_ALG_DH}
  NS_ALG_DSA           = 3;   { DSA KEY }
  {$EXTERNALSYM NS_ALG_DSA}
  NS_ALG_DSS           = NS_ALG_DSA;
  {$EXTERNALSYM NS_ALG_DSS}
  NS_ALG_EXPIRE_ONLY   = 253; { No alg, no security }
  {$EXTERNALSYM NS_ALG_EXPIRE_ONLY}
  NS_ALG_PRIVATE_OID   = 254; { Key begins with OID giving alg }
  {$EXTERNALSYM NS_ALG_PRIVATE_OID}

{ Protocol values  }
{ value 0 is reserved }
  NS_KEY_PROT_TLS         = 1;
  {$EXTERNALSYM NS_KEY_PROT_TLS}
  NS_KEY_PROT_EMAIL       = 2;
  {$EXTERNALSYM NS_KEY_PROT_EMAIL}
  NS_KEY_PROT_DNSSEC      = 3;
  {$EXTERNALSYM NS_KEY_PROT_DNSSEC}
  NS_KEY_PROT_IPSEC       = 4;
  {$EXTERNALSYM NS_KEY_PROT_IPSEC}
  NS_KEY_PROT_ANY         = 255;
  {$EXTERNALSYM NS_KEY_PROT_ANY}

{ Signatures }
  NS_MD5RSA_MIN_BITS      = 512;    { Size of a mod or exp in bits }
  {$EXTERNALSYM NS_MD5RSA_MIN_BITS}
  NS_MD5RSA_MAX_BITS      = 2552;
  {$EXTERNALSYM NS_MD5RSA_MAX_BITS}
  { Total of binary mod and exp }
  NS_MD5RSA_MAX_BYTES     = ((NS_MD5RSA_MAX_BITS+7 div 8)*2+3);
  {$EXTERNALSYM NS_MD5RSA_MAX_BYTES}
  { Max length of text sig block }
  NS_MD5RSA_MAX_BASE64    = (((NS_MD5RSA_MAX_BYTES+2) div 3)*4);
  {$EXTERNALSYM NS_MD5RSA_MAX_BASE64}
  NS_MD5RSA_MIN_SIZE      = ((NS_MD5RSA_MIN_BITS+7) div 8);
  {$EXTERNALSYM NS_MD5RSA_MIN_SIZE}
  NS_MD5RSA_MAX_SIZE      = ((NS_MD5RSA_MAX_BITS+7) div 8);
  {$EXTERNALSYM NS_MD5RSA_MAX_SIZE}

  NS_DSA_SIG_SIZE         = 41;
  {$EXTERNALSYM NS_DSA_SIG_SIZE}
  NS_DSA_MIN_SIZE         = 213;
  {$EXTERNALSYM NS_DSA_MIN_SIZE}
  NS_DSA_MAX_BYTES        = 405;
  {$EXTERNALSYM NS_DSA_MAX_BYTES}

{ Offsets into SIG record rdata to find various values }
  NS_SIG_TYPE             = 0;    { Type flags }
  {$EXTERNALSYM NS_SIG_TYPE}
  NS_SIG_ALG              = 2;    { Algorithm }
  {$EXTERNALSYM NS_SIG_ALG}
  NS_SIG_LABELS           = 3;    { How many labels in name }
  {$EXTERNALSYM NS_SIG_LABELS}
  NS_SIG_OTTL             = 4;    { Original TTL }
  {$EXTERNALSYM NS_SIG_OTTL}
  NS_SIG_EXPIR            = 8;    { Expiration time }
  {$EXTERNALSYM NS_SIG_EXPIR}
  NS_SIG_SIGNED           = 12;   { Signature time }
  {$EXTERNALSYM NS_SIG_SIGNED}
  NS_SIG_FOOT             = 16;   { Key footprint }
  {$EXTERNALSYM NS_SIG_FOOT}
  NS_SIG_SIGNER           = 18;   { Domain name of who signed it }
  {$EXTERNALSYM NS_SIG_SIGNER}

{ How RR types are represented as bit-flags in NXT records }
  NS_NXT_BITS = 8;
  {$EXTERNALSYM NS_NXT_BITS}

(* No way to translate these?
  NS_NXT_BIT_SET(  n,p) (p[(n)/NS_NXT_BITS] |=  (0x80>>((n)%NS_NXT_BITS)))
  NS_NXT_BIT_CLEAR(n,p) (p[(n)/NS_NXT_BITS] &= ~(0x80>>((n)%NS_NXT_BITS)))
  NS_NXT_BIT_ISSET(n,p) (p[(n)/NS_NXT_BITS] &   (0x80>>((n)%NS_NXT_BITS)))
*)

const
  NS_NXT_MAX = 127;
  {$EXTERNALSYM NS_NXT_MAX}

(* Do not perform the hiding for ANSI C compliance
{ ANSI C identifier hiding for bind's lib/nameser. }
#define ns_get16		__ns_get16
#define ns_get32		__ns_get32
#define ns_put16		__ns_put16
#define ns_put32		__ns_put32
#define ns_initparse		__ns_initparse
#define ns_skiprr		__ns_skiprr
#define ns_parserr		__ns_parserr
#define	ns_sprintrr		__ns_sprintrr
#define	ns_sprintrrf		__ns_sprintrrf
#define	ns_format_ttl		__ns_format_ttl
#define	ns_parse_ttl		__ns_parse_ttl
#define ns_datetosecs		__ns_datetosecs
#define	ns_name_ntol		__ns_name_ntol
#define	ns_name_ntop		__ns_name_ntop
#define	ns_name_pton		__ns_name_pton
#define	ns_name_unpack		__ns_name_unpack
#define	ns_name_pack		__ns_name_pack
#define	ns_name_compress	__ns_name_compress
#define	ns_name_uncompress	__ns_name_uncompress
#define	ns_name_skip		__ns_name_skip
#define	ns_name_rollback	__ns_name_rollback
#define	ns_sign			__ns_sign
#define	ns_sign_tcp		__ns_sign_tcp
#define	ns_sign_tcp_init	__ns_sign_tcp_init
#define ns_find_tsig		__ns_find_tsig
#define	ns_verify		__ns_verify
#define	ns_verify_tcp		__ns_verify_tcp
#define	ns_verify_tcp_init	__ns_verify_tcp_init
#define	ns_samedomain		__ns_samedomain
#define	ns_subdomain		__ns_subdomain
#define	ns_makecanon		__ns_makecanon
#define	ns_samename		__ns_samename
*)


function ns_get16(p1: PByte): u_int; cdecl;
{$EXTERNALSYM ns_get16}
function ns_get32(p1: PByte): u_long; cdecl;
{$EXTERNALSYM ns_get32}
procedure ns_put16(p1: u_int; p2: PByte); cdecl;
{$EXTERNALSYM ns_put16}
procedure ns_put32(p1: u_long; p2: u_char); cdecl;
{$EXTERNALSYM ns_put32}
function ns_initparse(p1: PByte; p2: Integer; p3: PNsMsg): Integer; cdecl;
{$EXTERNALSYM ns_initparse}
function ns_skiprr(p1: PByte; p2: PByte; p3: ns_sect; p4: Integer): Integer; cdecl;
{$EXTERNALSYM ns_skiprr}
function ns_parserr(p1: PNsMsg; p2: ns_sect; p3: Integer; p4: PNsRr): Integer; cdecl;
{$EXTERNALSYM ns_parserr}
function ns_sprintrr(p1: PNsMsg; p2: PNsRr; p3: PChar; p4: PChar; p5: PChar; p6: size_t): Integer; cdecl;
{$EXTERNALSYM ns_sprintrr}
function ns_sprintrrf(p1: PByte; p2: size_t; p3: PChar; p4: ns_class; p5: ns_type;
  p6: u_long; p7: PByte; p8: size_t; p9: PChar; p10: PChar; p11: PChar;
  p12: size_t): Integer; cdecl;
{$EXTERNALSYM ns_sprintrrf}
function ns_format_ttl(p1: u_long; p2: PChar; p3: size_t): Integer; cdecl;
{$EXTERNALSYM ns_format_ttl}
function ns_parse_ttl(p1: PChar; var p2: u_long): Integer; cdecl;
{$EXTERNALSYM ns_parse_ttl}
function ns_datetosecs(cp: PChar; errp: PInteger): u_int32_t; cdecl;
{$EXTERNALSYM ns_datetosecs}
function ns_name_ntol(p1: PByte; p2: PByte; p3: size_t): Integer; cdecl;
{$EXTERNALSYM ns_name_ntol}
function ns_name_ntop(p1: PByte; p2: PChar; p3: size_t): Integer; cdecl;
{$EXTERNALSYM ns_name_ntop}
function ns_name_pton(p1: PChar; p2: PByte; p3: size_t): Integer; cdecl;
{$EXTERNALSYM ns_name_pton}
function ns_name_unpack(p1: PByte; p2: PByte; p3: PByte; p4: PByte; p5: size_t): Integer; cdecl;
{$EXTERNALSYM ns_name_unpack}
function ns_name_pack(p1: PByte; p2: PByte; p3: Integer; var p4: PByte; var p5: PByte): Integer; cdecl;
{$EXTERNALSYM ns_name_pack}
function ns_name_uncompress(p1: PByte; p2: PByte; p3: PByte; p4: PByte; p5: size_t): Integer; cdecl;
{$EXTERNALSYM ns_name_uncompress}
function ns_name_compress(p1: PChar; p2: PByte; p3: size_t; var p4: PByte; var p5: PByte): Integer; cdecl;
{$EXTERNALSYM ns_name_compress}
function ns_name_skip(var p1: PByte; p2: PByte): Integer; cdecl;
{$EXTERNALSYM ns_name_skip}
procedure ns_name_rollback(p1: PByte; var p2: PByte; var p3: PByte); cdecl;
{$EXTERNALSYM ns_name_rollback}
function ns_sign(p1: PByte; p2: PInteger; p3: Integer; p4: Integer; p5: Pointer;
  p6: PByte; p7: Integer; p8: PByte; p9: PInteger; p10: time_t): Integer; cdecl;
{$EXTERNALSYM ns_sign}
function ns_sign_tcp(p1: PByte; p2: PInteger; p3: Integer; p4: Integer;
  var p5: ns_tcp_tsig_state; p6: Integer): Integer; cdecl;
{$EXTERNALSYM ns_sign_tcp}
function ns_sign_tcp_init(p1: Pointer; p2: PByte; p3: Integer; var p4: ns_tcp_tsig_state): Integer; cdecl;
{$EXTERNALSYM ns_sign_tcp_init}
function ns_find_tsig(p1: PByte; p2: PByte): PByte; cdecl;
{$EXTERNALSYM ns_find_tsig}
function ns_verify(p1: PByte; p2: PInteger; p3: Pointer; p4: PByte; p5: Integer;
  p6: PByte; p7: PInteger; var p8: time_t; p9: Integer): Integer; cdecl;
{$EXTERNALSYM ns_verify}
function ns_verify_tcp(p1: PByte; p2: PInteger; var p3: ns_tcp_tsig_state; p4: Integer): Integer; cdecl;
{$EXTERNALSYM ns_verify_tcp}
function ns_verify_tcp_init(p1: Pointer; p2: PByte; p3: Integer; var p4: ns_tcp_tsig_state): Integer; cdecl;
{$EXTERNALSYM ns_verify_tcp_init}
function ns_samedomain(p1: PChar; p2: PChar): Integer; cdecl;
{$EXTERNALSYM ns_samedomain}
function ns_subdomain(p1: PChar; p2: PChar): Integer; cdecl;
{$EXTERNALSYM ns_subdomain}
function ns_makecanon(p1: PChar; p2: PChar; p3: size_t): Integer; cdecl;
{$EXTERNALSYM ns_makecanon}
function ns_samename(p1: PChar; p2: PChar): Integer; cdecl;
{$EXTERNALSYM ns_samename}


{$HPPEMIT '#include <arpa/nameser_compat.h>'}
// Translated from arpa/nameser_compat.h

{
 * Structure for query header.  The order of the fields is machine- and
 * compiler-dependent, depending on the byte/bit order and the layout
 * of bit fields.  We use bit fields only in int variables, as this
 * is all ANSI requires.  This requires a somewhat confusing rearrangement.
 }

type
  HEADER = {packed} record
    __bitfield1: Cardinal;
  (*
    unsigned id :16;       { query identification number }
    { fields in third byte }
    unsigned rd :1;        { recursion desired }
    unsigned tc :1;        { truncated message }
    unsigned aa :1;        { authoritive answer }
    unsigned opcode :4;    { purpose of message }
    unsigned qr :1;        { response flag }
    { fields in fourth byte }
    unsigned rcode :4;	{ response code }
    unsigned cd: 1;         { checking disabled by resolver }
    unsigned ad: 1;         { authentic data from named }
    unsigned unused :1;     { unused bits (MBZ as of 4.9.3a3) }
    unsigned ra :1;         { recursion available }
  *)
    __bitfield2: Cardinal;
    { remaining bytes }
  (*
    unsigned qdcount :16;   { number of question entries }
    unsigned ancount :16;   { number of answer entries }
  *)
    __bitfield3: Cardinal;
  (*
    unsigned nscount :16;   { number of authority entries }
    unsigned arcount :16;   { number of resource entries }
  *)
  end;
  {$EXTERNALSYM HEADER}

const
  PACKETSZ           = NS_PACKETSZ;
  {$EXTERNALSYM PACKETSZ}
  MAXDNAME           = NS_MAXDNAME;
  {$EXTERNALSYM MAXDNAME}
  MAXCDNAME          = NS_MAXCDNAME;
  {$EXTERNALSYM MAXCDNAME}
  MAXLABEL           = NS_MAXLABEL;
  {$EXTERNALSYM MAXLABEL}
  HFIXEDSZ           = NS_HFIXEDSZ;
  {$EXTERNALSYM HFIXEDSZ}
  QFIXEDSZ           = NS_QFIXEDSZ;
  {$EXTERNALSYM QFIXEDSZ}
  RRFIXEDSZ          = NS_RRFIXEDSZ;
  {$EXTERNALSYM RRFIXEDSZ}
  INT32SZ            = NS_INT32SZ;
  {$EXTERNALSYM INT32SZ}
  INT16SZ            = NS_INT16SZ;
  {$EXTERNALSYM INT16SZ}
  INADDRSZ           = NS_INADDRSZ;
  {$EXTERNALSYM INADDRSZ}
  IN6ADDRSZ          = NS_IN6ADDRSZ;
  {$EXTERNALSYM IN6ADDRSZ}
  INDIR_MASK         = NS_CMPRSFLGS;
  {$EXTERNALSYM INDIR_MASK}
  NAMESERVER_PORT    = NS_DEFAULTPORT;
  {$EXTERNALSYM NAMESERVER_PORT}

  S_ZONE             = ns_s_zn;
  {$EXTERNALSYM S_ZONE}
  S_PREREQ           = ns_s_pr;
  {$EXTERNALSYM S_PREREQ}
  S_UPDATE           = ns_s_ud;
  {$EXTERNALSYM S_UPDATE}
  S_ADDT             = ns_s_ar;
  {$EXTERNALSYM S_ADDT}

  QUERY              = ns_o_query;
  {$EXTERNALSYM QUERY}
  IQUERY             = ns_o_iquery;
  {$EXTERNALSYM IQUERY}
  STATUS             = ns_o_status;
  {$EXTERNALSYM STATUS}
  NS_NOTIFY_OP       = ns_o_notify;
  {$EXTERNALSYM NS_NOTIFY_OP}
  NS_UPDATE_OP       = ns_o_update;
  {$EXTERNALSYM NS_UPDATE_OP}

  NOERROR            = ns_r_noerror;
  {$EXTERNALSYM NOERROR}
  FORMERR            = ns_r_formerr;
  {$EXTERNALSYM FORMERR}
  SERVFAIL           = ns_r_servfail;
  {$EXTERNALSYM SERVFAIL}
  NXDOMAIN           = ns_r_nxdomain;
  {$EXTERNALSYM NXDOMAIN}
  NOTIMP             = ns_r_notimpl;
  {$EXTERNALSYM NOTIMP}
  REFUSED            = ns_r_refused;
  {$EXTERNALSYM REFUSED}
  YXDOMAIN           = ns_r_yxdomain;
  {$EXTERNALSYM YXDOMAIN}
  YXRRSET            = ns_r_yxrrset;
  {$EXTERNALSYM YXRRSET}
  NXRRSET            = ns_r_nxrrset;
  {$EXTERNALSYM NXRRSET}
  NOTAUTH            = ns_r_notauth;
  {$EXTERNALSYM NOTAUTH}
  NOTZONE            = ns_r_notzone;
  {$EXTERNALSYM NOTZONE}

  DELETE             = ns_uop_delete;
  {$EXTERNALSYM DELETE}
  ADD                = ns_uop_add;
  {$EXTERNALSYM ADD}

  T_A                = ns_t_a;
  {$EXTERNALSYM T_A}
  T_NS               = ns_t_ns;
  {$EXTERNALSYM T_NS}
  T_MD               = ns_t_md;
  {$EXTERNALSYM T_MD}
  T_MF               = ns_t_mf;
  {$EXTERNALSYM T_MF}
  T_CNAME            = ns_t_cname;
  {$EXTERNALSYM T_CNAME}
  T_SOA              = ns_t_soa;
  {$EXTERNALSYM T_SOA}
  T_MB               = ns_t_mb;
  {$EXTERNALSYM T_MB}
  T_MG               = ns_t_mg;
  {$EXTERNALSYM T_MG}
  T_MR               = ns_t_mr;
  {$EXTERNALSYM T_MR}
  T_NULL             = ns_t_null;
  {$EXTERNALSYM T_NULL}
  T_WKS              = ns_t_wks;
  {$EXTERNALSYM T_WKS}
  T_PTR              = ns_t_ptr;
  {$EXTERNALSYM T_PTR}
  T_HINFO            = ns_t_hinfo;
  {$EXTERNALSYM T_HINFO}
  T_MINFO            = ns_t_minfo;
  {$EXTERNALSYM T_MINFO}
  T_MX               = ns_t_mx;
  {$EXTERNALSYM T_MX}
  T_TXT              = ns_t_txt;
  {$EXTERNALSYM T_TXT}
  T_RP               = ns_t_rp;
  {$EXTERNALSYM T_RP}
  T_AFSDB            = ns_t_afsdb;
  {$EXTERNALSYM T_AFSDB}
  T_X25              = ns_t_x25;
  {$EXTERNALSYM T_X25}
  T_ISDN             = ns_t_isdn;
  {$EXTERNALSYM T_ISDN}
  T_RT               = ns_t_rt;
  {$EXTERNALSYM T_RT}
  T_NSAP             = ns_t_nsap;
  {$EXTERNALSYM T_NSAP}
  T_NSAP_PTR         = ns_t_nsap_ptr;
  {$EXTERNALSYM T_NSAP_PTR}
  T_SIG              = ns_t_sig;
  {$EXTERNALSYM T_SIG}
  T_KEY              = ns_t_key;
  {$EXTERNALSYM T_KEY}
  T_PX               = ns_t_px;
  {$EXTERNALSYM T_PX}
  T_GPOS             = ns_t_gpos;
  {$EXTERNALSYM T_GPOS}
  T_AAAA             = ns_t_aaaa;
  {$EXTERNALSYM T_AAAA}
  T_LOC              = ns_t_loc;
  {$EXTERNALSYM T_LOC}
  T_NXT              = ns_t_nxt;
  {$EXTERNALSYM T_NXT}
  T_EID              = ns_t_eid;
  {$EXTERNALSYM T_EID}
  T_NIMLOC           = ns_t_nimloc;
  {$EXTERNALSYM T_NIMLOC}
  T_SRV              = ns_t_srv;
  {$EXTERNALSYM T_SRV}
  T_ATMA             = ns_t_atma;
  {$EXTERNALSYM T_ATMA}
  T_NAPTR            = ns_t_naptr;
  {$EXTERNALSYM T_NAPTR}
  T_TSIG             = ns_t_tsig;
  {$EXTERNALSYM T_TSIG}
  T_IXFR             = ns_t_ixfr;
  {$EXTERNALSYM T_IXFR}
  T_AXFR             = ns_t_axfr;
  {$EXTERNALSYM T_AXFR}
  T_MAILB            = ns_t_mailb;
  {$EXTERNALSYM T_MAILB}
  T_MAILA            = ns_t_maila;
  {$EXTERNALSYM T_MAILA}
  T_ANY              = ns_t_any;
  {$EXTERNALSYM T_ANY}

  C_IN               = ns_c_in;
  {$EXTERNALSYM C_IN}
  C_CHAOS            = ns_c_chaos;
  {$EXTERNALSYM C_CHAOS}
  C_HS               = ns_c_hs;
  {$EXTERNALSYM C_HS}
{ BIND_UPDATE }
  C_NONE             = ns_c_none;
  {$EXTERNALSYM C_NONE}
  C_ANY              = ns_c_any;
  {$EXTERNALSYM C_ANY}

(* Cannot translate function aliases
  GETSHORT = NS_GET16
  GETLONG = NS_GET32
  PUTSHORT = NS_PUT16
  PUTLONG = NS_PUT32
*)

{$HPPEMIT '#include <arpa/telnet.h>'}
// Translated from arpa/telnet.h

{ Definitions for the TELNET protocol. }
const
  IAC         = 255;    { interpret as command: }
  {$EXTERNALSYM IAC}
  DONT        = 254;    { you are not to use option }
  {$EXTERNALSYM DONT}
  __DO          = 253;  { please, you use option } (* Renamed from DO *)
  {.$EXTERNALSYM DO}
  WONT        = 252;    { I won't use option }
  {$EXTERNALSYM WONT}
  WILL        = 251;    { I will use option }
  {$EXTERNALSYM WILL}
  SB          = 250;    { interpret as subnegotiation }
  {$EXTERNALSYM SB}
  GA          = 249;    { you may reverse the line }
  {$EXTERNALSYM GA}
  EL          = 248;    { erase the current line }
  {$EXTERNALSYM EL}
  EC          = 247;    { erase the current character }
  {$EXTERNALSYM EC}
  AYT         = 246;    { are you there }
  {$EXTERNALSYM AYT}
  AO          = 245;    { abort output--but let prog finish }
  {$EXTERNALSYM AO}
  IP          = 244;    { interrupt process--permanently }
  {$EXTERNALSYM IP}
  BREAK       = 243;    { break }
  {$EXTERNALSYM BREAK}
  DM          = 242;    { data mark--for connect. cleaning }
  {$EXTERNALSYM DM}
  NOP         = 241;    { nop }
  {$EXTERNALSYM NOP}
  SE          = 240;    { end sub negotiation }
  {$EXTERNALSYM SE}
  EOR         = 239;    { end of record (transparent mode) }
  {$EXTERNALSYM EOR}
  ABORT       = 238;    { Abort process }
  {$EXTERNALSYM ABORT}
  SUSP        = 237;    { Suspend process }
  {$EXTERNALSYM SUSP}
  xEOF        = 236;    { End of file: EOF is already used... }
  {$EXTERNALSYM xEOF}

  SYNCH       = 242;    { for telfunc calls }
  {$EXTERNALSYM SYNCH}

const
  telcmds: array[0..21-1] of PChar = (
    'EOF', 'SUSP', 'ABORT', 'EOR', 'SE', 'NOP', 'DMARK', 'BRK', 'IP',
    'AO', 'AYT', 'EC', 'EL', 'GA', 'SB', 'WILL', 'WONT', 'DO', 'DONT', 'IAC', nil );
  {$EXTERNALSYM telcmds}

const
  TELCMD_FIRST   = xEOF;
  {$EXTERNALSYM TELCMD_FIRST}
  TELCMD_LAST    = IAC;
  {$EXTERNALSYM TELCMD_LAST}

function TELCMD_OK(x: Cardinal): Boolean;
{$EXTERNALSYM TELCMD_OK}
function TELCMD(x: Cardinal): PChar;
{$EXTERNALSYM TELCMD}


{ telnet options }
const
  TELOPT_BINARY        = 0;    { 8-bit data path }
  {$EXTERNALSYM TELOPT_BINARY}
  TELOPT_ECHO          = 1;    { echo }
  {$EXTERNALSYM TELOPT_ECHO}
  TELOPT_RCP           = 2;    { prepare to reconnect }
  {$EXTERNALSYM TELOPT_RCP}
  TELOPT_SGA           = 3;    { suppress go ahead }
  {$EXTERNALSYM TELOPT_SGA}
  TELOPT_NAMS          = 4;    { approximate message size }
  {$EXTERNALSYM TELOPT_NAMS}
  TELOPT_STATUS        = 5;    { give status }
  {$EXTERNALSYM TELOPT_STATUS}
  TELOPT_TM            = 6;    { timing mark }
  {$EXTERNALSYM TELOPT_TM}
  TELOPT_RCTE          = 7;    { remote controlled transmission and echo }
  {$EXTERNALSYM TELOPT_RCTE}
  TELOPT_NAOL          = 8;    { negotiate about output line width }
  {$EXTERNALSYM TELOPT_NAOL}
  TELOPT_NAOP          = 9;    { negotiate about output page size }
  {$EXTERNALSYM TELOPT_NAOP}
  TELOPT_NAOCRD        = 10;   { negotiate about CR disposition }
  {$EXTERNALSYM TELOPT_NAOCRD}
  TELOPT_NAOHTS        = 11;   { negotiate about horizontal tabstops }
  {$EXTERNALSYM TELOPT_NAOHTS}
  TELOPT_NAOHTD        = 12;   { negotiate about horizontal tab disposition }
  {$EXTERNALSYM TELOPT_NAOHTD}
  TELOPT_NAOFFD        = 13;   { negotiate about formfeed disposition }
  {$EXTERNALSYM TELOPT_NAOFFD}
  TELOPT_NAOVTS        = 14;   { negotiate about vertical tab stops }
  {$EXTERNALSYM TELOPT_NAOVTS}
  TELOPT_NAOVTD        = 15;   { negotiate about vertical tab disposition }
  {$EXTERNALSYM TELOPT_NAOVTD}
  TELOPT_NAOLFD        = 16;   { negotiate about output LF disposition }
  {$EXTERNALSYM TELOPT_NAOLFD}
  TELOPT_XASCII        = 17;   { extended ascii character set }
  {$EXTERNALSYM TELOPT_XASCII}
  TELOPT_LOGOUT        = 18;   { force logout }
  {$EXTERNALSYM TELOPT_LOGOUT}
  TELOPT_BM            = 19;   { byte macro }
  {$EXTERNALSYM TELOPT_BM}
  TELOPT_DET           = 20;   { data entry terminal }
  {$EXTERNALSYM TELOPT_DET}
  TELOPT_SUPDUP        = 21;   { supdup protocol }
  {$EXTERNALSYM TELOPT_SUPDUP}
  TELOPT_SUPDUPOUTPUT  = 22;   { supdup output }
  {$EXTERNALSYM TELOPT_SUPDUPOUTPUT}
  TELOPT_SNDLOC        = 23;   { send location }
  {$EXTERNALSYM TELOPT_SNDLOC}
  TELOPT_TTYPE         = 24;   { terminal type }
  {$EXTERNALSYM TELOPT_TTYPE}
  TELOPT_EOR           = 25;   { end or record }
  {$EXTERNALSYM TELOPT_EOR}
  TELOPT_TUID          = 26;   { TACACS user identification }
  {$EXTERNALSYM TELOPT_TUID}
  TELOPT_OUTMRK        = 27;   { output marking }
  {$EXTERNALSYM TELOPT_OUTMRK}
  TELOPT_TTYLOC        = 28;   { terminal location number }
  {$EXTERNALSYM TELOPT_TTYLOC}
  TELOPT_3270REGIME    = 29;   { 3270 regime }
  {$EXTERNALSYM TELOPT_3270REGIME}
  TELOPT_X3PAD         = 30;   { X.3 PAD }
  {$EXTERNALSYM TELOPT_X3PAD}
  TELOPT_NAWS          = 31;   { window size }
  {$EXTERNALSYM TELOPT_NAWS}
  TELOPT_TSPEED        = 32;   { terminal speed }
  {$EXTERNALSYM TELOPT_TSPEED}
  TELOPT_LFLOW         = 33;   { remote flow control }
  {$EXTERNALSYM TELOPT_LFLOW}
  TELOPT_LINEMODE      = 34;   { Linemode option }
  {$EXTERNALSYM TELOPT_LINEMODE}
  TELOPT_XDISPLOC      = 35;   { X Display Location }
  {$EXTERNALSYM TELOPT_XDISPLOC}
  TELOPT_OLD_ENVIRON   = 36;   { Old - Environment variables }
  {$EXTERNALSYM TELOPT_OLD_ENVIRON}
  TELOPT_AUTHENTICATION = 37;  { Authenticate }
  {$EXTERNALSYM TELOPT_AUTHENTICATION}
  TELOPT_ENCRYPT       = 38;   { Encryption option }
  {$EXTERNALSYM TELOPT_ENCRYPT}
  TELOPT_NEW_ENVIRON   = 39;   { New - Environment variables }
  {$EXTERNALSYM TELOPT_NEW_ENVIRON}
  TELOPT_EXOPL         = 255;  { extended-options-list }
  {$EXTERNALSYM TELOPT_EXOPL}

  NTELOPTS             = (1+TELOPT_NEW_ENVIRON);
  {$EXTERNALSYM NTELOPTS}

const
  telopts: array[0..NTELOPTS+1 -1] of PChar = (
    'BINARY', 'ECHO', 'RCP', 'SUPPRESS GO AHEAD', 'NAME',
    'STATUS', 'TIMING MARK', 'RCTE', 'NAOL', 'NAOP',
    'NAOCRD', 'NAOHTS', 'NAOHTD', 'NAOFFD', 'NAOVTS',
    'NAOVTD', 'NAOLFD', 'EXTEND ASCII', 'LOGOUT', 'BYTE MACRO',
    'DATA ENTRY TERMINAL', 'SUPDUP', 'SUPDUP OUTPUT',
    'SEND LOCATION', 'TERMINAL TYPE', 'END OF RECORD',
    'TACACS UID', 'OUTPUT MARKING', 'TTYLOC',
    '3270 REGIME', 'X.3 PAD', 'NAWS', 'TSPEED', 'LFLOW',
    'LINEMODE', 'XDISPLOC', 'OLD-ENVIRON', 'AUTHENTICATION',
    'ENCRYPT', 'NEW-ENVIRON',
    nil );

const
  TELOPT_FIRST = TELOPT_BINARY;
  {$EXTERNALSYM TELOPT_FIRST}
  TELOPT_LAST = TELOPT_NEW_ENVIRON;
  {$EXTERNALSYM TELOPT_LAST}

function TELOPT_OK(x: Cardinal): Boolean;
{$EXTERNALSYM TELOPT_OK}
function TELOPT(x: Cardinal): PChar;
{$EXTERNALSYM TELOPT}


{ sub-option qualifiers }
const
  TELQUAL_IS        = 0;   { option is... }
  {$EXTERNALSYM TELQUAL_IS}
  TELQUAL_SEND      = 1;   { send option }
  {$EXTERNALSYM TELQUAL_SEND}
  TELQUAL_INFO      = 2;   { ENVIRON: informational version of IS }
  {$EXTERNALSYM TELQUAL_INFO}
  TELQUAL_REPLY     = 2;   { AUTHENTICATION: client version of IS }
  {$EXTERNALSYM TELQUAL_REPLY}
  TELQUAL_NAME      = 3;   { AUTHENTICATION: client version of IS }
  {$EXTERNALSYM TELQUAL_NAME}

  LFLOW_OFF         = 0;   { Disable remote flow control }
  {$EXTERNALSYM LFLOW_OFF}
  LFLOW_ON          = 1;   { Enable remote flow control }
  {$EXTERNALSYM LFLOW_ON}
  LFLOW_RESTART_ANY = 2;   { Restart output on any char }
  {$EXTERNALSYM LFLOW_RESTART_ANY}
  LFLOW_RESTART_XON = 3;   { Restart output only on XON }
  {$EXTERNALSYM LFLOW_RESTART_XON}

{ LINEMODE suboptions }

  LM_MODE           = 1;
  {$EXTERNALSYM LM_MODE}
  LM_FORWARDMASK    = 2;
  {$EXTERNALSYM LM_FORWARDMASK}
  LM_SLC            = 3;
  {$EXTERNALSYM LM_SLC}

  MODE_EDIT         = $01;
  {$EXTERNALSYM MODE_EDIT}
  MODE_TRAPSIG      = $02;
  {$EXTERNALSYM MODE_TRAPSIG}
  MODE_ACK          = $04;
  {$EXTERNALSYM MODE_ACK}
  MODE_SOFT_TAB     = $08;
  {$EXTERNALSYM MODE_SOFT_TAB}
  MODE_LIT_ECHO     = $10;
  {$EXTERNALSYM MODE_LIT_ECHO}

  MODE_MASK         = $1f;
  {$EXTERNALSYM MODE_MASK}

{ Not part of protocol, but needed to simplify things... }
  MODE_FLOW      = $0100;
  {$EXTERNALSYM MODE_FLOW}
  MODE_ECHO      = $0200;
  {$EXTERNALSYM MODE_ECHO}
  MODE_INBIN     = $0400;
  {$EXTERNALSYM MODE_INBIN}
  MODE_OUTBIN    = $0800;
  {$EXTERNALSYM MODE_OUTBIN}
  MODE_FORCE     = $1000;
  {$EXTERNALSYM MODE_FORCE}

  SLC_SYNCH    = 1;
  {$EXTERNALSYM SLC_SYNCH}
  SLC_BRK      = 2;
  {$EXTERNALSYM SLC_BRK}
  SLC_IP       = 3;
  {$EXTERNALSYM SLC_IP}
  SLC_AO       = 4;
  {$EXTERNALSYM SLC_AO}
  SLC_AYT      = 5;
  {$EXTERNALSYM SLC_AYT}
  SLC_EOR      = 6;
  {$EXTERNALSYM SLC_EOR}
  SLC_ABORT    = 7;
  {$EXTERNALSYM SLC_ABORT}
  SLC_EOF      = 8;
  {$EXTERNALSYM SLC_EOF}
  SLC_SUSP     = 9;
  {$EXTERNALSYM SLC_SUSP}
  SLC_EC       = 10;
  {$EXTERNALSYM SLC_EC}
  SLC_EL       = 11;
  {$EXTERNALSYM SLC_EL}
  SLC_EW       = 12;
  {$EXTERNALSYM SLC_EW}
  SLC_RP       = 13;
  {$EXTERNALSYM SLC_RP}
  SLC_LNEXT    = 14;
  {$EXTERNALSYM SLC_LNEXT}
  SLC_XON      = 15;
  {$EXTERNALSYM SLC_XON}
  SLC_XOFF     = 16;
  {$EXTERNALSYM SLC_XOFF}
  SLC_FORW1    = 17;
  {$EXTERNALSYM SLC_FORW1}
  SLC_FORW2    = 18;
  {$EXTERNALSYM SLC_FORW2}

  NSLC         = 18;
  {$EXTERNALSYM NSLC}

{
 * For backwards compatibility, we define SLC_NAMES to be the
 * list of names if SLC_NAMES is not defined.
 }
const
  slc_names: array[0..20-1] of PChar = (
    '0', 'SYNCH', 'BRK', 'IP', 'AO', 'AYT', 'EOR', 'ABORT', 'EOF',
    'SUSP', 'EC', 'EL', 'EW', 'RP', 'LNEXT', 'XON', 'XOFF', 'FORW1', 'FORW2', nil);
  {$EXTERNALSYM slc_names}

function SLC_NAME_OK(x: Cardinal): Boolean;
{$EXTERNALSYM SLC_NAME_OK}
function SLC_NAME(x: Cardinal): PChar;
{$EXTERNALSYM SLC_NAME}

const
  SLC_NOSUPPORT    = 0;
  {$EXTERNALSYM SLC_NOSUPPORT}
  SLC_CANTCHANGE   = 1;
  {$EXTERNALSYM SLC_CANTCHANGE}
  SLC_VARIABLE     = 2;
  {$EXTERNALSYM SLC_VARIABLE}
  SLC_DEFAULT      = 3;
  {$EXTERNALSYM SLC_DEFAULT}
  SLC_LEVELBITS    = $03;
  {$EXTERNALSYM SLC_LEVELBITS}

  SLC_FUNC    = 0;
  {$EXTERNALSYM SLC_FUNC}
  SLC_FLAGS   = 1;
  {$EXTERNALSYM SLC_FLAGS}
  SLC_VALUE   = 2;
  {$EXTERNALSYM SLC_VALUE}

  SLC_ACK        = $80;
  {$EXTERNALSYM SLC_ACK}
  SLC_FLUSHIN    = $40;
  {$EXTERNALSYM SLC_FLUSHIN}
  SLC_FLUSHOUT   = $20;
  {$EXTERNALSYM SLC_FLUSHOUT}

  OLD_ENV_VAR     = 1;
  {$EXTERNALSYM OLD_ENV_VAR}
  OLD_ENV_VALUE   = 0;
  {$EXTERNALSYM OLD_ENV_VALUE}
  NEW_ENV_VAR     = 0;
  {$EXTERNALSYM NEW_ENV_VAR}
  NEW_ENV_VALUE   = 1;
  {$EXTERNALSYM NEW_ENV_VALUE}
  ENV_ESC         = 2;
  {$EXTERNALSYM ENV_ESC}
  ENV_USERVAR     = 3;
  {$EXTERNALSYM ENV_USERVAR}

{ AUTHENTICATION suboptions }

{ Who is authenticating who ... }
  AUTH_WHO_CLIENT = 0;   { Client authenticating server }
  {$EXTERNALSYM AUTH_WHO_CLIENT}
  AUTH_WHO_SERVER = 1;   { Server authenticating client }
  {$EXTERNALSYM AUTH_WHO_SERVER}
  AUTH_WHO_MASK   = 1;
  {$EXTERNALSYM AUTH_WHO_MASK}

{ Amount of authentication done }
  AUTH_HOW_ONE_WAY = 0;
  {$EXTERNALSYM AUTH_HOW_ONE_WAY}
  AUTH_HOW_MUTUAL  = 2;
  {$EXTERNALSYM AUTH_HOW_MUTUAL}
  AUTH_HOW_MASK    = 2;
  {$EXTERNALSYM AUTH_HOW_MASK}

  AUTHTYPE_NULL        = 0;
  {$EXTERNALSYM AUTHTYPE_NULL}
  AUTHTYPE_KERBEROS_V4 = 1;
  {$EXTERNALSYM AUTHTYPE_KERBEROS_V4}
  AUTHTYPE_KERBEROS_V5 = 2;
  {$EXTERNALSYM AUTHTYPE_KERBEROS_V5}
  AUTHTYPE_SPX         = 3;
  {$EXTERNALSYM AUTHTYPE_SPX}
  AUTHTYPE_MINK        = 4;
  {$EXTERNALSYM AUTHTYPE_MINK}
  AUTHTYPE_CNT         = 5;
  {$EXTERNALSYM AUTHTYPE_CNT}

  AUTHTYPE_TEST        = 99;
  {$EXTERNALSYM AUTHTYPE_TEST}

const
  authtype_names: array[0..6-1] of PChar =
    ('NULL', 'KERBEROS_V4', 'KERBEROS_V5', 'SPX', 'MINK', nil);
  {$EXTERNALSYM authtype_names}

function AUTHTYPE_NAME_OK(x: Cardinal): Boolean;
{$EXTERNALSYM AUTHTYPE_NAME_OK}
function AUTHTYPE_NAME(x: Cardinal): PChar;
{$EXTERNALSYM AUTHTYPE_NAME}


{ ENCRYPTion suboptions }
const
  ENCRYPT_IS         = 0;   { I pick encryption type ... }
  {$EXTERNALSYM ENCRYPT_IS}
  ENCRYPT_SUPPORT    = 1;   { I support encryption types ... }
  {$EXTERNALSYM ENCRYPT_SUPPORT}
  ENCRYPT_REPLY      = 2;   { Initial setup response }
  {$EXTERNALSYM ENCRYPT_REPLY}
  ENCRYPT_START      = 3;   { Am starting to send encrypted }
  {$EXTERNALSYM ENCRYPT_START}
  ENCRYPT_END        = 4;   { Am ending encrypted }
  {$EXTERNALSYM ENCRYPT_END}
  ENCRYPT_REQSTART   = 5;   { Request you start encrypting }
  {$EXTERNALSYM ENCRYPT_REQSTART}
  ENCRYPT_REQEND     = 6;   { Request you send encrypting }
  {$EXTERNALSYM ENCRYPT_REQEND}
  ENCRYPT_ENC_KEYID  = 7;
  {$EXTERNALSYM ENCRYPT_ENC_KEYID}
  ENCRYPT_DEC_KEYID  = 8;
  {$EXTERNALSYM ENCRYPT_DEC_KEYID}
  ENCRYPT_CNT        = 9;
  {$EXTERNALSYM ENCRYPT_CNT}

  ENCTYPE_ANY        = 0;
  {$EXTERNALSYM ENCTYPE_ANY}
  ENCTYPE_DES_CFB64  = 1;
  {$EXTERNALSYM ENCTYPE_DES_CFB64}
  ENCTYPE_DES_OFB64  = 2;
  {$EXTERNALSYM ENCTYPE_DES_OFB64}
  ENCTYPE_CNT        = 3;
  {$EXTERNALSYM ENCTYPE_CNT}

const
  encrypt_names: array[0..10-1] of PChar = (
    'IS', 'SUPPORT', 'REPLY', 'START', 'END',
    'REQUEST-START', 'REQUEST-END', 'ENC-KEYID', 'DEC-KEYID', nil);
  {$EXTERNALSYM encrypt_names}

  enctype_names: array[0..4-1] of PChar = (
    'ANY', 'DES_CFB64',  'DES_OFB64', nil);
  {$EXTERNALSYM enctype_names}


function ENCRYPT_NAME_OK(x: Cardinal): Boolean;
{$EXTERNALSYM ENCRYPT_NAME_OK}
function ENCRYPT_NAME(x: Cardinal): PChar;
{$EXTERNALSYM ENCRYPT_NAME}

function ENCTYPE_NAME_OK(x: Cardinal): Boolean;
{$EXTERNALSYM ENCTYPE_NAME_OK}
function ENCTYPE_NAME(x: Cardinal): PChar;
{$EXTERNALSYM ENCTYPE_NAME}


{$HPPEMIT '#include <arpa/tftp.h>'}
// Translated from arpa/tftp.h

const
{ Trivial File Transfer Protocol (IEN-133) }
  SEGSIZE = 512;   { data segment size }
  {$EXTERNALSYM SEGSIZE}

{ Packet types. }
  RRQ    = 1;   { read request }
  {$EXTERNALSYM RRQ}
  WRQ    = 2;   { write request }
  {$EXTERNALSYM WRQ}
  DATA   = 3;   { data packet }
  {$EXTERNALSYM DATA}
  ACK    = 4;   { acknowledgement }
  {$EXTERNALSYM ACK}
  ERROR_telnet  = 5;   { error code } (* renamed from TELNET *)
  {.$EXTERNALSYM ERROR}

type
  th_u = {packed} record
    case Integer of
      1: (tu_block: Word);                             { block # }
      2: (tu_code: Smallint);                          { error code }
      3: (tu_stuff: packed array[0..1-1] of Shortint); { request packet stuff }
    end;
  {$EXTERNALSYM th_u}

  tftphdr = {packed} record
    th_opcode: Smallint;                    { packet type }
    th_u_data: th_u;
    th_data: packed array[0..1-1] of Char;  { data or error string }
  end;
  {$EXTERNALSYM tftphdr}

const
{ Error codes. }
  EUNDEF     = 0;    { not defined }
  {$EXTERNALSYM EUNDEF}
  ENOTFOUND  = 1;    { file not found }
  {$EXTERNALSYM ENOTFOUND}
  EACCESS    = 2;    { access violation }
  {$EXTERNALSYM EACCESS}
  ENOSPACE   = 3;    { disk full or allocation exceeded }
  {$EXTERNALSYM ENOSPACE}
  EBADOP     = 4;    { illegal TFTP operation }
  {$EXTERNALSYM EBADOP}
  EBADID     = 5;    { unknown transfer ID }
  {$EXTERNALSYM EBADID}
  EEXISTS    = 6;    { file already exists }
  {$EXTERNALSYM EEXISTS}
  ENOUSER    = 7;    { no such user }
  {$EXTERNALSYM ENOUSER}


const
  libresolvmodulename = 'libresolv.so.2';

implementation

function ns_get16;                      external libresolvmodulename name '__ns_get16';
function ns_get32;                      external libresolvmodulename name '__ns_get32';
procedure ns_put16;                     external libresolvmodulename name '__ns_put16';
procedure ns_put32;                     external libresolvmodulename name '__ns_put32';
function ns_initparse;                  external libresolvmodulename name '__ns_initparse';
function ns_skiprr;                     external libresolvmodulename name '__ns_skiprr';
function ns_parserr;                    external libresolvmodulename name '__ns_parserr';
function ns_sprintrr;                   external libresolvmodulename name '__ns_sprintrr';
function ns_sprintrrf;                  external libresolvmodulename name '__ns_sprintrrf';
function ns_format_ttl;                 external libresolvmodulename name '__ns_format_ttl';
function ns_parse_ttl;                  external libresolvmodulename name '__ns_parse_ttl';
function ns_datetosecs;                 external libresolvmodulename name '__ns_datetosecs';
function ns_name_ntol;                  external libresolvmodulename name '__ns_name_ntol';
function ns_name_ntop;                  external libresolvmodulename name '__ns_name_ntop';
function ns_name_pton;                  external libresolvmodulename name '__ns_name_pton';
function ns_name_unpack;                external libresolvmodulename name '__ns_name_unpack';
function ns_name_pack;                  external libresolvmodulename name '__ns_name_pack';
function ns_name_uncompress;            external libresolvmodulename name '__ns_name_uncompress';
function ns_name_compress;              external libresolvmodulename name '__ns_name_compress';
function ns_name_skip;                  external libresolvmodulename name '__ns_name_skip';
procedure ns_name_rollback;             external libresolvmodulename name '__ns_name_rollback';
function ns_sign;                       external libresolvmodulename name '__ns_sign';
function ns_sign_tcp;                   external libresolvmodulename name '__ns_sign_tcp';
function ns_sign_tcp_init;              external libresolvmodulename name '__ns_sign_tcp_init';
function ns_find_tsig;                  external libresolvmodulename name '__ns_find_tsig';
function ns_verify;                     external libresolvmodulename name '__ns_verify';
function ns_verify_tcp;                 external libresolvmodulename name '__ns_verify_tcp';
function ns_verify_tcp_init;            external libresolvmodulename name '__ns_verify_tcp_init';
function ns_samedomain;                 external libresolvmodulename name '__ns_samedomain';
function ns_subdomain;                  external libresolvmodulename name '__ns_subdomain';
function ns_makecanon;                  external libresolvmodulename name '__ns_makecanon';
function ns_samename;                   external libresolvmodulename name '__ns_samename';


function ns_msg_getflag(const handle: ns_msg; flag: Cardinal): Integer;
var
  ns_flagdata: _ns_flagdata;
  ns_flagdata_Symbol: Pointer;
begin
  ns_flagdata_Symbol := dlsym(nil, '_ns_flagdata');
  if not Assigned(ns_flagdata_Symbol) then
  begin
    Result := -1;
    Exit;
  end;

  Inc(Cardinal(ns_flagdata_Symbol), SizeOf(_ns_flagdata) * flag);
  ns_flagdata := _ns_flagdata(ns_flagdata_Symbol^);

  Result := handle._flags and (ns_flagdata.mask shr ns_flagdata.shift);
end;

function ns_msg_id(const handle: ns_msg): Integer;
begin
  Result := handle._id;
end;

function ns_msg_base(const handle: ns_msg): PByte;
begin
  Result := handle._msg;
end;

function ns_msg_end(const handle: ns_msg): PByte;
begin
  Result := handle._eom;
end;

function ns_msg_size(const handle: ns_msg): Integer;
begin
  Result := Cardinal(handle._eom) - Cardinal(handle._msg);
end;

function ns_msg_count(const handle: ns_msg; section: Cardinal): u_int16_t;
begin
  Result := handle._counts[section];
end;


function ns_rr_name(const rr: ns_rr): PChar;
const
  Dot: PChar = '.';
begin
  if rr.name[0] <> #0 then
    Result := rr.name
  else
    Result := Dot;
end;

function ns_rr_type(const rr: ns_rr): u_int16_t;
begin
  Result := rr.__type;
end;

function ns_rr_class(const rr: ns_rr): u_int16_t;
begin
  Result := rr.rr_class;
end;

function ns_rr_ttl(const rr: ns_rr): u_int32_t;
begin
  Result := rr.ttl;
end;

function ns_rr_rdlen(const rr: ns_rr): u_int16_t;
begin
  Result := rr.rdlength;
end;

function ns_rr_rdata(const rr: ns_rr): PByte;
begin
  Result := rr.rdata;
end;


function ns_t_qt_p(Value: ns_type): Boolean;
begin
  Result := ns_t_xfr_p(Value) or (Value = ns_t_any) or
            (Value = ns_t_mailb) or (Value = ns_t_maila);
end;

{ Some kind of meta-RR? (not a QTYPE, but also not an RTYPE) }
function ns_t_mrr_p(Value: ns_type): Boolean;
begin
  Result := (Value = ns_t_tsig) or (Value = ns_t_opt);
end;

{ Exclusively an RTYPE? (not also a QTYPE or a meta-RR) }
function ns_t_rr_p(Value: ns_type): Boolean;
begin
  Result := (not ns_t_qt_p(Value)) and (not ns_t_mrr_p(Value));
end;

function ns_t_udp_p(Value: ns_type): Boolean;
begin
  Result := (Value <> ns_t_axfr) and (Value <> ns_t_zxfr);
end;

function ns_t_xfr_p(Value: ns_type): Boolean;
begin
  Result := (Value = ns_t_axfr) or(Value = ns_t_ixfr) or (Value = ns_t_zxfr);
end;

function TELCMD_OK(x: Cardinal): Boolean;
begin
  Result := (x <= TELCMD_LAST) and (x >= TELCMD_FIRST);
end;

function TELCMD(x: Cardinal): PChar;
begin
  Result := telcmds[x - TELCMD_FIRST];
end;

function TELOPT_OK(x: Cardinal): Boolean;
begin
  Result := (x <= TELOPT_LAST);
end;

function TELOPT(x: Cardinal): PChar;
begin
  Result := telopts[x - TELOPT_FIRST];
end;

function SLC_NAME_OK(x: Cardinal): Boolean;
begin
  Result := (x <= NSLC);
end;

function SLC_NAME(x: Cardinal): PChar;
begin
  Result := slc_names[x];
end;

function AUTHTYPE_NAME_OK(x: Cardinal): Boolean;
begin
  Result := (x < AUTHTYPE_CNT);
end;

function AUTHTYPE_NAME(x: Cardinal): PChar;
begin
  Result := authtype_names[x];
end;

function ENCRYPT_NAME_OK(x: Cardinal): Boolean;
begin
  Result := (x < ENCRYPT_CNT);
end;

function ENCRYPT_NAME(x: Cardinal): PChar;
begin
  Result := encrypt_names[x];
end;

function ENCTYPE_NAME_OK(x: Cardinal): Boolean;
begin
  Result := (x < ENCTYPE_CNT);
end;

function ENCTYPE_NAME(x: Cardinal): PChar;
begin
  Result := enctype_names[x];
end;

end.


