{ *********************************************************************** }
{                                                                         }
{  Borland Kylix Runtime Library                                          }
{  Linux API Interface Unit (RPC clients)                                 }
{                                                                         }
{  This translation is based on glibc 2.2.1,                              }
{  compiled from sources on a Linux 2.2.16 kernel.                        }
{                                                                         }
{  Copyright (C) 2001-2002 Borland Software Corporation                   }
{                                                                         }
{  Translator: Borland Software Corporation                               }
{                                                                         }
{  This file may be distributed and/or modified under the terms of the    }
{  GNU General Public License version 2 as published by the Free Software }
{  Foundation and appearing at http://www.borland.com/kylix/gpl.html.     }
{                                                                         }
{  Licensees holding a valid Borland No-Nonsense License for this         }
{  Software may use this file in accordance with such license, which      }
{  appears in hte file license.txt that came with this software.          }
{                                                                         }
{ *********************************************************************** }

unit LibcRpc;

{$WEAKPACKAGEUNIT}

{$ALIGN 4}
{$MINENUMSIZE 4}
{$ASSERTIONS OFF}

interface

uses
  Libc;

// Translated from rpc/types.h

{$HPPEMIT '#include <rpc/types.h>'}

{ Rpc additions to <sys/types.h> }

type
  bool_t = Integer;
  {$EXTERNALSYM bool_t}
  enum_t = Integer;
  {$EXTERNALSYM enum_t}
  { This needs to be changed to uint32_t in the future }
  rpcprog_t = LongWord;
  {$EXTERNALSYM rpcprog_t}
  rpcvers_t = LongWord;
  {$EXTERNALSYM rpcvers_t}
  rpcproc_t = LongWord;
  {$EXTERNALSYM rpcproc_t}
  rpcprot_t = LongWord;
  {$EXTERNALSYM rpcprot_t}
  rpcport_t = LongWord;
  {$EXTERNALSYM rpcport_t}

const
  __dontcare__ = -1;
  {$EXTERNALSYM __dontcare__}

(*
#include <stdlib.h>		{ For malloc decl.  }
#define mem_alloc(bsize)	malloc(bsize)
#define mem_free(ptr, bsize)	free(ptr)

#ifndef makedev { ie, we haven't already included it }
#include <sys/types.h>
#endif
#include <sys/time.h>
#include <sys/param.h>

#include <netinet/in.h>
*)

const
  INADDR_LOOPBACK = u_long($7F000001);
  {$EXTERNALSYM INADDR_LOOPBACK}
  MAXHOSTNAMELEN = 64;
  {$EXTERNALSYM MAXHOSTNAMELEN}


// Translated from rpc/xdr.h

{$HPPEMIT '#include <rpc/xdr.h>'}

{ External Data Representation Serialization Routines. }

{
 * XDR provides a conventional way for converting between C data
 * types and an external bit-string representation.  Library supplied
 * routines provide for the conversion on built-in C data types.  These
 * routines and utility routines defined here are used to help implement
 * a type encode/decode routine for each user-defined type.
 *
 * Each data type provides a single procedure which takes two arguments:
 *
 *      bool_t
 *      xdrproc(xdrs, argresp)
 *              XDR *xdrs;
 *              <type> *argresp;
 *
 * xdrs is an instance of a XDR handle, to which or from which the data
 * type is to be converted.  argresp is a pointer to the structure to be
 * converted.  The XDR handle contains an operation field which indicates
 * which of the operations (ENCODE, DECODE * or FREE) is to be performed.
 *
 * XDR_DECODE may allocate space if the pointer argresp is null.  This
 * data can be freed with the XDR_FREE operation.
 *
 * We write only one procedure per data type to make it easy
 * to keep the encode and decode procedures for a data type consistent.
 * In many cases the same code performs all operations on a user defined type,
 * because all the hard work is done in the component type routines.
 * decode as a series of calls on the nested data types.
 }

{
 * Xdr operations.  XDR_ENCODE causes the type to be encoded into the
 * stream.  XDR_DECODE causes the type to be extracted from the stream.
 * XDR_FREE can be used to release the space allocated by an XDR_DECODE
 * request.
 }
type
  xdr_op =
  (
    XDR_ENCODE = 0,
    {$EXTERNALSYM XDR_ENCODE}
    XDR_DECODE = 1,
    {$EXTERNALSYM XDR_DECODE}
    _XDR_FREE = 2
    {.$EXTERNALSYM XDR_FREE} // Renamed to avoid identifier conflict
  );
  {$EXTERNALSYM xdr_op}

{ This is the number of bytes per unit of external data. }
const
  BYTES_PER_XDR_UNIT = 4;
  {$EXTERNALSYM BYTES_PER_XDR_UNIT}
{
 * This only works if the above is a power of 2.  But it's defined to be
 * 4 by the appropriate RFCs.  So it will work.  And it's normally quicker
 * than the old routine.
 }

function RNDUP(x: Integer): Integer;
{$EXTERNALSYM RNDUP}

{
 * The XDR handle.
 * Contains operation which is being applied to the stream,
 * an operations vector for the particular implementation (e.g. see xdr_mem.c),
 * and two private fields for the use of the particular implementation.
 }

type
  Pint32_t = ^int32_t;
  PXdr = ^TXdr;

  xdr_ops = {packed} record
    x_getlong: function(__xdrs: PXdr; __lp: PLongWord): bool_t; cdecl;
    { get a long from underlying stream }
    x_putlong: function(__xdrs: PXdr; __lp: PLongWord): bool_t; cdecl;
    { put a long to " }
    x_getbytes: function(__xdrs: PXdr; __addr: caddr_t; __len: u_int): bool_t; cdecl;
    { get some bytes from " }
    x_putbytes: function(__xdrs: PXdr; __addr: PChar; __len: u_int): bool_t; cdecl;
    { put some bytes to " }
    x_getpostn: function(__xdrs: PXdr): u_int; cdecl;
    { returns bytes off from beginning }
    x_setpostn: function(__xdrs: PXdr; __pos: u_int): bool_t; cdecl;
    { lets you reposition the stream }
    x_inline: function(__xdrs: PXdr; __len: Integer): Pint32_t; cdecl;
    { buf quick ptr to buffered data }
    x_destroy: procedure(__xdrs: PXdr); cdecl;
    { free privates of this xdr_stream }
    x_getint32: function(__xdrs: PXdr; __ip: Pint32_t): bool_t; cdecl;
    { get a int from underlying stream }
    x_putint32: function(__xdrs: PXdr; __ip: Pint32_t): bool_t; cdecl;
    { put a int to " }
  end;
  TXdrOps = xdr_ops;
  PXdrOps = ^TXdrOps;

  XDR = {packed} record
    x_op: xdr_op;            { operation; fast additional param }
    x_ops: PXdrOps;
    x_public: caddr_t;       { users' data }
    x_private: caddr_t;      { pointer to private data }
    x_base: caddr_t;         { private used for position info }
    x_handy: Integer;        { extra private word }
  end;
  {$EXTERNALSYM XDR}
  TXdr = XDR;

{
 * A xdrproc_t exists for each data type which is to be encoded or decoded.
 *
 * The second argument to the xdrproc_t is a pointer to an opaque pointer.
 * The opaque pointer generally points to a structure of the data type
 * to be decoded.  If this pointer is 0, then the type routines should
 * allocate dynamic storage of the appropriate size and return it.
 * bool_t       (*xdrproc_t)(XDR *, caddr_t *);
 }

type
  xdrproc_t = function(p1: PXdr; p2: Pointer): bool_t; cdecl varargs;
  {$EXTERNALSYM xdrproc_t}


{
 * Operations defined on a XDR handle
 *
 * XDR          *xdrs;
 * int32_t      *int32p;
 * long         *longp;
 * caddr_t       addr;
 * u_int         len;
 * u_int         pos;
 }

function XDR_GETINT32(xdrs: PXdr; int32p: Pint32_t): bool_t;
{$EXTERNALSYM XDR_GETINT32}
function XDR_PUTINT32(xdrs: PXdr; int32p: Pint32_t): bool_t;
{$EXTERNALSYM XDR_PUTINT32}
function XDR_GETLONG(xdrs: PXdr; lp: PLongWord): bool_t;
{$EXTERNALSYM XDR_GETLONG}
function XDR_PUTLONG(xdrs: PXdr; lp: PLongWord): bool_t;
{$EXTERNALSYM XDR_PUTLONG}
function XDR_GETBYTES(xdrs: PXdr; addr: caddr_t; len: u_int): bool_t;
{$EXTERNALSYM XDR_GETBYTES}
function XDR_PUTBYTES(xdrs: PXdr; addr: PChar; len: u_int): bool_t;
{$EXTERNALSYM XDR_PUTBYTES}
function XDR_GETPOS(xdrs: PXdr): u_int;
{$EXTERNALSYM XDR_GETPOS}
function XDR_SETPOS(xdrs: PXdr; pos: u_int): bool_t;
{$EXTERNALSYM XDR_SETPOS}
function XDR_INLINE(xdrs: PXdr; len: Integer): Pint32_t;
{$EXTERNALSYM XDR_INLINE}
procedure XDR_DESTROY(xdrs: PXdr);
{$EXTERNALSYM XDR_DESTROY}


{
 * Support struct for discriminated unions.
 * You create an array of xdrdiscrim structures, terminated with
 * a entry with a null procedure pointer.  The xdr_union routine gets
 * the discriminant value and then searches the array of structures
 * for a matching value.  If a match is found the associated xdr routine
 * is called to handle that part of the union.  If there is
 * no match, then a default routine may be called.
 * If there is no match and no default routine it is an error.
 }
const
  NULL_xdrproc_t = nil;
  {$EXTERNALSYM NULL_xdrproc_t}

type
  xdr_discrim = {packed} record
    value: Integer;
    proc: xdrproc_t;
  end;
  {$EXTERNALSYM xdr_discrim}
  TXdrDiscrm = xdr_discrim;
  PXdrDiscrm = ^TXdrDiscrm;

{
 * Inline routines for fast encode/decode of primitive data types.
 * Caveat emptor: these use single memory cycles to get the
 * data from the underlying buffer, and will fail to operate
 * properly if the data is not aligned.  The standard way to use these
 * is to say:
 *      if ((buf = XDR_INLINE(xdrs, count)) == NULL)
 *              return (FALSE);
 *      <<< macro calls >>>
 * where ``count'' is the number of bytes of data occupied
 * by the primitive data types.
 *
 * N.B. and frozen for all time: each data type here uses 4 bytes
 * of external representation.
 }

function IXDR_GET_INT32(var Buf: Pointer): int32_t;
{$EXTERNALSYM IXDR_GET_INT32}
function IXDR_PUT_INT32(var Buf: Pointer; Value: int32_t): int32_t;
{$EXTERNALSYM IXDR_PUT_INT32}
function IXDR_GET_U_INT32(var Buf: Pointer): uint32_t;
{$EXTERNALSYM IXDR_GET_U_INT32}
function IXDR_PUT_U_INT32(var Buf: Pointer; Value: uint32_t): uint32_t;
{$EXTERNALSYM IXDR_PUT_U_INT32}

{ WARNING: The IXDR_*_LONG defines are removed by Sun for new platforms
 * and shouldn't be used any longer. Code which use this defines or longs
 * in the RPC code will not work on 64bit Solaris platforms !
 }

function IXDR_GET_LONG(var Buf: Pointer): Longint;
{$EXTERNALSYM IXDR_GET_LONG}
function IXDR_PUT_LONG(var Buf: Pointer; Value: Longint): Longint;
{$EXTERNALSYM IXDR_PUT_LONG}
function IXDR_GET_U_LONG(var Buf: Pointer): u_long;
{$EXTERNALSYM IXDR_GET_U_LONG}
function IXDR_PUT_U_LONG(var Buf: Pointer; Value: u_long): u_long;
{$EXTERNALSYM IXDR_PUT_U_LONG}

function IXDR_GET_BOOL(var Buf: Pointer): bool_t;
{$EXTERNALSYM IXDR_GET_BOOL}

(*
#define IXDR_GET_ENUM(buf, t)         ((t)IXDR_GET_LONG(buf))
{$EXTERNALSYM IXDR_GET_ENUM}
*)

function IXDR_GET_SHORT(var Buf: Pointer): Smallint;
{$EXTERNALSYM IXDR_GET_SHORT}
function IXDR_GET_U_SHORT(var Buf: Pointer): u_short;
{$EXTERNALSYM IXDR_GET_U_SHORT}
function IXDR_PUT_BOOL(var Buf: Pointer; Value: Boolean): Boolean;
{$EXTERNALSYM IXDR_PUT_BOOL}

(*
#define IXDR_PUT_ENUM(buf, v)         IXDR_PUT_LONG(buf, (long)(v))
{$EXTERNALSYM IXDR_PUT_ENUM}
*)

function IXDR_PUT_SHORT(var Buf: Pointer; Value: Smallint): Smallint;
{$EXTERNALSYM IXDR_PUT_SHORT}
function IXDR_PUT_U_SHORT(var Buf: Pointer; Value: u_short): u_short;
{$EXTERNALSYM IXDR_PUT_U_SHORT}


{
 * These are the "generic" xdr routines.
 * None of these can have const applied because it's not possible to
 * know whether the call is a read or a write to the passed parameter
 * also, the XDR structure is always updated by some of these calls.
 }
function xdr_void(): bool_t; cdecl;
{$EXTERNALSYM xdr_void}
function xdr_short(__xdrs: PXdr; var __sp: Smallint): bool_t; cdecl;
{$EXTERNALSYM xdr_short}
function xdr_u_short(__xdrs: PXdr; __usp: u_short): bool_t; cdecl;
{$EXTERNALSYM xdr_u_short}
function xdr_int(__xdrs: PXdr; var __ip: Integer): bool_t; cdecl;
{$EXTERNALSYM xdr_int}
function xdr_u_int(__xdrs: PXdr; var __up: Cardinal): bool_t; cdecl;
{$EXTERNALSYM xdr_u_int}
function xdr_long(__xdrs: PXdr; var __lp: Longint): bool_t; cdecl;
{$EXTERNALSYM xdr_long}
function xdr_u_long(__xdrs: PXdr; var __ulp: LongWord): bool_t; cdecl;
{$EXTERNALSYM xdr_u_long}
function xdr_hyper(__xdrs: PXdr; var __llp: quad_t): bool_t; cdecl;
{$EXTERNALSYM xdr_hyper}
function xdr_u_hyper(__xdrs: PXdr; var __ullp: u_quad_t): bool_t; cdecl;
{$EXTERNALSYM xdr_u_hyper}
function xdr_longlong_t(__xdrs: PXdr; var __llp: quad_t): bool_t; cdecl;
{$EXTERNALSYM xdr_longlong_t}
function xdr_u_longlong_t(__xdrs: PXdr; var __ullp: u_quad_t): bool_t; cdecl;
{$EXTERNALSYM xdr_u_longlong_t}
function xdr_int8_t(__xdrs: PXdr; var __ip: int8_t): bool_t; cdecl;
{$EXTERNALSYM xdr_int8_t}
function xdr_uint8_t(__xdrs: PXdr; var __up: uint8_t): bool_t; cdecl;
{$EXTERNALSYM xdr_uint8_t}
function xdr_int16_t(__xdrs: PXdr; var __ip: int16_t): bool_t; cdecl;
{$EXTERNALSYM xdr_int16_t}
function xdr_uint16_t(__xdrs: PXdr; var __up: uint16_t): bool_t; cdecl;
{$EXTERNALSYM xdr_uint16_t}
function xdr_int32_t(__xdrs: PXdr; var __ip: int32_t): bool_t; cdecl;
{$EXTERNALSYM xdr_int32_t}
function xdr_uint32_t(__xdrs: PXdr; var __up: uint32_t): bool_t; cdecl;
{$EXTERNALSYM xdr_uint32_t}
function xdr_int64_t(__xdrs: PXdr; var __ip: int64_t): bool_t; cdecl;
{$EXTERNALSYM xdr_int64_t}
function xdr_uint64_t(__xdrs: PXdr; var __up: uint64_t): bool_t; cdecl;
{$EXTERNALSYM xdr_uint64_t}
function xdr_bool(__xdrs: PXdr; var __bp: bool_t): bool_t; cdecl;
{$EXTERNALSYM xdr_bool}
function xdr_enum(__xdrs: PXdr; var __ep: enum_t): bool_t; cdecl;
{$EXTERNALSYM xdr_enum}
function xdr_array(__xdrs: PXdr; var __addrp: caddr_t; var __sizep: u_int;
  __maxsize: u_int; __elsize: u_int; __elproc: xdrproc_t): bool_t; cdecl;
{$EXTERNALSYM xdr_array}

function xdr_bytes(__xdrs: PXdr; var __cpp: PChar; var __sizep: u_int;
  __maxsize: u_int): bool_t; cdecl;
{$EXTERNALSYM xdr_bytes}
function xdr_opaque(__xdrs: PXdr; __cp: caddr_t; __cnt: u_int): bool_t; cdecl;
{$EXTERNALSYM xdr_opaque}
function xdr_string(__xdrs: PXdr; var __cpp: PChar; __maxsize: u_int): bool_t; cdecl;
{$EXTERNALSYM xdr_string}
function xdr_union(__xdrs: PXdr; var __dscmp: enum_t; __unp: PChar;
  const __choices: xdr_discrim; dfault: xdrproc_t): bool_t; cdecl;
{$EXTERNALSYM xdr_union}
function xdr_char(__xdrs: PXdr; var __cp: Shortint): bool_t; cdecl;
{$EXTERNALSYM xdr_char}
function xdr_u_char(__xdrs: PXdr; var __cp: u_char): bool_t; cdecl;
{$EXTERNALSYM xdr_u_char}
function xdr_vector(__xdrs: PXdr; __basep: PByte; __nelem: u_int;
  __elemsize: u_int; __xdr_elem: xdrproc_t): bool_t; cdecl;
{$EXTERNALSYM xdr_vector}
function xdr_float(__xdrs: PXdr; var __fp: Single): bool_t; cdecl;
{$EXTERNALSYM xdr_float}
function xdr_double(__xdrs: PXdr; var __dp: Double): bool_t; cdecl;
{$EXTERNALSYM xdr_double}
function xdr_reference(__xdrs: PXdr; var __xpp: caddr_t; __size: u_int;
  __proc: xdrproc_t): bool_t; cdecl;
{$EXTERNALSYM xdr_reference}
function xdr_pointer(__xdrs: PXdr; var __objpp: PChar; __obj_size: u_int;
  __xdr_obj: xdrproc_t): bool_t; cdecl;
{$EXTERNALSYM xdr_pointer}
function xdr_wrapstring(__xdrs: PXdr; var __cpp: PChar): bool_t; cdecl;
{$EXTERNALSYM xdr_wrapstring}
function xdr_sizeof(p1: xdrproc_t; p2: Pointer): u_long; cdecl;
{$EXTERNALSYM xdr_sizeof}

{
 * Common opaque bytes objects used by many rpc protocols;
 * declared here due to commonality.
 }
const
  MAX_NETOBJ_SZ = 1024;
  {$EXTERNALSYM MAX_NETOBJ_SZ}

type
  netobj = {packed} record
    n_len: u_int;
    n_bytes: PByte;
  end;
  {$EXTERNALSYM netobj}
  TNetObj = netobj;
  PNetObj = ^TNetObj;

function xdr_netobj(__xdrs: PXdr; __np: PNetObj): bool_t; cdecl;
{$EXTERNALSYM xdr_netobj}

{
 * These are the public routines for the various implementations of
 * xdr streams.
 }

{ XDR using memory buffers }
procedure xdrmem_create(__xdrs: PXdr; __addr: caddr_t; __size: u_int; __xop: xdr_op); cdecl;
{$EXTERNALSYM xdrmem_create}

{ XDR using stdio library }
procedure xdrstdio_create(__xdrs: PXdr; __file: PIOFile; __xop: xdr_op); cdecl;
{$EXTERNALSYM xdrstdio_create}

{ XDR pseudo records for tcp }

type
  // Used anonymously in header file
  xdrrec_readit_proc = function(p1: PChar; p2: PChar; p3: Integer): Integer; cdecl;
  xdrrec_writeit_proc = function(p1: PChar; p2: PChar; p3: Integer): Integer; cdecl;

procedure xdrrec_create(__xdrs: PXdr; __sendsize: u_int; __recvsize: u_int;
  __tcp_handle: caddr_t; __readit: xdrrec_readit_proc; __writeit: xdrrec_writeit_proc); cdecl;
{$EXTERNALSYM xdrrec_create}

{ make end of xdr record }
function xdrrec_endofrecord(__xdrs: PXdr; __sendnow: bool_t): bool_t; cdecl;
{$EXTERNALSYM xdrrec_endofrecord}

{ move to beginning of next record }
function xdrrec_skiprecord(__xdrs: PXdr): bool_t; cdecl;
{$EXTERNALSYM xdrrec_skiprecord}

{ true if no more input }
function xdrrec_eof(__xdrs: PXdr): bool_t; cdecl;
{$EXTERNALSYM xdrrec_eof}

{ free memory buffers for xdr }
procedure xdr_free(__proc: xdrproc_t; __objp: PChar); cdecl;
{$EXTERNALSYM xdr_free}


{$HPPEMIT '#include <rpc/auth.h>'}

// Translated from rpc/auth.h

{ Authentication interface. }
{
 * The data structures are completely opaque to the client.  The client
 * is required to pass a AUTH * to routines that create rpc
 * "sessions".
 }

const
  MAX_AUTH_BYTES   = 400;
  {$EXTERNALSYM MAX_AUTH_BYTES}
  MAXNETNAMELEN    = 255;  { maximum length of network user's name }
  {$EXTERNALSYM MAXNETNAMELEN}

{ Status returned from authentication check }
type
  auth_stat =
  (
    AUTH_OK = 0,
    {$EXTERNALSYM AUTH_OK}
    { failed at remote end }
    AUTH_BADCRED = 1,          { bogus credentials (seal broken) }
    {$EXTERNALSYM AUTH_BADCRED}
    AUTH_REJECTEDCRED = 2,     { client should begin new session }
    {$EXTERNALSYM AUTH_REJECTEDCRED}
    AUTH_BADVERF = 3,          { bogus verifier (seal broken) }
    {$EXTERNALSYM AUTH_BADVERF}
    AUTH_REJECTEDVERF = 4,     { verifier expired or was replayed }
    {$EXTERNALSYM AUTH_REJECTEDVERF}
    AUTH_TOOWEAK = 5,          { rejected due to security reasons }
    {$EXTERNALSYM AUTH_TOOWEAK}
    { failed locally }
    AUTH_INVALIDRESP = 6,      { bogus response verifier }
    {$EXTERNALSYM AUTH_INVALIDRESP}
    AUTH_FAILED = 7            { some unknown reason }
    {$EXTERNALSYM AUTH_FAILED}
  );
  {$EXTERNALSYM auth_stat}

type
  des_block = {packed} record
    case Integer of
      1: (c: packed array[0..8-1] of Char);
      2: (key: {packed} record
                 high: u_int32_t;
                 low: u_int32_t;
               end;
         );
    end;
  {$EXTERNALSYM des_block}
  TDesBlock = des_block;
  PDesBlock = ^TDesBlock;

function xdr_des_block(__xdrs: PXdr; var __blkp: des_block): bool_t; cdecl;
{$EXTERNALSYM xdr_des_block}

{ Authentication info.  Opaque to client. }
type
  opaque_auth = {packed} record
    oa_flavor: enum_t;     { flavor of auth }
    oa_base: caddr_t;      { address of more auth stuff }
    oa_length: u_int;      { not to exceed MAX_AUTH_BYTES }
  end;
  {$EXTERNALSYM opaque_auth}

{ Auth handle, interface to client side authenticators. }

  PAuthRecord = ^TAuthRecord;

  auth_ops = {packed} record
    ah_nextverf: procedure(p1: PAuthRecord); cdecl;
    { nextverf & serialize }
    ah_marshal: function(p1: PAuthRecord; p2: PXdr): Integer; cdecl;
    { validate verifier }
    ah_validate: function(p1: PAuthRecord; var p2: opaque_auth): Integer; cdecl;
    { refresh credentials }
    ah_refresh: function(p1: PAuthRecord): Integer; cdecl;
    { destroy this structure }
    ah_destroy: procedure(p1: PAuthRecord); cdecl;
  end;
  TAuthOps = auth_ops;
  PAuthOps = ^TAuthOps;

  AUTH = {packed} record
    ah_cred: opaque_auth;
    ah_verf: opaque_auth;
    ah_key: des_block;
    ah_ops: PAuthOps;
    ah_private: caddr_t;
  end;
  {$EXTERNALSYM AUTH}
  TAuthRecord = AUTH;

{
 * Authentication ops.
 * The ops and the auth handle provide the interface to the authenticators.
 *
 * AUTH	*auth;
 * XDR	*xdrs;
 * struct opaque_auth verf;
 }
procedure AUTH_NEXTVERF(auth: PAuthRecord);
{$EXTERNALSYM AUTH_NEXTVERF}
function AUTH_MARSHALL(auth: PAuthRecord; xdrs: PXdr): Integer;
{$EXTERNALSYM AUTH_MARSHALL}
function AUTH_VALIDATE(auth: PAuthRecord; var verfp: opaque_auth): Integer;
{$EXTERNALSYM AUTH_VALIDATE}
function AUTH_REFRESH(auth: PAuthRecord): Integer;
{$EXTERNALSYM AUTH_REFRESH}
procedure AUTH_DESTROY(auth: PAuthRecord);
{$EXTERNALSYM AUTH_DESTROY}

{
 * These are the various implementations of client side authenticators.
 }

{
 * Unix style authentication
 * AUTH *authunix_create(machname, uid, gid, len, aup_gids)
 *	char *machname;
 *	int uid;
 *	int gid;
 *	int len;
 *	int *aup_gids;
 }
function authunix_create(__machname: PChar; __uid: __uid_t; __gid: __gid_t;
  __len: Integer; __aup_gids: PGid): PAuthRecord; cdecl;
{$EXTERNALSYM authunix_create}
function authunix_create_default(): PAuthRecord; cdecl;
{$EXTERNALSYM authunix_create_default}
function authnone_create(): PAuthRecord; cdecl;
{$EXTERNALSYM authnone_create}
function authdes_create(__servername: PChar; __window: u_int; var __syncaddr: sockaddr;
  var __ckey: des_block): PAuthRecord; cdecl;
{$EXTERNALSYM authdes_create}
function authdes_pk_create(p1: PChar; p2: Pnetobj; p3: u_int; var p4: sockaddr;
  var p5: des_block): PAuthRecord; cdecl;
{$EXTERNALSYM authdes_pk_create}

const
  AUTH_NONE   = 0;        { no authentication }
  {$EXTERNALSYM AUTH_NONE}
  AUTH_NULL   = 0;        { backward compatibility }
  {$EXTERNALSYM AUTH_NULL}
  AUTH_SYS    = 1;        { unix style (uid, gids) }
  {$EXTERNALSYM AUTH_SYS}
  AUTH_UNIX   = AUTH_SYS;
  {$EXTERNALSYM AUTH_UNIX}
  AUTH_SHORT  = 2;        { short hand unix style }
  {$EXTERNALSYM AUTH_SHORT}
  AUTH_DES    = 3;        { des style (encrypted timestamps) }
  {$EXTERNALSYM AUTH_DES}
  AUTH_DH     = AUTH_DES; { Diffie-Hellman (this is DES) }
  {$EXTERNALSYM AUTH_DH}
  AUTH_KERB   = 4;        { kerberos style }
  {$EXTERNALSYM AUTH_KERB}

{
 *  Netname manipulating functions
 *
 }
function getnetname(p1: PChar): Integer; cdecl;
{$EXTERNALSYM getnetname}
function host2netname(p1: PChar; p2: PChar; p3: PChar): Integer; cdecl;
{$EXTERNALSYM host2netname}
function user2netname(p1: PChar; p2: uid_t; p3: PChar): Integer; cdecl;
{$EXTERNALSYM user2netname}
function netname2user(p1: PChar; var p2: uid_t; var p3: gid_t; var p4: Integer; var p5: gid_t): Integer; cdecl;
{$EXTERNALSYM netname2user}
function netname2host(p1: PChar; p2: PChar; p3: Integer): Integer; cdecl;
{$EXTERNALSYM netname2host}

{
 *
 * These routines interface to the keyserv daemon
 *
 }
function key_decryptsession(p1: PChar; var p2: des_block): Integer; cdecl;
{$EXTERNALSYM key_decryptsession}
function key_decryptsession_pk(p1: PChar; var p2: netobj; var p3: des_block): Integer; cdecl;
{$EXTERNALSYM key_decryptsession_pk}
function key_encryptsession(p1: PChar; var p2: des_block): Integer; cdecl;
{$EXTERNALSYM key_encryptsession}
function key_encryptsession_pk(p1: PChar; var p2: netobj; var p3: des_block): Integer; cdecl;
{$EXTERNALSYM key_encryptsession_pk}
function key_gendes(var p1: des_block): Integer; cdecl;
{$EXTERNALSYM key_gendes}
function key_setsecret(p1: PChar): Integer; cdecl;
{$EXTERNALSYM key_setsecret}
function key_secretkey_is_set(): Integer; cdecl;
{$EXTERNALSYM key_secretkey_is_set}
function key_get_conv(p1: PChar; var p2: des_block): Integer; cdecl;
{$EXTERNALSYM key_get_conv}

{ XDR an opaque authentication struct. }
function xdr_opaque_auth(p1: PXdr; var p2: opaque_auth): bool_t; cdecl;
{$EXTERNALSYM xdr_opaque_auth}


{$HPPEMIT '#include <rpc/auth_des.h>'}

// Translated from rpc/auth_des.h

{ There are two kinds of "names": fullnames and nicknames }
type
  authdes_namekind =
  (
    ADN_FULLNAME = 0,
    {$EXTERNALSYM ADN_FULLNAME}
    ADN_NICKNAME = 1
    {$EXTERNALSYM ADN_NICKNAME}
  );
  {$EXTERNALSYM authdes_namekind}

{ A fullname contains the network name of the client,
   a conversation key and the window }
  authdes_fullname = {packed} record
    name: PChar;        { network name of client, up to MAXNETNAMELEN }
    key: des_block;     { conversation key }
    window: uint32_t;   { associated window }
  end;
  {$EXTERNALSYM authdes_fullname}

{ A credential }
  authdes_cred = {packed} record
    adc_namekind: authdes_namekind;
    adc_fullname: authdes_fullname;
    adc_nickname: uint32_t;
  end;
  {$EXTERNALSYM authdes_cred}

{ A timeval replacement for !32bit platforms }
  rpc_timeval = {packed} record
    tv_sec: uint32_t;            { Seconds.  }
    tv_usec: uint32_t;           { Microseconds.  }
  end;
  {$EXTERNALSYM rpc_timeval}

{ A des authentication verifier }
  authdes_verf = {packed} record

    adv_time_u: {packed} record
      case Integer of
        1: (adv_ctime: rpc_timeval);   { clear time }
        2: (adv_xtime: des_block);     { crypt time }
      end;
    adv_int_u: uint32_t;
  end;
  {$EXTERNALSYM authdes_verf}

{ des authentication verifier: client variety

   adv_timestamp is the current time.
   adv_winverf is the credential window + 1.
   Both are encrypted using the conversation key. }

(* Cannot be translated
#define adv_timestamp  adv_time_u.adv_ctime
#define adv_xtimestamp adv_time_u.adv_xtime
#define adv_winverf    adv_int_u
*)

{ des authentication verifier: server variety

   adv_timeverf is the client's timestamp + client's window
   adv_nickname is the server's nickname for the client.
   adv_timeverf is encrypted using the conversation key. }
(* Cannot be translated
#define adv_timeverf   adv_time_u.adv_ctime
#define adv_xtimeverf  adv_time_u.adv_xtime
#define adv_nickname   adv_int_u
*)

{ Map a des credential into a unix cred. }
function authdes_getucred(const __adc: authdes_cred; var __uid: uid_t;
  var __gid: gid_t; var __grouplen: SmallInt; __groups: PGid): Integer; cdecl;
{$EXTERNALSYM authdes_getucred}

{ Get the public key for NAME and place it in KEY.  NAME can only be
   up to MAXNETNAMELEN bytes long and the destination buffer KEY should
   have HEXKEYBYTES + 1 bytes long to fit all characters from the key.  }
function getpublickey(__name: PChar; __key: PChar): Integer; cdecl;
{$EXTERNALSYM getpublickey}

{ Get the secret key for NAME and place it in KEY.  PASSWD is used to
   decrypt the encrypted key stored in the database.  NAME can only be
   up to MAXNETNAMELEN bytes long and the destination buffer KEY
   should have HEXKEYBYTES + 1 bytes long to fit all characters from
   the key.  }
function getsecretkey(__name: PChar; __key: PChar; __passwd: PChar): Integer; cdecl;
{$EXTERNALSYM getsecretkey}

function rtime(var __addrp: sockaddr_in; var __timep: rpc_timeval;
  var __timeout: rpc_timeval): Integer; cdecl;
{$EXTERNALSYM rtime}


{$HPPEMIT '#include <rpc/auth_unix.h>'}

// Translated from rpc/auth_unix.h

{ Protocol for UNIX style authentication parameters for RPC }
{
 * The system is very weak.  The client uses no encryption for  it
 * credentials and only sends null verifiers.  The server sends backs
 * null verifiers or optionally a verifier that suggests a new short hand
 * for the credentials.
 }

const
{ The machine name is part of a credential; it may not exceed 255 bytes }
  MAX_MACHINE_NAME = 255;
  {$EXTERNALSYM MAX_MACHINE_NAME}

{ gids compose part of a credential; there may not be more than 16 of them }
  NGRPS = 16;
  {$EXTERNALSYM NGRPS}

{ Unix style credentials. }
type
  authunix_parms = {packed} record
    aup_time: u_long;
    aup_machname: PChar;
    aup_uid: __uid_t;
    aup_gid: __gid_t;
    aup_len: u_int;
    aup_gids: PGid;
  end;
  {$EXTERNALSYM authunix_parms}

function xdr_authunix_parms(__xdrs: PXdr; var __p: authunix_parms): bool_t; cdecl;
{$EXTERNALSYM xdr_authunix_parms}

{
 * If a response verifier has flavor AUTH_SHORT,
 * then the body of the response verifier encapsulates the following structure;
 * again it is serialized in the obvious fashion.
 }
type
  short_hand_verf = {packed} record
    new_cred: opaque_auth;
  end;
  {$EXTERNALSYM short_hand_verf}


{$HPPEMIT '#include <rpc/clnt.h>'}

// Translated from rpc/clnt.h

{ Client side remote procedure call interface. }

{
 * Rpc calls return an enum clnt_stat.  This should be looked at more,
 * since each implementation is required to live with this (implementation
 * independent) list of errors.
 }
type
  clnt_stat =
  (
    RPC_SUCCESS = 0,         { call succeeded }
    {$EXTERNALSYM RPC_SUCCESS}
    { local errors }
    RPC_CANTENCODEARGS = 1,  { can't encode arguments }
    {$EXTERNALSYM RPC_CANTENCODEARGS}
    RPC_CANTDECODERES = 2,   { can't decode results }
    {$EXTERNALSYM RPC_CANTDECODERES}
    RPC_CANTSEND = 3,        { failure in sending call }
    {$EXTERNALSYM RPC_CANTSEND}
    RPC_CANTRECV = 4,        { failure in receiving result }
    {$EXTERNALSYM RPC_CANTRECV}
    RPC_TIMEDOUT = 5,        { call timed out }
    {$EXTERNALSYM RPC_TIMEDOUT}
    { remote errors }
    RPC_VERSMISMATCH = 6,    { rpc versions not compatible }
    {$EXTERNALSYM RPC_VERSMISMATCH}
    RPC_AUTHERROR = 7,       { authentication error }
    {$EXTERNALSYM RPC_AUTHERROR}
    RPC_PROGUNAVAIL = 8,     { program not available }
    {$EXTERNALSYM RPC_PROGUNAVAIL}
    RPC_PROGVERSMISMATCH = 9,{ program version mismatched }
    {$EXTERNALSYM RPC_PROGVERSMISMATCH}
    RPC_PROCUNAVAIL = 10,    { procedure unavailable }
    {$EXTERNALSYM RPC_PROCUNAVAIL}
    RPC_CANTDECODEARGS = 11, { decode arguments error }
    {$EXTERNALSYM RPC_CANTDECODEARGS}
    RPC_SYSTEMERROR = 12,    { generic "other problem" }
    {$EXTERNALSYM RPC_SYSTEMERROR}
    RPC_NOBROADCAST = 21,    { Broadcasting not supported }
    {$EXTERNALSYM RPC_NOBROADCAST}
    { callrpc & clnt_create errors }
    RPC_UNKNOWNHOST = 13,    { unknown host name }
    {$EXTERNALSYM RPC_UNKNOWNHOST}
    RPC_UNKNOWNPROTO = 17,   { unknown protocol }
    {$EXTERNALSYM RPC_UNKNOWNPROTO}
    RPC_UNKNOWNADDR = 19,    { Remote address unknown }
    {$EXTERNALSYM RPC_UNKNOWNADDR}

    { rpcbind errors }
    RPC_RPCBFAILURE = 14,    { portmapper failed in its call }
    {$EXTERNALSYM RPC_RPCBFAILURE}
    RPC_PMAPFAILURE = RPC_RPCBFAILURE,
    {$EXTERNALSYM RPC_PMAPFAILURE}
    RPC_PROGNOTREGISTERED = 15, { remote program is not registered }
    {$EXTERNALSYM RPC_PROGNOTREGISTERED}
    RPC_N2AXLATEFAILURE = 22,{ Name to addr translation failed }
    {$EXTERNALSYM RPC_N2AXLATEFAILURE}
    { unspecified error }
    RPC_FAILED = 16,
    {$EXTERNALSYM RPC_FAILED}
    RPC_INTR = 18,
    {$EXTERNALSYM RPC_INTR}
    RPC_TLIERROR = 20,
    {$EXTERNALSYM RPC_TLIERROR}
    RPC_UDERROR = 23,
    {$EXTERNALSYM RPC_UDERROR}
    { asynchronous errors }
    RPC_INPROGRESS = 24,
    {$EXTERNALSYM RPC_INPROGRESS}
    RPC_STALERACHANDLE = 25
    {$EXTERNALSYM RPC_STALERACHANDLE}
  );
  {$EXTERNALSYM clnt_stat}


{ Error info. }
type
  rpc_err = {packed} record
    re_status: clnt_stat;
    rpc_err_union: {packed} record
                     case Integer of
                       0: (RE_errno: Integer); { related system error }
                       1: (RE_why: auth_stat); { why the auth error occurred }
                       2: (RE_vers: {packed} record
                             low: u_long;      { lowest verion supported }
                             high: u_long;     { highest verion supported }
                           end);
                     end;
    RE_lb: {packed} record { maybe meaningful if RPC_FAILED }
      s1: Longint;
      s2: Longint;
    end;
  end;
  {$EXTERNALSYM rpc_err}
  ru = rpc_err;
  {$EXTERNALSYM ru}
  TRpcError = rpc_err;
  PRpcError = ^TRpcError;

(* Cannot be translated
#define	re_errno	ru.RE_errno
#define	re_why		ru.RE_why
#define	re_vers		ru.RE_vers
#define	re_lb		ru.RE_lb
*)


{
 * Client rpc handle.
 * Created by individual implementations, see e.g. rpc_udp.c.
 * Client is responsible for initializing auth, see e.g. auth_none.c.
 }

  PClientRecord = ^TClientRecord;

  clnt_ops = {packed} record
    { call remote procedure }
    cl_call: function(rh: PClientRecord; proc: u_long; xargs: xdrproc_t; argsp: caddr_t;
      xres: xdrproc_t; resp: caddr_t; secs: timeval): clnt_stat; cdecl;
    { abort a call }
    cl_abort: procedure(); cdecl;
    { get specific error code }
    cl_geterr: procedure(rh: PClientRecord; var errp: rpc_err); cdecl;
    { frees results }
    cl_freeres: function(rh: PClientRecord; xres: xdrproc_t; resp: caddr_t): bool_t; cdecl;
    { destroy this structure }
    cl_destroy: procedure(rh: PClientRecord); cdecl;
    { the ioctl() of rpc }
    cl_control: function(rh: PClientRecord; request: Integer; Info: PChar): bool_t; cdecl;
  end;
  TClientOps = clnt_ops;
  PClientOps = ^TClientOps;

  CLIENT = {packed} record
    cl_auth: PAuthRecord;  { authenticator }
    cl_ops: PClientOps;
    cl_private: caddr_t;   { private stuff }
  end;
  {$EXTERNALSYM CLIENT}
  TClientRecord = CLIENT;

{
 * client side rpc interface ops
 *
 * Parameter types are:
 *
 }

{
 * enum clnt_stat
 * CLNT_CALL(rh, proc, xargs, argsp, xres, resp, timeout)
 * 	CLIENT *rh;
 *	u_long proc;
 *	xdrproc_t xargs;
 *	caddr_t argsp;
 *	xdrproc_t xres;
 *	caddr_t resp;
 *	struct timeval timeout;
 }

function CLNT_CALL(rh: PClientRecord; proc: u_long; xargs: xdrproc_t; argsp: caddr_t;
  xres: xdrproc_t; resp: caddr_t; secs: timeval): clnt_stat;
{$EXTERNALSYM CLNT_CALL}

{
 * void
 * CLNT_ABORT(rh);
 * 	CLIENT *rh;
 }

procedure CLNT_ABORT(rh: PClientRecord);
{$EXTERNALSYM CLNT_ABORT}

{
 * struct rpc_err
 * CLNT_GETERR(rh);
 * 	CLIENT *rh;
 }

procedure CLNT_GETERR(rh: PClientRecord; var errp: rpc_err);
{$EXTERNALSYM CLNT_GETERR}

{
 * bool_t
 * CLNT_FREERES(rh, xres, resp);
 * 	CLIENT *rh;
 *	xdrproc_t xres;
 *	caddr_t resp;
 }

function CLNT_FREERES(rh: PClientRecord; xres: xdrproc_t; resp: caddr_t): bool_t;
{$EXTERNALSYM CLNT_FREERES}

{
 * bool_t
 * CLNT_CONTROL(cl, request, info)
 *      CLIENT *cl;
 *      u_int request;
 *      char *info;
 }
function CLNT_CONTROL(rh: PClientRecord; request: Integer; Info: PChar): bool_t;
{$EXTERNALSYM CLNT_CONTROL}

{
 * control operations that apply to all transports
 *
 * Note: options marked XXX are no-ops in this implementation of RPC.
 * The are present in TI-RPC but can't be implemented here since they
 * depend on the presence of STREAMS/TLI, which we don't have.
 }
const
  CLSET_TIMEOUT        = 1;    { set timeout (timeval) }
  {$EXTERNALSYM CLSET_TIMEOUT}
  CLGET_TIMEOUT        = 2;    { get timeout (timeval) }
  {$EXTERNALSYM CLGET_TIMEOUT}
  CLGET_SERVER_ADDR    = 3;    { get server's address (sockaddr) }
  {$EXTERNALSYM CLGET_SERVER_ADDR}
  CLGET_FD             = 6;    { get connections file descriptor }
  {$EXTERNALSYM CLGET_FD}
  CLGET_SVC_ADDR       = 7;    { get server's address (netbuf)      XXX }
  {$EXTERNALSYM CLGET_SVC_ADDR}
  CLSET_FD_CLOSE       = 8;    { close fd while clnt_destroy }
  {$EXTERNALSYM CLSET_FD_CLOSE}
  CLSET_FD_NCLOSE      = 9;    { Do not close fd while clnt_destroy}
  {$EXTERNALSYM CLSET_FD_NCLOSE}
  CLGET_XID            = 10;   { Get xid }
  {$EXTERNALSYM CLGET_XID}
  CLSET_XID            = 11;   { Set xid }
  {$EXTERNALSYM CLSET_XID}
  CLGET_VERS           = 12;   { Get version number }
  {$EXTERNALSYM CLGET_VERS}
  CLSET_VERS           = 13;   { Set version number }
  {$EXTERNALSYM CLSET_VERS}
  CLGET_PROG           = 14;   { Get program number }
  {$EXTERNALSYM CLGET_PROG}
  CLSET_PROG           = 15;   { Set program number }
  {$EXTERNALSYM CLSET_PROG}
  CLSET_SVC_ADDR       = 16;   { get server's address (netbuf)      XXX }
  {$EXTERNALSYM CLSET_SVC_ADDR}
  CLSET_PUSH_TIMOD     = 17;   { push timod if not already present  XXX }
  {$EXTERNALSYM CLSET_PUSH_TIMOD}
  CLSET_POP_TIMOD      = 18;   { pop timod                          XXX }
  {$EXTERNALSYM CLSET_POP_TIMOD}
{ Connectionless only control operations }
  CLSET_RETRY_TIMEOUT  = 4;    { set retry timeout (timeval) }
  {$EXTERNALSYM CLSET_RETRY_TIMEOUT}
  CLGET_RETRY_TIMEOUT  = 5;    { get retry timeout (timeval) }
  {$EXTERNALSYM CLGET_RETRY_TIMEOUT}

{
 * void
 * CLNT_DESTROY(rh);
 * 	CLIENT *rh;
 }

procedure CLNT_DESTROY(rh: PClientRecord);
{$EXTERNALSYM CLNT_DESTROY}

{
 * RPCTEST is a test program which is accessible on every rpc
 * transport/port.  It is used for testing, performance evaluation,
 * and network administration.
 }
const
  RPCTEST_PROGRAM           = u_long(1);
  {$EXTERNALSYM RPCTEST_PROGRAM}
  RPCTEST_VERSION           = u_long(1);
  {$EXTERNALSYM RPCTEST_VERSION}
  RPCTEST_NULL_PROC         = u_long(2);
  {$EXTERNALSYM RPCTEST_NULL_PROC}
  RPCTEST_NULL_BATCH_PROC   = u_long(3);
  {$EXTERNALSYM RPCTEST_NULL_BATCH_PROC}

{ By convention, procedure 0 takes null arguments and returns them }

  NULLPROC = u_long(0);
  {$EXTERNALSYM NULLPROC}

{
 * Below are the client handle creation routines for the various
 * implementations of client side rpc.  They can return NULL if a
 * creation failure occurs.
 }

{
 * Memory based rpc (for speed check and testing)
 * CLIENT *
 * clntraw_create(prog, vers)
 *	u_long prog;
 *	u_long vers;
 }
function clntraw_create(__prog: u_long; __vers: u_long): PClientRecord; cdecl;
{$EXTERNALSYM clntraw_create}


{
 * Generic client creation routine. Supported protocols are "udp", "tcp" and
 * "unix"
 * CLIENT *
 * clnt_create(host, prog, vers, prot)
 *	char *host; 	-- hostname
 *	u_long prog;	-- program number
 *	u_ong vers;	-- version number
 *	char *prot;	-- protocol
 }
function clnt_create(__host: PChar;  __prog: u_long; __vers: u_long;
  __prot: PChar): PClientRecord; cdecl;
{$EXTERNALSYM clnt_create}

{
 * TCP based rpc
 * CLIENT *
 * clnttcp_create(raddr, prog, vers, sockp, sendsz, recvsz)
 *	struct sockaddr_in *raddr;
 *	u_long prog;
 *	u_long version;
 *	register int *sockp;
 *	u_int sendsz;
 *	u_int recvsz;
 }
function clnttcp_create(const __raddr: sockaddr_in; __prog: u_long; __version: u_long;
  var __sockp: Integer; __sendsz: u_int; __recvsz: u_int): PClientRecord; cdecl;
{$EXTERNALSYM clnttcp_create}

{
 * UDP based rpc.
 * CLIENT *
 * clntudp_create(raddr, program, version, wait, sockp)
 *	struct sockaddr_in *raddr;
 *	u_long program;
 *	u_long version;
 *	struct timeval wait_resend;
 *	int *sockp;
 *
 * Same as above, but you specify max packet sizes.
 * CLIENT *
 * clntudp_bufcreate(raddr, program, version, wait, sockp, sendsz, recvsz)
 *	struct sockaddr_in *raddr;
 *	u_long program;
 *	u_long version;
 *	struct timeval wait_resend;
 *	int *sockp;
 *	u_int sendsz;
 *	u_int recvsz;
 }
function clntudp_create(const __raddr: sockaddr_in; __program: u_long; __version: u_long;
  __wait_resend: timeval; var __sockp: Integer): PClientRecord; cdecl;
{$EXTERNALSYM clntudp_create}
function clntudp_bufcreate(const __raddr: sockaddr_in; __program: u_long; __version: u_long;
  __wait_resend: timeval; var __sockp: Integer; __sendsz: u_int; __recvsz: u_int): PClientRecord; cdecl;
{$EXTERNALSYM clntudp_bufcreate}

{
 * AF_UNIX based rpc
 * CLIENT *
 * clntunix_create(raddr, prog, vers, sockp, sendsz, recvsz)
 *      struct sockaddr_un *raddr;
 *      u_long prog;
 *      u_long version;
 *      register int *sockp;
 *      u_int sendsz;
 *      u_int recvsz;
 }
function clntunix_create(const __raddr: sockaddr_un; __program: u_long; __version: u_long;
  var __sockp: Integer; __sendsz: u_int; __recvsz: u_int): PClientRecord; cdecl;
{$EXTERNALSYM clntunix_create}

function callrpc(__host: PChar; __prognum: u_long; __versnum: u_long; __procnum: u_long;
  __inproc: xdrproc_t; __in: PChar; __outproc: xdrproc_t; __out: PChar): Integer; cdecl;
{$EXTERNALSYM callrpc}
function _rpc_dtablesize(): Integer; cdecl;
{$EXTERNALSYM _rpc_dtablesize}

{ Print why creation failed }
procedure clnt_pcreateerror(__msg: PChar); cdecl;          { stderr }
{$EXTERNALSYM clnt_pcreateerror}
function clnt_spcreateerror(__msg: PChar): PChar; cdecl;   { string }
{$EXTERNALSYM clnt_spcreateerror}

{ Like clnt_perror(), but is more verbose in its output }
procedure clnt_perrno(__num: clnt_stat); cdecl;            { stderr }
{$EXTERNALSYM clnt_perrno}

{ Print an English error message, given the client error code }
procedure clnt_perror(__clnt: PClientRecord; __msg: PChar); cdecl;
{$EXTERNALSYM clnt_perror}
							{ stderr }
function clnt_sperror(__clnt: PClientRecord; __msg: PChar): PChar; cdecl;
{$EXTERNALSYM clnt_sperror}
							{ string }

{ If a creation fails, the following allows the user to figure out why. }
type
  rpc_createerr = {packed} record
    cf_stat: clnt_stat;
    cf_error: rpc_err;   { useful when cf_stat == RPC_PMAPFAILURE }
  end;
  {$EXTERNALSYM rpc_createerr}


{ Copy error message to buffer. }
function clnt_sperrno(__num: clnt_stat): PChar; cdecl; { string }
{$EXTERNALSYM clnt_sperrno}

{ Get the port number on the host for the rpc program,version and proto }
function getrpcport(__host: PChar; __prognum: u_long; __versnum: u_long;
  proto: u_int): Integer; cdecl;
{$EXTERNALSYM getrpcport}

{ Get the local host's IP address without consulting
   name service library functions }
procedure get_myaddress(var Result: sockaddr_in); cdecl;
{$EXTERNALSYM get_myaddress}

const
  UDPMSGSIZE      = 8800;  { rpc imposed limit on udp msg size }
  {$EXTERNALSYM UDPMSGSIZE}
  RPCSMALLMSGSIZE = 400;   { a more reasonable packet size }
  {$EXTERNALSYM RPCSMALLMSGSIZE}


{$HPPEMIT '#include <rpc/des_crypt.h>'}

// Translated from rpc/des_crypt.h

{ des library routine interface }

const
  DES_MAXDATA   = 8192;            { max bytes encrypted in one call }
  {$EXTERNALSYM DES_MAXDATA}
  DES_DIRMASK   = (1 shl 0);
  {$EXTERNALSYM DES_DIRMASK}
  DES_ENCRYPT   = (0*DES_DIRMASK); { Encrypt }
  {$EXTERNALSYM DES_ENCRYPT}
  DES_DECRYPT   = (1*DES_DIRMASK); { Decrypt }
  {$EXTERNALSYM DES_DECRYPT}


  DES_DEVMASK   = (1 shl 1);
  {$EXTERNALSYM DES_DEVMASK}
  DES_HW        = (0*DES_DEVMASK);   { Use hardware device }
  {$EXTERNALSYM DES_HW}
  DES_SW        = (1*DES_DEVMASK);   { Use software device }
  {$EXTERNALSYM DES_SW}


  DESERR_NONE       = 0;    { succeeded }
  {$EXTERNALSYM DESERR_NONE}
  DESERR_NOHWDEVICE = 1;    { succeeded, but hw device not available }
  {$EXTERNALSYM DESERR_NOHWDEVICE}
  DESERR_HWERROR    = 2;    { failed, hardware/driver error }
  {$EXTERNALSYM DESERR_HWERROR}
  DESERR_BADPARAM   = 3;    { failed, bad parameter to call }
  {$EXTERNALSYM DESERR_BADPARAM}

function DES_FAILED(err: Integer): Boolean;
{$EXTERNALSYM DES_FAILED}

{
 * cbc_crypt()
 * ecb_crypt()
 *
 * Encrypt (or decrypt) len bytes of a buffer buf.
 * The length must be a multiple of eight.
 * The key should have odd parity in the low bit of each byte.
 * ivec is the input vector, and is updated to the new one (cbc only).
 * The mode is created by oring together the appropriate parameters.
 * DESERR_NOHWDEVICE is returned if DES_HW was specified but
 * there was no hardware to do it on (the data will still be
 * encrypted though, in software).
 }


{ Cipher Block Chaining mode }
function cbc_crypt(__key: PChar; __buf: PChar; __len: Cardinal;
  __mode: Cardinal; __ivec: PChar): Integer; cdecl;
{$EXTERNALSYM cbc_crypt}

{ Electronic Code Book mode }
function ecb_crypt(__key: PChar; __buf: PChar; __len: Cardinal;
  __mode: Cardinal): Integer; cdecl;
{$EXTERNALSYM ecb_crypt}

{
 * Set des parity for a key.
 * DES parity is odd and in the low bit of each byte
 }
procedure des_setparity(__key: PChar); cdecl;
{$EXTERNALSYM des_setparity}


{$HPPEMIT '#include <rpc/rpc_msg.h>'}

// Translated from rpc/rpc_msg.h

{ rpc message definition }

const
  RPC_MSG_VERSION = u_long(2);
  {$EXTERNALSYM RPC_MSG_VERSION}
  RPC_SERVICE_PORT = u_short(2048);
  {$EXTERNALSYM RPC_SERVICE_PORT}

{
 * Bottom up definition of an rpc message.
 * NOTE: call and reply use the same overall struct but
 * different parts of unions within it.
 }

type
  msg_type =
  (
    CALL = 0,
    {$EXTERNALSYM CALL}
    REPLY = 1
    {$EXTERNALSYM REPLY}
  );
  {$EXTERNALSYM msg_type}

  reply_stat =
  (
    MSG_ACCEPTED = 0,
    {$EXTERNALSYM MSG_ACCEPTED}
    MSG_DENIED = 1
    {$EXTERNALSYM MSG_DENIED}
  );
  {$EXTERNALSYM reply_stat}

  accept_stat =
  (
    SUCCESS = 0,
    {$EXTERNALSYM SUCCESS}
    PROG_UNAVAIL = 1,
    {$EXTERNALSYM PROG_UNAVAIL}
    PROG_MISMATCH = 2,
    {$EXTERNALSYM PROG_MISMATCH}
    PROC_UNAVAIL = 3,
    {$EXTERNALSYM PROC_UNAVAIL}
    GARBAGE_ARGS = 4,
    {$EXTERNALSYM GARBAGE_ARGS}
    SYSTEM_ERR = 5
    {$EXTERNALSYM SYSTEM_ERR}
  );
  {$EXTERNALSYM accept_stat}

  reject_stat =
  (
    RPC_MISMATCH = 0,
    {$EXTERNALSYM RPC_MISMATCH}
    AUTH_ERROR = 1
    {$EXTERNALSYM AUTH_ERROR}
  );
  {$EXTERNALSYM reject_stat}

{ Reply part of an rpc exchange }

{
 * Reply to an rpc request that was accepted by the server.
 * Note: there could be an error even though the request was
 * accepted.
 }
type
  accepted_reply = {packed} record
    ar_verf: opaque_auth;
    ar_stat: accept_stat;
    ru: {packed} record
      case Integer of
        0: (AR_versions: {packed} record
                           low: u_long;
                           high: u_long;
                         end;
           );
        1: (AR_results: {packed} record
                          where: caddr_t;
                          proc: xdrproc_t;
                        end;
           );
      end;
  end;
  {$EXTERNALSYM accepted_reply}
  TAcceptedReply = accepted_reply;
  PAcceptedReply = ^TAcceptedReply;


{ Reply to an rpc request that was rejected by the server. }
  rejected_reply = {packed} record
    rj_stat: reject_stat;
    ru: {packed} record
          case Integer of
            0: (RJ_versions: {packed} record
                               low: u_long;
                               high: u_long;
                             end
                );
            1: (RJ_why: auth_stat);
          end;
  end;
  {$EXTERNALSYM rejected_reply}
  TRejectedReply = rejected_reply;
  PRejectedReply = ^TRejectedReply;


{ Body of a reply to an rpc request. }
  reply_body = {packed} record
    rp_stat: reply_stat;
    ru: {packed} record
          case Integer of
            0: (RP_ar: accepted_reply);
            1: (RP_dr: rejected_reply);
          end;
  end;
  {$EXTERNALSYM reply_body}
  TReplyBody = reply_body;
  PReplyBody = ^TReplyBody;


{ Body of an rpc request call. }
  call_body = {packed} record
    cb_rpcvers: u_long;       { must be equal to two }
    cb_prog: u_long;
    cb_vers: u_long;
    cb_proc: u_long;
    cb_cred: opaque_auth;
    cb_verf: opaque_auth;     { protocol specific - provided by client }
  end;
  {$EXTERNALSYM call_body}
  TCallBody = call_body;
  PCallBody = ^TCallBody;


{ The rpc message }
  rpc_msg = {packed} record
    rm_xid: u_long;
    rm_direction: msg_type;
    ru: {packed} record
          case Integer of
            0: (RM_cmb: call_body);
            1: (RM_rmb: reply_body);
          end;
  end;
  {$EXTERNALSYM rpc_msg}
  TRpcMsg = rpc_msg;
  PRpcMsg = ^TRpcMsg;


{
 * XDR routine to handle a rpc message.
 * xdr_callmsg(xdrs, cmsg)
 * 	XDR *xdrs;
 * 	struct rpc_msg *cmsg;
 }
function xdr_callmsg(__xdrs: PXdr; __cmsg: PRpcMsg): bool_t; cdecl;
{$EXTERNALSYM xdr_callmsg}

{
 * XDR routine to pre-serialize the static part of a rpc message.
 * xdr_callhdr(xdrs, cmsg)
 * 	XDR *xdrs;
 * 	struct rpc_msg *cmsg;
 }
function xdr_callhdr(__xdrs: PXdr; __cmsg: PRpcMsg): bool_t; cdecl;
{$EXTERNALSYM xdr_callhdr}

{
 * XDR routine to handle a rpc reply.
 * xdr_replymsg(xdrs, rmsg)
 * 	XDR *xdrs;
 * 	struct rpc_msg *rmsg;
 }
function xdr_replymsg(__xdrs: PXdr; __rmsg: PRpcMsg): bool_t; cdecl;
{$EXTERNALSYM xdr_replymsg}

{
 * Fills in the error part of a reply message.
 * _seterr_reply(msg, error)
 * 	struct rpc_msg *msg;
 * 	struct rpc_err *error;
 }
procedure _seterr_reply(__msg: PRpcMsg; __error: PRpcError); cdecl;
{$EXTERNALSYM _seterr_reply}


{$HPPEMIT '#include <rpc/svc.h>'}

// Translated from rpc/svc.h

{ Server-side remote procedure call interface. }

{
 * This interface must manage two items concerning remote procedure calling:
 *
 * 1) An arbitrary number of transport connections upon which rpc requests
 * are received.  The two most notable transports are TCP and UDP;  they are
 * created and registered by routines in svc_tcp.c and svc_udp.c, respectively;
 * they in turn call xprt_register and xprt_unregister.
 *
 * 2) An arbitrary number of locally registered services.  Services are
 * described by the following four data: program number, version number,
 * "service dispatch" function, a transport handle, and a boolean that
 * indicates whether or not the exported program should be registered with a
 * local binder service;  if true the program's number and version and the
 * port number from the transport handle are registered with the binder.
 * These data are registered with the rpc svc system via svc_register.
 *
 * A service's dispatch function is called whenever an rpc request comes in
 * on a transport.  The request's program and version numbers must match
 * those of the registered service.  The dispatch function is passed two
 * parameters, struct svc_req * and SVCXPRT *, defined below.
 }

type
  xprt_stat =
  (
    XPRT_DIED = 0,
    {$EXTERNALSYM XPRT_DIED}
    XPRT_MOREREQS = 1,
    {$EXTERNALSYM XPRT_MOREREQS}
    XPRT_IDLE = 2
    {$EXTERNALSYM XPRT_IDLE}
  );
  {$EXTERNALSYM xprt_stat}

{ Server side transport handle }

  PScvXpRt = ^TScvXpRt;

  xp_ops = {packed} record
    { receive incoming requests }
    xp_recv: function(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t; cdecl;
    { get transport status }
    xp_stat: function(__xprt: PScvXpRt): xprt_stat; cdecl;
    { get arguments }
    xp_getargs: function(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t; cdecl;
    { send reply }
    xp_reply: function(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t; cdecl;
    { free mem allocated for args }
    xp_freeargs: function(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t; cdecl;
    { destroy this struct }
    xp_destroy: procedure(__xprt: PScvXpRt); cdecl;
  end;
  TXpOps = xp_ops;
  PXpOps = ^TXpOps;


  SVCXPRT = {packed} record
    xp_sock: Integer;
    xp_port: u_short;           { associated port number }
    xp_ops: PXpOps;
    xp_addrlen: Integer;        { length of remote address }
    xp_raddr: sockaddr_in;      { remote address }
    xp_verf: opaque_auth;       { raw response verifier }
    xp_p1: caddr_t;             { private }
    xp_p2: caddr_t;             { private }
    xp_pad: packed array[0..256-1] of Byte;   { padding, internal use }
  end;
  {$EXTERNALSYM SVCXPRT}
  TScvXpRt = SVCXPRT;

{ Approved way of getting address of caller }
function svc_getcaller(const Service: TScvXpRt): sockaddr_in;
{$EXTERNALSYM svc_getcaller}

{
 * Operations defined on an SVCXPRT handle
 *
 * SVCXPRT		*xprt;
 * struct rpc_msg	*msg;
 * xdrproc_t		 xargs;
 * caddr_t		 argsp;
 }
function SVC_RECV(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t;
{$EXTERNALSYM SVC_RECV}
function SVC_STAT(__xprt: PScvXpRt): xprt_stat;
{$EXTERNALSYM SVC_STAT}
function SVC_GETARGS(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t;
{$EXTERNALSYM SVC_GETARGS}
function SVC_REPLY(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t;
{$EXTERNALSYM SVC_REPLY}
function SVC_FREEARGS(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t;
{$EXTERNALSYM SVC_FREEARGS}
procedure SVC_DESTROY(__xprt: PScvXpRt);
{$EXTERNALSYM SVC_DESTROY}


{ Service request }
type
  svc_req = {packed} record
    rq_prog: rpcprog_t;     { service program number }
    rq_vers: rpcvers_t;     { service protocol version }
    rq_proc: rpcproc_t;     { the desired procedure }
    rq_cred: opaque_auth;   { raw creds from the wire }
    rq_clntcred: caddr_t;   { read only cooked cred }
    rq_xprt: PScvXpRt;      { associated transport }
  end;
  {$EXTERNALSYM svc_req}
  TSvcReq = svc_req;
  PSvcReq = ^TSvcReq;

type
  __dispatch_fn_t = procedure(p1: PSvcReq; p2: PScvXpRt); cdecl;
  {$EXTERNALSYM __dispatch_fn_t}

{
 * Service registration
 *
 * svc_register(xprt, prog, vers, dispatch, protocol)
 *	SVCXPRT *xprt;
 *	rpcprog_t prog;
 *	rpcvers_t vers;
 *	void (*dispatch)(struct svc_req*, SVCXPRT*);
 *	rpcprot_t protocol;  like TCP or UDP, zero means do not register
 }
function svc_register(__xprt: PScvXpRt; __prog: rpcprog_t; __vers: rpcvers_t;
  __dispatch: __dispatch_fn_t; __protocol: rpcprot_t): bool_t; cdecl;
{$EXTERNALSYM svc_register}

{
 * Service un-registration
 *
 * svc_unregister(prog, vers)
 *	rpcprog_t prog;
 *	rpcvers_t vers;
 }
procedure svc_unregister(__prog: rpcprog_t; __vers: rpcvers_t); cdecl;
{$EXTERNALSYM svc_unregister}

{
 * Transport registration.
 *
 * xprt_register(xprt)
 *	SVCXPRT *xprt;
 }
procedure xprt_register(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM xprt_register}

{
 * Transport un-register
 *
 * xprt_unregister(xprt)
 *	SVCXPRT *xprt;
 }
procedure xprt_unregister(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM xprt_unregister}


{
 * When the service routine is called, it must first check to see if it
 * knows about the procedure;  if not, it should call svcerr_noproc
 * and return.  If so, it should deserialize its arguments via
 * SVC_GETARGS (defined above).  If the deserialization does not work,
 * svcerr_decode should be called followed by a return.  Successful
 * decoding of the arguments should be followed the execution of the
 * procedure's code and a call to svc_sendreply.
 *
 * Also, if the service refuses to execute the procedure due to too-
 * weak authentication parameters, svcerr_weakauth should be called.
 * Note: do not confuse access-control failure with weak authentication!
 *
 * NB: In pure implementations of rpc, the caller always waits for a reply
 * msg.  This message is sent when svc_sendreply is called.
 * Therefore pure service implementations should always call
 * svc_sendreply even if the function logically returns void;  use
 * xdr.h - xdr_void for the xdr routine.  HOWEVER, tcp based rpc allows
 * for the abuse of pure rpc via batched calling or pipelining.  In the
 * case of a batched call, svc_sendreply should NOT be called since
 * this would send a return message, which is what batching tries to avoid.
 * It is the service/protocol writer's responsibility to know which calls are
 * batched and which are not.  Warning: responding to batch calls may
 * deadlock the caller and server processes!
 }

function svc_sendreply(__xprt: PScvXpRt; __xdr_results: xdrproc_t;
  __xdr_location: caddr_t): bool_t; cdecl;
{$EXTERNALSYM svc_sendreply}

procedure svcerr_decode(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM svcerr_decode}

procedure svcerr_weakauth(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM svcerr_weakauth}

procedure svcerr_noproc(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM svcerr_noproc}

procedure svcerr_progvers(__xprt: PScvXpRt; __low_vers: rpcvers_t;
  __high_vers: rpcvers_t); cdecl;
{$EXTERNALSYM svcerr_progvers}

procedure svcerr_auth(__xprt: PScvXpRt; __why: auth_stat); cdecl;
{$EXTERNALSYM svcerr_auth}

procedure svcerr_noprog(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM svcerr_noprog}

procedure svcerr_systemerr(__xprt: PScvXpRt); cdecl;
{$EXTERNALSYM svcerr_systemerr}

{
 * Lowest level dispatching -OR- who owns this process anyway.
 * Somebody has to wait for incoming requests and then call the correct
 * service routine.  The routine svc_run does infinite waiting; i.e.,
 * svc_run never returns.
 * Since another (coexistent) package may wish to selectively wait for
 * incoming calls or other events outside of the rpc architecture, the
 * routine svc_getreq is provided.  It must be passed readfds, the
 * "in-place" results of a select system call (see select, section 2).
 }

{
 * Global keeper of rpc service descriptors in use
 * dynamic; must be inspected before each call to select
 }
(*
extern struct pollfd *svc_pollfd;
extern int svc_max_pollfd;
extern fd_set svc_fdset;
#define svc_fds svc_fdset.fds_bits[0]	{ compatibility }
*)

{
 * a small program implemented by the svc_rpc implementation itself;
 * also see clnt.h for protocol numbers.
 }
procedure svc_getreq(__rdfds: Integer); cdecl;
{$EXTERNALSYM svc_getreq}
procedure svc_getreq_common(__fd: Integer); cdecl;
{$EXTERNALSYM svc_getreq_common}
procedure svc_getreqset(__readfds: PFdSet); cdecl;
{$EXTERNALSYM svc_getreqset}
procedure svc_getreq_poll(p1: PPollFD; p2: Integer); cdecl;
{$EXTERNALSYM svc_getreq_poll}
procedure svc_exit(); cdecl;
{$EXTERNALSYM svc_exit}
procedure svc_run(); cdecl;
{$EXTERNALSYM svc_run}

{ Socket to use on svcxxx_create call to get default socket }
const
  RPC_ANYSOCK = -1;
  {$EXTERNALSYM RPC_ANYSOCK}

{ These are the existing service side transport implementations }

{ Memory based rpc for testing and timing. }
function svcraw_create(): PScvXpRt; cdecl;
{$EXTERNALSYM svcraw_create}

{ Udp based rpc. }
function svcudp_create(__sock: Integer): PScvXpRt; cdecl;
{$EXTERNALSYM svcudp_create}
function svcudp_bufcreate(__sock: Integer; __sendsz: u_int; __recvsz: u_int): PScvXpRt; cdecl;
{$EXTERNALSYM svcudp_bufcreate}

{ Tcp based rpc. }
function svctcp_create(__sock: Integer; __sendsize: u_int; __recvsize: u_int): PScvXpRt; cdecl;
{$EXTERNALSYM svctcp_create}

{ Unix based rpc. }
function svcunix_create(__sock: Integer; __sendsize: u_int; __recvsize: u_int;
  __path: PChar): PScvXpRt; cdecl;
{$EXTERNALSYM svcunix_create}

{$HPPEMIT '#include <rpc/key_prot.h>'}


// Translated from rpc/key_prot.h

const
  PROOT = 3;
  {$EXTERNALSYM PROOT}
  HEXMODULUS = 'd4a0ba0250b6fd2ec626e7efd637df76c716e22d0944b88b';
  {$EXTERNALSYM HEXMODULUS}
  HEXKEYBYTES = 48;
  {$EXTERNALSYM HEXKEYBYTES}
  KEYSIZE = 192;
  {$EXTERNALSYM KEYSIZE}
  KEYBYTES = 24;
  {$EXTERNALSYM KEYBYTES}
  KEYCHECKSUMSIZE = 16;
  {$EXTERNALSYM KEYCHECKSUMSIZE}

type
  keystatus =
  (
    KEY_SUCCESS = 0,
    {$EXTERNALSYM KEY_SUCCESS}
    KEY_NOSECRET = 1,
    {$EXTERNALSYM KEY_NOSECRET}
    KEY_UNKNOWN = 2,
    {$EXTERNALSYM KEY_UNKNOWN}
    KEY_SYSTEMERR = 3
    {$EXTERNALSYM KEY_SYSTEMERR}
  );
  {$EXTERNALSYM keystatus}
  PKeyStatus = ^keystatus;


function xdr_keystatus(__xdr: PXdr; var __keystatus: keystatus): bool_t; cdecl;
{$EXTERNALSYM xdr_keystatus}

type
  keybuf = packed array[0..HEXKEYBYTES-1] of Byte;
  {$EXTERNALSYM keybuf}

function xdr_keybuf(__xdr: PXdr; var __keybuf: keybuf): bool_t; cdecl;
{$EXTERNALSYM xdr_keybuf}

type
  netnamestr = PChar;
  {$EXTERNALSYM netnamestr}

function xdr_netnamestr(__xdr: PXdr; var __netnamestr: netnamestr): bool_t; cdecl;
{$EXTERNALSYM xdr_netnamestr}

type
  cryptkeyarg = {packed} record
    remotename: netnamestr;
    deskey: des_block;
  end;
  {$EXTERNALSYM cryptkeyarg}
  TCryptKeyArg = cryptkeyarg;
  PCryptKeyArg = ^TCryptKeyArg;

function xdr_cryptkeyarg(__xdr: PXdr; var __cryptkeyarg: cryptkeyarg): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyarg}

type
  cryptkeyarg2 = {packed} record
    remotename: netnamestr;
    remotekey: netobj;
    deskey: des_block;
  end;
  {$EXTERNALSYM cryptkeyarg2}
  TCryptKeyArg2 = cryptkeyarg2;
  PCryptKeyArg2 = ^TCryptKeyArg2;

function xdr_cryptkeyarg2(__xdr: PXdr; var __cryptkeyarg2: cryptkeyarg2): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyarg2}

type
  cryptkeyres = {packed} record
    status: keystatus;
    deskey: des_block;
  end;
  {$EXTERNALSYM cryptkeyres}
  TCryptKeyRes = cryptkeyres;
  PCryptKeyRes = ^TCryptKeyRes;

function xdr_cryptkeyres(__xdr: PXdr; var __cryptkeyres: cryptkeyres): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyres}

const
  MAXGIDS = 16;
  {$EXTERNALSYM MAXGIDS}

type
  Pu_int = ^u_int;

  unixcred = {packed} record
    uid: u_int;
    gid: u_int;
    gids: {packed} record
            gids_len: u_int;
            gids_val: Pu_int;
          end;
  end;
  {$EXTERNALSYM unixcred}

function xdr_unixcred(__xdr: PXdr; var __unixcred: unixcred): bool_t; cdecl;
{$EXTERNALSYM xdr_unixcred}

type
  getcredres = {packed} record
    status: keystatus;
    cred: unixcred;
  end;
  {$EXTERNALSYM getcredres}
  TGetCredRes = getcredres;
  PGetCredRes = ^TGetCredRes;

function xdr_getcredres(__xdr: PXdr; var __getcredres: getcredres): bool_t; cdecl;
{$EXTERNALSYM xdr_getcredres}

type
  key_netstarg = {packed} record
    st_priv_key: keybuf;
    st_pub_key: keybuf;
    st_netname: netnamestr;
  end;
  {$EXTERNALSYM key_netstarg}
  TKeyNetStArg = key_netstarg;
  PKeyNetStArg = ^TKeyNetStArg;

function xdr_key_netstarg(__xdr: PXdr; var __key_netstarg: key_netstarg): bool_t; cdecl;
{$EXTERNALSYM xdr_key_netstarg}

type
  key_netstres = {packed} record
    status: keystatus;
    knet: key_netstarg;
  end;
  {$EXTERNALSYM key_netstres}
  TKeyNetStRes = key_netstres;
  PKeyNetStRes = ^TKeyNetStRes;

function xdr_key_netstres(__xdr: PXdr; var __key_netstres: key_netstres): bool_t; cdecl;
{$EXTERNALSYM xdr_key_netstres}


type
  opaque = Byte;
  {$EXTERNALSYM opaque}
  POpaque = ^opaque; // Not declared in header file.

const
  KEY_PROG = u_long(100029);
  {$EXTERNALSYM KEY_PROG}
  KEY_VERS = u_long(1);
  {$EXTERNALSYM KEY_VERS}

const
  KEY_SET = u_long(1);
  {$EXTERNALSYM KEY_SET}

function key_set_1(OpaqueData: POpaque; AClient: PClientRecord): PKeyStatus; cdecl;
{$EXTERNALSYM key_set_1}
function key_set_1_svc(OpaqueData: POpaque; ServiceReq: PSvcReq): PKeyStatus; cdecl;
{$EXTERNALSYM key_set_1_svc}

const
  KEY_ENCRYPT = u_long(2);
  {$EXTERNALSYM KEY_ENCRYPT}

function key_encrypt_1(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_1}
function key_encrypt_1_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_1_svc}

const
  KEY_DECRYPT = u_long(3);
  {$EXTERNALSYM KEY_DECRYPT}

function key_decrypt_1(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_1}
function key_decrypt_1_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_1_svc}

const
  KEY_GEN = u_long(4);
  {$EXTERNALSYM KEY_GEN}

function key_gen_1(P: Pointer; AClient: PClientRecord): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_1}
function key_gen_1_svc(P: Pointer; ServiceReq: PSvcReq): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_1_svc}

const
  KEY_GETCRED = u_long(5);
  {$EXTERNALSYM KEY_GETCRED}

function key_getcred_1(var __netnamestr: netnamestr; AClient: PClientRecord): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_1}
function key_getcred_1_svc(var __netnamestr: netnamestr; ServiceReq: PSvcReq): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_1_svc}

const
  KEY_VERS2 = u_long(2);
  {$EXTERNALSYM KEY_VERS2}

function key_set_2(OpaqueData: POpaque; AClient: PClientRecord): PKeyStatus; cdecl;
{$EXTERNALSYM key_set_2}
function key_set_2_svc(OpaqueData: POpaque; ServiceReq: PSvcReq): PKeyStatus; cdecl;
{$EXTERNALSYM key_set_2_svc}

function key_encrypt_2(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_2}
function key_encrypt_2_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_2_svc}
function key_decrypt_2(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_2}
function key_decrypt_2_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_2_svc}

function key_gen_2(P: Pointer; AClient: PClientRecord): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_2}
function key_gen_2_svc(P: Pointer; ServiceReq: PSvcReq): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_2_svc}

function key_getcred_2(var __netnamestr: netnamestr; AClient: PClientRecord): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_2}
function key_getcred_2_svc(var __netnamestr: netnamestr; ServiceReq: PSvcReq): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_2_svc}

const
  KEY_ENCRYPT_PK = u_long(6);
  {$EXTERNALSYM KEY_ENCRYPT_PK}

function key_encrypt_pk_2(p1: PCryptKeyArg2; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_pk_2}
function key_encrypt_pk_2_svc(p1: PCryptKeyArg2; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_pk_2_svc}

const
  KEY_DECRYPT_PK = u_long(7);
  {$EXTERNALSYM KEY_DECRYPT_PK}

function key_decrypt_pk_2(p1: PCryptKeyArg2; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_pk_2}
function key_decrypt_pk_2_svc(p1: PCryptKeyArg2; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_pk_2_svc}

const
  KEY_NET_PUT = u_long(8);
  {$EXTERNALSYM KEY_NET_PUT}

function key_net_put_2(__key_netstarg: PKeyNetStArg; AClient: PClientRecord): PKeyStatus; cdecl;
{$EXTERNALSYM key_net_put_2}
function key_net_put_2_svc(__key_netstarg: PKeyNetStArg; ServiceReq: PSvcReq): PKeyStatus; cdecl;
{$EXTERNALSYM key_net_put_2_svc}

const
  KEY_NET_GET = u_long(9);
  {$EXTERNALSYM KEY_NET_GET}

function key_net_get_2(P: Pointer; AClient: PClientRecord): PKeyNetStRes; cdecl;
{$EXTERNALSYM key_net_get_2}
function key_net_get_2_svc(P: Pointer; ServiceReq: PSvcReq): PKeyNetStRes; cdecl;
{$EXTERNALSYM key_net_get_2_svc}

const
  _KEY_GET_CONV = u_long(10);
  {.$EXTERNALSYM KEY_GET_CONV} // Renamed to avoid identifier conflict

function key_get_conv_2(OpaqueData: POpaque; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_get_conv_2}
function key_get_conv_2_svc(OpaqueData: POpaque; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_get_conv_2_svc}


{$HPPEMIT '#include <rpc/netdb.h>'}

// Translated from rpc/netdb.h

{ Cleaned up for GNU C library roland@gnu.ai.mit.edu:
   added multiple inclusion protection and use of <sys/cdefs.h>.
   In GNU this file is #include'd by <netdb.h>.  }

type
  rpcent = {packed} record
    r_name: PChar;       { Name of server for this rpc program.  }
    r_aliases: PPChar;   { Alias list.  }
    r_number: Integer;   { RPC program number.  }
  end;
  {$EXTERNALSYM rpcent}
  TRpcEnt = rpcent;
  PRpcEnt = ^TRpcEnt;

procedure setrpcent(__stayopen: Integer); cdecl;
{$EXTERNALSYM setrpcent}
procedure endrpcent(); cdecl;
{$EXTERNALSYM endrpcent}
function getrpcbyname(__name: PChar): PRpcEnt; cdecl;
{$EXTERNALSYM getrpcbyname}
function getrpcbynumber(__number: Integer): PRpcEnt; cdecl;
{$EXTERNALSYM getrpcbynumber}
function getrpcent(): PRpcEnt; cdecl;
{$EXTERNALSYM getrpcent}

function getrpcbyname_r(__name: PChar; var __result_buf: rpcent; __buffer: PChar;
  __buflen: size_t; var __result: PRpcEnt): Integer; cdecl;
{$EXTERNALSYM getrpcbyname_r}

function getrpcbynumber_r(__number: Integer; var __result_buf: rpcent; __buffer: PChar;
  __buflen: size_t; var __result: PRpcEnt): Integer; cdecl;
{$EXTERNALSYM getrpcbynumber_r}

function getrpcent_r(var __result_buf: rpcent; __buffer: PChar;
  __buflen: size_t; var __result: PRpcEnt): Integer; cdecl;
{$EXTERNALSYM getrpcent_r}


{$HPPEMIT '#include <rpc/pmap_prot.h>'}

// Translated from rpc/pmap_prot.h

{ Protocol for the local binder service, or pmap. }

{ The following procedures are supported by the protocol:
 *
 * PMAPPROC_NULL() returns ()
 * 	takes nothing, returns nothing
 *
 * PMAPPROC_SET(struct pmap) returns (bool_t)
 * 	TRUE is success, FALSE is failure.  Registers the tuple
 *	[prog, vers, prot, port].
 *
 * PMAPPROC_UNSET(struct pmap) returns (bool_t)
 *	TRUE is success, FALSE is failure.  Un-registers pair
 *	[prog, vers].  prot and port are ignored.
 *
 * PMAPPROC_GETPORT(struct pmap) returns (long unsigned).
 *	0 is failure.  Otherwise returns the port number where the pair
 *	[prog, vers] is registered.  It may lie!
 *
 * PMAPPROC_DUMP() RETURNS (struct pmaplist *)
 *
 * PMAPPROC_CALLIT(unsigned, unsigned, unsigned, string<>)
 * 	RETURNS (port, string<>);
 * usage: encapsulatedresults = PMAPPROC_CALLIT(prog, vers, proc, encapsulatedargs);
 * 	Calls the procedure on the local machine.  If it is not registered,
 *	this procedure is quite; ie it does not return error information!!!
 *	This procedure only is supported on rpc/udp and calls via
 *	rpc/udp.  This routine only passes null authentication parameters.
 *	This file has no interface to xdr routines for PMAPPROC_CALLIT.
 *
 * The service supports remote procedure calls on udp/ip or tcp/ip socket 111.
 }

const
  PMAPPORT         = u_short(111);
  {$EXTERNALSYM PMAPPORT}
  PMAPPROG         = u_long(100000);
  {$EXTERNALSYM PMAPPROG}
  PMAPVERS         = u_long(2);
  {$EXTERNALSYM PMAPVERS}
  PMAPVERS_PROTO   = u_long(2);
  {$EXTERNALSYM PMAPVERS_PROTO}
  PMAPVERS_ORIG    = u_long(1);
  {$EXTERNALSYM PMAPVERS_ORIG}
  PMAPPROC_NULL    = u_long(0);
  {$EXTERNALSYM PMAPPROC_NULL}
  PMAPPROC_SET     = u_long(1);
  {$EXTERNALSYM PMAPPROC_SET}
  PMAPPROC_UNSET   = u_long(2);
  {$EXTERNALSYM PMAPPROC_UNSET}
  PMAPPROC_GETPORT = u_long(3);
  {$EXTERNALSYM PMAPPROC_GETPORT}
  PMAPPROC_DUMP    = u_long(4);
  {$EXTERNALSYM PMAPPROC_DUMP}
  PMAPPROC_CALLIT  = u_long(5);
  {$EXTERNALSYM PMAPPROC_CALLIT}

type
  pmap = {packed} record
    pm_prog: LongWord;
    pm_vers: LongWord;
    pm_prot: LongWord;
    pm_port: LongWord;
  end;
  {$EXTERNALSYM pmap}
  TPMap = pmap;
  PPMap = ^TPMap;

function xdr_pmap(__xdrs: PXdr; __regs: PPMap): bool_t; cdecl;
{$EXTERNALSYM xdr_pmap}

type
  PPMapList = ^TPMapList;

  pmaplist = {packed} record
    pml_map: pmap;
    pml_nex: PPMapList;
  end;
  {$EXTERNALSYM pmaplist}
  TPMapList = pmaplist;

function xdr_pmaplist(__xdrs: PXdr; var __rp: PPMapList): bool_t; cdecl;
{$EXTERNALSYM xdr_pmaplist}


{$HPPEMIT '#include <rpc/pmap_rmt.h>'}

// Translated from rpc/pmap_rmt.h

{ Structures and XDR routines for parameters to and replies from
   the portmapper remote-call-service. }

type
  rmtcallargs = {packed} record
    prog, vers, proc, arglen: u_long;
    args_ptr: caddr_t;
    xdr_args: xdrproc_t;
  end;
  {$EXTERNALSYM rmtcallargs}
  TRmtCallArgs = rmtcallargs;
  PRmtCallArgs = ^TRmtCallArgs;

function xdr_rmtcall_args(__xdrs: PXdr; __crp: PRmtCallArgs): bool_t; cdecl;
{$EXTERNALSYM xdr_rmtcall_args}

type
  Pu_long = ^u_long;

  rmtcallres = {packed} record
    port_ptr: Pu_long;
    resultslen: u_long;
    results_ptr: caddr_t;
    xdr_results: xdrproc_t;
  end;
  {$EXTERNALSYM rmtcallres}
  TRmtCallRes = rmtcallres;
  PRmtCallRes = ^TRmtCallRes;

function xdr_rmtcallres(__xdrs: PXdr; __crp: PRmtCallRes): bool_t; cdecl;
{$EXTERNALSYM xdr_rmtcallres}


{$HPPEMIT '#include <rpc/rpc_des.h>'}

// Translated from rpc/rpc_des.h

{
 * Generic DES driver interface
 * Keep this file hardware independent!
 * Copyright (c) 1986 by Sun Microsystems, Inc.
 }
const
  DES_MAXLEN   = 65536;     { maximum # of bytes to encrypt  }
  {$EXTERNALSYM DES_MAXLEN}
  DES_QUICKLEN = 16;        { maximum # of bytes to encrypt quickly }
  {$EXTERNALSYM DES_QUICKLEN}

type
  desdir =
  (
    ENCRYPT = 0,
    {$EXTERNALSYM ENCRYPT}
    DECRYPT = 1
    {$EXTERNALSYM DECRYPT}
  );
  {$EXTERNALSYM desdir}

  desmode =
  (
    CBC = 0,
    {$EXTERNALSYM CBC}
    ECB = 1
    {$EXTERNALSYM ECB}
  );
  {$EXTERNALSYM desmode}

{ parameters to ioctl call }
type
  Pu_char = ^u_char;

  desparams = {packed} record
    des_key: packed array[0..8-1] of u_char;      { key (with low bit parity) }
    des_dir: desdir;                              { direction }
    des_mode: desmode;                            { mode }
    des_ivec: packed array[0..8-1] of u_char;     { input vector }
    des_len: Cardinal;                   { number of bytes to crypt }
    UDES: {packed} record
            case Integer of
	0: (UDES_data: packed array[0..DES_QUICKLEN-1] of u_char);
	1: (UDES_buf: Pu_char);
            end;
  end;
  {$EXTERNALSYM desparams}


{$HPPEMIT '#include <rpc/pmap_clnt.h>'}

// Translated from rpc/pmap_clnt.h

{ Supplies C routines to get to portmap services. }

type
  resultproc_t = function(resp: caddr_t; raddr: PSockAddrIn): bool_t; cdecl;
  {$EXTERNALSYM resultproc_t}

{
 * Usage:
 *	success = pmap_set(program, version, protocol, port);
 *	success = pmap_unset(program, version);
 *	port = pmap_getport(address, program, version, protocol);
 *	head = pmap_getmaps(address);
 *	clnt_stat = pmap_rmtcall(address, program, version, procedure,
 *		xdrargs, argsp, xdrres, resp, tout, port_ptr)
 *		(works for udp only.)
 * 	clnt_stat = clnt_broadcast(program, version, procedure,
 *		xdrargs, argsp,	xdrres, resp, eachresult)
 *		(like pmap_rmtcall, except the call is broadcasted to all
 *		locally connected nets.  For each valid response received,
 *		the procedure eachresult is called.  Its form is:
 *	done = eachresult(resp, raddr)
 *		bool_t done;
 *		caddr_t resp;
 *		struct sockaddr_in raddr;
 *		where resp points to the results of the call and raddr is the
 *		address if the responder to the broadcast.
 }

function pmap_set(__program: u_long; __vers: u_long; __protocol: Integer;
  __port: u_short): bool_t; cdecl;
{$EXTERNALSYM pmap_set}
function pmap_unset(__program: u_long; __vers: u_long): bool_t; cdecl;
{$EXTERNALSYM pmap_unset}

function pmap_getmaps(__address: PSockaddrIn): PPMapList;
{$EXTERNALSYM pmap_getmaps}
function pmap_rmtcall(__address: PSockaddrIn; __prog: u_long; __vers: u_long;
  __proc: u_long; __xdrargs: xdrproc_t; __argsp: caddr_t; __xdrres: xdrproc_t;
  __resp: caddr_t; __tout: timeval; var __port_ptr: u_long): clnt_stat; cdecl;
{$EXTERNALSYM pmap_rmtcall}
function clnt_broadcast(__prog: u_long; __vers: u_long; __proc: u_long;
  __xargs: xdrproc_t; __argsp: caddr_t; __xresults: xdrproc_t; __resultsp: caddr_t;
  __eachresult: resultproc_t): clnt_stat; cdecl;
{$EXTERNALSYM clnt_broadcast}
function pmap_getport(__address: PSockaddrIn; __program: u_long; __version: u_long;
  __protocol: u_int): u_short; cdecl;
{$EXTERNALSYM pmap_getport}


{$HPPEMIT '#include <rpc/svc_auth.h>'}

// Translated from rpc/svc_auth.h

{ Service side of rpc authentication. }

{ Server side authenticator }
function _authenticate(__rqst: PSvcReq; __msg: PRpcMsg): auth_stat; cdecl;
{$EXTERNALSYM _authenticate}


{$HPPEMIT '#include <rpc/rpc.h>'}

// Translated from rpc/rpc.h

{ Just includes the billions of rpc header files necessary to
   do remote procedure calling. }

(*
  Nothing do to here
*)


implementation

function xdr_void;                      external libcmodulename name 'xdr_void';
function xdr_short;                     external libcmodulename name 'xdr_short';
function xdr_u_short;                   external libcmodulename name 'xdr_u_short';
function xdr_int;                       external libcmodulename name 'xdr_int';
function xdr_u_int;                     external libcmodulename name 'xdr_u_int';
function xdr_long;                      external libcmodulename name 'xdr_long';
function xdr_u_long;                    external libcmodulename name 'xdr_u_long';
function xdr_hyper;                     external libcmodulename name 'xdr_hyper';
function xdr_u_hyper;                   external libcmodulename name 'xdr_u_hyper';
function xdr_longlong_t;                external libcmodulename name 'xdr_longlong_t';
function xdr_u_longlong_t;              external libcmodulename name 'xdr_u_longlong_t';
function xdr_int8_t;                    external libcmodulename name 'xdr_int8_t';
function xdr_uint8_t;                   external libcmodulename name 'xdr_uint8_t';
function xdr_int16_t;                   external libcmodulename name 'xdr_int16_t';
function xdr_uint16_t;                  external libcmodulename name 'xdr_uint16_t';
function xdr_int32_t;                   external libcmodulename name 'xdr_int32_t';
function xdr_uint32_t;                  external libcmodulename name 'xdr_uint32_t';
function xdr_int64_t;                   external libcmodulename name 'xdr_int64_t';
function xdr_uint64_t;                  external libcmodulename name 'xdr_uint64_t';
function xdr_bool;                      external libcmodulename name 'xdr_bool';
function xdr_enum;                      external libcmodulename name 'xdr_enum';
function xdr_array;                     external libcmodulename name 'xdr_array';
function xdr_bytes;                     external libcmodulename name 'xdr_bytes';
function xdr_opaque;                    external libcmodulename name 'xdr_opaque';
function xdr_string;                    external libcmodulename name 'xdr_string';
function xdr_union;                     external libcmodulename name 'xdr_union';
function xdr_char;                      external libcmodulename name 'xdr_char';
function xdr_u_char;                    external libcmodulename name 'xdr_u_char';
function xdr_vector;                    external libcmodulename name 'xdr_vector';
function xdr_float;                     external libcmodulename name 'xdr_float';
function xdr_double;                    external libcmodulename name 'xdr_double';
function xdr_reference;                 external libcmodulename name 'xdr_reference';
function xdr_pointer;                   external libcmodulename name 'xdr_pointer';
function xdr_wrapstring;                external libcmodulename name 'xdr_wrapstring';
function xdr_sizeof;                    external libcmodulename name 'xdr_sizeof';

function xdr_netobj;                    external libcmodulename name 'xdr_netobj';
procedure xdrmem_create;                external libcmodulename name 'xdrmem_create';
procedure xdrstdio_create;              external libcmodulename name 'xdrstdio_create';
procedure xdrrec_create;                external libcmodulename name 'xdrrec_create';
function xdrrec_endofrecord;            external libcmodulename name 'xdrrec_endofrecord';
function xdrrec_skiprecord;             external libcmodulename name 'xdrrec_skiprecord';
function xdrrec_eof;                    external libcmodulename name 'xdrrec_eof';
procedure xdr_free;                     external libcmodulename name 'xdr_free';

function xdr_des_block;                 external libcmodulename name 'xdr_des_block';

function authunix_create;               external libcmodulename name 'authunix_create';
function authunix_create_default;       external libcmodulename name 'authunix_create_default';
function authnone_create;               external libcmodulename name 'authnone_create';
function authdes_create;                external libcmodulename name 'authdes_create';
function authdes_pk_create;             external libcmodulename name 'authdes_pk_create';

function getnetname;                    external libcmodulename name 'getnetname';
function host2netname;                  external libcmodulename name 'host2netname';
function user2netname;                  external libcmodulename name 'user2netname';
function netname2user;                  external libcmodulename name 'netname2user';
function netname2host;                  external libcmodulename name 'netname2host';
function key_decryptsession;            external libcmodulename name 'key_decryptsession';
function key_decryptsession_pk;         external libcmodulename name 'key_decryptsession_pk';
function key_encryptsession;            external libcmodulename name 'key_encryptsession';
function key_encryptsession_pk;         external libcmodulename name 'key_encryptsession_pk';
function key_gendes;                    external libcmodulename name 'key_gendes';
function key_setsecret;                 external libcmodulename name 'key_setsecret';
function key_secretkey_is_set;          external libcmodulename name 'key_secretkey_is_set';
function key_get_conv;                  external libcmodulename name 'key_get_conv';
function xdr_opaque_auth;               external libcmodulename name 'xdr_opaque_auth';

function authdes_getucred;              external libcmodulename name 'authdes_getucred';
function getpublickey;                  external libcmodulename name 'getpublickey';
function getsecretkey;                  external libcmodulename name 'getsecretkey';
function rtime;                         external libcmodulename name 'rtime';

function xdr_authunix_parms;            external libcmodulename name 'xdr_authunix_parms';
function clntraw_create;                external libcmodulename name 'clntraw_create';
function clnt_create;                   external libcmodulename name 'clnt_create';
function clnttcp_create;                external libcmodulename name 'clnttcp_create';
function clntudp_create;                external libcmodulename name 'clntudp_create';
function clntudp_bufcreate;             external libcmodulename name 'clntudp_bufcreate';
function clntunix_create;               external libcmodulename name 'clntunix_create';
function callrpc;                       external libcmodulename name 'callrpc';
function _rpc_dtablesize;               external libcmodulename name '_rpc_dtablesize';
procedure clnt_pcreateerror;            external libcmodulename name 'clnt_pcreateerror';
function clnt_spcreateerror;            external libcmodulename name 'clnt_spcreateerror';
procedure clnt_perrno;                  external libcmodulename name 'clnt_perrno';
procedure clnt_perror;                  external libcmodulename name 'clnt_perror';
function clnt_sperror;                  external libcmodulename name 'clnt_sperror';
function clnt_sperrno;                  external libcmodulename name 'clnt_sperrno';
function getrpcport;                    external libcmodulename name 'getrpcport';
procedure get_myaddress;                external libcmodulename name 'get_myaddress';

function cbc_crypt;                     external libcmodulename name 'cbc_crypt';
function ecb_crypt;                     external libcmodulename name 'ecb_crypt';
procedure des_setparity;                external libcmodulename name 'des_setparity';

function xdr_callmsg;                   external libcmodulename name 'xdr_callmsg';
function xdr_callhdr;                   external libcmodulename name 'xdr_callhdr';
function xdr_replymsg;                  external libcmodulename name 'xdr_replymsg';
procedure _seterr_reply;                external libcmodulename name '_seterr_reply';

function svc_register;                  external libcmodulename name 'svc_register';
procedure svc_unregister;               external libcmodulename name 'svc_unregister';
procedure xprt_register;                external libcmodulename name 'xprt_register';
procedure xprt_unregister;              external libcmodulename name 'xprt_unregister';
function svc_sendreply;                 external libcmodulename name 'svc_sendreply';
procedure svcerr_decode;                external libcmodulename name 'svcerr_decode';
procedure svcerr_weakauth;              external libcmodulename name 'svcerr_weakauth';
procedure svcerr_noproc;                external libcmodulename name 'svcerr_noproc';
procedure svcerr_progvers;              external libcmodulename name 'svcerr_progvers';
procedure svcerr_auth;                  external libcmodulename name 'svcerr_auth';
procedure svcerr_noprog;                external libcmodulename name 'svcerr_noprog';
procedure svcerr_systemerr;             external libcmodulename name 'svcerr_systemerr';
procedure svc_getreq;                   external libcmodulename name 'svc_getreq';
procedure svc_getreq_common;            external libcmodulename name 'svc_getreq_common';
procedure svc_getreqset;                external libcmodulename name 'svc_getreqset';
procedure svc_getreq_poll;              external libcmodulename name 'svc_getreq_poll';
procedure svc_exit;                     external libcmodulename name 'svc_exit';
procedure svc_run;                      external libcmodulename name 'svc_run';
function svcraw_create;                 external libcmodulename name 'svcraw_create';
function svcudp_create;                 external libcmodulename name 'svcudp_create';
function svcudp_bufcreate;              external libcmodulename name 'svcudp_bufcreate';
function svctcp_create;                 external libcmodulename name 'svctcp_create';
function svcunix_create;                external libcmodulename name 'svcunix_create';

function xdr_keystatus;                 external libcmodulename name 'xdr_keystatus';
function xdr_keybuf;                    external libcmodulename name 'xdr_keybuf';
function xdr_netnamestr;                external libcmodulename name 'xdr_netnamestr';
function xdr_cryptkeyarg;               external libcmodulename name 'xdr_cryptkeyarg';
function xdr_cryptkeyarg2;              external libcmodulename name 'xdr_cryptkeyarg2';
function xdr_cryptkeyres;               external libcmodulename name 'xdr_cryptkeyres';
function xdr_unixcred;                  external libcmodulename name 'xdr_unixcred';
function xdr_getcredres;                external libcmodulename name 'xdr_getcredres';
function xdr_key_netstarg;              external libcmodulename name 'xdr_key_netstarg';
function xdr_key_netstres;              external libcmodulename name 'xdr_key_netstres';

function key_set_1;                     external libcmodulename name 'key_set_1';
function key_set_1_svc;                 external libcmodulename name 'key_set_1_svc';
function key_encrypt_1;                 external libcmodulename name 'key_encrypt_1';
function key_encrypt_1_svc;             external libcmodulename name 'key_encrypt_1_svc';
function key_decrypt_1;                 external libcmodulename name 'key_decrypt_1';
function key_decrypt_1_svc;             external libcmodulename name 'key_decrypt_1_svc';
function key_gen_1;                     external libcmodulename name 'key_gen_1';
function key_gen_1_svc;                 external libcmodulename name 'key_gen_1_svc';
function key_getcred_1;                 external libcmodulename name 'key_getcred_1';
function key_getcred_1_svc;             external libcmodulename name 'key_getcred_1_svc';
function key_set_2;                     external libcmodulename name 'key_set_2';
function key_set_2_svc;                 external libcmodulename name 'key_set_2_svc';
function key_encrypt_2;                 external libcmodulename name 'key_encrypt_2';
function key_encrypt_2_svc;             external libcmodulename name 'key_encrypt_2_svc';
function key_decrypt_2;                 external libcmodulename name 'key_decrypt_2';
function key_decrypt_2_svc;             external libcmodulename name 'key_decrypt_2_svc';
function key_gen_2;                     external libcmodulename name 'key_gen_2';
function key_gen_2_svc;                 external libcmodulename name 'key_gen_2_svc';
function key_getcred_2;                 external libcmodulename name 'key_getcred_2';
function key_getcred_2_svc;             external libcmodulename name 'key_getcred_2_svc';
function key_encrypt_pk_2;              external libcmodulename name 'key_encrypt_pk_2';
function key_encrypt_pk_2_svc;          external libcmodulename name 'key_encrypt_pk_2_svc';
function key_decrypt_pk_2;              external libcmodulename name 'key_decrypt_pk_2';
function key_decrypt_pk_2_svc;          external libcmodulename name 'key_decrypt_pk_2_svc';
function key_net_put_2;                 external libcmodulename name 'key_net_put_2';
function key_net_put_2_svc;             external libcmodulename name 'key_net_put_2_svc';
function key_net_get_2;                 external libcmodulename name 'key_net_get_2';
function key_net_get_2_svc;             external libcmodulename name 'key_net_get_2_svc';
function key_get_conv_2;                external libcmodulename name 'key_get_conv_2';
function key_get_conv_2_svc;            external libcmodulename name 'key_get_conv_2_svc';

procedure setrpcent;                    external libcmodulename name 'setrpcent';
procedure endrpcent;                    external libcmodulename name 'endrpcent';
function getrpcbyname;                  external libcmodulename name 'getrpcbyname';
function getrpcbynumber;                external libcmodulename name 'getrpcbynumber';
function getrpcent;                     external libcmodulename name 'getrpcent';
function getrpcbyname_r;                external libcmodulename name 'getrpcbyname_r';
function getrpcbynumber_r;              external libcmodulename name 'getrpcbynumber_r';
function getrpcent_r;                   external libcmodulename name 'getrpcent_r';

function xdr_pmap;                      external libcmodulename name 'xdr_pmap';
function xdr_pmaplist;                  external libcmodulename name 'xdr_pmaplist';

function xdr_rmtcall_args;              external libcmodulename name 'xdr_rmtcall_args';
function xdr_rmtcallres;                external libcmodulename name 'xdr_rmtcallres';

function pmap_set;                      external libcmodulename name 'pmap_set';
function pmap_unset;                    external libcmodulename name 'pmap_unset';
function pmap_getmaps;                  external libcmodulename name 'pmap_getmaps';
function pmap_rmtcall;                  external libcmodulename name 'pmap_rmtcall';
function clnt_broadcast;                external libcmodulename name 'clnt_broadcast';
function pmap_getport;                  external libcmodulename name 'pmap_getport';

function _authenticate;                 external libcmodulename name '_authenticate';


function RNDUP(x: Integer): Integer;
begin
  Result := (x + BYTES_PER_XDR_UNIT - 1) and not (BYTES_PER_XDR_UNIT - 1)
end;

function XDR_GETINT32(xdrs: PXdr; int32p: Pint32_t): bool_t;
begin
  Result := xdrs^.x_ops^.x_getint32(xdrs, int32p);
end;

function XDR_PUTINT32(xdrs: PXdr; int32p: Pint32_t): bool_t;
begin
  Result := xdrs^.x_ops^.x_putint32(xdrs, int32p);
end;

function XDR_GETLONG(xdrs: PXdr; lp: PLongWord): bool_t;
begin
  Result := xdrs^.x_ops^.x_getlong(xdrs, lp);
end;

function XDR_PUTLONG(xdrs: PXdr; lp: PLongWord): bool_t;
begin
  Result := xdrs^.x_ops^.x_putlong(xdrs, lp);
end;

function XDR_GETBYTES(xdrs: PXdr; addr: caddr_t; len: u_int): bool_t;
begin
  Result := xdrs^.x_ops^.x_getbytes(xdrs, addr, len);
end;

function XDR_PUTBYTES(xdrs: PXdr; addr: PChar; len: u_int): bool_t;
begin
  Result := xdrs^.x_ops^.x_putbytes(xdrs, addr, len);
end;

function XDR_GETPOS(xdrs: PXdr): u_int;
begin
  Result := xdrs^.x_ops^.x_getpostn(xdrs);
end;

function XDR_SETPOS(xdrs: PXdr; pos: u_int): bool_t;
begin
  Result := xdrs^.x_ops^.x_setpostn(xdrs, pos);
end;

function XDR_INLINE(xdrs: PXdr; len: Integer): Pint32_t;
begin
  Result := xdrs^.x_ops^.x_inline(xdrs, len);
end;

procedure XDR_DESTROY(xdrs: PXdr);
begin
  if Assigned(xdrs^.x_ops^.x_destroy) then
    xdrs^.x_ops^.x_destroy(xdrs);
end;

function IXDR_GET_INT32(var Buf: Pointer): int32_t;
type
  Puint32_t = ^uint32_t;
begin
  Result := ntohl(Puint32_t(Buf)^);
  Inc(Puint32_t(Buf));
end;

function IXDR_PUT_INT32(var Buf: Pointer; Value: int32_t): int32_t;
type
  Pint32_t = ^int32_t;
begin
  Pint32_t(Buf)^ := htonl(Value);
  Result := Pint32_t(Buf)^;
  Inc(Pint32_t(Buf));
end;

function IXDR_GET_U_INT32(var Buf: Pointer): uint32_t;
begin
  Result := IXDR_GET_INT32(Buf);
end;

function IXDR_PUT_U_INT32(var Buf: Pointer; Value: uint32_t): uint32_t;
begin
  Result := IXDR_PUT_INT32(Buf, Value);
end;

function IXDR_GET_LONG(var Buf: Pointer): Longint;
type
  Pu_int32_t = ^u_int32_t;
begin
  Result := ntohl(u_long(Pu_int32_t(Buf)^));
  Inc(Pu_int32_t(Buf));
end;

function IXDR_PUT_LONG(var Buf: Pointer; Value: Longint): Longint;
type
  Pu_int32_t = ^u_int32_t;
begin
  Pu_int32_t(Buf)^ := Longint(htonl(u_long(Value)));
  Result := Pu_int32_t(Buf)^;
  Inc(Pu_int32_t(Buf));
end;

function IXDR_GET_U_LONG(var Buf: Pointer): u_long;
begin
  Result := IXDR_GET_LONG(Buf);
end;

function IXDR_PUT_U_LONG(var Buf: Pointer; Value: u_long): u_long;
begin
  Result := IXDR_PUT_LONG(Buf, Value);
end;

function IXDR_GET_BOOL(var Buf: Pointer): bool_t;
begin
  Result := IXDR_GET_LONG(Buf);
end;

(*
#define IXDR_GET_ENUM(buf, t)         ((t)IXDR_GET_LONG(buf))
*)

function IXDR_GET_SHORT(var Buf: Pointer): Smallint;
begin
  Result := IXDR_GET_LONG(Buf);
end;

function IXDR_GET_U_SHORT(var Buf: Pointer): u_short;
begin
  Result := IXDR_GET_LONG(Buf);
end;

function IXDR_PUT_BOOL(var Buf: Pointer; Value: Boolean): Boolean;
begin
  Result := Boolean(IXDR_PUT_LONG(Buf, Longint(Value)));
end;

(*
#define IXDR_PUT_ENUM(buf, v)         IXDR_PUT_LONG(buf, (long)(v))
*)

function IXDR_PUT_SHORT(var Buf: Pointer; Value: Smallint): Smallint;
begin
  Result := IXDR_PUT_LONG(Buf, Value);
end;

function IXDR_PUT_U_SHORT(var Buf: Pointer; Value: u_short): u_short;
begin
  Result := IXDR_PUT_LONG(Buf, Value);
end;

procedure AUTH_NEXTVERF(auth: PAuthRecord);
begin
  auth^.ah_ops^.ah_nextverf(auth);
end;

function AUTH_MARSHALL(auth: PAuthRecord; xdrs: PXdr): Integer;
begin
  Result := auth^.ah_ops^.ah_marshal(auth, xdrs);
end;

function AUTH_VALIDATE(auth: PAuthRecord; var verfp: opaque_auth): Integer;
begin
  Result := auth^.ah_ops^.ah_validate(auth, verfp);
end;

function AUTH_REFRESH(auth: PAuthRecord): Integer;
begin
  Result := auth^.ah_ops^.ah_refresh(auth);
end;

procedure AUTH_DESTROY(auth: PAuthRecord);
begin
  auth^.ah_ops^.ah_destroy(auth);
end;

function CLNT_CALL(rh: PClientRecord; proc: u_long; xargs: xdrproc_t; argsp: caddr_t;
  xres: xdrproc_t; resp: caddr_t; secs: timeval): clnt_stat;
begin
  Result := rh^.cl_ops^.cl_call(rh, proc, xargs, argsp, xres, resp, secs);
end;

procedure CLNT_ABORT(rh: PClientRecord);
begin
  rh^.cl_ops^.cl_abort();
end;

procedure CLNT_GETERR(rh: PClientRecord; var errp: rpc_err);
begin
  rh^.cl_ops^.cl_geterr(rh, errp);
end;

function CLNT_FREERES(rh: PClientRecord; xres: xdrproc_t; resp: caddr_t): bool_t;
begin
  Result := rh^.cl_ops^.cl_freeres(rh, xres, resp);
end;

function CLNT_CONTROL(rh: PClientRecord; request: Integer; Info: PChar): bool_t;
begin
  Result := rh^.cl_ops^.cl_control(rh, request, info);
end;

procedure CLNT_DESTROY(rh: PClientRecord);
begin
  rh^.cl_ops^.cl_destroy(rh);
end;

function DES_FAILED(err: Integer): Boolean;
begin
  Result := (err > DESERR_NOHWDEVICE);
end;

function svc_getcaller(const Service: TScvXpRt): sockaddr_in;
begin
  Result := Service.xp_raddr;
end;

function SVC_RECV(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t;
begin
  Result := __xprt^.xp_ops^.xp_recv(__xprt, __msg);
end;

function SVC_STAT(__xprt: PScvXpRt): xprt_stat;
begin
  Result :=  __xprt^.xp_ops^.xp_stat(__xprt);
end;

function SVC_GETARGS(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t;
begin
  Result := __xprt^.xp_ops^.xp_getargs(__xprt, __xdr_args, args_ptr);
end;

function SVC_REPLY(__xprt: PScvXpRt; __msg: PRpcMsg): bool_t;
begin
  Result := __xprt^.xp_ops^.xp_reply(__xprt, __msg);
end;

function SVC_FREEARGS(__xprt: PScvXpRt; __xdr_args: xdrproc_t; args_ptr: caddr_t): bool_t;
begin
  Result := __xprt^.xp_ops^.xp_freeargs(__xprt, __xdr_args, args_ptr);
end;

procedure SVC_DESTROY(__xprt: PScvXpRt);
begin
  __xprt^.xp_ops^.xp_destroy(__xprt);
end;


end.
