{ *********************************************************************** }
{                                                                         }
{  Borland Kylix Runtime Library                                          }
{  Linux API Interface Unit - XWindows library                            }
{                                                                         }
{  Copyright (C) 2001-2002 Borland Software Corporation                   }
{                                                                         }
{  Translator: Borland Software Corporation                               }
{                                                                         }
{  This file may be distributed and/or modified under the terms of the    }
{  GNU General Public License version 2 as published by the Free Software }
{  Foundation and appearing at http://www.borland.com/kylix/gpl.html.     }
{                                                                         }
{  Licensees holding a valid Borland No-Nonsense License for this         }
{  Software may use this file in accordance with such license, which      }
{  appears in the file license.txt that came with this software.          }
{                                                                         }
{ *********************************************************************** }

unit Xpm;

{$WEAKPACKAGEUNIT}

{$ALIGN 4}
{$MINENUMSIZE 4}

interface

uses Libc, Xlib;

(*$HPPEMIT  'struct XpmColorSymbol;'*)
(*$HPPEMIT  'struct XpmExtension;'*)
(*$HPPEMIT  'struct XpmColor;'*)
(*$HPPEMIT  'struct XpmImage;'*)
(*$HPPEMIT  'struct XpmInfo;'*)
(*$HPPEMIT  'struct XpmAttributes;'*)

const
  XpmFormat = 3;
  {$EXTERNALSYM XpmFormat}
  XpmVersion = 4;
  {$EXTERNALSYM XpmVersion}
  XpmRevision = 11;
  {$EXTERNALSYM XpmRevision}
  XpmIncludeVersion = (XpmFormat * 100 + XpmVersion) * 100 + XpmRevision;
  {$EXTERNALSYM XpmIncludeVersion}

  XpmColorError   = 1;
  {$EXTERNALSYM XpmColorError}
  XpmSuccess      = 0;
  {$EXTERNALSYM XpmSuccess}
  XpmOpenFailed   = -1;
  {$EXTERNALSYM XpmOpenFailed}
  XpmFileInvalid  = -2;
  {$EXTERNALSYM XpmFileInvalid}
  XpmNoMemory     = -3;
  {$EXTERNALSYM XpmNoMemory}
  XpmColorFailed  = -4;
  {$EXTERNALSYM XpmColorFailed}

{ XpmAttributes value masks bits }
  XpmVisual        = LongWord(1 shl 0);
  {$EXTERNALSYM XpmVisual}
  XpmColormap      = LongWord(1 shl 1);
  {$EXTERNALSYM XpmColormap}
  XpmDepth         = LongWord(1 shl 2);
  {$EXTERNALSYM XpmDepth}
  XpmSize          = LongWord(1 shl 3); { width & height }
  {$EXTERNALSYM XpmSize}
  XpmHotspot       = LongWord(1 shl 4); { x_hotspot & y_hotspot }
  {$EXTERNALSYM XpmHotspot}
  XpmCharsPerPixel = LongWord(1 shl 5);
  {$EXTERNALSYM XpmCharsPerPixel}
  XpmColorSymbols  = LongWord(1 shl 6);
  {$EXTERNALSYM XpmColorSymbols}
  XpmRgbFilename   = LongWord(1 shl 7);
  {$EXTERNALSYM XpmRgbFilename}
{ 3.2 backward compatibility code }
  XpmInfos         = LongWord(1 shl 8);
  {$EXTERNALSYM XpmInfos}
  XpmReturnInfos   = XpmInfos;
  {$EXTERNALSYM XpmReturnInfos}
{ end 3.2 bc }
  XpmReturnPixels  = LongWord(1 shl 9);
  {$EXTERNALSYM XpmReturnPixels}
  XpmExtensions    = LongWord(1 shl 10);
  {$EXTERNALSYM XpmExtensions}
  XpmReturnExtensions = XpmExtensions;
  {$EXTERNALSYM XpmReturnExtensions}

  XpmExactColors   = LongWord(1 shl 11);
  {$EXTERNALSYM XpmExactColors}
  XpmCloseness     = LongWord(1 shl 12);
  {$EXTERNALSYM XpmCloseness}
  XpmRGBCloseness  = LongWord(1 shl 13);
  {$EXTERNALSYM XpmRGBCloseness}
  XpmColorKey      = LongWord(1 shl 14);
  {$EXTERNALSYM XpmColorKey}

  XpmColorTable    = LongWord(1 shl 15);
  {$EXTERNALSYM XpmColorTable}
  XpmReturnColorTable = XpmColorTable;
  {$EXTERNALSYM XpmReturnColorTable}

  XpmReturnAllocPixels = LongWord(1 shl 16);
  {$EXTERNALSYM XpmReturnAllocPixels}
  XpmAllocCloseColors = LongWord(1 shl 17);
  {$EXTERNALSYM XpmAllocCloseColors}
  XpmBitmapFormat  = LongWord(1 shl 18);
  {$EXTERNALSYM XpmBitmapFormat}

  XpmAllocColor    = LongWord(1 shl 19);
  {$EXTERNALSYM XpmAllocColor}
  XpmFreeColors    = LongWord(1 shl 20);
  {$EXTERNALSYM XpmFreeColors}
  XpmColorClosure  = LongWord(1 shl 21);
  {$EXTERNALSYM XpmColorClosure}


{ XpmInfo value masks bits }
  XpmComments      = XpmInfos;
  {$EXTERNALSYM XpmComments}
  XpmReturnComments = XpmComments;
  {$EXTERNALSYM XpmReturnComments}

{ XpmAttributes mask_pixel value when there is no mask }
  XpmUndefPixel    = LongWord($80000000);
  {$EXTERNALSYM XpmUndefPixel}

{ color keys for visual type, they must fit along with the number key of
  each related element in xpmColorKeys[] defined in XpmI.h }
  XPM_MONO      = 2;
  {$EXTERNALSYM XPM_MONO}
  XPM_GREY4     = 3;
  {$EXTERNALSYM XPM_GREY4}
  XPM_GRAY4     = 3;
  {$EXTERNALSYM XPM_GRAY4}
  XPM_GREY      = 4;
  {$EXTERNALSYM XPM_GREY}
  XPM_GRAY      = 4;
  {$EXTERNALSYM XPM_GRAY}
  XPM_COLOR     = 5;
  {$EXTERNALSYM XPM_COLOR}

type
  PXpmColorSymbol = ^XpmColorSymbol;
  XpmColorSymbol = record
    name: PChar;		{ Symbolic color name }
    value: PChar;		{ Color value }
    pixel: Pixel;		{ Color pixel }
  end;
  {$EXTERNALSYM XpmColorSymbol}

  PXpmExtension = ^XpmExtension;
  XpmExtension = record
    name: PChar;		{ name of the extension }
    nlines: LongWord;   	{ number of lines in this extension }
    lines: PPChar;		{ pointer to the extension array of strings }
  end;
  {$EXTERNALSYM XpmExtension}

  PXpmColor = ^XpmColor;
  XpmColor = record
    _string: PChar;		{ characters string }
    symbolic: PChar;		{ symbolic name }
    m_color: PChar;		{ monochrom default }
    g4_color: PChar;		{ 4 level grayscale default }
    g_color: PChar;		{ other level grayscale default }
    c_color: PChar;		{ color default }
  end;
  {$EXTERNALSYM XpmColor}

  PXpmImage = ^XpmImage;
  XpmImage = record
    width: LongWord;		{ image width }
    height: LongWord;   	{ image height }
    cpp: LongWord;		{ number of characters per pixel }
    ncolors: LongWord;  	{ number of colors }
    colorTable: PXpmColor;	{ list of related colors }
    data: PLongWord;		{ image data }
  end;
  {$EXTERNALSYM XpmImage}

  PXpmInfo = ^XpmInfo;
  XpmInfo = record
    valuemask: LongWord;	{ Specifies which attributes are defined }
    hints_cmt: PChar;		{ Comment of the hints section }
    colors_cmt: PChar;		{ Comment of the colors section }
    pixels_cmt: PChar;		{ Comment of the pixels section }
    x_hotspot: LongWord;	{ Returns the x hotspot's coordinate }
    y_hotspot: LongWord;	{ Returns the y hotspot's coordinate }
    nextensions: LongWord;	{ number of extensions }
    extensions: PXpmExtension;	{ pointer to array of extensions }
  end;
  {$EXTERNALSYM XpmInfo}

  XpmAllocColorFunc = function(
    display: PDisplay;		{ display }
    colormap: Colormap;		{ colormap }
    colorname: PChar;		{ colorname }
    xcolor: PXColor;		{ xcolor }
    closure: Pointer		{ closure }
  ): Integer cdecl;
  {$EXTERNALSYM XpmAllocColorFunc}

  XpmFreeColorsFunc = function(
    display: PDisplay;		{ display }
    colormap: Colormap;		{ colormap }
    pixels: PPixel;	    	{ pixels }
    npixels: Integer;       { npixels }
    closure: Pointer		{ closure }
  ): Integer cdecl;
  {$EXTERNALSYM XpmFreeColorsFunc}

  PXpmAttributes = ^XpmAttributes;
  XpmAttributes = record
    valuemask: LongWord;		{ Specifies which attributes are
					  defined }
    visual: PVisual;			{ Specifies the visual to use }
    colormap: Colormap;			{ Specifies the colormap to use }
    depth: LongWord;			{ Specifies the depth }
    width: LongWord;			{ Returns the width of the created
					   pixmap }
    height: LongWord;   		{ Returns the height of the created
					   pixmap }
    x_hotspot: LongWord;		{ Returns the x hotspot's
					   coordinate }
    y_hotspot: LongWord;       		{ Returns the y hotspot's
					   coordinate }
    cpp: LongWord;			{ Specifies the number of char per
					   pixel }
    pixels: PPixel;			{ List of used color pixels }
    npixels: LongWord;  		{ Number of used pixels }
    colorsymbols: PXpmColorSymbol;	{ List of color symbols to override }
    numsymbols: LongWord;		{ Number of symbols }
    rgb_fname: PChar;			{ RGB text file name }
    nextensions: LongWord;		{ Number of extensions }
    extensions: PXpmExtension;		{ List of extensions }

    ncolors: LongWord;                  { Number of colors }
    colorTable: PXpmColor;              { List of colors }
{ 3.2 backward compatibility code }
    hints_cmt: PChar;                   { Comment of the hints section }
    colors_cmt: PChar;                  { Comment of the colors section }
    pixels_cmt: PChar;                  { Comment of the pixels section }
{ end 3.2 bc }
    mask_pixel: LongWord;               { Color table index of transparent
                                          color }

    { Color Allocation Directives }
    exactColors: LongBool;		{ Only use exact colors for visual }
    closeness: LongWord;		{ Allowable RGB deviation }
    red_closeness: LongWord;		{ Allowable red deviation }
    green_closeness: LongWord;  	{ Allowable green deviation }
    blue_closeness: LongWord;   	{ Allowable blue deviation }
    color_key: LongWord;		{ Use colors from this color set }

    alloc_pixels: PPixel;		{ Returns the list of alloc'ed color
		        		   pixels }
    nalloc_pixels: Integer;		{ Returns the number of alloc'ed
					   color pixels }

    alloc_close_colors: LongBool;    	{ Specify whether close colors should
					   be allocated using XAllocColor
					   or not }
    bitmap_format: Integer;		{ Specify the format of 1bit depth
					   images: ZPixmap or XYBitmap }

    { Color functions }
    alloc_color: XpmAllocColorFunc;	{ Application color allocator }
    free_colors: XpmFreeColorsFunc;	{ Application color de-allocator }
    color_closure: Pointer;		{ Application private data to pass to
					   alloc_color and free_colors }
  end;
  {$EXTERNALSYM XpmAttributes}

{ FOR_MSW, all ..Pixmap.. are excluded, only the ..XImage.. are used }
{ Same for Amiga! }

function XpmCreatePixmapFromData(display: PDisplay;
				 d: Drawable;
				 data: PPChar;
				 out pixmap_return: Pixmap;
				 out shapemask_return: Pixmap;
				 attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreatePixmapFromData}

function XpmCreateDataFromPixmap(display: PDisplay;
				 out data_return: PPChar;
			         pixmap,
				 shapemask: Pixmap;
				 attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateDataFromPixmap}

function XpmReadFileToPixmap(display: PDisplay;
			     d: Drawable;
			     filename: PChar;
			     out pixmap_return: Pixmap;
			     out shapemask_return: Pixmap;
			     attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmReadFileToPixmap}

function XpmWriteFileFromPixmap(display: PDisplay;
				filename: PChar;
				pixmap,
				shapemask: Pixmap;
				attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmWriteFileFromPixmap}

function XpmCreateImageFromData(display: PDisplay;
				data: PPChar;
				out image_return: PXImage;
				out shapemask_return: PXImage;
                                attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateImageFromData}

function XpmCreateDataFromImage(display: PDisplay;
				out data_return: PPChar;
				image,
				shapeimage: PXImage;
				attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateDataFromImage}

function XpmReadFileToImage(display: PDisplay;
			    filename: PChar;
			    out image_return: PXImage;
			    out shapeimage_return: PXImage;
			    attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmReadFileToImage}

function XpmWriteFileFromImage(display: PDisplay;
			       filename: PChar;
			       image,
			       shapeimage: PXImage;
			       attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmWriteFileFromImage}

function XpmCreateImageFromBuffer(display: PDisplay;
				  buffer: PChar;
				  out image_return: PXImage;
				  out shapemask_return: PXImage;
				  attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateImageFromBuffer}

function XpmCreatePixmapFromBuffer(display: PDisplay;
				   d: Drawable;
				   buffer: PChar;
				   out pixmap_return: Pixmap;
				   out shapemask_return: Pixmap;
				   attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreatePixmapFromBuffer}

function XpmCreateBufferFromImage(display: PDisplay;
				  out buffer_return: PChar;
				  image,
				  shapeimage: PXImage;
				  attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateBufferFromImage}

function XpmCreateBufferFromPixmap(display: PDisplay;
				   out buffer_return: PChar;
				   pixmap,
				   shapemask: Pixmap;
				   attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateBufferFromPixmap}

function XpmReadFileToBuffer(filename: PChar; out buffer_return: PChar): Integer; cdecl;
{$EXTERNALSYM XpmReadFileToBuffer}
function XpmWriteFileFromBuffer(filename: PChar; buffer: PChar): Integer; cdecl;
{$EXTERNALSYM XpmWriteFileFromBuffer}

function XpmReadFileToData(filename: PChar; out data_return: PPChar): Integer; cdecl;
{$EXTERNALSYM XpmReadFileToData}
function XpmWriteFileFromData(filename: PChar; data: PPChar): Integer; cdecl;
{$EXTERNALSYM XpmWriteFileFromData}

function XpmAttributesSize: Integer; cdecl;
{$EXTERNALSYM XpmAttributesSize}
procedure XpmFreeAttributes(attributes: PXpmAttributes); cdecl;
{$EXTERNALSYM XpmFreeAttributes}
procedure XpmFreeExtensions(extensions: PXpmExtension; nextensions: Integer); cdecl;
{$EXTERNALSYM XpmFreeExtensions}

procedure XpmFreeXpmImage(image: PXpmImage); cdecl;
{$EXTERNALSYM XpmFreeXpmImage}
procedure XpmFreeXpmInfo(info: PXpmInfo); cdecl;
{$EXTERNALSYM XpmFreeXpmInfo}
function XpmGetErrorString(errcode: Integer): PChar; cdecl;
{$EXTERNALSYM XpmGetErrorString}
function XpmLibraryVersion: Integer; cdecl;
{$EXTERNALSYM XpmLibraryVersion}

{ XpmImage functions }
function XpmReadFileToXpmImage(filename: PChar;
			       image: PXpmImage;
			       info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmReadFileToXpmImage}

function XpmWriteFileFromXpmImage(filename: PChar;
				  image: PXpmImage;
				  info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmWriteFileFromXpmImage}

function XpmCreatePixmapFromXpmImage(display: PDisplay;
				     d: Drawable;
				     image: PXpmImage;
				     out pixmap_return: Pixmap;
				     out shapemask_return: Pixmap;
				     attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreatePixmapFromXpmImage}

function XpmCreateImageFromXpmImage(display: PDisplay;
				    image: PXpmImage;
				    out image_return: PXImage;
				    out shapeimage_return: PXImage;
				    attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateImageFromXpmImage}

function XpmCreateXpmImageFromImage(display: PDisplay;
				    image: PXImage;
				    shapeimage: PXImage;
				    xpmimage: PXpmImage;
				    attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateXpmImageFromImage}

function XpmCreateXpmImageFromPixmap(display: PDisplay;
				     pixmap,
				     shapemask: Pixmap;
				     xpmimage: PXpmImage;
				     attributes: PXpmAttributes): Integer; cdecl;
{$EXTERNALSYM XpmCreateXpmImageFromPixmap}

function XpmCreateDataFromXpmImage(out data_return: PPChar;
				   image: PXpmImage;
				   info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmCreateDataFromXpmImage}

function XpmCreateXpmImageFromData(data: PPChar;
				   image: PXpmImage;
				   info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmCreateXpmImageFromData}

function XpmCreateXpmImageFromBuffer(buffer: PChar;
				     image: PXpmImage;
				     info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmCreateXpmImageFromBuffer}

function XpmCreateBufferFromXpmImage(out buffer_return: PChar;
				     image: PXpmImage;
				     info: PXpmInfo): Integer; cdecl;
{$EXTERNALSYM XpmCreateBufferFromXpmImage}

function XpmGetParseError(filename: PChar;
			  out linenum_return: Integer;
			  out charnum_return: Integer): Integer; cdecl;
{$EXTERNALSYM XpmGetParseError}

procedure XpmFree(ptr: Pointer); cdecl;
{$EXTERNALSYM XpmFree}

implementation

const
  libXpm = 'libXpm.so.4';

function XpmCreatePixmapFromData; external libXpm name 'XpmCreatePixmapFromData';
function XpmCreateDataFromPixmap; external libXpm name 'XpmCreateDataFromPixmap';
function XpmReadFileToPixmap; external libXpm name 'XpmReadFileToPixmap';
function XpmWriteFileFromPixmap; external libXpm name 'XpmWriteFileFromPixmap';
function XpmCreateImageFromData; external libXpm name 'XpmCreateImageFromData';
function XpmCreateDataFromImage; external libXpm name 'XpmCreateDataFromImage';
function XpmReadFileToImage; external libXpm name 'XpmReadFileToImage';
function XpmWriteFileFromImage; external libXpm name 'XpmWriteFileFromImage';
function XpmCreateImageFromBuffer; external libXpm name 'XpmCreateImageFromBuffer';
function XpmCreatePixmapFromBuffer; external libXpm name 'XpmCreatePixmapFromBuffer';
function XpmCreateBufferFromImage; external libXpm name 'XpmCreateBufferFromImage';
function XpmCreateBufferFromPixmap; external libXpm name 'XpmCreateBufferFromPixmap';
function XpmReadFileToBuffer; external libXpm name 'XpmReadFileToBuffer';
function XpmWriteFileFromBuffer; external libXpm name 'XpmWriteFileFromBuffer';
function XpmReadFileToData; external libXpm name 'XpmReadFileToData';
function XpmWriteFileFromData; external libXpm name 'XpmWriteFileFromData';
function XpmAttributesSize; external libXpm name 'XpmAttributesSize';
procedure XpmFreeAttributes; external libXpm name 'XpmFreeAttributes';
procedure XpmFreeExtensions; external libXpm name 'XpmFreeExtensions';
procedure XpmFreeXpmImage; external libXpm name 'XpmFreeXpmImage';
procedure XpmFreeXpmInfo; external libXpm name 'XpmFreeXpmInfo';
function XpmGetErrorString; external libXpm name 'XpmGetErrorString';
function XpmLibraryVersion; external libXpm name 'XpmLibraryVersion';
function XpmReadFileToXpmImage; external libXpm name 'XpmReadFileToXpmImage';
function XpmWriteFileFromXpmImage; external libXpm name 'XpmWriteFileFromXpmImage';
function XpmCreatePixmapFromXpmImage; external libXpm name 'XpmCreatePixmapFromXpmImage';
function XpmCreateImageFromXpmImage; external libXpm name 'XpmCreateImageFromXpmImage';
function XpmCreateXpmImageFromImage; external libXpm name 'XpmCreateXpmImageFromImage';
function XpmCreateXpmImageFromPixmap; external libXpm name 'XpmCreateXpmImageFromPixmap';
function XpmCreateDataFromXpmImage; external libXpm name 'XpmCreateDataFromXpmImage';
function XpmCreateXpmImageFromData; external libXpm name 'XpmCreateXpmImageFromData';
function XpmCreateXpmImageFromBuffer; external libXpm name 'XpmCreateXpmImageFromBuffer';
function XpmCreateBufferFromXpmImage; external libXpm name 'XpmCreateBufferFromXpmImage';
function XpmGetParseError; external libXpm name 'XpmGetParseError';
procedure XpmFree; external libXpm name 'XpmFree';

end.
