{ *********************************************************************** }
{                                                                         }
{  Borland Kylix Runtime Library                                          }
{  Linux API Interface Unit (RPC Services)                                }
{                                                                         }
{  This translation is based on glibc 2.2.1,                              }
{  compiled from sources on a Linux 2.2.16 kernel.                        }
{                                                                         }
{  Copyright (C) 2001-2002 Borland Software Corporation                   }
{                                                                         }
{  Translator: Borland Software Corporation                               }
{                                                                         }
{  This file may be distributed and/or modified under the terms of the    }
{  GNU General Public License version 2 as published by the Free Software }
{  Foundation and appearing at http://www.borland.com/kylix/gpl.html.     }
{                                                                         }
{  Licensees holding a valid Borland No-Nonsense License for this         }
{  Software may use this file in accordance with such license, which      }
{  appears in the file license.txt that came with this software.          }
{                                                                         }
{ *********************************************************************** }

unit LibcRpcSvc;

{$WEAKPACKAGEUNIT}

{$ALIGN 4}
{$MINENUMSIZE 4}
{$ASSERTIONS OFF}

interface

{ By default define the new YP prototypes. A switch
  to the old YP prototypes can be made by disabling
  the NEW_YP_PROTOTYPES conditional define. }

{$DEFINE NEW_YP_PROTOTYPES}

uses
  LibcRpc,
  Libc;

type
  Pbool_t = ^bool_t;
  Puint32_t = ^uint32_t;

// Translated from rpcsvc/bootparam_prot.h

const
  MAX_MACHINE_NAME = 255;
  {$EXTERNALSYM MAX_MACHINE_NAME}
  MAX_PATH_LEN = 1024;
  {$EXTERNALSYM MAX_PATH_LEN}
  MAX_FILEID = 32;
  {$EXTERNALSYM MAX_FILEID}
  IP_ADDR_TYPE = 1;
  {$EXTERNALSYM IP_ADDR_TYPE}

type
  bp_machine_name_t = PChar;
  {$EXTERNALSYM bp_machine_name_t}

  bp_path_t = PChar;
  {$EXTERNALSYM bp_path_t}

  bp_fileid_t = PChar;
  {$EXTERNALSYM bp_fileid_t}

  ip_addr_t = {packed} record
    net: Byte;
    host: Byte;
    lh: Byte;
    impno: Byte;
  end;
  {$EXTERNALSYM ip_addr_t}

  bp_address = {packed} record
    address_type: Integer;
    bp_address_u: {packed} record
                    case Integer of
                      0: (ip_addr: ip_addr_t);
                    end;
  end;
  {$EXTERNALSYM bp_address}

  bp_whoami_arg = {packed} record
    client_address: bp_address;
  end;
  {$EXTERNALSYM bp_whoami_arg}
  TBpWhoamiArg = bp_whoami_arg;
  {$HPPEMIT 'struct bp_whoami_arg;'}
  PBpWhoamiArg = ^TBpWhoamiArg;

  bp_whoami_res = {packed} record
    client_name: bp_machine_name_t;
    domain_name: bp_machine_name_t;
    router_address: bp_address;
  end;
  {$EXTERNALSYM bp_whoami_res}
  TBpWhoamiRes = bp_whoami_res;
  {$HPPEMIT 'struct bp_whoami_res;'}
  PBpWhoamiRes = ^TBpWhoamiRes;

  bp_getfile_arg = {packed} record
    client_name: bp_machine_name_t;
    file_id: bp_fileid_t;
  end;
  {$EXTERNALSYM bp_getfile_arg}
  TBpGetfileArg = bp_getfile_arg;
  {$HPPEMIT 'struct bp_getfile_arg;'}
  PBpGetfileArg = ^TBpGetfileArg;

  bp_getfile_res = {packed} record
    server_name: bp_machine_name_t;
    server_address: bp_address;
    server_path: bp_path_t;
  end;
  {$EXTERNALSYM bp_getfile_res}
  TBpGetfileRes = bp_getfile_res;
  {$HPPEMIT 'struct bp_getfile_res;'}
  PBpGetfileRes = ^TBpGetfileRes;

const
  BOOTPARAMPROG = 100026;
  {$EXTERNALSYM BOOTPARAMPROG}
  BOOTPARAMVERS = 1;
  {$EXTERNALSYM BOOTPARAMVERS}

const
  BOOTPARAMPROC_WHOAMI = 1;
  {$EXTERNALSYM BOOTPARAMPROC_WHOAMI}

function bootparamproc_whoami_1(p1: PBpWhoamiArg; AClient: PClientRecord): PBpWhoamiRes; cdecl;
{$EXTERNALSYM bootparamproc_whoami_1}
function bootparamproc_whoami_1_svc(p1: PBpWhoamiArg; ServiceReq: PSvcReq): PBpWhoamiRes; cdecl;
{$EXTERNALSYM bootparamproc_whoami_1_svc}

const
  BOOTPARAMPROC_GETFILE = 2;
  {$EXTERNALSYM BOOTPARAMPROC_GETFILE}

function bootparamproc_getfile_1(p1: PBpGetfileArg; AClient: PClientRecord): PBpGetfileRes; cdecl;
{$EXTERNALSYM bootparamproc_getfile_1}
function bootparamproc_getfile_1_svc(p1: PBpGetfileArg; ServiceReq: PSvcReq): PBpGetfileRes; cdecl;
{$EXTERNALSYM bootparamproc_getfile_1_svc}
function bootparamprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM bootparamprog_1_freeresult}


{$HPPEMIT '#include <rpcsvc/key_prot.h>'}

// Translated from rpcsvc/key_prot.h

const
  PROOT = 3;
  {$EXTERNALSYM PROOT}
  HEXMODULUS = 'd4a0ba0250b6fd2ec626e7efd637df76c716e22d0944b88b';
  {$EXTERNALSYM HEXMODULUS}
  HEXKEYBYTES = 48;
  {$EXTERNALSYM HEXKEYBYTES}
  KEYSIZE = 192;
  {$EXTERNALSYM KEYSIZE}
  KEYBYTES = 24;
  {$EXTERNALSYM KEYBYTES}
  KEYCHECKSUMSIZE = 16;
  {$EXTERNALSYM KEYCHECKSUMSIZE}

type
  keystatus =
  (
    KEY_SUCCESS = 0,
    {$EXTERNALSYM KEY_SUCCESS}
    KEY_NOSECRET = 1,
    {$EXTERNALSYM KEY_NOSECRET}
    KEY_UNKNOWN = 2,
    {$EXTERNALSYM KEY_UNKNOWN}
    KEY_SYSTEMERR = 3
    {$EXTERNALSYM KEY_SYSTEMERR}
  );
  {$EXTERNALSYM keystatus}
  PKeystatus = ^keystatus;

type
  keybuf = packed array[0..HEXKEYBYTES-1] of Char;
  {$EXTERNALSYM keybuf}

type
  netnamestr = PChar;
  {$EXTERNALSYM netnamestr}

type
  cryptkeyarg = {packed} record
    remotename: netnamestr;
    deskey: des_block;
  end;
  {$EXTERNALSYM cryptkeyarg}
  TCryptKeyArg = cryptkeyarg;
  PCryptKeyArg = ^TCryptKeyArg;

  cryptkeyarg2 = {packed} record
    remotename: netnamestr;
    remotekey: netobj;
    deskey: des_block;
  end;
  {$EXTERNALSYM cryptkeyarg2}
  TCryptKeyArg2 = cryptkeyarg2;
  PCryptKeyArg2 = ^TCryptKeyArg2;

  cryptkeyres = {packed} record
    status: keystatus;
    cryptkeyres_u: {packed} record
                     case Integer of
                       0: (deskey: des_block);
                     end;
  end;
  {$EXTERNALSYM cryptkeyres}
  TCryptKeyRes = cryptkeyres;
  PCryptKeyRes = ^TCryptKeyRes;

const
  MAXGIDS = 16;
  {$EXTERNALSYM MAXGIDS}

type
  unixcred = {packed} record
    uid: u_int;
    gid: u_int;
    gids: {packed} record
            gids_len: u_int ;
            gids_val: Pu_int;
          end;
  end;
  {$EXTERNALSYM unixcred}

  getcredres = {packed} record
    status: keystatus;
    getcredres_u: {packed} record
                    case Integer of
                      0: (cred: unixcred);
                    end;
  end;
  {$EXTERNALSYM getcredres}
  TGetCredRes = getcredres;
  PGetCredRes = ^TGetCredRes;

  key_netstarg = {packed} record
    st_priv_key: keybuf;
    st_pub_key: keybuf;
    st_netname: netnamestr;
  end;
  {$EXTERNALSYM key_netstarg}
  TKeyNetStArg = key_netstarg;
  PKeyNetStArg = ^TKeyNetStArg;

  key_netstres = {packed} record
    status: keystatus;
    key_netstres_u: {packed} record
                      case Integer of
                        0: (knet: key_netstarg);
                      end;
  end;
  {$EXTERNALSYM key_netstres}
  TKeyNetStRes = key_netstres;
  PKeyNetStRes = ^TKeyNetStRes;

type
  opaque = Char;
  {$EXTERNALSYM opaque}
  POpaque = ^opaque;
  {$EXTERNALSYM POpaque}


const
  KEY_PROG = 100029;
  {$EXTERNALSYM KEY_PROG}
  KEY_VERS = 1;
  {$EXTERNALSYM KEY_VERS}

const
  KEY_SET = 1;
  {$EXTERNALSYM KEY_SET}

function key_set_1(p1: PChar; AClient: PClientRecord): PKeystatus; cdecl;
{$EXTERNALSYM key_set_1}
function key_set_1_svc(p1: PChar; ServiceReq: PSvcReq): PKeystatus; cdecl;
{$EXTERNALSYM key_set_1_svc}

const
  KEY_ENCRYPT = 2;
  {$EXTERNALSYM KEY_ENCRYPT}

function key_encrypt_1(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_1}
function key_encrypt_1_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_1_svc}

const
  KEY_DECRYPT = 3;
  {$EXTERNALSYM KEY_DECRYPT}

function key_decrypt_1(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_1}
function key_decrypt_1_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_1_svc}

const
  KEY_GEN = 4;
  {$EXTERNALSYM KEY_GEN}

function key_gen_1(P: Pointer; AClient: PClientRecord): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_1}
function key_gen_1_svc(P: Pointer; ServiceReq: PSvcReq): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_1_svc}

const
  KEY_GETCRED = 5;
  {$EXTERNALSYM KEY_GETCRED}

function key_getcred_1(var __netnamestr: netnamestr; AClient: PClientRecord): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_1}
function key_getcred_1_svc(var __netnamestr: netnamestr; ServiceReq: PSvcReq): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_1_svc}
function key_prog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM key_prog_1_freeresult}

const
  KEY_VERS2 = 2;
  {$EXTERNALSYM KEY_VERS2}

function key_set_2(p1: PChar; AClient: PClientRecord): PKeystatus; cdecl;
{$EXTERNALSYM key_set_2}
function key_set_2_svc(p1: PChar; ServiceReq: PSvcReq): PKeystatus; cdecl;
{$EXTERNALSYM key_set_2_svc}
function key_encrypt_2(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_2}
function key_encrypt_2_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_2_svc}
function key_decrypt_2(__cryptkeyarg: PCryptKeyArg; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_2}
function key_decrypt_2_svc(__cryptkeyarg: PCryptKeyArg; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_2_svc}
function key_gen_2(P: Pointer; AClient: PClientRecord): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_2}
function key_gen_2_svc(P: Pointer; ServiceReq: PSvcReq): PDesBlock; cdecl;
{$EXTERNALSYM key_gen_2_svc}
function key_getcred_2(var __netnamestr: netnamestr; AClient: PClientRecord): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_2}
function key_getcred_2_svc(var __netnamestr: netnamestr; ServiceReq: PSvcReq): PGetCredRes; cdecl;
{$EXTERNALSYM key_getcred_2_svc}

const
  KEY_ENCRYPT_PK = 6;
  {$EXTERNALSYM KEY_ENCRYPT_PK}

function key_encrypt_pk_2(p1: PCryptKeyArg2; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_pk_2}
function key_encrypt_pk_2_svc(p1: PCryptKeyArg2; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_encrypt_pk_2_svc}

const
  KEY_DECRYPT_PK = 7;
  {$EXTERNALSYM KEY_DECRYPT_PK}

function key_decrypt_pk_2(p1: PCryptKeyArg2; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_pk_2}
function key_decrypt_pk_2_svc(p1: PCryptKeyArg2; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_decrypt_pk_2_svc}

const
  KEY_NET_PUT = 8;
  {$EXTERNALSYM KEY_NET_PUT}

function key_net_put_2(__key_netstarg: PKeyNetStArg; AClient: PClientRecord): PKeystatus; cdecl;
{$EXTERNALSYM key_net_put_2}
function key_net_put_2_svc(__key_netstarg: PKeyNetStArg; ServiceReq: PSvcReq): PKeystatus; cdecl;
{$EXTERNALSYM key_net_put_2_svc}

const
  KEY_NET_GET = 9;
  {$EXTERNALSYM KEY_NET_GET}

function key_net_get_2(P: Pointer; AClient: PClientRecord): PKeyNetStRes; cdecl;
{$EXTERNALSYM key_net_get_2}
function key_net_get_2_svc(P: Pointer; ServiceReq: PSvcReq): PKeyNetStRes; cdecl;
{$EXTERNALSYM key_net_get_2_svc}

const
  KEY_GET_CONV = 10;
  {$EXTERNALSYM KEY_GET_CONV}

function key_get_conv_2(p1: PChar; AClient: PClientRecord): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_get_conv_2}
function key_get_conv_2_svc(p1: PChar; ServiceReq: PSvcReq): PCryptKeyRes; cdecl;
{$EXTERNALSYM key_get_conv_2_svc}
function key_prog_2_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM key_prog_2_freeresult}


{ the xdr functions }

function xdr_keystatus(__xdr: PXdr; var __keystatus: keystatus): bool_t; cdecl;
{$EXTERNALSYM xdr_keystatus}
function xdr_keybuf(__xdr: PXdr; __keybuf: keybuf): bool_t; cdecl;
{$EXTERNALSYM xdr_keybuf}
function xdr_netnamestr(__xdr: PXdr; var __netnamestr: netnamestr): bool_t; cdecl;
{$EXTERNALSYM xdr_netnamestr}
function xdr_cryptkeyarg(__xdr: PXdr; var __cryptkeyarg: cryptkeyarg): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyarg}
function xdr_cryptkeyarg2(__xdr: PXdr; var __cryptkeyarg2: cryptkeyarg2): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyarg2}
function xdr_cryptkeyres(__xdr: PXdr; var __cryptkeyres: cryptkeyres): bool_t; cdecl;
{$EXTERNALSYM xdr_cryptkeyres}
function xdr_unixcred(__xdr: PXdr; var __unixcred: unixcred): bool_t; cdecl;
{$EXTERNALSYM xdr_unixcred}
function xdr_getcredres(__xdr: PXdr; var __getcredres: getcredres): bool_t; cdecl;
{$EXTERNALSYM xdr_getcredres}
function xdr_key_netstarg(__xdr: PXdr; var __key_netstarg: key_netstarg): bool_t; cdecl;
{$EXTERNALSYM xdr_key_netstarg}
function xdr_key_netstres(__xdr: PXdr; var __key_netstres: key_netstres): bool_t; cdecl;
{$EXTERNALSYM xdr_key_netstres}


{$HPPEMIT '#include <rpcsvc/klm_prot.h>'}

// Translated from rpcsvc/klm_prot.h

type
  klm_stats =
  (
    klm_granted = 0,
    {$EXTERNALSYM klm_granted}
    klm_denied = 1,
    {$EXTERNALSYM klm_denied}
    klm_denied_nolocks = 2,
    {$EXTERNALSYM klm_denied_nolocks}
    klm_working = 3
    {$EXTERNALSYM klm_working}
  );
  {$EXTERNALSYM klm_stats}

type
  klm_lock = {packed} record
    server_name: PChar;
    fh: netobj;
    pid: Integer;
    l_offset: u_int;
    l_len: u_int;
  end;
  {$EXTERNALSYM klm_lock}

  klm_holder = {packed} record
    exclusive: bool_t;
    svid: Integer;
    l_offset: u_int;
    l_len: u_int;
  end;
  {$EXTERNALSYM klm_holder}

  klm_stat = {packed} record
    stat: klm_stats;
  end;
  {$EXTERNALSYM klm_stat}
  TKlmStat = klm_stat;
  PKlmStat = ^TKlmStat;

  klm_testrply = {packed} record
    stat: klm_stats;
    klm_testrply_u: {packed} record
                      case Integer of
                        0: (holder: klm_holder);
                      end;
  end;
  {$EXTERNALSYM klm_testrply}
  TKlmTestRply = klm_testrply;
  PKlmTestRply = ^TKlmTestRply;

  klm_lockargs = {packed} record
    block: bool_t;
    exclusive: bool_t;
    alock: klm_lock;
  end;
  {$EXTERNALSYM klm_lockargs}
  TKlmLockArgs = klm_lockargs;
  PKlmLockArgs = ^TKlmLockArgs;

  klm_testargs = {packed} record
    exclusive: bool_t;
    alock: klm_lock;
  end;
  {$EXTERNALSYM klm_testargs}
  TKlmTestArgs = klm_testargs;
  PKlmTestArgs = ^TKlmTestArgs;

  klm_unlockargs = {packed} record
    alock: klm_lock;
  end;
  {$EXTERNALSYM klm_unlockargs}
  TKlmUnlockArgs = klm_unlockargs;
  PKlmUnlockArgs = ^TKlmUnlockArgs;

const
  KLM_PROG = 100020;
  {$EXTERNALSYM KLM_PROG}
  KLM_VERS = 1;
  {$EXTERNALSYM KLM_VERS}

const
  KLM_TEST = 1;
  {$EXTERNALSYM KLM_TEST}

function klm_test_1(p1: PKlmTestArgs; AClient: PClientRecord): PKlmTestRply; cdecl;
{$EXTERNALSYM klm_test_1}
function klm_test_1_svc(p1: PKlmTestArgs; ServiceReq: PSvcReq): PKlmTestRply; cdecl;
{$EXTERNALSYM klm_test_1_svc}

const
  _KLM_LOCK = 2;
  {.$EXTERNALSYM KLM_LOCK} // Renamed to avoid identifier conflict

function klm_lock_1(p1: PKlmLockArgs; AClient: PClientRecord): PKlmStat; cdecl;
{$EXTERNALSYM klm_lock_1}
function klm_lock_1_svc(p1: PKlmLockArgs; ServiceReq: PSvcReq): PKlmStat; cdecl;
{$EXTERNALSYM klm_lock_1_svc}

const
  KLM_CANCEL = 3;
  {$EXTERNALSYM KLM_CANCEL}

function klm_cancel_1(p1: PKlmLockArgs; AClient: PClientRecord): PKlmStat; cdecl;
{$EXTERNALSYM klm_cancel_1}
function klm_cancel_1_svc(p1: PKlmLockArgs; ServiceReq: PSvcReq): PKlmStat; cdecl;
{$EXTERNALSYM klm_cancel_1_svc}

const
  KLM_UNLOCK = 4;
  {$EXTERNALSYM KLM_UNLOCK}

function klm_unlock_1(p1: PKlmUnlockArgs; AClient: PClientRecord): PKlmStat; cdecl;
{$EXTERNALSYM klm_unlock_1}
function klm_unlock_1_svc(p1: PKlmUnlockArgs; ServiceReq: PSvcReq): PKlmStat; cdecl;
{$EXTERNALSYM klm_unlock_1_svc}
function klm_prog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM klm_prog_1_freeresult}

{ the xdr functions }

function xdr_klm_stats(__xdr: PXdr; var __klm_stats: klm_stats): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_stats}
function xdr_klm_lock(__xdr: PXdr; var __klm_lock: klm_lock): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_lock}
function xdr_klm_holder(__xdr: PXdr; var __klm_holder: klm_holder): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_holder}
function xdr_klm_stat(__xdr: PXdr; var __klm_stat: klm_stat): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_stat}
function xdr_klm_testrply(__xdr: PXdr; var __klm_testrply: klm_testrply): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_testrply}
function xdr_klm_lockargs(__xdr: PXdr; var __klm_lockargs: klm_lockargs): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_lockargs}
function xdr_klm_testargs(__xdr: PXdr; var __klm_testargs: klm_testargs): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_testargs}
function xdr_klm_unlockargs(__xdr: PXdr; var __klm_unlockargs: klm_unlockargs): bool_t; cdecl;
{$EXTERNALSYM xdr_klm_unlockargs}


{$HPPEMIT '#include <rpcsvc/mount.h>'}

// Translated from rpcsvc/mount.h

const
  MNTPATHLEN = 1024;
  {$EXTERNALSYM MNTPATHLEN}
  MNTNAMLEN = 255;
  {$EXTERNALSYM MNTNAMLEN}
  FHSIZE = 32;
  {$EXTERNALSYM FHSIZE}

type
  fhandle = packed array[0..FHSIZE-1] of Char;
  {$EXTERNALSYM fhandle}

type
  fhstatus = {packed} record
    fhs_status: u_int;
    fhstatus_u: {packed} record
                  case Integer of
                    0: (fhs_fhandle: fhandle);
                  end;
  end;
  {$EXTERNALSYM fhstatus}
  TFhStatus = fhstatus;
  PFhStatus = ^TFhStatus;

type
  dirpath = PChar;
  {$EXTERNALSYM dirpath}
  PDirPath = ^dirpath;

  name = PChar;
  {$EXTERNALSYM name}

type
  mountlist = ^mountbody;
  {$EXTERNALSYM mountlist}
  PMountList = ^mountlist;

  mountbody = {packed} record
    ml_hostname: name;
    ml_directory: dirpath;
    ml_next: mountlist;
  end;
  {$EXTERNALSYM mountbody}

type
  groups = ^groupnode;
  {$EXTERNALSYM groups}

  groupnode = {packed} record
    gr_name: name;
    gr_next: groups;
  end;
  {$EXTERNALSYM groupnode}

type
  _exports = ^exportnode;
  {.$EXTERNALSYM exports} // Renamed because exports is a keyword
  TExports = _exports;
  PExports = ^TExports;

  exportnode = {packed} record
    ex_dir: dirpath;
    ex_groups: groups;
    ex_next: TExports;
  end;
  {$EXTERNALSYM exportnode}


const
  MOUNTPROG = 100005;
  {$EXTERNALSYM MOUNTPROG}
  MOUNTVERS = 1;
  {$EXTERNALSYM MOUNTVERS}

const
  MOUNTPROC_NULL = 0;
  {$EXTERNALSYM MOUNTPROC_NULL}

function mountproc_null_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM mountproc_null_1}
function mountproc_null_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM mountproc_null_1_svc}

const
  MOUNTPROC_MNT = 1;
  {$EXTERNALSYM MOUNTPROC_MNT}

function mountproc_mnt_1(p1: PDirPath; AClient: PClientRecord): PFhStatus; cdecl;
{$EXTERNALSYM mountproc_mnt_1}
function mountproc_mnt_1_svc(p1: PDirPath; ServiceReq: PSvcReq): PFhStatus; cdecl;
{$EXTERNALSYM mountproc_mnt_1_svc}

const
  MOUNTPROC_DUMP = 2;
  {$EXTERNALSYM MOUNTPROC_DUMP}

function mountproc_dump_1(p1: Pointer; AClient: PClientRecord): PMountList; cdecl;
{$EXTERNALSYM mountproc_dump_1}
function mountproc_dump_1_svc(p1: Pointer; ServiceReq: PSvcReq): PMountList; cdecl;
{$EXTERNALSYM mountproc_dump_1_svc}

const
  MOUNTPROC_UMNT = 3;
  {$EXTERNALSYM MOUNTPROC_UMNT}

function mountproc_umnt_1(p1: PDirPath; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM mountproc_umnt_1}
function mountproc_umnt_1_svc(p1: PDirPath; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM mountproc_umnt_1_svc}

const
  MOUNTPROC_UMNTALL = 4;
  {$EXTERNALSYM MOUNTPROC_UMNTALL}

function mountproc_umntall_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM mountproc_umntall_1}
function mountproc_umntall_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM mountproc_umntall_1_svc}

const
  MOUNTPROC_EXPORT = 5;
  {$EXTERNALSYM MOUNTPROC_EXPORT}

function mountproc_export_1(p1: Pointer; AClient: PClientRecord): PExports; cdecl;
{$EXTERNALSYM mountproc_export_1}
function mountproc_export_1_svc(p1: Pointer; ServiceReq: PSvcReq): PExports; cdecl;
{$EXTERNALSYM mountproc_export_1_svc}

const
  MOUNTPROC_EXPORTALL = 6;
  {$EXTERNALSYM MOUNTPROC_EXPORTALL}

function mountproc_exportall_1(p1: Pointer; AClient: PClientRecord): PExports; cdecl;
{$EXTERNALSYM mountproc_exportall_1}
function mountproc_exportall_1_svc(p1: Pointer; ServiceReq: PSvcReq): PExports; cdecl;
{$EXTERNALSYM mountproc_exportall_1_svc}

function mountprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM mountprog_1_freeresult}

{ the xdr functions }

function xdr_fhandle(__xdr: PXdr; var __fhandle: fhandle): bool_t; cdecl;
{$EXTERNALSYM xdr_fhandle}
function xdr_fhstatus(__xdr: PXdr; var __fhstatus: fhstatus): bool_t; cdecl;
{$EXTERNALSYM xdr_fhstatus}
function xdr_dirpath(__xdr: PXdr; var __dirpath: dirpath): bool_t; cdecl;
{$EXTERNALSYM xdr_dirpath}
function xdr_name(__xdr: PXdr; var __name: name): bool_t; cdecl;
{$EXTERNALSYM xdr_name}
function xdr_mountlist(__xdr: PXdr; var __mountlist: mountlist): bool_t; cdecl;
{$EXTERNALSYM xdr_mountlist}
function xdr_mountbody(__xdr: PXdr; var __mountbody: mountbody): bool_t; cdecl;
{$EXTERNALSYM xdr_mountbody}
function xdr_groups(__xdr: PXdr; var __groups: groups): bool_t; cdecl;
{$EXTERNALSYM xdr_groups}
function xdr_groupnode(__xdr: PXdr; var __groupnode: groupnode): bool_t; cdecl;
{$EXTERNALSYM xdr_groupnode}
function xdr_exports(__xdr: PXdr; var __exports: TExports): bool_t; cdecl;
{$EXTERNALSYM xdr_exports}
function xdr_exportnode(__xdr: PXdr; var __exportnode: exportnode): bool_t; cdecl;
{$EXTERNALSYM xdr_exportnode}


{$HPPEMIT '#include <rpcsvc/nfs_prot.h>'}

// Translated from rpcsvc/nfs_prot.h

const
  NFS_PORT = 2049;
  {$EXTERNALSYM NFS_PORT}
  NFS_MAXDATA = 8192;
  {$EXTERNALSYM NFS_MAXDATA}
  NFS_MAXPATHLEN = 1024;
  {$EXTERNALSYM NFS_MAXPATHLEN}
  NFS_MAXNAMLEN = 255;
  {$EXTERNALSYM NFS_MAXNAMLEN}
  NFS_FHSIZE = 32;
  {$EXTERNALSYM NFS_FHSIZE}
  NFS_COOKIESIZE = 4;
  {$EXTERNALSYM NFS_COOKIESIZE}
  NFS_FIFO_DEV = -1;
  {$EXTERNALSYM NFS_FIFO_DEV}
  NFSMODE_FMT = $F000;
  {$EXTERNALSYM NFSMODE_FMT}
  NFSMODE_DIR =$4000;
  {$EXTERNALSYM NFSMODE_DIR}
  NFSMODE_CHR = $2000;
  {$EXTERNALSYM NFSMODE_CHR}
  NFSMODE_BLK = $6000;
  {$EXTERNALSYM NFSMODE_BLK}
  NFSMODE_REG = $8000;
  {$EXTERNALSYM NFSMODE_REG}
  NFSMODE_LNK = $A000;
  {$EXTERNALSYM NFSMODE_LNK}
  NFSMODE_SOCK = $C000;
  {$EXTERNALSYM NFSMODE_SOCK}
  NFSMODE_FIFO = $1000;
  {$EXTERNALSYM NFSMODE_FIFO}

type
  nfsstat =
  (
    NFS_OK = 0,
    {$EXTERNALSYM NFS_OK}
    NFSERR_PERM = 1,
    {$EXTERNALSYM NFSERR_PERM}
    NFSERR_NOENT = 2,
    {$EXTERNALSYM NFSERR_NOENT}
    NFSERR_IO = 5,
    {$EXTERNALSYM NFSERR_IO}
    NFSERR_NXIO = 6,
    {$EXTERNALSYM NFSERR_NXIO}
    NFSERR_ACCES = 13,
    {$EXTERNALSYM NFSERR_ACCES}
    NFSERR_EXIST = 17,
    {$EXTERNALSYM NFSERR_EXIST}
    NFSERR_NODEV = 19,
    {$EXTERNALSYM NFSERR_NODEV}
    NFSERR_NOTDIR = 20,
    {$EXTERNALSYM NFSERR_NOTDIR}
    NFSERR_ISDIR = 21,
    {$EXTERNALSYM NFSERR_ISDIR}
    NFSERR_FBIG = 27,
    {$EXTERNALSYM NFSERR_FBIG}
    NFSERR_NOSPC = 28,
    {$EXTERNALSYM NFSERR_NOSPC}
    NFSERR_ROFS = 30,
    {$EXTERNALSYM NFSERR_ROFS}
    NFSERR_NAMETOOLONG = 63,
    {$EXTERNALSYM NFSERR_NAMETOOLONG}
    NFSERR_NOTEMPTY = 66,
    {$EXTERNALSYM NFSERR_NOTEMPTY}
    NFSERR_DQUOT = 69,
    {$EXTERNALSYM NFSERR_DQUOT}
    NFSERR_STALE = 70,
    {$EXTERNALSYM NFSERR_STALE}
    NFSERR_WFLUSH = 99
    {$EXTERNALSYM NFSERR_WFLUSH}
  );
  {$EXTERNALSYM nfsstat}
  PNfsStat = ^nfsstat;
  {$EXTERNALSYM PNfsStat}

  ftype =
  (
    NFNON = 0,
    {$EXTERNALSYM NFNON}
    NFREG = 1,
    {$EXTERNALSYM NFREG}
    NFDIR = 2,
    {$EXTERNALSYM NFDIR}
    NFBLK = 3,
    {$EXTERNALSYM NFBLK}
    NFCHR = 4,
    {$EXTERNALSYM NFCHR}
    NFLNK = 5,
    {$EXTERNALSYM NFLNK}
    NFSOCK = 6,
    {$EXTERNALSYM NFSOCK}
    NFBAD = 7,
    {$EXTERNALSYM NFBAD}
    NFFIFO = 8
    {$EXTERNALSYM NFFIFO}
  );
  {$EXTERNALSYM ftype}

type
  nfs_fh = {packed} record
    data: packed array[0..NFS_FHSIZE-1] of Char;
  end;
  {$EXTERNALSYM nfs_fh}
  TNfsFh = nfs_fh;
  PNfsFh = ^TNfsFh;

  nfstime = {packed} record
    seconds: u_int;
    useconds: u_int;
  end;
  {$EXTERNALSYM nfstime}

  fattr = {packed} record
    __type: ftype;
    mode: u_int;
    nlink: u_int;
    uid: u_int;
    gid: u_int;
    size: u_int;
    blocksize: u_int;
    rdev: u_int;
    blocks: u_int;
    fsid: u_int;
    fileid: u_int;
    atime: nfstime;
    mtime: nfstime;
    ctime: nfstime;
  end;
  {$EXTERNALSYM fattr}

  sattr = {packed} record
    mode: u_int;
    uid: u_int;
    gid: u_int;
    size: u_int;
    atime: nfstime;
    mtime: nfstime;
  end;
  {$EXTERNALSYM sattr}

type
  filename = PChar;
  {$EXTERNALSYM filename}

  nfspath = PChar;
  {$EXTERNALSYM nfspath}

type
  attrstat = {packed} record
    status: nfsstat ;
    attrstat_u: {packed} record
                  case Integer of
                    0: (attributes: fattr);
                  end;
  end;
  {$EXTERNALSYM attrstat}
  TAttrStat = attrstat;
  PAttrStat = ^TAttrStat;

  sattrargs = {packed} record
    __file: nfs_fh;
    attributes: sattr;
  end;
  {$EXTERNALSYM sattrargs}
  TSAttrArgs = sattrargs;
  PSAttrArgs = ^TSAttrArgs; 

  diropargs = {packed} record
    dir: nfs_fh;
    name: filename;
  end;
  {$EXTERNALSYM diropargs}
  TDirOpArgs = diropargs;
  PDirOpArgs = ^TDirOpArgs;

  diropokres = {packed} record
    __file: nfs_fh;
    attributes: fattr;
  end;
  {$EXTERNALSYM diropokres}

  diropres = {packed} record
    status: nfsstat;
    diropres_u: {packed} record
                  case Integer of
                    0: (diropres: diropokres);
                  end;
  end;
  {$EXTERNALSYM diropres}
  TDirOpRes = diropres;
  PDirOpRes = ^TDirOpRes;

  readlinkres = {packed} record
    status: nfsstat;
    readlinkres_u: {packed} record
                     case Integer of
                       0: (data: nfspath);
                     end;
  end;
  {$EXTERNALSYM readlinkres}
  TReadLinkRes = readlinkres;
  PReadLinkRes = ^TReadLinkRes;

  readargs = {packed} record
    __file: nfs_fh;
    offset: u_int;
    count: u_int;
    totalcount: u_int;
  end;
  {$EXTERNALSYM readargs}
  TReadArgs = readargs;
  PReadArgs = ^TReadArgs;

  readokres = {packed} record
    attributes: fattr;
    data: {packed} record
      data_len: u_int;
      data_val: PChar;
    end;
  end;
  {$EXTERNALSYM readokres}

  readres = {packed} record
    status: nfsstat;
    readres_u: {packed} record
                 case Integer of
                   0: (reply: readokres);
                 end;
  end;
  {$EXTERNALSYM readres}
  TReadRes = readres;
  PReadRes = ^TReadRes;

  writeargs = {packed} record
    __file: nfs_fh;
    beginoffset: u_int;
    offset: u_int;
    totalcount: u_int;
    data: {packed} record
            data_len: u_int;
            data_val: PChar;
    end;
  end;
  {$EXTERNALSYM writeargs}
  TWriteArgs = writeargs;
  PWriteArgs = ^TWriteArgs;

  createargs = {packed} record
    where: diropargs;
    attributes: sattr;
  end;
  {$EXTERNALSYM createargs}
  TCreateArgs = createargs;
  PCreateArgs = ^TCreateArgs;

  renameargs = {packed} record
    from: diropargs;
    __to: diropargs;
  end;
  {$EXTERNALSYM renameargs}
  TRenameArgs = renameargs;
  PRenameArgs = ^TRenameArgs;

  linkargs = {packed} record
    from: nfs_fh;
    __to: diropargs;
  end;
  {$EXTERNALSYM linkargs}
  TLinkArgs = linkargs;
  PLinkArgs = ^TLinkArgs;

  symlinkargs = {packed} record
    from: diropargs;
    __to: nfspath;
    attributes: sattr;
  end;
  {$EXTERNALSYM symlinkargs}
  TSymLinkArgs = symlinkargs;
  PSymLinkArgs = ^TSymLinkArgs;

type
  nfscookie = packed array[0..NFS_COOKIESIZE-1] of Char;
  {$EXTERNALSYM nfscookie}

  readdirargs = {packed} record
    dir: nfs_fh;
    cookie: nfscookie;
    count: u_int;
  end;
  {$EXTERNALSYM readdirargs}
  TReadDirArgs = readdirargs;
  PReadDirArgs = ^TReadDirArgs;

  PEntry = ^TEntry;

  entry = {packed} record
    fileid: u_int;
    name: filename;
    cookie: nfscookie;
    nextentry: PEntry;
  end;
  {$EXTERNALSYM entry}
  TEntry = entry;

  dirlist = {packed} record
    entries: PEntry;
    eof: bool_t;
  end;
  {$EXTERNALSYM dirlist}

  readdirres = {packed} record
    status: nfsstat;
    readdirres_u: {packed} record
                    case Integer of
                      0: (reply: dirlist);
                    end;
  end;
  {$EXTERNALSYM readdirres}
  TReadDirRes = readdirres;
  PReadDirRes = ^TReadDirRes;

  statfsokres = {packed} record
    tsize: u_int;
    bsize: u_int;
    blocks: u_int;
    bfree: u_int;
    bavail: u_int;
  end;
  {$EXTERNALSYM statfsokres}

  statfsres = {packed} record
    status: nfsstat;
    statfsres_u: {packed} record
                   case Integer of
                     0: (reply: statfsokres);
                   end;
  end;
  {$EXTERNALSYM statfsres}
  TStatFsRes = statfsres;
  PStatFsRes = ^PStatFsRes;

const
  NFS_PROGRAM = 100003;
  {$EXTERNALSYM NFS_PROGRAM}
  NFS_VERSION = 2;
  {$EXTERNALSYM NFS_VERSION}

const
  NFSPROC_NULL = 0;
  {$EXTERNALSYM NFSPROC_NULL}

function nfsproc_null_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nfsproc_null_2}
function nfsproc_null_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nfsproc_null_2_svc}

const
  NFSPROC_GETATTR = 1;
  {$EXTERNALSYM NFSPROC_GETATTR}

function nfsproc_getattr_2(p1: PNfsFh; AClient: PClientRecord): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_getattr_2}
function nfsproc_getattr_2_svc(p1: PNfsFh; ServiceReq: PSvcReq): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_getattr_2_svc}

const
  NFSPROC_SETATTR = 2;
  {$EXTERNALSYM NFSPROC_SETATTR}

function nfsproc_setattr_2(p1: PSAttrArgs; AClient: PClientRecord): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_setattr_2}
function nfsproc_setattr_2_svc(p1: PSAttrArgs; ServiceReq: PSvcReq): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_setattr_2_svc}

const
  NFSPROC_ROOT = 3;
  {$EXTERNALSYM NFSPROC_ROOT}

function nfsproc_root_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nfsproc_root_2}
function nfsproc_root_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nfsproc_root_2_svc}

const
  NFSPROC_LOOKUP = 4;
  {$EXTERNALSYM NFSPROC_LOOKUP}

function nfsproc_lookup_2(p1: PDirOpArgs; AClient: PClientRecord): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_lookup_2}
function nfsproc_lookup_2_svc(p1: PDirOpArgs; ServiceReq: PSvcReq): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_lookup_2_svc}

const
  NFSPROC_READLINK = 5;
  {$EXTERNALSYM NFSPROC_READLINK}

function nfsproc_readlink_2(p1: PNfsFh; AClient: PClientRecord): PReadLinkRes; cdecl;
{$EXTERNALSYM nfsproc_readlink_2}
function nfsproc_readlink_2_svc(p1: PNfsFh; ServiceReq: PSvcReq): PReadLinkRes; cdecl;
{$EXTERNALSYM nfsproc_readlink_2_svc}

const
  NFSPROC_READ = 6;
  {$EXTERNALSYM NFSPROC_READ}

function nfsproc_read_2(p1: PReadArgs; AClient: PClientRecord): PReadRes; cdecl;
{$EXTERNALSYM nfsproc_read_2}
function nfsproc_read_2_svc(p1: PReadArgs; ServiceReq: PSvcReq): PReadRes; cdecl;
{$EXTERNALSYM nfsproc_read_2_svc}

const
  NFSPROC_WRITECACHE = 7;
  {$EXTERNALSYM NFSPROC_WRITECACHE}

function nfsproc_writecache_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nfsproc_writecache_2}
function nfsproc_writecache_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nfsproc_writecache_2_svc}

const
  NFSPROC_WRITE = 8;
  {$EXTERNALSYM NFSPROC_WRITE}

function nfsproc_write_2(p1: PWriteArgs; AClient: PClientRecord): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_write_2}
function nfsproc_write_2_svc(p1: PWriteArgs; ServiceReq: PSvcReq): PAttrStat; cdecl;
{$EXTERNALSYM nfsproc_write_2_svc}

const
  NFSPROC_CREATE = 9;
  {$EXTERNALSYM NFSPROC_CREATE}

function nfsproc_create_2(p1: PCreateArgs; AClient: PClientRecord): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_create_2}
function nfsproc_create_2_svc(p1: PCreateArgs; ServiceReq: PSvcReq): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_create_2_svc}

const
  NFSPROC_REMOVE = 10;
  {$EXTERNALSYM NFSPROC_REMOVE}

function nfsproc_remove_2(p1: PDirOpArgs; AClient: PClientRecord): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_remove_2}
function nfsproc_remove_2_svc(p1: PDirOpArgs; ServiceReq: PSvcReq): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_remove_2_svc}

const
  NFSPROC_RENAME = 11;
  {$EXTERNALSYM NFSPROC_RENAME}

function nfsproc_rename_2(p1: PRenameArgs; AClient: PClientRecord): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_rename_2}
function nfsproc_rename_2_svc(p1: PRenameArgs; ServiceReq: PSvcReq): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_rename_2_svc}

const
  NFSPROC_LINK = 12;
  {$EXTERNALSYM NFSPROC_LINK}

function nfsproc_link_2(p1: PLinkArgs; AClient: PClientRecord): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_link_2}
function nfsproc_link_2_svc(p1: PLinkArgs; ServiceReq: PSvcReq): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_link_2_svc}

const
  NFSPROC_SYMLINK = 13;
  {$EXTERNALSYM NFSPROC_SYMLINK}

function nfsproc_symlink_2(p1: PSymLinkArgs; AClient: PClientRecord): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_symlink_2}
function nfsproc_symlink_2_svc(p1: PSymLinkArgs; ServiceReq: PSvcReq): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_symlink_2_svc}

const
  NFSPROC_MKDIR = 14;
  {$EXTERNALSYM NFSPROC_MKDIR}

function nfsproc_mkdir_2(p1: PCreateArgs; AClient: PClientRecord): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_mkdir_2}
function nfsproc_mkdir_2_svc(p1: PCreateArgs; ServiceReq: PSvcReq): PDirOpRes; cdecl;
{$EXTERNALSYM nfsproc_mkdir_2_svc}

const
  NFSPROC_RMDIR = 15;
  {$EXTERNALSYM NFSPROC_RMDIR}

function nfsproc_rmdir_2(p1: PDirOpArgs; AClient: PClientRecord): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_rmdir_2}
function nfsproc_rmdir_2_svc(p1: PDirOpArgs; ServiceReq: PSvcReq): PNfsStat; cdecl;
{$EXTERNALSYM nfsproc_rmdir_2_svc}

const
  NFSPROC_READDIR = 16;
  {$EXTERNALSYM NFSPROC_READDIR}

function nfsproc_readdir_2(p1: PReadDirArgs; AClient: PClientRecord): PReadDirRes; cdecl;
{$EXTERNALSYM nfsproc_readdir_2}
function nfsproc_readdir_2_svc(p1: PReadDirArgs; ServiceReq: PSvcReq): PReadDirRes; cdecl;
{$EXTERNALSYM nfsproc_readdir_2_svc}

const
  NFSPROC_STATFS = 17;
  {$EXTERNALSYM NFSPROC_STATFS}

function nfsproc_statfs_2(p1: PNfsFh; AClient: PClientRecord): PStatFsRes; cdecl;
{$EXTERNALSYM nfsproc_statfs_2}
function nfsproc_statfs_2_svc(p1: PNfsFh; ServiceReq: PSvcReq): PStatFsRes; cdecl;
{$EXTERNALSYM nfsproc_statfs_2_svc}

function nfs_program_2_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM nfs_program_2_freeresult}

{ the xdr functions }

function xdr_nfsstat(__xdr: PXdr; var __nfsstat: nfsstat): bool_t; cdecl;
{$EXTERNALSYM xdr_nfsstat}
function xdr_ftype(__xdr: PXdr; var __ftype: ftype): bool_t; cdecl;
{$EXTERNALSYM xdr_ftype}
function xdr_nfs_fh(__xdr: PXdr; var __nfs_fh: nfs_fh): bool_t; cdecl;
{$EXTERNALSYM xdr_nfs_fh}
function xdr_nfstime(__xdr: PXdr; var __nfstime: nfstime): bool_t; cdecl;
{$EXTERNALSYM xdr_nfstime}
function xdr_fattr(__xdr: PXdr; var __fattr: fattr): bool_t; cdecl;
{$EXTERNALSYM xdr_fattr}
function xdr_sattr(__xdr: PXdr; var __sattr: sattr): bool_t; cdecl;
{$EXTERNALSYM xdr_sattr}
function xdr_filename(__xdr: PXdr; var __filename: filename): bool_t; cdecl;
{$EXTERNALSYM xdr_filename}
function xdr_nfspath(__xdr: PXdr; var __nfspath: nfspath): bool_t; cdecl;
{$EXTERNALSYM xdr_nfspath}
function xdr_attrstat(__xdr: PXdr; var __attrstat: attrstat): bool_t; cdecl;
{$EXTERNALSYM xdr_attrstat}
function xdr_sattrargs(__xdr: PXdr; var __sattrargs: sattrargs): bool_t; cdecl;
{$EXTERNALSYM xdr_sattrargs}
function xdr_diropargs(__xdr: PXdr; var __diropargs: diropargs): bool_t; cdecl;
{$EXTERNALSYM xdr_diropargs}
function xdr_diropokres(__xdr: PXdr; var __diropokres: diropokres): bool_t; cdecl;
{$EXTERNALSYM xdr_diropokres}
function xdr_diropres(__xdr: PXdr; var __diropres: diropres): bool_t; cdecl;
{$EXTERNALSYM xdr_diropres}
function xdr_readlinkres(__xdr: PXdr; var __readlinkres: readlinkres): bool_t; cdecl;
{$EXTERNALSYM xdr_readlinkres}
function xdr_readargs(__xdr: PXdr; var __readargs: readargs): bool_t; cdecl;
{$EXTERNALSYM xdr_readargs}
function xdr_readokres(__xdr: PXdr; var __readokres: readokres): bool_t; cdecl;
{$EXTERNALSYM xdr_readokres}
function xdr_readres(__xdr: PXdr; var __readres: readres): bool_t; cdecl;
{$EXTERNALSYM xdr_readres}
function xdr_writeargs(__xdr: PXdr; var __writeargs: writeargs): bool_t; cdecl;
{$EXTERNALSYM xdr_writeargs}
function xdr_createargs(__xdr: PXdr; var __createargs: createargs): bool_t; cdecl;
{$EXTERNALSYM xdr_createargs}
function xdr_renameargs(__xdr: PXdr; var __renameargs: renameargs): bool_t; cdecl;
{$EXTERNALSYM xdr_renameargs}
function xdr_linkargs(__xdr: PXdr; var __linkargs: linkargs): bool_t; cdecl;
{$EXTERNALSYM xdr_linkargs}
function xdr_symlinkargs(__xdr: PXdr; var __symlinkargs: symlinkargs): bool_t; cdecl;
{$EXTERNALSYM xdr_symlinkargs}
function xdr_nfscookie(__xdr: PXdr; var __nfscookie: nfscookie): bool_t; cdecl;
{$EXTERNALSYM xdr_nfscookie}
function xdr_readdirargs(__xdr: PXdr; var __readdirargs: readdirargs): bool_t; cdecl;
{$EXTERNALSYM xdr_readdirargs}
function xdr_entry(__xdr: PXdr; var __entry: entry): bool_t; cdecl;
{$EXTERNALSYM xdr_entry}
function xdr_dirlist(__xdr: PXdr; var __dirlist: dirlist): bool_t; cdecl;
{$EXTERNALSYM xdr_dirlist}
function xdr_readdirres(__xdr: PXdr; var __readdirres: readdirres): bool_t; cdecl;
{$EXTERNALSYM xdr_readdirres}
function xdr_statfsokres(__xdr: PXdr; var __statfsokres: statfsokres): bool_t; cdecl;
{$EXTERNALSYM xdr_statfsokres}
function xdr_statfsres(__xdr: PXdr; var __statfsres: statfsres): bool_t; cdecl;
{$EXTERNALSYM xdr_statfsres}


{$HPPEMIT '#include <rpcsvc/nis_tags.h>'}

// Translated from rpcsvc/nis_tags.h

const
  NIS_DIR = 'data';
  {$EXTERNALSYM NIS_DIR}

{ Lookup and List function flags }
  FOLLOW_LINKS     = (1 shl 0);    { Follow link objects }
  {$EXTERNALSYM FOLLOW_LINKS}
  FOLLOW_PATH      = (1 shl 1);    { Follow the path in a table }
  {$EXTERNALSYM FOLLOW_PATH}
  HARD_LOOKUP      = (1 shl 2);    { Block until successful }
  {$EXTERNALSYM HARD_LOOKUP}
  ALL_RESULTS      = (1 shl 3);    { Retrieve all results }
  {$EXTERNALSYM ALL_RESULTS}
  NO_CACHE         = (1 shl 4);    { Do not return 'cached' results }
  {$EXTERNALSYM NO_CACHE}
  MASTER_ONLY      = (1 shl 5);    { Get value only from master server }
  {$EXTERNALSYM MASTER_ONLY}
  EXPAND_NAME      = (1 shl 6);    { Expand partitially qualified names }
  {$EXTERNALSYM EXPAND_NAME}

{ Semantic modification for table operations flags }
  RETURN_RESULT    = (1 shl 7);    { Return resulting object to client }
  {$EXTERNALSYM RETURN_RESULT}
  ADD_OVERWRITE    = (1 shl 8);    { Allow overwrites on ADD }
  {$EXTERNALSYM ADD_OVERWRITE}
  REM_MULTIPLE     = (1 shl 9);    { Allow wildcard deletes }
  {$EXTERNALSYM REM_MULTIPLE}
  MOD_SAMEOBJ      = (1 shl 10);   { Check modified object before write }
  {$EXTERNALSYM MOD_SAMEOBJ}
  ADD_RESERVED     = (1 shl 11);   { Spare ADD semantic }
  {$EXTERNALSYM ADD_RESERVED}
  REM_RESERVED     = (1 shl 12);   { Spare REM semantic }
  {$EXTERNALSYM REM_RESERVED}
  MOD_EXCLUSIVE    = (1 shl 13);   { Modify no overwrite on modified keys }
  {$EXTERNALSYM MOD_EXCLUSIVE}

{ Lookup and List function flags (continued) }
  SOFT_LOOKUP      = (1 shl 14);   { The "old default" return on failure  }
  {$EXTERNALSYM SOFT_LOOKUP}

{ Transport specific modifications to the operation }
  USE_DGRAM        = (1 shl 16);   { Use a datagram transport }
  {$EXTERNALSYM USE_DGRAM}
  NO_AUTHINFO      = (1 shl 17);   { Don't bother attaching auth info }
  {$EXTERNALSYM NO_AUTHINFO}

{
 * Declarations for "standard" NIS+ tags
 * State variable tags have values   0 - 2047
 * Statistic tags have values        2048 - 65535
 * User Tags have values             >2^16
 }
  TAG_DEBUG = 1;            { set debug level }
  {$EXTERNALSYM TAG_DEBUG}
  TAG_STATS = 2;            { Enable/disable statistics }
  {$EXTERNALSYM TAG_STATS}
  TAG_GCACHE = 3;           { Flush the Group Cache }
  {$EXTERNALSYM TAG_GCACHE}
  TAG_GCACHE_ALL = TAG_GCACHE;
  {$EXTERNALSYM TAG_GCACHE_ALL}
  TAG_DCACHE = 4;           { Flush the directory cache }
  {$EXTERNALSYM TAG_DCACHE}
  TAG_DCACHE_ONE = TAG_DCACHE;
  {$EXTERNALSYM TAG_DCACHE_ONE}
  TAG_OCACHE = 5;           { Flush the Object Cache }
  {$EXTERNALSYM TAG_OCACHE}
  TAG_SECURE = 6;           { Set the security level  }
  {$EXTERNALSYM TAG_SECURE}
  TAG_TCACHE_ONE = 7;       { Flush the table cache }
  {$EXTERNALSYM TAG_TCACHE_ONE}
  TAG_DCACHE_ALL = 8;       { Flush entire directory cache }
  {$EXTERNALSYM TAG_DCACHE_ALL}
  TAG_TCACHE_ALL = 9;       { Flush entire table cache }
  {$EXTERNALSYM TAG_TCACHE_ALL}
  TAG_GCACHE_ONE = 10;      { Flush one group object }
  {$EXTERNALSYM TAG_GCACHE_ONE}
  TAG_DCACHE_ONE_REFRESH = 11; { Flush and refresh one DO }
  {$EXTERNALSYM TAG_DCACHE_ONE_REFRESH}
  TAG_READONLY = 12;     { Set read only mode }
  {$EXTERNALSYM TAG_READONLY}
  TAG_READWRITE = 14;    { Reset read-write mode }
  {$EXTERNALSYM TAG_READWRITE}

  TAG_OPSTATS = 2048;    { NIS+ operations statistics }
  {$EXTERNALSYM TAG_OPSTATS}
  TAG_THREADS = 2049;    { Child process/thread status }
  {$EXTERNALSYM TAG_THREADS}
  TAG_HEAP = 2050;       { Heap usage statistics }
  {$EXTERNALSYM TAG_HEAP}
  TAG_UPDATES = 2051;    { Updates to this service }
  {$EXTERNALSYM TAG_UPDATES}
  TAG_VISIBLE = 2052;    { First update that isn't replicated }
  {$EXTERNALSYM TAG_VISIBLE}
  TAG_S_DCACHE = 2053;   { Directory cache statistics }
  {$EXTERNALSYM TAG_S_DCACHE}
  TAG_S_OCACHE = 2054;   { Object cache statistics }
  {$EXTERNALSYM TAG_S_OCACHE}
  TAG_S_GCACHE = 2055;   { Group cache statistics }
  {$EXTERNALSYM TAG_S_GCACHE}
  TAG_S_STORAGE = 2056;  { Group cache statistics }
  {$EXTERNALSYM TAG_S_STORAGE}
  TAG_UPTIME = 2057;     { Time that server has been up }
  {$EXTERNALSYM TAG_UPTIME}
  TAG_DIRLIST = 2058;    { Dir served by this server }
  {$EXTERNALSYM TAG_DIRLIST}
  TAG_NISCOMPAT = 2059;  { Whether supports NIS compat mode }
  {$EXTERNALSYM TAG_NISCOMPAT}
  TAG_DNSFORWARDING = 2060;  { Whether DNS forwarding supported }
  {$EXTERNALSYM TAG_DNSFORWARDING}
  TAG_SECURITY_LEVEL = 2061; { Security level of the server }
  {$EXTERNALSYM TAG_SECURITY_LEVEL}
  TAG_ROOTSERVER = 2062;     { Whether root server }
  {$EXTERNALSYM TAG_ROOTSERVER}

{
 * Declarations for the Group object flags. Currently
 * there are only 3.
 }
  IMPMEM_GROUPS = 1;        { Implicit Membership allowed }
  {$EXTERNALSYM IMPMEM_GROUPS}
  RECURS_GROUPS = 2;        { Recursive Groups allowed }
  {$EXTERNALSYM RECURS_GROUPS}
  NEGMEM_GROUPS = 4;        { Negative Groups allowed }
  {$EXTERNALSYM NEGMEM_GROUPS}


{$HPPEMIT '#include <rpcsvc/nis.h>'}

// Translated from rpcsvc/nis.h

const
  NIS_MAXSTRINGLEN = 255;
  {$EXTERNALSYM NIS_MAXSTRINGLEN}
  NIS_MAXNAMELEN = 1024;
  {$EXTERNALSYM NIS_MAXNAMELEN}
  NIS_MAXATTRNAME = 32;
  {$EXTERNALSYM NIS_MAXATTRNAME}
  NIS_MAXATTRVAL = 2048;
  {$EXTERNALSYM NIS_MAXATTRVAL}
  NIS_MAXCOLUMNS = 64;
  {$EXTERNALSYM NIS_MAXCOLUMNS}
  NIS_MAXATTR = 16;
  {$EXTERNALSYM NIS_MAXATTR}
  NIS_MAXPATH = 1024;
  {$EXTERNALSYM NIS_MAXPATH}
  NIS_MAXREPLICAS = 128;
  {$EXTERNALSYM NIS_MAXREPLICAS}
  NIS_MAXLINKS = 16;
  {$EXTERNALSYM NIS_MAXLINKS}
  NIS_PK_NONE = 0;
  {$EXTERNALSYM NIS_PK_NONE}
  NIS_PK_DH = 1;
  {$EXTERNALSYM NIS_PK_DH}
  NIS_PK_RSA = 2;
  {$EXTERNALSYM NIS_PK_RSA}
  NIS_PK_KERB = 3;
  {$EXTERNALSYM NIS_PK_KERB}
  NIS_PK_DHEXT = 4;
  {$EXTERNALSYM NIS_PK_DHEXT}

type
  nis_attr = {packed} record
    zattr_ndx: PChar;
    zattr_val: {packed} record
      zattr_val_len: u_int;
      zattr_val_val: PChar;
    end;
  end;
  {$EXTERNALSYM nis_attr}
  TNisAttr = nis_attr;
  PNisAttr = ^TNisAttr;

type
  nis_name = PChar;
  {$EXTERNALSYM nis_name}
  PNisName = ^nis_name;

  zotypes =
  (
    BOGUS_OBJ = 0,
    {$EXTERNALSYM BOGUS_OBJ}
    NO_OBJ = 1,
    {$EXTERNALSYM NO_OBJ}
    DIRECTORY_OBJ = 2,
    {$EXTERNALSYM DIRECTORY_OBJ}
    GROUP_OBJ = 3,
    {$EXTERNALSYM GROUP_OBJ}
    TABLE_OBJ = 4,
    {$EXTERNALSYM TABLE_OBJ}
    ENTRY_OBJ = 5,
    {$EXTERNALSYM ENTRY_OBJ}
    LINK_OBJ = 6,
    {$EXTERNALSYM LINK_OBJ}
    PRIVATE_OBJ = 7,
    {$EXTERNALSYM PRIVATE_OBJ}
    NIS_BOGUS_OBJ = 0,
    {$EXTERNALSYM NIS_BOGUS_OBJ}
    NIS_NO_OBJ = 1,
    {$EXTERNALSYM NIS_NO_OBJ}
    NIS_DIRECTORY_OBJ = 2,
    {$EXTERNALSYM NIS_DIRECTORY_OBJ}
    NIS_GROUP_OBJ = 3,
    {$EXTERNALSYM NIS_GROUP_OBJ}
    NIS_TABLE_OBJ = 4,
    {$EXTERNALSYM NIS_TABLE_OBJ}
    NIS_ENTRY_OBJ = 5,
    {$EXTERNALSYM NIS_ENTRY_OBJ}
    NIS_LINK_OBJ = 6,
    {$EXTERNALSYM NIS_LINK_OBJ}
    NIS_PRIVATE_OBJ = 7
    {$EXTERNALSYM NIS_PRIVATE_OBJ}
  );
  {$EXTERNALSYM zotypes}

  nstype =
  (
    UNKNOWN = 0,
    {$EXTERNALSYM UNKNOWN}
    NIS = 1,
    {$EXTERNALSYM NIS}
    SUNYP = 2,
    {$EXTERNALSYM SUNYP}
    IVY = 3,
    {$EXTERNALSYM IVY}
    DNS = 4,
    {$EXTERNALSYM DNS}
    X500 = 5,
    {$EXTERNALSYM X500}
    DNANS = 6,
    {$EXTERNALSYM DNANS}
    XCHS = 7,
    {$EXTERNALSYM XCHS}
    CDS = 8
    {$EXTERNALSYM CDS}
  );
  {$EXTERNALSYM nstype}

type
  oar_mask = {packed} record
    oa_rights: uint32_t;
    oa_otype: zotypes;
  end;
  {$EXTERNALSYM oar_mask}
  TOarMask = oar_mask;
  POarMask = ^TOarMask;

  endpoint = {packed} record
    uaddr: PChar;
    family: PChar;
    proto: PChar;
  end;
  {$EXTERNALSYM endpoint}
  TEndPoint = endpoint;
  PEndPoint = ^TEndPoint;

  nis_server = {packed} record
    name: nis_name;
    ep: {packed} record
      ep_len: u_int;
      ep_val: PEndPoint;
    end;
    key_type: uint32_t;
    pkey: netobj;
  end;
  {$EXTERNALSYM nis_server}
  TNisServer = nis_server;
  PNisServer = ^TNisServer;
  PPNisServer = ^PNisServer;

  _directory_obj = {packed} record
    do_name: nis_name;
    do_type: nstype;
    do_servers: {packed} record
      do_servers_len: u_int;
      do_servers_val: PNisServer;
    end;
    do_ttl: uint32_t;
    do_armask: {packed} record
      do_armask_len: u_int;
      do_armask_val: POarMask;
    end;
  end;
  {.$EXTERNALSYM directory_obj} // Renamed because of identifier conflict
  TDirectoryObj = _directory_obj;
  PDirectoryObj = ^TDirectoryObj;

const
  EN_BINARY = 1;
  {$EXTERNALSYM EN_BINARY}
  EN_CRYPT = 2;
  {$EXTERNALSYM EN_CRYPT}
  EN_XDR = 4;
  {$EXTERNALSYM EN_XDR}
  EN_MODIFIED = 8;
  {$EXTERNALSYM EN_MODIFIED}
  EN_ASN1 = 64;
  {$EXTERNALSYM EN_ASN1}

type
  entry_col = {packed} record
    ec_flags: uint32_t;
    ec_value: {packed} record
      ec_value_len: u_int;
      ec_value_val: PChar;
    end;
  end;
  {$EXTERNALSYM entry_col}
  TEntryCol = entry_col;
  PEntryCol = ^TEntryCol;

  _entry_obj = {packed} record
    en_type: PChar;
    en_cols: {packed} record
      en_cols_len: u_int;
      en_cols_val: PEntryCol;
    end;
  end;
  {.$EXTERNALSYM entry_obj} // Renamed because of identifier conflict
  TEntryObj = _entry_obj;
  PEntryObj = ^TEntryObj;

  _group_obj = {packed} record
    gr_flags: uint32_t;
    gr_members: {packed} record
      gr_members_len: u_int;
      gr_members_val: PNisName;
    end;
  end;
  {.$EXTERNALSYM group_obj} // Renamed because of identifier conflict
  TGroupObj = _group_obj;
  PGroupObj = ^TGroupObj;

  _link_obj = {packed} record
    li_rtype: zotypes;
    li_attrs: {packed} record
      li_attrs_len: u_int;
      li_attrs_val: PNisAttr;
    end;
    li_name: nis_name;
  end;
  {.$EXTERNALSYM link_obj} // Renamed because of identifier conflict
  TLinkObj = _link_obj;
  PLinkObj = ^TLinkObj;

const
  TA_BINARY = 1;
  {$EXTERNALSYM TA_BINARY}
  TA_CRYPT = 2;
  {$EXTERNALSYM TA_CRYPT}
  TA_XDR = 4;
  {$EXTERNALSYM TA_XDR}
  TA_SEARCHABLE = 8;
  {$EXTERNALSYM TA_SEARCHABLE}
  TA_CASE = 16;
  {$EXTERNALSYM TA_CASE}
  TA_MODIFIED = 32;
  {$EXTERNALSYM TA_MODIFIED}
  TA_ASN1 = 64;
  {$EXTERNALSYM TA_ASN1}

type
  table_col = {packed} record
    tc_name: PChar;
    tc_flags: uint32_t;
    tc_rights: uint32_t;
  end;
  {$EXTERNALSYM table_col}
  TTableCol = table_col;
  PTableCol = ^TTableCol;

  _table_obj = {packed} record
    ta_type: PChar;
    ta_maxcol: Integer;
    ta_sep: u_char;
    ta_cols: {packed} record
      ta_cols_len: u_int;
      ta_cols_val: PTableCol;
    end;
    ta_path: PChar;
  end;
  {.$EXTERNALSYM table_obj} // Renamed because of identifier conflict
  TTableObj = _table_obj;
  PTableObj = ^TTableObj;

  objdata = {packed} record
    zo_type: zotypes;
    objdata_u: {packed} record
                 case Integer of
                   0: (di_data: TDirectoryObj);
                   1: (gr_data: TGroupObj);
                   2: (ta_data: TTableObj);
                   3: (en_data: TEntryObj);
                   4: (li_data: TLinkObj);
                   5: (po_data: {packed} record
                                  po_data_len: u_int;
                                  po_data_val: PChar
                                end);
                 end;
  end;
  {$EXTERNALSYM objdata}

  nis_oid = {packed} record
    ctime: uint32_t;
    mtime: uint32_t;
  end;
  {$EXTERNALSYM nis_oid}

  nis_object = {packed} record
    zo_oid: nis_oid;
    zo_name: nis_name;
    zo_owner: nis_name;
    zo_group: nis_name;
    zo_domain: nis_name;
    zo_access: uint32_t;
    zo_ttl: uint32_t;
    zo_data: objdata;
  end;
  {$EXTERNALSYM nis_object}
  TNisObject = nis_object;
  PNisObject = ^TNisObject;

  nis_error =
  (
    NIS_SUCCESS = 0,
    {$EXTERNALSYM NIS_SUCCESS}
    NIS_S_SUCCESS = 1,
    {$EXTERNALSYM NIS_S_SUCCESS}
    NIS_NOTFOUND = 2,
    {$EXTERNALSYM NIS_NOTFOUND}
    NIS_S_NOTFOUND = 3,
    {$EXTERNALSYM NIS_S_NOTFOUND}
    NIS_CACHEEXPIRED = 4,
    {$EXTERNALSYM NIS_CACHEEXPIRED}
    NIS_NAMEUNREACHABLE = 5,
    {$EXTERNALSYM NIS_NAMEUNREACHABLE}
    NIS_UNKNOWNOBJ = 6,
    {$EXTERNALSYM NIS_UNKNOWNOBJ}
    NIS_TRYAGAIN = 7,
    {$EXTERNALSYM NIS_TRYAGAIN}
    NIS_SYSTEMERROR = 8,
    {$EXTERNALSYM NIS_SYSTEMERROR}
    NIS_CHAINBROKEN = 9,
    {$EXTERNALSYM NIS_CHAINBROKEN}
    NIS_PERMISSION = 10,
    {$EXTERNALSYM NIS_PERMISSION}
    NIS_NOTOWNER = 11,
    {$EXTERNALSYM NIS_NOTOWNER}
    NIS_NOT_ME = 12,
    {$EXTERNALSYM NIS_NOT_ME}
    NIS_NOMEMORY = 13,
    {$EXTERNALSYM NIS_NOMEMORY}
    NIS_NAMEEXISTS = 14,
    {$EXTERNALSYM NIS_NAMEEXISTS}
    NIS_NOTMASTER = 15,
    {$EXTERNALSYM NIS_NOTMASTER}
    NIS_INVALIDOBJ = 16,
    {$EXTERNALSYM NIS_INVALIDOBJ}
    NIS_BADNAME = 17,
    {$EXTERNALSYM NIS_BADNAME}
    NIS_NOCALLBACK = 18,
    {$EXTERNALSYM NIS_NOCALLBACK}
    NIS_CBRESULTS = 19,
    {$EXTERNALSYM NIS_CBRESULTS}
    NIS_NOSUCHNAME = 20,
    {$EXTERNALSYM NIS_NOSUCHNAME}
    NIS_NOTUNIQUE = 21,
    {$EXTERNALSYM NIS_NOTUNIQUE}
    NIS_IBMODERROR = 22,
    {$EXTERNALSYM NIS_IBMODERROR}
    NIS_NOSUCHTABLE = 23,
    {$EXTERNALSYM NIS_NOSUCHTABLE}
    NIS_TYPEMISMATCH = 24,
    {$EXTERNALSYM NIS_TYPEMISMATCH}
    NIS_LINKNAMEERROR = 25,
    {$EXTERNALSYM NIS_LINKNAMEERROR}
    NIS_PARTIAL = 26,
    {$EXTERNALSYM NIS_PARTIAL}
    NIS_TOOMANYATTRS = 27,
    {$EXTERNALSYM NIS_TOOMANYATTRS}
    NIS_RPCERROR = 28,
    {$EXTERNALSYM NIS_RPCERROR}
    NIS_BADATTRIBUTE = 29,
    {$EXTERNALSYM NIS_BADATTRIBUTE}
    NIS_NOTSEARCHABLE = 30,
    {$EXTERNALSYM NIS_NOTSEARCHABLE}
    NIS_CBERROR = 31,
    {$EXTERNALSYM NIS_CBERROR}
    NIS_FOREIGNNS = 32,
    {$EXTERNALSYM NIS_FOREIGNNS}
    NIS_BADOBJECT = 33,
    {$EXTERNALSYM NIS_BADOBJECT}
    NIS_NOTSAMEOBJ = 34,
    {$EXTERNALSYM NIS_NOTSAMEOBJ}
    NIS_MODFAIL = 35,
    {$EXTERNALSYM NIS_MODFAIL}
    NIS_BADREQUEST = 36,
    {$EXTERNALSYM NIS_BADREQUEST}
    NIS_NOTEMPTY = 37,
    {$EXTERNALSYM NIS_NOTEMPTY}
    NIS_COLDSTART_ERR = 38,
    {$EXTERNALSYM NIS_COLDSTART_ERR}
    NIS_RESYNC = 39,
    {$EXTERNALSYM NIS_RESYNC}
    NIS_FAIL = 40,
    {$EXTERNALSYM NIS_FAIL}
    NIS_UNAVAIL = 41,
    {$EXTERNALSYM NIS_UNAVAIL}
    NIS_RES2BIG = 42,
    {$EXTERNALSYM NIS_RES2BIG}
    NIS_SRVAUTH = 43,
    {$EXTERNALSYM NIS_SRVAUTH}
    NIS_CLNTAUTH = 44,
    {$EXTERNALSYM NIS_CLNTAUTH}
    NIS_NOFILESPACE = 45,
    {$EXTERNALSYM NIS_NOFILESPACE}
    NIS_NOPROC = 46,
    {$EXTERNALSYM NIS_NOPROC}
    NIS_DUMPLATER = 47
    {$EXTERNALSYM NIS_DUMPLATER}
  );
  {$EXTERNALSYM nis_error}
  PNisError = ^nis_error;

  nis_result = {packed} record
    status: nis_error;
    objects: {packed} record
      objects_len: u_int;
      objects_val: PNisObject;
    end;
    cookie: netobj;
    zticks: uint32_t;
    dticks: uint32_t;
    aticks: uint32_t;
    cticks: uint32_t;
  end;
  {$EXTERNALSYM nis_result}
  TNisResult = nis_result;
  PNisResult = ^TNisResult;

  ns_request = {packed} record
    ns_name: nis_name;
    ns_object: {packed} record
      ns_object_len: u_int;
      ns_object_val: PNisObject;
    end;
  end;
  {$EXTERNALSYM ns_request}
  TNsRequest = ns_request;
  PNsRequest = ^TNsRequest;

  ib_request = {packed} record
    ibr_name: nis_name;
    ibr_srch: {packed} record
      ibr_srch_len: u_int;
      ibr_srch_val: PNisAttr;
    end;
    ibr_flags: uint32_t;
    ibr_obj: {packed} record
      ibr_obj_len: u_int;
      ibr_obj_val: PNisObject;
    end;
    ibr_cbhost: {packed} record
      ibr_cbhost_len: u_int;
      ibr_cbhost_val: PNisServer;
    end;
    ibr_bufsize: u_int;
    ibr_cookie: netobj;
  end;
  {$EXTERNALSYM ib_request}
  TIbRequest = ib_request;
  PIbRequest = ^TIbRequest;

  ping_args = {packed} record
    dir: nis_name;
    stamp: uint32_t;
  end;
  {$EXTERNALSYM ping_args}
  TPingArgs = ping_args;
  PPingArgs = ^TPingArgs;

  log_entry_t =
  (
    LOG_NOP = 0,
    {$EXTERNALSYM LOG_NOP}

    ADD_NAME = 1,
    {$EXTERNALSYM ADD_NAME}
    REM_NAME = 2,
    {$EXTERNALSYM REM_NAME}
    MOD_NAME_OLD = 3,
    {$EXTERNALSYM MOD_NAME_OLD}
    MOD_NAME_NEW = 4,
    {$EXTERNALSYM MOD_NAME_NEW}
    ADD_IBASE = 5,
    {$EXTERNALSYM ADD_IBASE}
    REM_IBASE = 6,
    {$EXTERNALSYM REM_IBASE}
    MOD_IBASE = 7,
    {$EXTERNALSYM MOD_IBASE}
    UPD_STAMP = 8
    {$EXTERNALSYM UPD_STAMP}
  );
  {$EXTERNALSYM log_entry_t}

  log_entry = {packed} record
    le_time: uint32_t;
    le_type: log_entry_t;
    le_princp: nis_name;
    le_name: nis_name;
    le_attrs: {packed} record
      le_attrs_len: u_int;
      le_attrs_val: PNisAttr;
    end;
    le_object: nis_object;
  end;
  {$EXTERNALSYM log_entry}
  TLogEntry = log_entry;
  PLogEntry = ^TLogEntry;

  log_result = {packed} record
    lr_status: nis_error;
    lr_cookie: netobj;
    lr_entries: {packed} record
      lr_entries_len: u_int;
      lr_entries_val: PLogEntry;
    end;
  end;
  {$EXTERNALSYM log_result}
  TLogResult = log_result;
  PLogResult = ^TLogResult;

  cp_result = {packed} record
    cp_status: nis_error;
    cp_zticks: uint32_t;
    cp_dticks: uint32_t;
  end;
  {$EXTERNALSYM cp_result}
  TCpResult = cp_result;
  PCpResult = ^TCpResult;

  nis_tag = {packed} record
    tag_type: uint32_t;
    tag_val: PChar;
  end;
  {$EXTERNALSYM nis_tag}
  TNisTag = nis_tag;
  PNisTag = ^TNisTag;

  nis_taglist = {packed} record
    tags: {packed} record
      tags_len: u_int;
      tags_val: PNisTag;
    end;
  end;
  {$EXTERNALSYM nis_taglist}
  TNisTagList = nis_taglist;
  PNisTagList = ^TNisTagList;

  dump_args = {packed} record
    da_dir: nis_name;
    da_time: uint32_t;
    da_cbhost: {packed} record
      da_cbhost_len: u_int;
      da_cbhost_val: PNisServer;
    end;
  end;
  {$EXTERNALSYM dump_args}
  TDumpArgs = dump_args;
  PDumpArgs = ^TDumpArgs;

  fd_args = {packed} record
    dir_name: nis_name;
    requester: nis_name;
  end;
  {$EXTERNALSYM fd_args}
  TFdArgs = fd_args;
  PFdArgs = ^TFdArgs;

  fd_result = {packed} record
    status: nis_error;
    source: nis_name;
    dir_data: {packed} record
      dir_data_len: u_int;
      dir_data_val: PChar;
    end;
    signature: {packed} record
      signature_len: u_int;
      signature_val: PChar;
    end;
  end;
  {$EXTERNALSYM fd_result}
  TFdResult = fd_result;
  PFdResult = ^TFdResult;

{ Generic client creating flags }
const
  ZMH_VC    = 1;
  {$EXTERNALSYM ZMH_VC}
  ZMH_DG    = 2;
  {$EXTERNALSYM ZMH_DG}
  ZMH_AUTH  = 4;
  {$EXTERNALSYM ZMH_AUTH}

{ Testing Access rights for objects }

  NIS_READ_ACC     = 1;
  {$EXTERNALSYM NIS_READ_ACC}
  NIS_MODIFY_ACC   = 2;
  {$EXTERNALSYM NIS_MODIFY_ACC}
  NIS_CREATE_ACC   = 4;
  {$EXTERNALSYM NIS_CREATE_ACC}
  NIS_DESTROY_ACC  = 8;
  {$EXTERNALSYM NIS_DESTROY_ACC}

{ Test macros. a == access rights, m == desired rights. }
function NIS_WORLD(a, m: Cardinal): Boolean;
{$EXTERNALSYM NIS_WORLD}
function NIS_GROUP(a, m: Cardinal): Boolean;
{$EXTERNALSYM NIS_GROUP}
function NIS_OWNER(a, m: Cardinal): Boolean;
{$EXTERNALSYM NIS_OWNER}
function NIS_NOBODY(a, m: Cardinal): Boolean;
{$EXTERNALSYM NIS_NOBODY}
{
 * EOL Alert - The following non-prefixed test macros are
 * here for backward compatability, and will be not be present
 * in future releases - use the NIS_*() macros above.
 }
function WORLD(a, m: Cardinal): Boolean;
{$EXTERNALSYM WORLD}
function GROUP(a, m: Cardinal): Boolean;
{$EXTERNALSYM GROUP}
function OWNER(a, m: Cardinal): Boolean;
{$EXTERNALSYM OWNER}
function NOBODY(a, m: Cardinal): Boolean;
{$EXTERNALSYM NOBODY}

function OATYPE(d: PDirectoryObj; n: Cardinal): zotypes;
{$EXTERNALSYM OATYPE}
function OARIGHTS(d: PDirectoryObj; n: Cardinal): uint32_t;
{$EXTERNALSYM OARIGHTS}

const
  WORLD_DEFAULT = (NIS_READ_ACC);
  {$EXTERNALSYM WORLD_DEFAULT}
  GROUP_DEFAULT = (NIS_READ_ACC shl 8);
  {$EXTERNALSYM GROUP_DEFAULT}
  OWNER_DEFAULT = ((NIS_READ_ACC + NIS_MODIFY_ACC + NIS_CREATE_ACC + NIS_DESTROY_ACC) shl 16);
  {$EXTERNALSYM OWNER_DEFAULT}
  DEFAULT_RIGHTS = (WORLD_DEFAULT or GROUP_DEFAULT or OWNER_DEFAULT);
  {$EXTERNALSYM DEFAULT_RIGHTS}

{ Result manipulation defines ... }
function NIS_RES_NUMOBJ(x: PNisResult): u_int;
{$EXTERNALSYM NIS_RES_NUMOBJ}
function NIS_RES_OBJECT(x: PNisResult): PNisObject;
{$EXTERNALSYM NIS_RES_OBJECT}
function NIS_RES_COOKIE(x: PNisResult): netobj;
{$EXTERNALSYM NIS_RES_COOKIE}
function NIS_RES_STATUS(x: PNisResult): nis_error;
{$EXTERNALSYM NIS_RES_STATUS}

(* Cannot be translated
{ These defines make getting at the variant part of the object easier. }
#define TA_data zo_data.objdata_u.ta_data
#define EN_data zo_data.objdata_u.en_data
#define DI_data zo_data.objdata_u.di_data
#define LI_data zo_data.objdata_u.li_data
#define GR_data zo_data.objdata_u.gr_data
*)

function __type_of(o: PNisObject): zotypes;
{$EXTERNALSYM __type_of}

{ Declarations for the internal subroutines in nislib.c }
type
  name_pos =
  (
    SAME_NAME = 0,
    {$EXTERNALSYM SAME_NAME}
    HIGHER_NAME = 1,
    {$EXTERNALSYM HIGHER_NAME}
    LOWER_NAME = 2,
    {$EXTERNALSYM LOWER_NAME}
    NOT_SEQUENTIAL = 3,
    {$EXTERNALSYM NOT_SEQUENTIAL}
    BAD_NAME = 4
    {$EXTERNALSYM BAD_NAME}
  );
  {$EXTERNALSYM name_pos}


{
 * Defines for getting at column data in entry objects. Because RPCGEN
 * generates some rather wordy structures, we create some defines that
 * collapse the needed keystrokes to access a particular value using
 * these definitions they take an nis_object *, and an int and return
 * a u_char * for Value, and an int for length.
 }
function ENTRY_VAL(obj: PNisObject; col: Cardinal): PChar;
{$EXTERNALSYM ENTRY_VAL}
function ENTRY_LEN(obj: PNisObject; col: Cardinal): u_int;
{$EXTERNALSYM ENTRY_LEN}

{
 * This file contains definitions that are only of interest to the actual
 * service daemon and client stubs. Normal users of NIS will not include
 * this file.
 }

const
  NIS_PROG = 100300;
  {$EXTERNALSYM NIS_PROG}
  NIS_VERSION = 3;
  {$EXTERNALSYM NIS_VERSION}

const
  _NIS_LOOKUP = 1;
  {.$EXTERNALSYM NIS_LOOKUP} // Renamed due to identifier conflict

function nis_lookup_3(p1: PNsRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_lookup_3}
function nis_lookup_3_svc(p1: PNsRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_lookup_3_svc}

const
  _NIS_ADD = 2;
  {.$EXTERNALSYM NIS_ADD} // Renamed due to identifier conflict

function nis_add_3(p1: PNsRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_add_3}
function nis_add_3_svc(p1: PNsRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_add_3_svc}

const
  _NIS_MODIFY = 3;
  {.$EXTERNALSYM NIS_MODIFY} // Renamed due to identifier conflict

function nis_modify_3(p1: PNsRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_modify_3}
function nis_modify_3_svc(p1: PNsRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_modify_3_svc}

const
  _NIS_REMOVE = 4;
  {.$EXTERNALSYM NIS_REMOVE} // Renamed due to identifier conflict

function nis_remove_3(p1: PNsRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_remove_3}
function nis_remove_3_svc(p1: PNsRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_remove_3_svc}

const
  NIS_IBLIST = 5;
  {$EXTERNALSYM NIS_IBLIST}

function nis_iblist_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_iblist_3}
function nis_iblist_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_iblist_3_svc}

const
  NIS_IBADD = 6;
  {$EXTERNALSYM NIS_IBADD}

function nis_ibadd_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_ibadd_3}
function nis_ibadd_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_ibadd_3_svc}

const
  NIS_IBMODIFY = 7;
  {$EXTERNALSYM NIS_IBMODIFY}

function nis_ibmodify_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_ibmodify_3}
function nis_ibmodify_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_ibmodify_3_svc}

const
  NIS_IBREMOVE = 8;
  {$EXTERNALSYM NIS_IBREMOVE}

function nis_ibremove_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_ibremove_3}
function nis_ibremove_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_ibremove_3_svc}

const
  NIS_IBFIRST = 9;
  {$EXTERNALSYM NIS_IBFIRST}

function nis_ibfirst_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_ibfirst_3}
function nis_ibfirst_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_ibfirst_3_svc}

const
  NIS_IBNEXT = 10;
  {$EXTERNALSYM NIS_IBNEXT}

function nis_ibnext_3(p1: PIbRequest; AClient: PClientRecord): PNisResult; cdecl;
{$EXTERNALSYM nis_ibnext_3}
function nis_ibnext_3_svc(p1: PIbRequest; ServiceReq: PSvcReq): PNisResult; cdecl;
{$EXTERNALSYM nis_ibnext_3_svc}

const
  NIS_FINDDIRECTORY = 12;
  {$EXTERNALSYM NIS_FINDDIRECTORY}

function nis_finddirectory_3(p1: PFdArgs; AClient: PClientRecord): PFdResult; cdecl;
{$EXTERNALSYM nis_finddirectory_3}
function nis_finddirectory_3_svc(p1: PFdArgs; ServiceReq: PSvcReq): PFdResult; cdecl;
{$EXTERNALSYM nis_finddirectory_3_svc}

const
  NIS_STATUS = 14;
  {$EXTERNALSYM NIS_STATUS}

function nis_status_3(p1: PNisTagList; AClient: PClientRecord): PNisTagList; cdecl;
{$EXTERNALSYM nis_status_3}
function nis_status_3_svc(p1: PNisTagList; ServiceReq: PSvcReq): PNisTagList; cdecl;
{$EXTERNALSYM nis_status_3_svc}

const
  NIS_DUMPLOG = 15;
  {$EXTERNALSYM NIS_DUMPLOG}    

function nis_dumplog_3(p1: PDumpArgs; AClient: PClientRecord): PLogResult; cdecl;
{$EXTERNALSYM nis_dumplog_3}
function nis_dumplog_3_svc(p1: PDumpArgs; ServiceReq: PSvcReq): PLogResult; cdecl;
{$EXTERNALSYM nis_dumplog_3_svc}

const
  NIS_DUMP = 16;
  {$EXTERNALSYM NIS_DUMP}

function nis_dump_3(p1: PDumpArgs; AClient: PClientRecord): PLogResult; cdecl;
{$EXTERNALSYM nis_dump_3}
function nis_dump_3_svc(p1: PDumpArgs; ServiceReq: PSvcReq): PLogResult; cdecl;
{$EXTERNALSYM nis_dump_3_svc}

const
  NIS_CALLBACK = 17;
  {$EXTERNALSYM NIS_CALLBACK}

function nis_callback_3(p1: PNetObj; AClient: PClientRecord): Pbool_t; cdecl;
{$EXTERNALSYM nis_callback_3}
function nis_callback_3_svc(p1: PNetObj; ServiceReq: PSvcReq): Pbool_t; cdecl;
{$EXTERNALSYM nis_callback_3_svc}

const
  NIS_CPTIME = 18;
  {$EXTERNALSYM NIS_CPTIME}

function nis_cptime_3(p1: PNisName; AClient: PClientRecord): Puint32_t; cdecl;
{$EXTERNALSYM nis_cptime_3}
function nis_cptime_3_svc(p1: PNisName; ServiceReq: PSvcReq): Puint32_t; cdecl;
{$EXTERNALSYM nis_cptime_3_svc}

const
  _NIS_CHECKPOINT = 19;
  {.$EXTERNALSYM NIS_CHECKPOINT} // Renamed due to identifier conflict

function nis_checkpoint_3(p1: PNisName; AClient: PClientRecord): PCpResult; cdecl;
{$EXTERNALSYM nis_checkpoint_3}
function nis_checkpoint_3_svc(p1: PNisName; ServiceReq: PSvcReq): PCpResult; cdecl;
{$EXTERNALSYM nis_checkpoint_3_svc}

const
  _NIS_PING = 20;
  {.$EXTERNALSYM NIS_PING} // Renamed due to identifier conflict

function nis_ping_3(p1: PPingArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nis_ping_3}
function nis_ping_3_svc(p1: PPingArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nis_ping_3_svc}

const
  _NIS_SERVSTATE = 21;
  {.$EXTERNALSYM NIS_SERVSTATE} // Renamed due to identifier conflict

function nis_servstate_3(p1: PNisTagList; AClient: PClientRecord): PNisTagList; cdecl;
{$EXTERNALSYM nis_servstate_3}
function nis_servstate_3_svc(p1: PNisTagList; ServiceReq: PSvcReq): PNisTagList; cdecl;
{$EXTERNALSYM nis_servstate_3_svc}

const
  _NIS_MKDIR = 22;
  {.$EXTERNALSYM NIS_MKDIR} // Renamed due to identifier conflict

function nis_mkdir_3(p1: PNisName; AClient: PClientRecord): PNisError; cdecl;
{$EXTERNALSYM nis_mkdir_3}
function nis_mkdir_3_svc(p1: PNisName; ServiceReq: PSvcReq): PNisError; cdecl;
{$EXTERNALSYM nis_mkdir_3_svc}

const
  _NIS_RMDIR = 23;
  {.$EXTERNALSYM NIS_RMDIR} // Renamed due to identifier conflict

function nis_rmdir_3(p1: PNisName; AClient: PClientRecord): PNisError; cdecl;
{$EXTERNALSYM nis_rmdir_3}
function nis_rmdir_3_svc(p1: PNisName; ServiceReq: PSvcReq): PNisError; cdecl;
{$EXTERNALSYM nis_rmdir_3_svc}

const
  NIS_UPDKEYS = 24;
  {$EXTERNALSYM NIS_UPDKEYS}

function nis_updkeys_3(p1: PNisName; AClient: PClientRecord): PNisError; cdecl;
{$EXTERNALSYM nis_updkeys_3}
function nis_updkeys_3_svc(p1: PNisName; ServiceReq: PSvcReq): PNisError; cdecl;
{$EXTERNALSYM nis_updkeys_3_svc}


{$HPPEMIT '#include <rpcsvc/nislib.h>'}

// Translated from rpcsvc/nislib.h

type
  const_nis_name = PChar;
  {$EXTERNALSYM const_nis_name}

{ nis_names: These functions are used to locate and manipulate all NIS+
 * objects except the NIS+ entry objects.
 *
 * nis_lookup (name, flags) resolves a NIS+ name and returns a copy of
 *                          that object  from a NIS+ server.
 *    const nis_name name: name of the object to be resolved
 *    unsigned int flags: logically ORing zero or more flags (FOLLOW_LINKS,
 *                          HARD_LOOKUP, [NO_CACHE], MASTER_ONLY, EXPAND_NAME)
 *
 * nis_add (name, obj) adds objects to the NIS+ namespace.
 *    const nis_name name: fully qualified NIS+ name.
 *    const nis_object *obj: object members zo_name and zo_domain will be
 *                           constructed from name.
 *
 * nis_remove (name, obj) removes objects from the NIS+ namespace.
 *    const nis_name name: fully qualified NIS+ name.
 *    const nis_object *obj: if not NULL, it is assumed to point to a copy
 *                           of the object being removed. In this case, if
 *                           the object on the server does not have the same
 *                           object identifier as the  object  being  passed,
 *                           the operation will fail with the NIS_NOTSAMEOBJ
 *                           error.
 *
 * nis_modify (name, obj) can change specific attributes of an object
 *                        that already exists in the namespace.
 }
function nis_lookup(name: const_nis_name; flags: Cardinal): PNisResult; cdecl;
{$EXTERNALSYM nis_lookup}
function nis_add(name: const_nis_name; obj: PNisObject): PNisResult; cdecl;
{$EXTERNALSYM nis_add}
function nis_remove(name: const_nis_name; obj: PNisObject): PNisResult; cdecl;
{$EXTERNALSYM nis_remove}
function nis_modify(name: const_nis_name; obj: PNisObject): PNisResult; cdecl;
{$EXTERNALSYM nis_modify}

{ nis_tables: These functions are used to search and modify NIS+ tables.
 *
 * nis_list (table_name, flags, callback(table_name, obj, userdata), userdata)
 *           search a table in the NIS+ namespace.
 *    const nis_name table_name: indexed name ([xx=yy],table.dir)
 *    unsigned int flags: logically ORing one or more flags (FOLLOW_LINKS,
 *                      [FOLLOW_PATH], HARD_LOOKUP, [ALL_RESULTS], [NO_CACHE],
 *                      MASTER_ONLY, EXPAND_NAME, RETURN_RESULT)
 *    callback(): callback is an optional pointer to a function that will
 *                process the ENTRY type objects that are returned from the
 *                search. If this pointer is NULL, then all entries that match
 *                the search criteria are returned in the nis_result structure,
 *                otherwise  this  function  will  be  called once for each
 *                entry returned.
 *    void *userdata: passed to callback function along with the returned
 *                    entry object.
 *
 * nis_add_entry (table_name, obj, flags) will add the NIS+ object to the
 *                                        NIS+ table_name.
 *    const nis_name table_name
 *    const nis_object *obj
 *    unsigned int flags: 0, ADD_OVERWRITE, RETURN_RESULT
 *
 * nis_modify_entry (name, obj, flags) modifies an object identified by name.
 *    const nis_name name: object identifier
 *    const nis_object *obj: should point to an entry with the EN_MODIFIED
 *                           flag set in each column that contains new
 *                           information.
 *    unsigned int flags: 0, MOD_SAMEOBJ, RETURN_RESULT
 *
 * nis_remove_entry (table_name, obj, flags) removes a set of entries
 *                                 identified by table_name from the table.
 *    const nis_name table_name: indexed NIS+ name
 *    const nis_object *obj: if obj is non-null, it is presumed to point to
 *                           a cached copy of the entry. When the removal is
 *                           attempted, and the object that would be removed
 *                           is not the same as the cached object pointed to
 *                           by object then the operation will fail with an
 *                           NIS_NOTSAMEOBJ error
 *    unsigned int flags: 0, REM_MULTIPLE
 *
 * nis_first_entry (table_name) fetches entries from a table one at a time.
 *    const nis_name table_name
 *
 * nis_next_entry (table_name, cookie) retrieves the "next" entry from a
 *                                     table specified by table_name.
 *    const nis_name table_name:
 *    const netobj *cookie: The value of cookie from the nis_result structure
 *                          form the previous call.
 }
type
  TNisListCallback = function(table_name: const_nis_name; obj: PNisObject;
                       userdata: Pointer): Integer; cdecl;

function nis_list(name: const_nis_name; flags: Cardinal; callback: TNisListCallback;
  userdata: Pointer): PNisResult; cdecl;
{$EXTERNALSYM nis_list}
function nis_add_entry(table_name: const_nis_name; obj: PNisObject; flags: Cardinal): PNisResult; cdecl;
{$EXTERNALSYM nis_add_entry}
function nis_modify_entry(name: const_nis_name; obj: PNisObject; flags: Cardinal): PNisResult; cdecl;
{$EXTERNALSYM nis_modify_entry}
function nis_remove_entry(table_name: const_nis_name; obj: PNisObject; flags: Cardinal): PNisResult; cdecl;
{$EXTERNALSYM nis_remove_entry}
function nis_first_entry(table_name: const_nis_name): PNisResult; cdecl;
{$EXTERNALSYM nis_first_entry}
function nis_next_entry(table_name: const_nis_name; cookie: PNetObj): PNisResult; cdecl;
{$EXTERNALSYM nis_next_entry}
{ nis_server }
function nis_mkdir(dir_name: const_nis_name; machine: PNisServer): nis_error; cdecl;
{$EXTERNALSYM nis_mkdir}
function nis_rmdir(dir_name: const_nis_name; machine: PNisServer): nis_error; cdecl;
{$EXTERNALSYM nis_rmdir}
function nis_servstate(machine: PNisServer; tags: PNisTag; numtags: Integer;
  var result: PNisTag): nis_error; cdecl;
{$EXTERNALSYM nis_servstate}
function nis_stats(machine: PNisServer; tags: PNisTag; numtags: Integer;
  var result: PNisTag): nis_error; cdecl;
{$EXTERNALSYM nis_stats}
procedure nis_freetags(tags: PNisTag; numtags: Integer); cdecl;
{$EXTERNALSYM nis_freetags}
function nis_getservlist(dirname: const_nis_name): PPNisServer; cdecl;
{$EXTERNALSYM nis_getservlist}
procedure nis_freeservlist(var machines: PNisServer); cdecl;
{$EXTERNALSYM nis_freeservlist}

{ nis_subr }
function nis_leaf_of(name: const_nis_name): nis_name; cdecl;
{$EXTERNALSYM nis_leaf_of}
function nis_leaf_of_r(name: const_nis_name; buffer: PChar; buflen: size_t): nis_name; cdecl;
{$EXTERNALSYM nis_leaf_of_r}
function nis_name_of(name: const_nis_name): nis_name; cdecl;
{$EXTERNALSYM nis_name_of}
function nis_name_of_r(name: const_nis_name; buffer: PChar; buflen: size_t): nis_name; cdecl;
{$EXTERNALSYM nis_name_of_r}
function nis_domain_of(name: const_nis_name): nis_name; cdecl;
{$EXTERNALSYM nis_domain_of}
function nis_domain_of_r(name: const_nis_name; buffer: PChar; buflen: size_t): nis_name; cdecl;
{$EXTERNALSYM nis_domain_of_r}
function nis_getnames(name: const_nis_name): PNisName; cdecl;
{$EXTERNALSYM nis_getnames}
procedure nis_freenames(namelist: PNisName); cdecl;
{$EXTERNALSYM nis_freenames}
function nis_dir_cmp(n1: const_nis_name; n2: const_nis_name): name_pos; cdecl;
{$EXTERNALSYM nis_dir_cmp}
function nis_clone_object(src: PNisObject; dest: PNisObject): PNisObject; cdecl;
{$EXTERNALSYM nis_clone_object}
procedure nis_destroy_object(obj: PNisObject); cdecl;
{$EXTERNALSYM nis_destroy_object}
procedure nis_print_object(obj: PNisObject); cdecl;
{$EXTERNALSYM nis_print_object}

{ nis_local_names }
function nis_local_group(): nis_name; cdecl;
{$EXTERNALSYM nis_local_group}
function nis_local_directory(): nis_name; cdecl;
{$EXTERNALSYM nis_local_directory}
function nis_local_principal(): nis_name; cdecl;
{$EXTERNALSYM nis_local_principal}
function nis_local_host(): nis_name; cdecl;
{$EXTERNALSYM nis_local_host}

{ nis_error }
function nis_sperrno(status: nis_error): PChar; cdecl;
{$EXTERNALSYM nis_sperrno}
procedure nis_perror(status: nis_error; __label: PChar); cdecl;
{$EXTERNALSYM nis_perror}
procedure nis_lerror(status: nis_error; __label: PChar); cdecl;
{$EXTERNALSYM nis_lerror}
function nis_sperror(status: nis_error; __label: PChar): PChar; cdecl;
{$EXTERNALSYM nis_sperror}
function nis_sperror_r(status: nis_error; __label: PChar; buffer: PChar; buflen: size_t): PChar; cdecl;
{$EXTERNALSYM nis_sperror_r}
{ nis_groups }
function nis_ismember(principal: const_nis_name; group: const_nis_name): bool_t; cdecl;
{$EXTERNALSYM nis_ismember}
function nis_addmember(member: const_nis_name; group: const_nis_name): nis_error; cdecl;
{$EXTERNALSYM nis_addmember}
function nis_removemember(member: const_nis_name; group: const_nis_name): nis_error; cdecl;
{$EXTERNALSYM nis_removemember}
function nis_creategroup(group: const_nis_name; flags: Cardinal): nis_error; cdecl;
{$EXTERNALSYM nis_creategroup}
function nis_destroygroup(group: const_nis_name): nis_error; cdecl;
{$EXTERNALSYM nis_destroygroup}
procedure nis_print_group_entry(group: const_nis_name); cdecl;
{$EXTERNALSYM nis_print_group_entry}
function nis_verifygroup(group: const_nis_name): nis_error; cdecl;
{$EXTERNALSYM nis_verifygroup}

{ nis_ping }
procedure nis_ping(dirname: const_nis_name; utime: uint32_t; dirobj: PNisObject); cdecl;
{$EXTERNALSYM nis_ping}
function nis_checkpoint(dirname: const_nis_name): PNisResult; cdecl;
{$EXTERNALSYM nis_checkpoint}

{ nis_print (XXX INTERNAL FUNCTIONS, SHOULD NOT BE USED !!) }
procedure nis_print_result(result: PNisResult); cdecl;
{$EXTERNALSYM nis_print_result}
procedure nis_print_rights(rights: Cardinal); cdecl;
{$EXTERNALSYM nis_print_rights}
procedure nis_print_directory(dirobj: PDirectoryObj); cdecl;
{$EXTERNALSYM nis_print_directory}
procedure nis_print_group(grpobj: PGroupObj); cdecl;
{$EXTERNALSYM nis_print_group}
procedure nis_print_table(tblobj: PTableObj); cdecl;
{$EXTERNALSYM nis_print_table}
procedure nis_print_link(lnkobj: PLinkObj); cdecl;
{$EXTERNALSYM nis_print_link}
procedure nis_print_entry(enobj: PEntryObj); cdecl;
{$EXTERNALSYM nis_print_entry}

{ nis_file (XXX INTERNAL FUNCTIONS, SHOULD NOT BE USED !!) }
function readColdStartFile(): PDirectoryObj; cdecl;
{$EXTERNALSYM readColdStartFile}
function writeColdStartFile(dirobj: PDirectoryObj): bool_t; cdecl;
{$EXTERNALSYM writeColdStartFile}
function nis_read_obj(obj: PChar): PNisObject; cdecl;
{$EXTERNALSYM nis_read_obj}
function nis_write_obj(__file: PChar; obj: PNisObject): bool_t; cdecl;
{$EXTERNALSYM nis_write_obj}

{ nis_clone - (XXX INTERNAL FUNCTIONS, SHOULD NOT BE USED !!) }
function nis_clone_directory(src: PDirectoryObj; dest: PDirectoryObj): PDirectoryObj; cdecl;
{$EXTERNALSYM nis_clone_directory}
function nis_clone_result(src: PNisResult; dest: PNisResult): PNisResult; cdecl;
{$EXTERNALSYM nis_clone_result}

{ nis_free - nis_freeresult }
procedure nis_freeresult(result: PNisResult); cdecl;
{$EXTERNALSYM nis_freeresult}
{ (XXX THE FOLLOWING ARE INTERNAL FUNCTIONS, SHOULD NOT BE USED !!) }
procedure nis_free_request(req: PIbRequest); cdecl;
{$EXTERNALSYM nis_free_request}
procedure nis_free_directory(dirobj: PDirectoryObj); cdecl;
{$EXTERNALSYM nis_free_directory}
procedure nis_free_object(obj: PNisObject); cdecl;
{$EXTERNALSYM nis_free_object}

{ (XXX INTERNAL FUNCTIONS, SHOULD NOT BE USED !!) }
function __nis_default_owner(p1: PChar): nis_name; cdecl;
{$EXTERNALSYM __nis_default_owner}
function __nis_default_group(p1: PChar): nis_name; cdecl;
{$EXTERNALSYM __nis_default_group}
function __nis_default_ttl(p1: PChar): uint32_t; cdecl;
{$EXTERNALSYM __nis_default_ttl}
function __nis_default_access(p1: PChar; p2: Cardinal): Cardinal; cdecl;
{$EXTERNALSYM __nis_default_access}
function __nis_finddirectory(p1: PDirectoryObj; p2: const_nis_name): PFdResult; cdecl;
{$EXTERNALSYM __nis_finddirectory}
procedure __free_fdresult(p1: PFdResult); cdecl;
{$EXTERNALSYM __free_fdresult}
function __nis_hash(keyarg: Pointer; len: size_t): uint32_t; cdecl;
{$EXTERNALSYM __nis_hash}

{ NIS+ cache locking }
function __nis_lock_cache(): Integer; cdecl;
{$EXTERNALSYM __nis_lock_cache}
function __nis_unlock_cache(): Integer; cdecl;
{$EXTERNALSYM __nis_unlock_cache}


{$HPPEMIT '#include <rpcsvc/nis_callback.h>'}

// Translated from rpcsvc/nis_callback.h

type
  obj_p = PNisObject;
  {$EXTERNALSYM obj_p}
  PObjP = ^obj_p;

  cback_data = {packed} record
    entries: {packed} record
      entries_len: u_int;
      entries_val: PObjP;
    end;
  end;
  {$EXTERNALSYM cback_data}
  TCBackData = cback_data;
  PCBackData = ^TCBackData;

const
  CB_PROG = 100302;
  {$EXTERNALSYM CB_PROG}
  CB_VERS = 1;
  {$EXTERNALSYM CB_VERS}

const
  CBPROC_RECEIVE = 1;
  {$EXTERNALSYM CBPROC_RECEIVE}

function cbproc_receive_1(p1: PCBackData; AClient: PClientRecord): Pbool_t; cdecl;
{$EXTERNALSYM cbproc_receive_1}
function cbproc_receive_1_svc(p1: PCBackData; ServiceReq: PSvcReq): Pbool_t; cdecl;
{$EXTERNALSYM cbproc_receive_1_svc}

const
  CBPROC_FINISH = 2;
  {$EXTERNALSYM CBPROC_FINISH}

function cbproc_finish_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM cbproc_finish_1}
function cbproc_finish_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM cbproc_finish_1_svc}

const
  CBPROC_ERROR = 3;
  {$EXTERNALSYM CBPROC_ERROR}

function cbproc_error_1(p1: PNisError; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM cbproc_error_1}
function cbproc_error_1_svc(p1: PNisError; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM cbproc_error_1_svc}

function cb_prog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM cb_prog_1_freeresult}

{ the xdr functions }
function xdr_obj_p(__xdr: PXdr; p2: PObjP): bool_t; cdecl;
{$EXTERNALSYM xdr_obj_p}
function xdr_cback_data(__xdr: PXdr; p2: PCBackData): bool_t; cdecl;
{$EXTERNALSYM xdr_cback_data}


{$HPPEMIT '#include <rpcsvc/nlm_prot.h>}

// Translated from rpcsvc/nlm_prot.h

const
  LM_MAXSTRLEN   = 1024;
  {$EXTERNALSYM LM_MAXSTRLEN}
  MAXNAMELEN     = LM_MAXSTRLEN+1;
  {$EXTERNALSYM MAXNAMELEN}

type
  nlm_stats =
  (
    nlm_granted = 0,
    {$EXTERNALSYM nlm_granted}
    nlm_denied = 1,
    {$EXTERNALSYM nlm_denied}
    nlm_denied_nolocks = 2,
    {$EXTERNALSYM nlm_denied_nolocks}
    nlm_blocked = 3,
    {$EXTERNALSYM nlm_blocked}
    nlm_denied_grace_period = 4
    {$EXTERNALSYM nlm_denied_grace_period}
  );
  {$EXTERNALSYM nlm_stats}

type
  nlm_holder = {packed} record
    exclusive: bool_t;
    svid: Integer;
    oh: netobj;
    l_offset: u_int;
    l_len: u_int;
  end;
  {$EXTERNALSYM nlm_holder}

  nlm_testrply = {packed} record
    stat: nlm_stats;
    nlm_testrply_u: {packed} record
                      case Integer of
                        0: (holder: nlm_holder);
                      end;
  end;
  {$EXTERNALSYM nlm_testrply}

  nlm_stat = {packed} record
    stat: nlm_stats;
  end;
  {$EXTERNALSYM nlm_stat}

  nlm_res = {packed} record
    cookie: netobj;
    stat: nlm_stat;
  end;
  {$EXTERNALSYM nlm_res}
  TNlmRes = nlm_res;
  PNlmRes = ^TNlmRes;

  nlm_testres = {packed} record
    cookie: netobj;
    stat: nlm_testrply;
  end;
  {$EXTERNALSYM nlm_testres}
  TNlmTestRes = nlm_testres;
  PNlmTestRes = ^TNlmTestRes;

  nlm_lock = {packed} record
    caller_name: PChar;
    fh: netobj;
    oh: netobj;
    svid: Integer;
    l_offset: u_int;
    l_len: u_int;
  end;
  {$EXTERNALSYM nlm_lock}
  TNlmLock = nlm_lock;
  PNlmLock = ^TNlmLock;

  nlm_lockargs = {packed} record
    cookie: netobj;
    block: bool_t;
    exclusive: bool_t;
    alock: nlm_lock;
    reclaim: bool_t;
    state: Integer;
  end;
  {$EXTERNALSYM nlm_lockargs}
  TNlmLockArgs = nlm_lockargs;
  PNlmLockArgs = ^TNlmLockArgs;

  nlm_cancargs = {packed} record
    cookie: netobj;
    block: bool_t;
    exclusive: bool_t;
    alock: nlm_lock;
  end;
  {$EXTERNALSYM nlm_cancargs}
  TNlmCancArgs = nlm_cancargs;
  PNlmCancArgs = ^TNlmCancArgs;

  nlm_testargs = {packed} record
    cookie: netobj;
    exclusive: bool_t;
    alock: nlm_lock;
  end;
  {$EXTERNALSYM nlm_testargs}
  TNlmTestArgs = nlm_testargs;
  PNlmTestArgs = ^TNlmTestArgs;

  nlm_unlockargs = {packed} record
    cookie: netobj;
    alock: nlm_lock;
  end;
  {$EXTERNALSYM nlm_unlockargs}
  TNlmUnlockArgs = nlm_unlockargs;
  PNlmUnlockArgs = ^TNlmUnlockArgs;

{
 * The following enums are actually bit encoded for efficient
 * boolean algebra.... DON'T change them.....
 }

type
  fsh_mode =
  (
    fsm_DN = 0,
    {$EXTERNALSYM fsm_DN}
    fsm_DR = 1,
    {$EXTERNALSYM fsm_DR}
    fsm_DW = 2,
    {$EXTERNALSYM fsm_DW}
    fsm_DRW = 3
    {$EXTERNALSYM fsm_DRW}
  );
  {$EXTERNALSYM fsh_mode}

  fsh_access =
  (
    fsa_NONE = 0,
    {$EXTERNALSYM fsa_NONE}
    fsa_R = 1,
    {$EXTERNALSYM fsa_R}
    fsa_W = 2,
    {$EXTERNALSYM fsa_W}
    fsa_RW = 3
    {$EXTERNALSYM fsa_RW}
  );
  {$EXTERNALSYM fsh_access}

type
  nlm_share = {packed} record
    caller_name: PChar;
    fh: netobj;
    oh: netobj;
    mode: fsh_mode;
    access: fsh_access;
  end;
  {$EXTERNALSYM nlm_share}
  TNlmShare = nlm_share;
  PNlmShare = ^TNlmShare;

  nlm_shareargs = {packed} record
    cookie: netobj;
    share: nlm_share;
    reclaim: bool_t;
  end;
  {$EXTERNALSYM nlm_shareargs}
  TNlmShareArgs = nlm_shareargs;
  PNlmShareArgs = ^TNlmShareArgs;

  nlm_shareres = {packed} record
    cookie: netobj;
    stat: nlm_stats;
    sequence: Integer;
  end;
  {$EXTERNALSYM nlm_shareres}
  TNlmShareRes = nlm_shareres;
  PNlmShareRes = ^TNlmShareRes;

  nlm_notify = {packed} record
    name: PChar;
    state: Longint;
  end;
  {$EXTERNALSYM nlm_notify}
  TNlmNotify = nlm_notify;
  PNlmNotify = ^TNlmNotify;

const
  NLM_PROG = 100021;
  {$EXTERNALSYM NLM_PROG}
  NLM_VERS = 1;
  {$EXTERNALSYM NLM_VERS}


const
  NLM_TEST = 1;
  {$EXTERNALSYM NLM_TEST}

function nlm_test_1(p1: PNlmTestArgs; AClient: PClientRecord): PNlmTestRes; cdecl;
{$EXTERNALSYM nlm_test_1}
function nlm_test_1_svc(p1: PNlmTestArgs; ServiceReq: PSvcReq): PNlmTestRes; cdecl;
{$EXTERNALSYM nlm_test_1_svc}

const
  _NLM_LOCK = 2;
  {.$EXTERNALSYM NLM_LOCK} // Renamed due to identifier conflict

function nlm_lock_1(p1: PNlmLockArgs; AClient: PClientRecord): PNlmRes; cdecl;
{$EXTERNALSYM nlm_lock_1}
function nlm_lock_1_svc(p1: PNlmLockArgs; ServiceReq: PSvcReq): PNlmRes; cdecl;
{$EXTERNALSYM nlm_lock_1_svc}

const
  NLM_CANCEL = 3;
  {$EXTERNALSYM NLM_CANCEL}

function nlm_cancel_1(p1: PNlmCancArgs; AClient: PClientRecord): PNlmRes; cdecl;
{$EXTERNALSYM nlm_cancel_1}
function nlm_cancel_1_svc(p1: PNlmCancArgs; ServiceReq: PSvcReq): PNlmRes; cdecl;
{$EXTERNALSYM nlm_cancel_1_svc}

const
  NLM_UNLOCK = 4;
  {$EXTERNALSYM NLM_UNLOCK}

function nlm_unlock_1(p1: PNlmUnlockArgs; AClient: PClientRecord): PNlmRes; cdecl;
{$EXTERNALSYM nlm_unlock_1}
function nlm_unlock_1_svc(p1: PNlmUnlockArgs; ServiceReq: PSvcReq): PNlmRes; cdecl;
{$EXTERNALSYM nlm_unlock_1_svc}

const
  _NLM_GRANTED = 5;
  {.$EXTERNALSYM NLM_GRANTED} // Renamed due to identifier conflict

function nlm_granted_1(p1: PNlmTestArgs; AClient: PClientRecord): PNlmRes; cdecl;
{$EXTERNALSYM nlm_granted_1}
function nlm_granted_1_svc(p1: PNlmTestArgs; ServiceReq: PSvcReq): PNlmRes; cdecl;
{$EXTERNALSYM nlm_granted_1_svc}

const
  NLM_TEST_MSG = 6;
  {$EXTERNALSYM NLM_TEST_MSG}

function nlm_test_msg_1(p1: PNlmTestArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_test_msg_1}
function nlm_test_msg_1_svc(p1: PNlmTestArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_test_msg_1_svc}

const
  NLM_LOCK_MSG = 7;
  {$EXTERNALSYM NLM_LOCK_MSG}

function nlm_lock_msg_1(p1: PNlmLockArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_lock_msg_1}
function nlm_lock_msg_1_svc(p1: PNlmLockArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_lock_msg_1_svc}

const
  NLM_CANCEL_MSG = 8;
  {$EXTERNALSYM NLM_CANCEL_MSG}

function nlm_cancel_msg_1(p1: PNlmCancArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_cancel_msg_1}
function nlm_cancel_msg_1_svc(p1: PNlmCancArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_cancel_msg_1_svc}

const
  NLM_UNLOCK_MSG = 9;
  {$EXTERNALSYM NLM_UNLOCK_MSG}

function nlm_unlock_msg_1(p1: PNlmUnlockArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_unlock_msg_1}
function nlm_unlock_msg_1_svc(p1: PNlmUnlockArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_unlock_msg_1_svc}

const
  NLM_GRANTED_MSG = 10;
  {$EXTERNALSYM NLM_GRANTED_MSG}

function nlm_granted_msg_1(p1: PNlmTestArgs; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_granted_msg_1}
function nlm_granted_msg_1_svc(p1: PNlmTestArgs; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_granted_msg_1_svc}

const
  NLM_TEST_RES = 11;
  {$EXTERNALSYM NLM_TEST_RES}

function nlm_test_res_1(p1: PNlmTestRes; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_test_res_1}
function nlm_test_res_1_svc(p1: PNlmTestRes; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_test_res_1_svc}

const
  NLM_LOCK_RES = 12;
  {$EXTERNALSYM NLM_LOCK_RES}

function nlm_lock_res_1(p1: PNlmRes; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_lock_res_1}
function nlm_lock_res_1_svc(p1: PNlmRes; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_lock_res_1_svc}

const
  NLM_CANCEL_RES = 13;
  {$EXTERNALSYM NLM_CANCEL_RES}

function nlm_cancel_res_1(p1: PNlmRes; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_cancel_res_1}
function nlm_cancel_res_1_svc(p1: PNlmRes; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_cancel_res_1_svc}

const
  NLM_UNLOCK_RES = 14;
  {$EXTERNALSYM NLM_UNLOCK_RES}

function nlm_unlock_res_1(p1: PNlmRes; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_unlock_res_1}
function nlm_unlock_res_1_svc(p1: PNlmRes; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_unlock_res_1_svc}

const
  NLM_GRANTED_RES = 15;
  {$EXTERNALSYM NLM_GRANTED_RES}

function nlm_granted_res_1(p1: PNlmRes; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_granted_res_1}
function nlm_granted_res_1_svc(p1: PNlmRes; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_granted_res_1_svc}

function nlm_prog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM nlm_prog_1_freeresult}

const
  NLM_VERSX = 3;
  {$EXTERNALSYM NLM_VERSX}

const
  _NLM_SHARE = 20;
  {.$EXTERNALSYM NLM_SHARE} // Renamed due to identifier conflict

function nlm_share_3(p1: PNlmShareArgs; AClient: PClientRecord): PNlmShareRes; cdecl;
{$EXTERNALSYM nlm_share_3}
function nlm_share_3_svc(p1: PNlmShareArgs; ServiceReq: PSvcReq): PNlmShareRes; cdecl;
{$EXTERNALSYM nlm_share_3_svc}

const
  NLM_UNSHARE = 21;
  {$EXTERNALSYM NLM_UNSHARE}

function nlm_unshare_3(p1: PNlmShareArgs; AClient: PClientRecord): PNlmShareRes; cdecl;
{$EXTERNALSYM nlm_unshare_3}
function nlm_unshare_3_svc(p1: PNlmShareArgs; ServiceReq: PSvcReq): PNlmShareRes; cdecl;
{$EXTERNALSYM nlm_unshare_3_svc}

const
  NLM_NM_LOCK = 22;
  {$EXTERNALSYM NLM_NM_LOCK}

function nlm_nm_lock_3(p1: PNlmLockArgs; AClient: PClientRecord): PNlmRes; cdecl;
{$EXTERNALSYM nlm_nm_lock_3}
function nlm_nm_lock_3_svc(p1: PNlmLockArgs; ServiceReq: PSvcReq): PNlmRes; cdecl;
{$EXTERNALSYM nlm_nm_lock_3_svc}

const
  NLM_FREE_ALL = 23;
  {$EXTERNALSYM NLM_FREE_ALL}

function nlm_free_all_3(p1: PNlmNotify; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM nlm_free_all_3}
function nlm_free_all_3_svc(p1: PNlmNotify; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM nlm_free_all_3_svc}

function nlm_prog_3_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM nlm_prog_3_freeresult}

{ the xdr functions }

function xdr_nlm_stats(__xdr: PXdr; var __nlm_stats: nlm_stats): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_stats}
function xdr_nlm_holder(__xdr: PXdr; var __nlm_holder: nlm_holder): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_holder}
function xdr_nlm_testrply(__xdr: PXdr; var __nlm_testrply: nlm_testrply): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_testrply}
function xdr_nlm_stat(__xdr: PXdr; var __nlm_stat: nlm_stat): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_stat}
function xdr_nlm_res(__xdr: PXdr; var __nlm_res: nlm_res): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_res}
function xdr_nlm_testres(__xdr: PXdr; var __nlm_testres: nlm_testres): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_testres}
function xdr_nlm_lock(__xdr: PXdr; var __nlm_lock: nlm_lock): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_lock}
function xdr_nlm_lockargs(__xdr: PXdr; var __nlm_lockargs: nlm_lockargs): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_lockargs}
function xdr_nlm_cancargs(__xdr: PXdr; var __nlm_cancargs: nlm_cancargs): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_cancargs}
function xdr_nlm_testargs(__xdr: PXdr; var __nlm_testargs: nlm_testargs): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_testargs}
function xdr_nlm_unlockargs(__xdr: PXdr; var __nlm_unlockargs: nlm_unlockargs): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_unlockargs}
function xdr_fsh_mode(__xdr: PXdr; var __fsh_mode: fsh_mode): bool_t; cdecl;
{$EXTERNALSYM xdr_fsh_mode}
function xdr_fsh_access(__xdr: PXdr; var __fsh_access: fsh_access): bool_t; cdecl;
{$EXTERNALSYM xdr_fsh_access}
function xdr_nlm_share(__xdr: PXdr; var __nlm_share: nlm_share): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_share}
function xdr_nlm_shareargs(__xdr: PXdr; var __nlm_shareargs: nlm_shareargs): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_shareargs}
function xdr_nlm_shareres(__xdr: PXdr; var __nlm_shareres: nlm_shareres): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_shareres}
function xdr_nlm_notify(__xdr: PXdr; var __nlm_notify: nlm_notify): bool_t; cdecl;
{$EXTERNALSYM xdr_nlm_notify}


{$HPPEMIT '#include <rpcsvc/rex.h>}

// Translated from rpcsvc/rex.h

const
  STRINGSIZE = 1024;
  {$EXTERNALSYM STRINGSIZE}

type
  rexstring = PChar;
  {$EXTERNALSYM rexstring}
  PRexString = ^rexstring;

const
  SIGINT = 2;
  {$EXTERNALSYM SIGINT}
  REX_INTERACTIVE = 1;
  {$EXTERNALSYM REX_INTERACTIVE}

type
  rex_start = {packed} record
    rst_cmd: {packed} record
      rst_cmd_len: u_int;
      rst_cmd_val: PRexString;
    end;
    rst_host: rexstring;
    rst_fsname: rexstring;
    rst_dirwithin: rexstring;
    rst_env: {packed} record
      rst_env_len: u_int;
      rst_env_val: RexString;
    end;
    rst_port0: u_int;
    rst_port1: u_int;
    rst_port2: u_int;
    rst_flags: u_int;
  end;
  {$EXTERNALSYM rex_start}
  TRexStart = rex_start;
  PRexStart = ^TRexStart;

  rex_result = {packed} record
    rlt_stat: Integer;
    rlt_message: rexstring;
  end;
  {$EXTERNALSYM rex_result}
  TRexResult = rex_result;
  PRexResult = ^TRexResult; 

  sgttyb = {packed} record
    four: u_int;
    chars: packed array[0..4-1] of Char;
    flags: u_int;
  end;
  {$EXTERNALSYM sgttyb}

const
  B0 = 0;
  {$EXTERNALSYM B0}
  B50 = 1;
  {$EXTERNALSYM B50}
  B75 = 2;
  {$EXTERNALSYM B75}
  B110 = 3;
  {$EXTERNALSYM B110}
  B134 = 4;
  {$EXTERNALSYM B134}
  B150 = 5;
  {$EXTERNALSYM B150}
  B200 = 6;
  {$EXTERNALSYM B200}
  B300 = 7;
  {$EXTERNALSYM B300}
  B600 = 8;
  {$EXTERNALSYM B600}
  B1200 = 9;
  {$EXTERNALSYM B1200}
  B1800 = 10;
  {$EXTERNALSYM B1800}
  B2400 = 11;
  {$EXTERNALSYM B2400}
  B4800 = 12;
  {$EXTERNALSYM B4800}
  B9600 = 13;
  {$EXTERNALSYM B9600}
  B19200 = 14;
  {$EXTERNALSYM B19200}
  B38400 = 15;
  {$EXTERNALSYM B38400}
  TANDEM = $00000001;
  {$EXTERNALSYM TANDEM}
  CBREAK = $00000002;
  {$EXTERNALSYM CBREAK}
  LCASE = $00000004;
  {$EXTERNALSYM LCASE}
  ECHO = $00000008;
  {$EXTERNALSYM ECHO}
  CRMOD = $00000010;
  {$EXTERNALSYM CRMOD}
  RAW = $00000020;
  {$EXTERNALSYM RAW}
  ODDP = $00000040;
  {$EXTERNALSYM ODDP}
  EVENP = $00000080;
  {$EXTERNALSYM EVENP}
  ANYP = $000000c0;
  {$EXTERNALSYM ANYP}
  NLDELAY = $00000300;
  {$EXTERNALSYM NLDELAY}
  NL0 = $00000000;
  {$EXTERNALSYM NL0}
  NL1 = $00000100;
  {$EXTERNALSYM NL1}
  NL2 = $00000200;
  {$EXTERNALSYM NL2}
  NL3 = $00000300;
  {$EXTERNALSYM NL3}
  TBDELAY = $00000c00;
  {$EXTERNALSYM TBDELAY}
  TAB0 = $00000000;
  {$EXTERNALSYM TAB0}
  TAB1 = $00000400;
  {$EXTERNALSYM TAB1}
  TAB2 = $00000800;
  {$EXTERNALSYM TAB2}
  XTABS = $00000c00;
  {$EXTERNALSYM XTABS}
  CRDELAY = $00003000;
  {$EXTERNALSYM CRDELAY}
  CR0 = $00000000;
  {$EXTERNALSYM CR0}
  CR1 = $00001000;
  {$EXTERNALSYM CR1}
  CR2 = $00002000;
  {$EXTERNALSYM CR2}
  CR3 = $00003000;
  {$EXTERNALSYM CR3}
  VTDELAY = $00004000;
  {$EXTERNALSYM VTDELAY}
  FF0 = $00000000;
  {$EXTERNALSYM FF0}
  FF1 = $00004000;
  {$EXTERNALSYM FF1}
  BSDELAY = $00008000;
  {$EXTERNALSYM BSDELAY}
  BS0 = $00000000;
  {$EXTERNALSYM BS0}
  BS1 = $00008000;
  {$EXTERNALSYM BS1}
  CRTBS = $00010000;
  {$EXTERNALSYM CRTBS}
  PRTERA = $00020000;
  {$EXTERNALSYM PRTERA}
  CRTERA = $00040000;
  {$EXTERNALSYM CRTERA}
  TILDE = $00080000;
  {$EXTERNALSYM TILDE}
  MDMBUF = $00100000;
  {$EXTERNALSYM MDMBUF}
  LITOUT = $00200000;
  {$EXTERNALSYM LITOUT}
  TOSTOP = $00400000;
  {$EXTERNALSYM TOSTOP}
  FLUSHO = $00800000;
  {$EXTERNALSYM FLUSHO}
  NOHANG = $01000000;
  {$EXTERNALSYM NOHANG}
  L001000 = $02000000;
  {$EXTERNALSYM L001000}
  CRTKIL = $04000000;
  {$EXTERNALSYM CRTKIL}
  PASS8 = $08000000;
  {$EXTERNALSYM PASS8}
  CTLECH = $10000000;
  {$EXTERNALSYM CTLECH}
  PENDIN = $20000000;
  {$EXTERNALSYM PENDIN}
  DECCTQ = $40000000;
  {$EXTERNALSYM DECCTQ}
  NOFLSH = $80000000;
  {$EXTERNALSYM NOFLSH}

type
  tchars = {packed} record
    six: u_int;
    chars: packed array[0..6-1] of Char;
  end;
  {$EXTERNALSYM tchars}

  ltchars = {packed} record
    six: u_int;
    chars: packed array[0..6-1] of Char;
    mode: u_int;
  end;
  {$EXTERNALSYM ltchars}

  rex_ttysize = {packed} record
    ts_lines: Integer;
    ts_cols: Integer;
  end;
  {$EXTERNALSYM rex_ttysize}
  TRexTtySize = rex_ttysize;
  PRexTtySize = ^TRexTtySize;

  rex_ttymode = {packed} record
    basic: sgttyb;
    more: tchars;
    yetmore: ltchars;
    andmore: u_int;
  end;
  {$EXTERNALSYM rex_ttymode}
  TRexTtyMode = rex_ttymode;
  PRexTtyMode = ^TRexTtyMode;

const
  LCRTBS = $0001;
  {$EXTERNALSYM LCRTBS}
  LPRTERA = $0002;
  {$EXTERNALSYM LPRTERA}
  LCRTERA = $0004;
  {$EXTERNALSYM LCRTERA}
  LTILDE = $0008;
  {$EXTERNALSYM LTILDE}
  LMDMBUF = $0010;
  {$EXTERNALSYM LMDMBUF}
  LLITOUT = $0020;
  {$EXTERNALSYM LLITOUT}
  LTOSTOP = $0040;
  {$EXTERNALSYM LTOSTOP}
  LFLUSHO = $0080;
  {$EXTERNALSYM LFLUSHO}
  LNOHANG = $0100;
  {$EXTERNALSYM LNOHANG}
  LL001000 = $0200;
  {$EXTERNALSYM LL001000}
  LCRTKIL = $0400;
  {$EXTERNALSYM LCRTKIL}
  LPASS8 = $0800;
  {$EXTERNALSYM LPASS8}
  LCTLECH = $1000;
  {$EXTERNALSYM LCTLECH}
  LPENDIN = $2000;
  {$EXTERNALSYM LPENDIN}
  LDECCTQ = $4000;
  {$EXTERNALSYM LDECCTQ}
  LNOFLSH = $8000;
  {$EXTERNALSYM LNOFLSH}

  REXPROG = 100017;
  {$EXTERNALSYM REXPROG}
  REXVERS = 1;
  {$EXTERNALSYM REXVERS}

const
  REXPROC_START = 1;
  {$EXTERNALSYM REXPROC_START}

function rexproc_start_1(p1: PRexStart; AClient: PClientRecord): PRexResult; cdecl;
{$EXTERNALSYM rexproc_start_1}
function rexproc_start_1_svc(p1: PRexStart; ServiceReq: PSvcReq): PRexResult; cdecl;
{$EXTERNALSYM rexproc_start_1_svc}

const
  REXPROC_WAIT = 2;
  {$EXTERNALSYM REXPROC_WAIT}

function rexproc_wait_1(p1: Pointer; AClient: PClientRecord): PRexResult; cdecl;
{$EXTERNALSYM rexproc_wait_1}
function rexproc_wait_1_svc(p1: Pointer; ServiceReq: PSvcReq): PRexResult; cdecl;
{$EXTERNALSYM rexproc_wait_1_svc}

const
  REXPROC_MODES = 3;
  {$EXTERNALSYM REXPROC_MODES}

function rexproc_modes_1(p1: PRexTtyMode; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM rexproc_modes_1}
function rexproc_modes_1_svc(p1: PRexTtyMode; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM rexproc_modes_1_svc}

const
  REXPROC_WINCH = 4;
  {$EXTERNALSYM REXPROC_WINCH}

function rexproc_winch_1(p1: PRexTtySize; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM rexproc_winch_1}
function rexproc_winch_1_svc(p1: PRexTtySize; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM rexproc_winch_1_svc}

const
  REXPROC_SIGNAL = 5;
  {$EXTERNALSYM REXPROC_SIGNAL}

function rexproc_signal_1(p1: PInteger; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM rexproc_signal_1}
function rexproc_signal_1_svc(p1: PInteger; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM rexproc_signal_1_svc}

function rexprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rexprog_1_freeresult}

{ the xdr functions }

function xdr_rexstring(__xdr: PXdr; var __rexstring: rexstring): bool_t; cdecl;
{$EXTERNALSYM xdr_rexstring}
function xdr_rex_start(__xdr: PXdr; var __rex_start: rex_start): bool_t; cdecl;
{$EXTERNALSYM xdr_rex_start}
function xdr_rex_result(__xdr: PXdr; var __rex_result: rex_result): bool_t; cdecl;
{$EXTERNALSYM xdr_rex_result}
function xdr_sgttyb(__xdr: PXdr; var __sgttyb: sgttyb): bool_t; cdecl;
{$EXTERNALSYM xdr_sgttyb}
function xdr_tchars(__xdr: PXdr; var __tchars: tchars): bool_t; cdecl;
{$EXTERNALSYM xdr_tchars}
function xdr_ltchars(__xdr: PXdr; var __ltchars: ltchars): bool_t; cdecl;
{$EXTERNALSYM xdr_ltchars}
function xdr_rex_ttysize(__xdr: PXdr; var __rex_ttysize: rex_ttysize): bool_t; cdecl;
{$EXTERNALSYM xdr_rex_ttysize}
function xdr_rex_ttymode(__xdr: PXdr; var __rex_ttymode: rex_ttymode): bool_t; cdecl;
{$EXTERNALSYM xdr_rex_ttymode}


{$HPPEMIT '#include <rpcsvc/rquota.h>}

// Translated from rpcsvc/rquota.h

const
  RQ_PATHLEN = 1024;
  {$EXTERNALSYM RQ_PATHLEN}

type
  getquota_args = {packed} record
    gqa_pathp: PChar;
    gqa_uid: Integer;
  end;
  {$EXTERNALSYM getquota_args}
  TGetQuoteArgs = getquota_args;
  PGetQuoteArgs = ^TGetQuoteArgs;

  rquota = {packed} record
    rq_bsize: Integer;
    rq_active: bool_t;
    rq_bhardlimit: u_int;
    rq_bsoftlimit: u_int;
    rq_curblocks: u_int;
    rq_fhardlimit: u_int;
    rq_fsoftlimit: u_int;
    rq_curfiles: u_int;
    rq_btimeleft: u_int;
    rq_ftimeleft: u_int;
  end;
  {$EXTERNALSYM rquota}

type
  gqr_status =
  (
    Q_OK = 1,
    {$EXTERNALSYM Q_OK}
    Q_NOQUOTA = 2,
    {$EXTERNALSYM Q_NOQUOTA}
    Q_EPERM = 3
    {$EXTERNALSYM Q_EPERM}
  );
  {$EXTERNALSYM gqr_status}

type
  getquota_rslt = {packed} record
    status: gqr_status;
    getquota_rslt_u: {packed} record
                       case Integer of
                         0: (gqr_rquota: rquota);
                       end;
  end;
  {$EXTERNALSYM getquota_rslt}
  TGetQuotaResult = getquota_rslt;
  PGetQuotaResult = ^TGetQuotaResult;

const
  RQUOTAPROG = 100011;
  {$EXTERNALSYM RQUOTAPROG}
  RQUOTAVERS = 1;
  {$EXTERNALSYM RQUOTAVERS}

const
  RQUOTAPROC_GETQUOTA = 1;
  {$EXTERNALSYM RQUOTAPROC_GETQUOTA}

function rquotaproc_getquota_1(p1: PGetQuoteArgs; AClient: PClientRecord): PGetQuotaResult; cdecl;
{$EXTERNALSYM rquotaproc_getquota_1}
function rquotaproc_getquota_1_svc(p1: PGetQuoteArgs; ServiceReq: PSvcReq): PGetQuotaResult; cdecl;
{$EXTERNALSYM rquotaproc_getquota_1_svc}

const
  RQUOTAPROC_GETACTIVEQUOTA = 2;
  {$EXTERNALSYM RQUOTAPROC_GETACTIVEQUOTA}

function rquotaproc_getactivequota_1(p1: PGetQuoteArgs; AClient: PClientRecord): PGetQuotaResult; cdecl;
{$EXTERNALSYM rquotaproc_getactivequota_1}
function rquotaproc_getactivequota_1_svc(p1: PGetQuoteArgs; ServiceReq: PSvcReq): PGetQuotaResult; cdecl;
{$EXTERNALSYM rquotaproc_getactivequota_1_svc}

function rquotaprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rquotaprog_1_freeresult}

{ the xdr functions }

function xdr_getquota_args(__xdr: PXdr; var __getquota_args: getquota_args): bool_t; cdecl;
{$EXTERNALSYM xdr_getquota_args}
function xdr_rquota(__xdr: PXdr; var __rquota: rquota): bool_t; cdecl;
{$EXTERNALSYM xdr_rquota}
function xdr_gqr_status(__xdr: PXdr; var __gqr_status: gqr_status): bool_t; cdecl;
{$EXTERNALSYM xdr_gqr_status}
function xdr_getquota_rslt(__xdr: PXdr; var __getquota_rslt: getquota_rslt): bool_t; cdecl;
{$EXTERNALSYM xdr_getquota_rslt}


{$HPPEMIT '#include <rpcsvc/rstat.h>}

// Translated from rpcsvc/rstat.h

const
{ Scale factor for scaled integers used to count load averages. }
  FSHIFT = 8; { bits to right of fixed binary point }
  {$EXTERNALSYM FSHIFT}
  FSCALE = (1 shl FSHIFT);
  {$EXTERNALSYM FSCALE}

const
  CPUSTATES = 4;
  {$EXTERNALSYM CPUSTATES}
  DK_NDRIVE = 4;
  {$EXTERNALSYM DK_NDRIVE}

type
  rstat_timeval = {packed} record
    tv_sec: u_int;
    tv_usec: u_int;
  end;
  {$EXTERNALSYM rstat_timeval}

  statstime = {packed} record
    cp_time: packed array[0..CPUSTATES-1] of Integer;
    dk_xfer: packed array[0..DK_NDRIVE-1] of Integer;
    v_pgpgin: u_int;
    v_pgpgout: u_int;
    v_pswpin: u_int;
    v_pswpout: u_int;
    v_intr: u_int;
    if_ipackets: Integer;
    if_ierrors: Integer;
    if_oerrors: Integer;
    if_collisions: Integer;
    v_swtch: u_int;
    avenrun: packed array[0..3-1] of Integer;
    boottime: rstat_timeval;
    curtime: rstat_timeval;
    if_opackets: Integer;
  end;
  {$EXTERNALSYM statstime}
  TStatsTime = statstime;
  PStatsTime = ^TStatsTime;

  statsswtch = {packed} record
    cp_time: packed array[0..CPUSTATES-1] of Integer;
    dk_xfer: packed array[0..DK_NDRIVE-1] of Integer;
    v_pgpgin: u_int;
    v_pgpgout: u_int;
    v_pswpin: u_int;
    v_pswpout: u_int;
    v_intr: u_int;
    if_ipackets: Integer;
    if_ierrors: Integer;
    if_oerrors: Integer;
    if_collisions: Integer;
    v_swtch: u_int;
    avenrun: packed array[0..3-1] of u_int;
    boottime: rstat_timeval;
    if_opackets: Integer;
  end;
  {$EXTERNALSYM statsswtch}
  TStatsSwitch = statsswtch;
  PStatsSwitch = ^TStatsSwitch;

  stats = {packed} record
    cp_time: packed array[0..CPUSTATES-1] of Integer;
    dk_xfer: packed array[0..DK_NDRIVE-1] of Integer;
    v_pgpgin: u_int;
    v_pgpgout: u_int;
    v_pswpin: u_int;
    v_pswpout: u_int;
    v_intr: u_int;
    if_ipackets: Integer;
    if_ierrors: Integer;
    if_oerrors: Integer;
    if_collisions: Integer;
    if_opackets: Integer;
  end;
  {$EXTERNALSYM stats}
  TStats = stats;
  PStats = ^TStats;

const
  RSTATPROG = 100001;
  {$EXTERNALSYM RSTATPROG}
  RSTATVERS_TIME = 3;
  {$EXTERNALSYM RSTATVERS_TIME}

const
  RSTATPROC_STATS = 1;
  {$EXTERNALSYM RSTATPROC_STATS}

function rstatproc_stats_3(p1: Pointer; AClient: PClientRecord): PStatsTime; cdecl;
{$EXTERNALSYM rstatproc_stats_3}
function rstatproc_stats_3_svc(p1: Pointer; ServiceReq: PSvcReq): PStatsTime; cdecl;
{$EXTERNALSYM rstatproc_stats_3_svc}

const
  RSTATPROC_HAVEDISK = 2;
  {$EXTERNALSYM RSTATPROC_HAVEDISK}

function rstatproc_havedisk_3(p1: Pointer; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_3}
function rstatproc_havedisk_3_svc(p1: Pointer; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_3_svc}

function rstatprog_3_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rstatprog_3_freeresult}

const
  RSTATVERS_SWTCH = 2;
  {$EXTERNALSYM RSTATVERS_SWTCH}

function rstatproc_stats_2(p1: Pointer; AClient: PClientRecord): PStatsSwitch; cdecl;
{$EXTERNALSYM rstatproc_stats_2}
function rstatproc_stats_2_svc(p1: Pointer; ServiceReq: PSvcReq): PStatsSwitch; cdecl;
{$EXTERNALSYM rstatproc_stats_2_svc}

function rstatproc_havedisk_2(p1: Pointer; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_2}
function rstatproc_havedisk_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_2_svc}

function rstatprog_2_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rstatprog_2_freeresult}

const
  RSTATVERS_ORIG = 1;
  {$EXTERNALSYM RSTATVERS_ORIG}

function rstatproc_stats_1(p1: Pointer; AClient: PClientRecord): PStats; cdecl;
{$EXTERNALSYM rstatproc_stats_1}
function rstatproc_stats_1_svc(p1: Pointer; ServiceReq: PSvcReq): PStats; cdecl;
{$EXTERNALSYM rstatproc_stats_1_svc}

function rstatproc_havedisk_1(p1: Pointer; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_1}
function rstatproc_havedisk_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM rstatproc_havedisk_1_svc}

function rstatprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rstatprog_1_freeresult}

{ the xdr functions }

function xdr_rstat_timeval(__xdr: PXdr; var __rstat_timeval: rstat_timeval): bool_t; cdecl;
{$EXTERNALSYM xdr_rstat_timeval}
function xdr_statstime(__xdr: PXdr; var __statstime: statstime): bool_t; cdecl;
{$EXTERNALSYM xdr_statstime}
function xdr_statsswtch(__xdr: PXdr; var __statsswtch: statsswtch): bool_t; cdecl;
{$EXTERNALSYM xdr_statsswtch}
function xdr_stats(__xdr: PXdr; var __stats: stats): bool_t; cdecl;
{$EXTERNALSYM xdr_stats}


{$HPPEMIT '#include <rpcsvc/rusers.h>}

// Translated from rpcsvc/rusers.h

{ Find out about remote users }
const
  RUSERS_MAXUSERLEN = 32;
  {$EXTERNALSYM RUSERS_MAXUSERLEN}
  RUSERS_MAXLINELEN = 32;
  {$EXTERNALSYM RUSERS_MAXLINELEN}
  RUSERS_MAXHOSTLEN = 257;
  {$EXTERNALSYM RUSERS_MAXHOSTLEN}

type
  rusers_utmp = {packed} record
    ut_user: PChar;
    ut_line: PChar;
    ut_host: PChar;
    ut_type: Integer;
    ut_time: Integer;
    ut_idle: u_int;
  end;
  {$EXTERNALSYM rusers_utmp}
  TRUsersUTmp = rusers_utmp;
  PRUsersUTmp = ^TRUsersUTmp;

  utmp_array = {packed} record
    utmp_array_len: u_int;
    utmp_array_val: PRUsersUTmp;
  end;
  {$EXTERNALSYM utmp_array}

{ Values for ut_type field above. }
const
  RUSERS_EMPTY = 0;
  {$EXTERNALSYM RUSERS_EMPTY}
  RUSERS_RUN_LVL = 1;
  {$EXTERNALSYM RUSERS_RUN_LVL}
  RUSERS_BOOT_TIME = 2;
  {$EXTERNALSYM RUSERS_BOOT_TIME}
  RUSERS_OLD_TIME = 3;
  {$EXTERNALSYM RUSERS_OLD_TIME}
  RUSERS_NEW_TIME = 4;
  {$EXTERNALSYM RUSERS_NEW_TIME}
  RUSERS_INIT_PROCESS = 5;
  {$EXTERNALSYM RUSERS_INIT_PROCESS}
  RUSERS_LOGIN_PROCESS = 6;
  {$EXTERNALSYM RUSERS_LOGIN_PROCESS}
  RUSERS_USER_PROCESS = 7;
  {$EXTERNALSYM RUSERS_USER_PROCESS}
  RUSERS_DEAD_PROCESS = 8;
  {$EXTERNALSYM RUSERS_DEAD_PROCESS}
  RUSERS_ACCOUNTING = 9;
  {$EXTERNALSYM RUSERS_ACCOUNTING}

{
 * The following structures are used by version 2 of the rusersd protocol.
 * They were not developed with rpcgen, so they do not appear as RPCL.
 }
const
  RUSERSVERS_IDLE = 2;
  {$EXTERNALSYM RUSERSVERS_IDLE}
  RUSERSVERS = 3;        { current version }
  {$EXTERNALSYM RUSERSVERS}
  MAXUSERS = 100;
  {$EXTERNALSYM MAXUSERS}

{
 * This is the structure used in version 2 of the rusersd RPC service.
 * It corresponds to the utmp structure for BSD systems.
 }
type
  ru_utmp = {packed} record
    ut_line: packed array[0..8-1] of Char;    { tty name }
    ut_name: packed array[0..8-1] of Char;    { user id }
    ut_host: packed array[0..16-1] of Char;   { host name, if remote }
    ut_time: Longint;                         { time on }
  end;
  {$EXTERNALSYM ru_utmp}
  TRuUTmp = ru_utmp;
  PRuUTmp = ^TRuUTmp;
  PPRuUTmp = ^PRuUTmp;

  utmparr = {packed} record
    uta_arr: PPRuUTmp;
    uta_cnt: Integer;
  end;
  {$EXTERNALSYM utmparr}
  TUTmpArray = utmparr;
  PUTmpArray = ^TUTmpArray;

function xdr_utmparr(xdrs: PXdr; var objp: utmparr): bool_t; cdecl;
{$EXTERNALSYM xdr_utmparr}

type
  utmpidle = {packed} record
    ui_utmp: ru_utmp;
    ui_idle: Cardinal;
  end;
  {$EXTERNALSYM utmpidle}
  TUTmpIdle = utmpidle;
  PUTmpIdle = ^TUTmpIdle;
  PPUTmpIdle = ^PUTmpIdle;

  utmpidlearr = {packed} record
    uia_arr: PPUTmpIdle;
    uia_cnt: Integer;
  end;
  {$EXTERNALSYM utmpidlearr}

function xdr_utmpidlearr(xdrs: PXdr; var objp: utmpidlearr): bool_t; cdecl;
{$EXTERNALSYM xdr_utmpidlearr}

const
  RUSERSPROG = 100002;
  {$EXTERNALSYM RUSERSPROG}
  RUSERSVERS_3 = 3;
  {$EXTERNALSYM RUSERSVERS_3}

const
  RUSERSPROC_NUM = 1;
  {$EXTERNALSYM RUSERSPROC_NUM}

function rusersproc_num_3(p1: Pointer; AClient: PClientRecord): PInteger;
{$EXTERNALSYM rusersproc_num_3}
function rusersproc_num_3_svc(p1: Pointer; ServiceReq: PSvcReq): PInteger;
{$EXTERNALSYM rusersproc_num_3_svc}

const
  RUSERSPROC_NAMES = 2;
  {$EXTERNALSYM RUSERSPROC_NAMES}

function rusersproc_names_3(p1: Pointer; AClient: PClientRecord): PUTmpArray; cdecl;
{$EXTERNALSYM rusersproc_names_3}
function rusersproc_names_3_svc(p1: Pointer; ServiceReq: PSvcReq): PUTmpArray; cdecl;
{$EXTERNALSYM rusersproc_names_3_svc}

const
  RUSERSPROC_ALLNAMES = 3;
  {$EXTERNALSYM RUSERSPROC_ALLNAMES}

function rusersproc_allnames_3(p1: Pointer; AClient: PClientRecord): PUTmpArray; cdecl;
{$EXTERNALSYM rusersproc_allnames_3}
function rusersproc_allnames_3_svc(p1: Pointer; ServiceReq: PSvcReq): PUTmpArray; cdecl;
{$EXTERNALSYM rusersproc_allnames_3_svc}

function rusersprog_3_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM rusersprog_3_freeresult}

{ the xdr functions }

function xdr_rusers_utmp(__xdr: PXdr; var __rusers_utmp: rusers_utmp): bool_t; cdecl;
{$EXTERNALSYM xdr_rusers_utmp}
function xdr_utmp_array(__xdr: PXdr; var __utmp_array: utmp_array): bool_t; cdecl;
{$EXTERNALSYM xdr_utmp_array}


{$HPPEMIT '#include <rpcsvc/sm_inter.h>}

// Translated from rpcsvc/sm_inter.h

const
  SM_MAXSTRLEN = 1024;
  {$EXTERNALSYM SM_MAXSTRLEN}

type
  sm_name = {packed} record
    mon_name: PChar;
  end;
  {$EXTERNALSYM sm_name}
  TSmName = sm_name;
  PSmName = ^TSmName;

  my_id = {packed} record
    my_name: PChar;
    my_prog: Integer;
    my_vers: Integer;
    my_proc: Integer;
  end;
  {$EXTERNALSYM my_id}
  TMyId = my_id;
  PMyId = ^TMyId;

  mon_id = {packed} record
    mon_name: PChar;
    my_id: TMyId;
  end;
  {$EXTERNALSYM mon_id}
  TMonId = mon_id;
  PMonId = ^TMonId;

  mon = {packed} record
    mon_id: TMonId;
    priv: packed array[0..16-1] of Char;
  end;
  {$EXTERNALSYM mon}
  TMon = mon;
  PMon = ^TMon;

  sm_stat = {packed} record
    state: Integer;
  end;
  {$EXTERNALSYM sm_stat}
  TSmStat = sm_stat;
  PSmStat = ^TSmStat;

type
  res =
  (
    stat_succ = 0,
    {$EXTERNALSYM stat_succ}
    stat_fail = 1
    {$EXTERNALSYM stat_fail}
  );
  {$EXTERNALSYM res}

type
  sm_stat_res = {packed} record
    res_stat: res;
    state: Integer;
  end;
  {$EXTERNALSYM sm_stat_res}
  TSmStatRes = sm_stat_res;
  PSmStatRes = ^TSmStatRes;

  status = {packed} record
    mon_name: PChar;
    state: Integer;
    priv: packed array[0..16-1] of Char;
  end;
  {$EXTERNALSYM status}

const
  SM_PROG = 100024;
  {$EXTERNALSYM SM_PROG}
  SM_VERS = 1;
  {$EXTERNALSYM SM_VERS}

const
  _SM_STAT = 1;
  {.$EXTERNALSYM SM_STAT} // Renamed due to identifier conflict

function sm_stat_1(p1: PSmName; AClient: PClientRecord): PSmStatRes; cdecl;
{$EXTERNALSYM sm_stat_1}
function sm_stat_1_svc(p1: PSmName; ServiceReq: PSvcReq): PSmStatRes; cdecl;
{$EXTERNALSYM sm_stat_1_svc}

const
  SM_MON = 2;
  {$EXTERNALSYM SM_MON}

function sm_mon_1(p1: PMon; AClient: PClientRecord): PSmStatRes; cdecl;
{$EXTERNALSYM sm_mon_1}
function sm_mon_1_svc(p1: PMon; ServiceReq: PSvcReq): PSmStatRes; cdecl;
{$EXTERNALSYM sm_mon_1_svc}

const
  SM_UNMON = 3;
  {$EXTERNALSYM SM_UNMON}

function sm_unmon_1(p1: PMonId; AClient: PClientRecord): PSmStat; cdecl;
{$EXTERNALSYM sm_unmon_1}
function sm_unmon_1_svc(p1: PMonId; ServiceReq: PSvcReq): PSmStat; cdecl;
{$EXTERNALSYM sm_unmon_1_svc}

const
  SM_UNMON_ALL = 4;
  {$EXTERNALSYM SM_UNMON_ALL}

function sm_unmon_all_1(p1: PMyId; AClient: PClientRecord): PSmStat; cdecl;
{$EXTERNALSYM sm_unmon_all_1}
function sm_unmon_all_1_svc(p1: PMyId; ServiceReq: PSvcReq): PSmStat; cdecl;
{$EXTERNALSYM sm_unmon_all_1_svc}

const
  SM_SIMU_CRASH = 5;
  {$EXTERNALSYM SM_SIMU_CRASH}

function sm_simu_crash_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM sm_simu_crash_1}
function sm_simu_crash_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM sm_simu_crash_1_svc}

function sm_prog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM sm_prog_1_freeresult}

{ the xdr functions }

function xdr_sm_name(__xdr: PXdr; var __sm_name: sm_name): bool_t; cdecl;
{$EXTERNALSYM xdr_sm_name}
function xdr_my_id(__xdr: PXdr; var __my_id: my_id): bool_t; cdecl;
{$EXTERNALSYM xdr_my_id}
function xdr_mon_id(__xdr: PXdr; var __mon_id: mon_id): bool_t; cdecl;
{$EXTERNALSYM xdr_mon_id}
function xdr_mon(__xdr: PXdr; var __mon: mon): bool_t; cdecl;
{$EXTERNALSYM xdr_mon}
function xdr_sm_stat(__xdr: PXdr; var __sm_stat: sm_stat): bool_t; cdecl;
{$EXTERNALSYM xdr_sm_stat}
function xdr_res(__xdr: PXdr; var __res: res): bool_t; cdecl;
{$EXTERNALSYM xdr_res}
function xdr_sm_stat_res(__xdr: PXdr; var __sm_stat_res: sm_stat_res): bool_t; cdecl;
{$EXTERNALSYM xdr_sm_stat_res}
function xdr_status(__xdr: PXdr; var __status: status): bool_t; cdecl;
{$EXTERNALSYM xdr_status}


{$HPPEMIT '#include <rpcsvc/spray.h>}

// Translated from rpcsvc/spray.h

const
  SPRAYMAX = 8845;
  {$EXTERNALSYM SPRAYMAX}

type
  spraytimeval = {packed} record
    sec: u_int;
    usec: u_int;
  end;
  {$EXTERNALSYM spraytimeval}

  spraycumul = {packed} record
    counter: u_int;
    clock: spraytimeval;
  end;
  {$EXTERNALSYM spraycumul}
  TSprayCumul = spraycumul;
  PSprayCumul = ^TSprayCumul;

  sprayarr = {packed} record
    sprayarr_len: u_int;
    sprayarr_val: Pointer;
  end;
  {$EXTERNALSYM sprayarr}
  TSprayArr = sprayarr;
  PSprayArr = ^TSprayArr;

const
  SPRAYPROG = 100012;
  {$EXTERNALSYM SPRAYPROG}
  SPRAYVERS = 1;
  {$EXTERNALSYM SPRAYVERS}

const
  SPRAYPROC_SPRAY = 1;
  {$EXTERNALSYM SPRAYPROC_SPRAY}

function sprayproc_spray_1(p1: PSprayArr; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM sprayproc_spray_1}
function sprayproc_spray_1_svc(p1: PSprayArr; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM sprayproc_spray_1_svc}

const
  SPRAYPROC_GET = 2;
  {$EXTERNALSYM SPRAYPROC_GET}

function sprayproc_get_1(p1: Pointer; AClient: PClientRecord): PSprayCumul; cdecl;
{$EXTERNALSYM sprayproc_get_1}
function sprayproc_get_1_svc(p1: Pointer; ServiceReq: PSvcReq): PSprayCumul; cdecl;
{$EXTERNALSYM sprayproc_get_1_svc}

const
  SPRAYPROC_CLEAR = 3;
  {$EXTERNALSYM SPRAYPROC_CLEAR}

function sprayproc_clear_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM sprayproc_clear_1}
function sprayproc_clear_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM sprayproc_clear_1_svc}

function sprayprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM sprayprog_1_freeresult}

{ the xdr functions }

function xdr_spraytimeval(__xdr: PXdr; var __spraytimeval: spraytimeval): bool_t; cdecl;
{$EXTERNALSYM xdr_spraytimeval}
function xdr_spraycumul(__xdr: PXdr; var __spraycumul: spraycumul): bool_t; cdecl;
{$EXTERNALSYM xdr_spraycumul}
function xdr_sprayarr(__xdr: PXdr; var __sprayarr: sprayarr): bool_t; cdecl;
{$EXTERNALSYM xdr_sprayarr}


{$HPPEMIT '#include <rpcsvc/yp.h>}

// Translated from rpcsvc/yp.h

{$IFDEF OLD_YP_PROTOTYPES}
const
  YPMAXRECORD = 1024;
  {$EXTERNALSYM YPMAXRECORD}
  YPMAXDOMAIN = 64;
  {$EXTERNALSYM YPMAXDOMAIN}
  YPMAXMAP = 64;
  {$EXTERNALSYM YPMAXMAP}
  YPMAXPEER = 64;
  {$EXTERNALSYM YPMAXPEER}

type
  ypstat =
  (
    YP_TRUE = 1,
    {$EXTERNALSYM YP_TRUE}
    YP_NOMORE = 2,
    {$EXTERNALSYM YP_NOMORE}
    YP_FALSE = 0,
    {$EXTERNALSYM YP_FALSE}
    YP_NOMAP = -1,
    {$EXTERNALSYM YP_NOMAP}
    YP_NODOM = -2,
    {$EXTERNALSYM YP_NODOM}
    YP_NOKEY = -3,
    {$EXTERNALSYM YP_NOKEY}
    YP_BADOP = -4,
    {$EXTERNALSYM YP_BADOP}
    YP_BADDB = -5,
    {$EXTERNALSYM YP_BADDB}
    YP_YPERR = -6,
    {$EXTERNALSYM YP_YPERR}
    YP_BADARGS = -7,
    {$EXTERNALSYM YP_BADARGS}
    YP_VERS = -8
    {$EXTERNALSYM YP_VERS}
  );
  {$EXTERNALSYM ypstat}

  ypxfrstat =
  (
    YPXFR_SUCC = 1,
    {$EXTERNALSYM YPXFR_SUCC}
    YPXFR_AGE = 2,
    {$EXTERNALSYM YPXFR_AGE}
    YPXFR_NOMAP = -1,
    {$EXTERNALSYM YPXFR_NOMAP}
    YPXFR_NODOM = -2,
    {$EXTERNALSYM YPXFR_NODOM}
    YPXFR_RSRC = -3,
    {$EXTERNALSYM YPXFR_RSRC}
    YPXFR_RPC = -4,
    {$EXTERNALSYM YPXFR_RPC}
    YPXFR_MADDR = -5,
    {$EXTERNALSYM YPXFR_MADDR}
    YPXFR_YPERR = -6,
    {$EXTERNALSYM YPXFR_YPERR}
    YPXFR_BADARGS = -7,
    {$EXTERNALSYM YPXFR_BADARGS}
    YPXFR_DBM = -8,
    {$EXTERNALSYM YPXFR_DBM}
    YPXFR_FILE = -9,
    {$EXTERNALSYM YPXFR_FILE}
    YPXFR_SKEW = -10,
    {$EXTERNALSYM YPXFR_SKEW}
    YPXFR_CLEAR = -11,
    {$EXTERNALSYM YPXFR_CLEAR}
    YPXFR_FORCE = -12,
    {$EXTERNALSYM YPXFR_FORCE}
    YPXFR_XFRERR = -13,
    {$EXTERNALSYM YPXFR_XFRERR}
    YPXFR_REFUSED = -14
    {$EXTERNALSYM YPXFR_REFUSED}
  );
  {$EXTERNALSYM ypxfrstat}

type
  domainname = PChar;
  {$EXTERNALSYM domainname}
  PDomainName = ^domainname;

  mapname = PChar;
  {$EXTERNALSYM mapname}
  peername = PChar;
  {$EXTERNALSYM peername}

type
  keydat = {packed} record
    keydat_len: u_int;
    keydat_val: PChar;
  end;
  {$EXTERNALSYM keydat}

  valdat = {packed} record
    valdat_len: u_int;
    valdat_val: PChar;
  end;
  {$EXTERNALSYM valdat}

  ypmap_parms = {packed} record
    domain: domainname;
    map: mapname;
    ordernum: u_int;
    peer: peername;
  end;
  {$EXTERNALSYM ypmap_parms}

  ypreq_key = {packed} record
    domain: domainname;
    map: mapname;
    key: keydat;
  end;
  {$EXTERNALSYM ypreq_key}
  TYpReqKey = ypreq_key;
  PYpReqKey = ^TYpReqKey;

  ypreq_nokey = {packed} record
    domain: domainname;
    map: mapname;
  end;
  {$EXTERNALSYM ypreq_nokey}
  TYpReqNoKey = ypreq_nokey;
  PYpReqNoKey = ^TYpReqNoKey;

  ypreq_xfr = {packed} record
    map_parms: ypmap_parms;
    transid: u_int;
    prog: u_int;
    port: u_int;
  end;
  {$EXTERNALSYM ypreq_xfr}
  TYpReqXfr = ypreq_xfr;
  PYpReqXfr = ^TYpReqXfr;

  ypresp_val = {packed} record
    stat: ypstat;
    val: valdat;
  end;
  {$EXTERNALSYM ypresp_val}
  TYpRespVal = ypresp_val;
  PYpRespVal = ^TYpRespVal;

  ypresp_key_val = {packed} record
    stat: ypstat;
{$IFDEF STUPID_SUN_BUG}
  { This is the form as distributed by Sun.  But even the Sun NIS
     servers expect the values in the other order.  So their
     implementation somehow must change the order internally.  We
     don't want to follow this bad example since the user should be
     able to use rpcgen on this file.  }
    key: keydat;
    val: valdat;
{$ELSE}
    val: valdat;
    key: keydat;
{$ENDIF}
  end;
  {$EXTERNALSYM ypresp_key_val}
  TYpRespKeyVal = ypresp_key_val;
  PYpRespKeyVal = ^TYpRespKeyVal;

  ypresp_master = {packed} record
    stat: ypstat;
    peer: peername;
  end;
  {$EXTERNALSYM ypresp_master}
  TYpRespMaster = ypresp_master;
  PYpRespMaster = ^TYpRespMaster;

  ypresp_order = {packed} record
    stat: ypstat;
    ordernum: u_int;
  end;
  {$EXTERNALSYM ypresp_order}
  TYpRespOrder = ypresp_order;
  PYpRespOrder = ^TYpRespOrder;

  ypresp_all = {packed} record
    more: bool_t;
    ypresp_all_u: {packed} record
                    case Integer of
                      0: (val: ypresp_key_val);
                    end;
  end;
  {$EXTERNALSYM ypresp_all}
  TYpRespAll = ypresp_all;
  PYpRespAll = ^TYpRespAll;

  ypresp_xfr = {packed} record
    transid: u_int;
    xfrstat: ypxfrstat;
  end;
  {$EXTERNALSYM ypresp_xfr}
  TYpRespXfr = ypresp_xfr;
  PYpRespXfr = ^TYpRespXfr;

  PYpMapList = ^TYpMapList;

  ypmaplist = {packed} record
    map: mapname;
    next: PYpMapList;
  end;
  {$EXTERNALSYM ypmaplist}
  TYpMapList = ypmaplist;

  ypresp_maplist = {packed} record
    stat: ypstat;
    maps: PYpMapList;
  end;
  {$EXTERNALSYM ypresp_maplist}
  TYpRespMapList = ypresp_maplist;
  PYpRespMapList = ^TYpRespMapList;

  yppush_status =
  (
    YPPUSH_SUCC = 1,
    {$EXTERNALSYM YPPUSH_SUCC}
    YPPUSH_AGE = 2,
    {$EXTERNALSYM YPPUSH_AGE}
    YPPUSH_NOMAP = -1,
    {$EXTERNALSYM YPPUSH_NOMAP}
    YPPUSH_NODOM = -2,
    {$EXTERNALSYM YPPUSH_NODOM}
    YPPUSH_RSRC = -3,
    {$EXTERNALSYM YPPUSH_RSRC}
    YPPUSH_RPC = -4,
    {$EXTERNALSYM YPPUSH_RPC}
    YPPUSH_MADDR = -5,
    {$EXTERNALSYM YPPUSH_MADDR}
    YPPUSH_YPERR = -6,
    {$EXTERNALSYM YPPUSH_YPERR}
    YPPUSH_BADARGS = -7,
    {$EXTERNALSYM YPPUSH_BADARGS}
    YPPUSH_DBM = -8,
    {$EXTERNALSYM YPPUSH_DBM}
    YPPUSH_FILE = -9,
    {$EXTERNALSYM YPPUSH_FILE}
    YPPUSH_SKEW = -10,
    {$EXTERNALSYM YPPUSH_SKEW}
    YPPUSH_CLEAR = -11,
    {$EXTERNALSYM YPPUSH_CLEAR}
    YPPUSH_FORCE = -12,
    {$EXTERNALSYM YPPUSH_FORCE}
    YPPUSH_XFRERR = -13,
    {$EXTERNALSYM YPPUSH_XFRERR}
    YPPUSH_REFUSED = -14
    {$EXTERNALSYM YPPUSH_REFUSED}
  );
  {$EXTERNALSYM yppush_status}

  yppushresp_xfr = {packed} record
    transid: u_int;
    status: yppush_status;
  end;
  {$EXTERNALSYM yppushresp_xfr}
  TYpPushRespXfr = yppushresp_xfr;
  PYpPushRespXfr = ^TYpPushRespXfr;

  ypbind_resptype =
  (
    YPBIND_SUCC_VAL = 1,
    {$EXTERNALSYM YPBIND_SUCC_VAL}
    YPBIND_FAIL_VAL = 2
    {$EXTERNALSYM YPBIND_FAIL_VAL}
  );
  {$EXTERNALSYM ypbind_resptype}

  ypbind_binding = {packed} record
    ypbind_binding_addr: packed array[0..4-1] of Char;
    ypbind_binding_port: packed array[0..2-1] of Char;
  end;
  {$EXTERNALSYM ypbind_binding}

  ypbind_resp = {packed} record
    ypbind_status: ypbind_resptype;
    ypbind_resp_u: {packed} record
                     case Integer of
                       0: (ypbind_error: u_int);
                       1: (ypbind_bindinfo: ypbind_binding);
                     end;
  end;
  {$EXTERNALSYM ypbind_resp}
  TYpBindResp = ypbind_resp;
  PYpBindResp = ^TYpBindResp;

const
  YPBIND_ERR_ERR = 1;
  {$EXTERNALSYM YPBIND_ERR_ERR}
  YPBIND_ERR_NOSERV = 2;
  {$EXTERNALSYM YPBIND_ERR_NOSERV}
  YPBIND_ERR_RESC = 3;
  {$EXTERNALSYM YPBIND_ERR_RESC}

type
  ypbind_setdom = {packed} record
    ypbind_setdom: domainname;
    ypsetdom_binding: ypbind_binding;
    ypsetdom_vers: u_int;
  end;
  {$EXTERNALSYM ypbind_setdom}
  TYpBindSetDom = ypbind_setdom;
  PYpBindSetDom = ^TYpBindSetDom;

const
  YPPROG = 100004;
  {$EXTERNALSYM YPPROG}
  YPVERS = 2;
  {$EXTERNALSYM YPVERS}

const
  YPPROC_NULL = 0;
  {$EXTERNALSYM YPPROC_NULL}

function ypproc_null_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM ypproc_null_2}
function ypproc_null_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM ypproc_null_2_svc}

const
  YPPROC_DOMAIN = 1;
  {$EXTERNALSYM YPPROC_DOMAIN}

function ypproc_domain_2(p1: PDomainName; AClient: PClientRecord): Pbool_t; cdecl;
{$EXTERNALSYM ypproc_domain_2}
function ypproc_domain_2_svc(p1: PDomainName; ServiceReq: PSvcReq): Pbool_t; cdecl;
{$EXTERNALSYM ypproc_domain_2_svc}

const
  YPPROC_DOMAIN_NONACK = 2;
  {$EXTERNALSYM YPPROC_DOMAIN_NONACK}

function ypproc_domain_nonack_2(p1: PDomainName; AClient: PClientRecord): Pbool_t; cdecl;
{$EXTERNALSYM ypproc_domain_nonack_2}
function ypproc_domain_nonack_2_svc(p1: PDomainName; ServiceReq: PSvcReq): Pbool_t; cdecl;
{$EXTERNALSYM ypproc_domain_nonack_2_svc}

const
  YPPROC_MATCH = 3;
  {$EXTERNALSYM YPPROC_MATCH}

function ypproc_match_2(p1: PYpReqKey; AClient: PClientRecord): PYpRespVal; cdecl;
{$EXTERNALSYM ypproc_match_2}
function ypproc_match_2_svc(p1: PYpReqKey; ServiceReq: PSvcReq): PYpRespVal; cdecl;
{$EXTERNALSYM ypproc_match_2_svc}

const
  YPPROC_FIRST = 4;
  {$EXTERNALSYM YPPROC_FIRST}

function ypproc_first_2(p1: PYpReqKey; AClient: PClientRecord): PYpRespKeyVal; cdecl;
{$EXTERNALSYM ypproc_first_2}
function ypproc_first_2_svc(p1: PYpReqKey; ServiceReq: PSvcReq): PYpRespKeyVal; cdecl;
{$EXTERNALSYM ypproc_first_2_svc}

const
  YPPROC_NEXT = 5;
  {$EXTERNALSYM YPPROC_NEXT}

function ypproc_next_2(p1: PYpReqKey; AClient: PClientRecord): PYpRespKeyVal; cdecl;
{$EXTERNALSYM ypproc_next_2}
function ypproc_next_2_svc(p1: PYpReqKey; ServiceReq: PSvcReq): PYpRespKeyVal; cdecl;
{$EXTERNALSYM ypproc_next_2_svc}

const
  YPPROC_XFR = 6;
  {$EXTERNALSYM YPPROC_XFR}

function ypproc_xfr_2(p1: PYpReqXfr; AClient: PClientRecord): PYpRespXfr; cdecl;
{$EXTERNALSYM ypproc_xfr_2}
function ypproc_xfr_2_svc(p1: PYpReqXfr; ServiceReq: PSvcReq): PYpRespXfr; cdecl;
{$EXTERNALSYM ypproc_xfr_2_svc}

const
  YPPROC_CLEAR = 7;
  {$EXTERNALSYM YPPROC_CLEAR}

function ypproc_clear_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM ypproc_clear_2}
function ypproc_clear_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM ypproc_clear_2_svc}

const
  YPPROC_ALL = 8;
  {$EXTERNALSYM YPPROC_ALL}

function ypproc_all_2(p1: PYpReqNoKey; AClient: PClientRecord): PYpRespAll; cdecl;
{$EXTERNALSYM ypproc_all_2}
function ypproc_all_2_svc(p1: PYpReqNoKey; ServiceReq: PSvcReq): PYpRespAll; cdecl;
{$EXTERNALSYM ypproc_all_2_svc}

const
  YPPROC_MASTER = 9;
  {$EXTERNALSYM YPPROC_MASTER}

function ypproc_master_2(p1: PYpReqNoKey; AClient: PClientRecord): PYpRespMaster; cdecl;
{$EXTERNALSYM ypproc_master_2}
function ypproc_master_2_svc(p1: PYpReqNoKey; ServiceReq: PSvcReq): PYpRespMaster; cdecl;
{$EXTERNALSYM ypproc_master_2_svc}

const
  YPPROC_ORDER = 10;
  {$EXTERNALSYM YPPROC_ORDER}

function ypproc_order_2(p1: PYpReqNoKey; AClient: PClientRecord): PYpRespOrder; cdecl;
{$EXTERNALSYM ypproc_order_2}
function ypproc_order_2_svc(p1: PYpReqNoKey; ServiceReq: PSvcReq): PYpRespOrder; cdecl;
{$EXTERNALSYM ypproc_order_2_svc}

const
  YPPROC_MAPLIST = 11;
  {$EXTERNALSYM YPPROC_MAPLIST}

function ypproc_maplist_2(p1: PDomainName; AClient: PClientRecord): PYpRespMapList; cdecl;
{$EXTERNALSYM ypproc_maplist_2}
function ypproc_maplist_2_svc(p1: PDomainName; ServiceReq: PSvcReq): PYpRespMapList; cdecl;
{$EXTERNALSYM ypproc_maplist_2_svc}

function ypprog_2_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM ypprog_2_freeresult}


const
  YPPUSH_XFRRESPPROG = ($40000000);
  {$EXTERNALSYM YPPUSH_XFRRESPPROG}
  YPPUSH_XFRRESPVERS = 1;
  {$EXTERNALSYM YPPUSH_XFRRESPVERS}

const
  YPPUSHPROC_NULL = 0;
  {$EXTERNALSYM YPPUSHPROC_NULL}

function yppushproc_null_1(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM yppushproc_null_1}
function yppushproc_null_1_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM yppushproc_null_1_svc}

const
  YPPUSHPROC_XFRRESP = 1;
  {$EXTERNALSYM YPPUSHPROC_XFRRESP}

function yppushproc_xfrresp_1(p1: PYpPushRespXfr; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM yppushproc_xfrresp_1}
function yppushproc_xfrresp_1_svc(p1: PYpPushRespXfr; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM yppushproc_xfrresp_1_svc}

function yppush_xfrrespprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM yppush_xfrrespprog_1_freeresult}


const
  YPBINDPROG = 100007;
  {$EXTERNALSYM YPBINDPROG}
  YPBINDVERS = 2;
  {$EXTERNALSYM YPBINDVERS}

const
  YPBINDPROC_NULL = 0;
  {$EXTERNALSYM YPBINDPROC_NULL}

function ypbindproc_null_2(p1: Pointer; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM ypbindproc_null_2}
function ypbindproc_null_2_svc(p1: Pointer; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM ypbindproc_null_2_svc}

const
  YPBINDPROC_DOMAIN = 1;
  {$EXTERNALSYM YPBINDPROC_DOMAIN}

function ypbindproc_domain_2(p1: PDomainName; AClient: PClientRecord): PYpBindResp; cdecl;
{$EXTERNALSYM ypbindproc_domain_2}
function ypbindproc_domain_2_svc(p1: PDomainName; ServiceReq: PSvcReq): PYpBindResp; cdecl;
{$EXTERNALSYM ypbindproc_domain_2_svc}

const
  YPBINDPROC_SETDOM = 2;
  {$EXTERNALSYM YPBINDPROC_SETDOM}

function ypbindproc_setdom_2(p1: PYpBindSetDom; AClient: PClientRecord): Pointer; cdecl;
{$EXTERNALSYM ypbindproc_setdom_2}
function ypbindproc_setdom_2_svc(p1: PYpBindSetDom; ServiceReq: PSvcReq): Pointer; cdecl;
{$EXTERNALSYM ypbindproc_setdom_2_svc}

function ypbindprog_2_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM ypbindprog_2_freeresult}


function xdr_ypstat(__xdr: PXdr; var __ypstat: ypstat): bool_t; cdecl;
{$EXTERNALSYM xdr_ypstat}
function xdr_ypxfrstat(__xdr: PXdr; var __ypxfrstat: ypxfrstat): bool_t; cdecl;
{$EXTERNALSYM xdr_ypxfrstat}
function xdr_domainname(__xdr: PXdr; var __domainname: domainname): bool_t; cdecl;
{$EXTERNALSYM xdr_domainname}
function xdr_mapname(__xdr: PXdr; var __mapname: mapname): bool_t; cdecl;
{$EXTERNALSYM xdr_mapname}
function xdr_peername(__xdr: PXdr; var __peername: peername): bool_t; cdecl;
{$EXTERNALSYM xdr_peername}
function xdr_keydat(__xdr: PXdr; var __keydat: keydat): bool_t; cdecl;
{$EXTERNALSYM xdr_keydat}
function xdr_valdat(__xdr: PXdr; var __valdat: valdat): bool_t; cdecl;
{$EXTERNALSYM xdr_valdat}
function xdr_ypmap_parms(__xdr: PXdr; var __ypmap_parms: ypmap_parms): bool_t; cdecl;
{$EXTERNALSYM xdr_ypmap_parms}
function xdr_ypreq_key(__xdr: PXdr; var __ypreq_key: ypreq_key): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_key}
function xdr_ypreq_nokey(__xdr: PXdr; var __ypreq_nokey: ypreq_nokey): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_nokey}
function xdr_ypreq_xfr(__xdr: PXdr; var __ypreq_xfr: ypreq_xfr): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_xfr}
function xdr_ypresp_val(__xdr: PXdr; var __ypresp_val: ypresp_val): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_val}
function xdr_ypresp_key_val(__xdr: PXdr; var __ypresp_key_val: ypresp_key_val): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_key_val}
function xdr_ypresp_master(__xdr: PXdr; var __ypresp_master: ypresp_master): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_master}
function xdr_ypresp_order(__xdr: PXdr; var __ypresp_order: ypresp_order): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_order}
function xdr_ypresp_all(__xdr: PXdr; var __ypresp_all: ypresp_all): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_all}
function xdr_ypresp_xfr(__xdr: PXdr; var __ypresp_xfr: ypresp_xfr): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_xfr}
function xdr_ypmaplist(__xdr: PXdr; var __ypmaplist: ypmaplist): bool_t; cdecl;
{$EXTERNALSYM xdr_ypmaplist}
function xdr_ypresp_maplist(__xdr: PXdr; var __ypresp_maplist: ypresp_maplist): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_maplist}
function xdr_yppush_status(__xdr: PXdr; var __yppush_status: yppush_status): bool_t; cdecl;
{$EXTERNALSYM xdr_yppush_status}
function xdr_yppushresp_xfr(__xdr: PXdr; var __yppush_status: yppushresp_xfr): bool_t; cdecl;
{$EXTERNALSYM xdr_yppushresp_xfr}
function xdr_ypbind_resptype(__xdr: PXdr; var __ypbind_resptype: ypbind_resptype): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_resptype}
function xdr_ypbind_binding(__xdr: PXdr; var __ypbind_binding: ypbind_binding): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_binding}
function xdr_ypbind_resp(__xdr: PXdr; var __ypbind_resp: ypbind_resp): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_resp}
function xdr_ypbind_setdom(__xdr: PXdr; var __ypbind_setdom: ypbind_setdom): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_setdom}

{$ENDIF OLD_YP_PROTOTYPES}

{$HPPEMIT '#include <rpcsvc/ypclnt.h>}

//  Translated from rpcsvc/ypclnt.h

{ Some defines }
const
  YPERR_SUCCESS = 0;     { There is no error }
  {$EXTERNALSYM YPERR_SUCCESS}
  YPERR_BADARGS = 1;     { Args to function are bad }
  {$EXTERNALSYM YPERR_BADARGS}
  YPERR_RPC = 2;         { RPC failure }
  {$EXTERNALSYM YPERR_RPC}
  YPERR_DOMAIN = 3;      { Can't bind to a server with this domain }
  {$EXTERNALSYM YPERR_DOMAIN}
  YPERR_MAP = 4;         { No such map in server's domain }
  {$EXTERNALSYM YPERR_MAP}
  YPERR_KEY = 5;         { No such key in map }
  {$EXTERNALSYM YPERR_KEY}
  YPERR_YPERR = 6;       { Internal yp server or client error }
  {$EXTERNALSYM YPERR_YPERR}
  YPERR_RESRC = 7;       { Local resource allocation failure }
  {$EXTERNALSYM YPERR_RESRC}
  YPERR_NOMORE = 8;      { No more records in map database }
  {$EXTERNALSYM YPERR_NOMORE}
  YPERR_PMAP = 9;        { Can't communicate with portmapper }
  {$EXTERNALSYM YPERR_PMAP}
  YPERR_YPBIND = 10;     { Can't communicate with ypbind }
  {$EXTERNALSYM YPERR_YPBIND}
  YPERR_YPSERV = 11;     { Can't communicate with ypserv }
  {$EXTERNALSYM YPERR_YPSERV}
  YPERR_NODOM = 12;      { Local domain name not set }
  {$EXTERNALSYM YPERR_NODOM}
  YPERR_BADDB = 13;      { yp data base is bad }
  {$EXTERNALSYM YPERR_BADDB}
  YPERR_VERS = 14;       { YP version mismatch }
  {$EXTERNALSYM YPERR_VERS}
  YPERR_ACCESS = 15;     { Access violation }
  {$EXTERNALSYM YPERR_ACCESS}
  YPERR_BUSY = 16;       { Database is busy }
  {$EXTERNALSYM YPERR_BUSY}

{ Types of update operations }
  YPOP_CHANGE = 1;       { Change, do not add }
  {$EXTERNALSYM YPOP_CHANGE}
  YPOP_INSERT = 2;       { Add, do not change }
  {$EXTERNALSYM YPOP_INSERT}
  YPOP_DELETE = 3;       { Delete this entry }
  {$EXTERNALSYM YPOP_DELETE}
  YPOP_STORE = 4;        { Add, or change }
  {$EXTERNALSYM YPOP_STORE}


{ struct ypall_callback * is the arg which must be passed to yp_all.  }
type
  // Used anonymously in header file
  TYpAllCallbackForEach = function(__status: Integer; __key: PChar; __keylen: Integer;
                            __val: PChar; __vallen: Integer; __data: PChar): Integer; cdecl;

  ypall_callback = {packed} record
    foreach: TYpAllCallbackForEach;
    data: PChar;
  end;
  {$EXTERNALSYM ypall_callback}
  TYpAllCallback = ypall_callback;
  PYpAllCallback = ^TYpAllCallback;

{ External NIS client function references.  }
function yp_bind(p1: PChar): Integer; cdecl;
{$EXTERNALSYM yp_bind}
procedure yp_unbind(p1: PChar); cdecl;
{$EXTERNALSYM yp_unbind}
function yp_get_default_domain(p1: PPChar): Integer; cdecl;
{$EXTERNALSYM yp_get_default_domain}
function yp_match(p1: PChar; p2: PChar; p3: PChar; p4: Integer; p5: PPChar; p6: PInteger): Integer; cdecl;
{$EXTERNALSYM yp_match}
function yp_first(p1: PChar; p2: PChar; p3: PPChar; p4: PInteger; p5: PPChar; p6: PInteger): Integer; cdecl;
{$EXTERNALSYM yp_first}
function yp_next(p1: PChar; p2: PChar; p3: PChar; p4: Integer; p5: PPChar; p6: PInteger;
  p7: PPChar; p8: PInteger): Integer; cdecl;
{$EXTERNALSYM yp_next}
function yp_master(p1: PChar; p2: PChar; p3: PPChar): Integer; cdecl;
{$EXTERNALSYM yp_master}
function yp_order(p1: PChar; p2: PChar; p3: PCardinal): Integer; cdecl;
{$EXTERNALSYM yp_order}
function yp_all(p1: PChar; p2: PChar; p3: PYpAllCallback): Integer; cdecl;
{$EXTERNALSYM yp_all}
function yperr_string(p1: Integer): PChar; cdecl;
{$EXTERNALSYM yperr_string}
function ypbinderr_string(p1: Integer): PChar; cdecl;
{$EXTERNALSYM ypbinderr_string}
function ypprot_err(p1: Integer): Integer; cdecl;
{$EXTERNALSYM ypprot_err}
function yp_update(p1: PChar; p2: PChar; p3: Cardinal; p4: PChar; p5: Integer;
  p6: PChar; p7: Integer): Integer; cdecl;
{$EXTERNALSYM yp_update}

{ This functions exists only under BSD and Linux systems.  }
function __yp_check(p1: PPChar): Integer; cdecl;
{$EXTERNALSYM __yp_check}


{$IFDEF NEW_YP_PROTOTYPES}

// Translated from rpcsvc/yp_prot.h

{
 * The following procedures are supported by the protocol:
 *
 * YPPROC_NULL() returns () takes nothing, returns nothing.  This indicates
 * that the NIS server is alive.
 *
 * YPPROC_DOMAIN (char *) returns (bool_t) TRUE.  Indicates that the
 * responding NIS server does serve the named domain; FALSE indicates no
 * support.
 *
 * YPPROC_DOMAIN_NONACK (char *) returns (TRUE) if the NIS server does serve
 * the named domain, otherwise does not return.  Used in the broadcast case.
 *
 * YPPROC_MATCH (struct ypreq_key) returns (struct ypresp_val).  Returns the
 * right-hand value for a passed left-hand key, within a named map and
 * domain.
 *
 * YPPROC_FIRST (struct ypreq_nokey) returns (struct ypresp_key_val).
 * Returns the first key-value pair from a named domain and map.
 *
 * YPPROC_NEXT (struct ypreq_key) returns (struct ypresp_key_val).  Returns
 * the key-value pair following a passed key-value pair within a named
 * domain and map.
 *
 * YPPROC_XFR (struct ypreq_xfr) returns nothing.  Indicates to a server that
 * a map should be updated.
 *
 * YPPROC_CLEAR	takes nothing, returns nothing.  Instructs a NIS server to
 * close the current map, so that old versions of the disk file don't get
 * held open.
 *
 * YPPROC_ALL (struct ypreq_nokey), returns
 * 	union switch (bool_t more)
 *		TRUE:	(struct ypresp_key_val);
 *		FALSE:	(struct) ;
 *
 *
 * YPPROC_MASTER (struct ypreq_nokey), returns (ypresp_master)
 *
 * YPPROC_ORDER (struct ypreq_nokey), returns (ypresp_order)
 *
 * YPPROC_MAPLIST (char * ), returns (struct ypmaplist * )
 }

{ Program and version symbols, magic numbers }
const
  YPPROG = 100004;
  {$EXTERNALSYM YPPROG}
  YPVERS = 2;
  {$EXTERNALSYM YPVERS}
  YPVERS_ORIG = 1;
  {$EXTERNALSYM YPVERS_ORIG}
  YPMAXRECORD = 1024;
  {$EXTERNALSYM YPMAXRECORD}
  YPMAXDOMAIN = 64; { XXX orig. yp_prot.h defines 256 }
  {$EXTERNALSYM YPMAXDOMAIN}
  YPMAXMAP = 64;
  {$EXTERNALSYM YPMAXMAP}
  YPMAXPEER = 64; { XXX orig. yp_prot.h defines 256 }
  {$EXTERNALSYM YPMAXPEER}

{ byte size of a large NIS packet }
  YPMSGSZ = 1600;
  {$EXTERNALSYM YPMSGSZ}

type
  keydat_t = {packed} record
    keydat_len: u_int;
    keydat_val: PChar;
  end;
  {$EXTERNALSYM keydat_t}

  valdat_t = {packed} record
    valdat_len: u_int;
    valdat_val: PChar;
  end;
  {$EXTERNALSYM valdat_t}

  ypmap_parms = {packed} record
    domain: PChar;           { Null string means not available }
    map: PChar;              { Null string means not available }
    ordernum: Cardinal;      { 0 means not available }
    owner: PChar;            { Null string means not available }
  end;
  {$EXTERNALSYM ypmap_parms}

{ Request parameter structures }

  ypreq_key = {packed} record
    domain: PChar;
    map: PChar;
    keydat: keydat_t;
  end;
  {$EXTERNALSYM ypreq_key}

  ypreq_nokey = {packed} record
    domain: PChar;
    map: PChar;
  end;
  {$EXTERNALSYM ypreq_nokey}

  ypreq_xfr = {packed} record
    map_parms: ypmap_parms;
    transid: u_int;
    proto: u_int;
    port: u_int;
  end;
  {$EXTERNALSYM ypreq_xfr}

(* Cannot be translated
#define ypxfr_domain map_parms.domain
#define ypxfr_map map_parms.map
#define ypxfr_ordernum map_parms.ordernum
#define ypxfr_owner map_parms.owner
*)

{ Return status values }
type
  ypstat =
  (
    YP_TRUE = 1,          { General purpose success code }
    {$EXTERNALSYM YP_TRUE}
    YP_NOMORE = 2,        { No more entries in map }
    {$EXTERNALSYM YP_NOMORE}
    YP_FALSE = 0,         { General purpose failure code }
    {$EXTERNALSYM YP_FALSE}
    YP_NOMAP = -1,        { No such map in domain }
    {$EXTERNALSYM YP_NOMAP}
    YP_NODOM = -2,        { Domain not supported }
    {$EXTERNALSYM YP_NODOM}
    YP_NOKEY = -3,        { No such key in map }
    {$EXTERNALSYM YP_NOKEY}
    YP_BADOP = -4,        { Invalid operation }
    {$EXTERNALSYM YP_BADOP}
    YP_BADDB = -5,        { Server data base is bad }
    {$EXTERNALSYM YP_BADDB}
    YP_YPERR = -6,        { NIS server error }
    {$EXTERNALSYM YP_YPERR}
    YP_BADARGS = -7,      { Request arguments bad }
    {$EXTERNALSYM YP_BADARGS}
    YP_VERS = -8          { NIS server version mismatch - server can't supply
                            requested service. }
    {$EXTERNALSYM YP_VERS}
  );
  {$EXTERNALSYM ypstat}

{ Response parameter structures }

type
  ypresp_val = {packed} record
    status: ypstat;
    valdat: valdat_t;
  end;
  {$EXTERNALSYM ypresp_val}

  ypresp_key_val = {packed} record
    status: ypstat;
{$IFDEF STUPID_SUN_BUG}
  { This is the form as distributed by Sun.  But even the Sun NIS
     servers expect the values in the other order.  So their
     implementation somehow must change the order internally.  We
     don't want to follow this bad example since the user should be
     able to use rpcgen on this file.  }
  keydat: keydat_t;
  valdat: valdat_t;
{$ELSE}
  valdat: valdat_t;
  keydat: keydat_t;
{$ENDIF}
  end;
  {$EXTERNALSYM ypresp_key_val}

  ypresp_master = {packed} record
    status: ypstat;
    master: PChar;
  end;
  {$EXTERNALSYM ypresp_master}

  ypresp_order = {packed} record
    status: ypstat;
    ordernum: u_int;
  end;
  {$EXTERNALSYM ypresp_order}

  PYpMapList = ^TYpMapList;

  ypmaplist = {packed} record
    map: PChar;
    next: PYpMapList;
  end;
  {$EXTERNALSYM ypmaplist}
  TYpMapList = ypmaplist;

(* Cannot translate this
#define ypml_name map
#define ypml_next next
*)

  ypresp_maplist = {packed} record
    status: ypstat;
    list: PYpMapList;
  end;
  {$EXTERNALSYM ypresp_maplist}

{
 * Procedure symbols.  YPPROC_NULL, YPPROC_DOMAIN, and YPPROC_DOMAIN_NONACK
 * must keep the same values (0, 1, and 2) that they had in the first version
 * of the protocol.
 }

const
  YPPROC_NULL           = 0;
  {$EXTERNALSYM YPPROC_NULL}
  YPPROC_DOMAIN         = 1;
  {$EXTERNALSYM YPPROC_DOMAIN}
  YPPROC_DOMAIN_NONACK  = 2;
  {$EXTERNALSYM YPPROC_DOMAIN_NONACK}
  YPPROC_MATCH          = 3;
  {$EXTERNALSYM YPPROC_MATCH}
  YPPROC_FIRST          = 4;
  {$EXTERNALSYM YPPROC_FIRST}
  YPPROC_NEXT           = 5;
  {$EXTERNALSYM YPPROC_NEXT}
  YPPROC_XFR            = 6;
  {$EXTERNALSYM YPPROC_XFR}
  YPPROC_CLEAR          = 7;
  {$EXTERNALSYM YPPROC_CLEAR}
  YPPROC_ALL            = 8;
  {$EXTERNALSYM YPPROC_ALL}
  YPPROC_MASTER         = 9;
  {$EXTERNALSYM YPPROC_MASTER}
  YPPROC_ORDER          = 10;
  {$EXTERNALSYM YPPROC_ORDER}
  YPPROC_MAPLIST        = 11;
  {$EXTERNALSYM YPPROC_MAPLIST}
  YPPROC_NEWXFR         = 12;
  {$EXTERNALSYM YPPROC_NEWXFR}

{ Protocol between clients and NIS binder servers }

{
 * The following procedures are supported by the protocol:
 *
 * YPBINDPROC_NULL() returns ()
 * 	takes nothing, returns nothing
 *
 * YPBINDPROC_DOMAIN takes (char *) returns (struct ypbind_resp)
 *
 * YPBINDPROC_SETDOM takes (struct ypbind_setdom) returns nothing
 }

{ Program and version symbols, magic numbers }
const
  YPBINDPROG = 100007;
  {$EXTERNALSYM YPBINDPROG}
  YPBINDVERS = 2;
  {$EXTERNALSYM YPBINDVERS}
  YPBINDVERS_ORIG = 1;
  {$EXTERNALSYM YPBINDVERS_ORIG}

{ Procedure symbols }

  YPBINDPROC_NULL = 0;
  {$EXTERNALSYM YPBINDPROC_NULL}
  YPBINDPROC_DOMAIN = 1;
  {$EXTERNALSYM YPBINDPROC_DOMAIN}
  YPBINDPROC_SETDOM = 2;
  {$EXTERNALSYM YPBINDPROC_SETDOM}
{
 * Response structure and overall result status codes.  Success and failure
 * represent two separate response message types.
 }

type
  ypbind_resptype =
  (
    YPBIND_SUCC_VAL = 1,
    {$EXTERNALSYM YPBIND_SUCC_VAL}
    YPBIND_FAIL_VAL = 2
    {$EXTERNALSYM YPBIND_FAIL_VAL}
  );
  {$EXTERNALSYM ypbind_resptype}

  ypbind_binding = {packed} record
    ypbind_binding_addr: in_addr; { In network order }
    ypbind_binding_port: Word;    { In network order }
  end;
  {$EXTERNALSYM ypbind_binding}

  ypbind_resp = {packed} record
    ypbind_status: ypbind_resptype;
    ypbind_respbody: {packed} record
                       case Integer of
                         0: (ypbind_error: u_int);
                         1: (ypbind_bindinfo: ypbind_binding);
                       end;
  end;
  {$EXTERNALSYM ypbind_resp}


{ Detailed failure reason codes for response field ypbind_error}

const
  YPBIND_ERR_ERR = 1;        { Internal error }
  {$EXTERNALSYM YPBIND_ERR_ERR}
  YPBIND_ERR_NOSERV = 2;     { No bound server for passed domain }
  {$EXTERNALSYM YPBIND_ERR_NOSERV}
  YPBIND_ERR_RESC = 3;       { System resource allocation failure }
  {$EXTERNALSYM YPBIND_ERR_RESC}

{ Request data structure for ypbind "Set domain" procedure. }
type
  ypbind_setdom = {packed} record
    ypsetdom_domain: PChar;
    ypsetdom_binding: ypbind_binding;
    ypsetdom_vers: u_int;
  end;
  {$EXTERNALSYM ypbind_setdom}

(* Cannot translate this
#define ypsetdom_addr ypsetdom_binding.ypbind_binding_addr
#define ypsetdom_port ypsetdom_binding.ypbind_binding_port
*)

{
 *		Protocol between clients (ypxfr, only) and yppush
 *		yppush speaks a protocol in the transient range, which
 *		is supplied to ypxfr as a command-line parameter when it
 *		is activated by ypserv.
 }
const
  YPPUSHVERS = 1;
  {$EXTERNALSYM YPPUSHVERS}
  YPPUSHVERS_ORIG = 1;
  {$EXTERNALSYM YPPUSHVERS_ORIG}

{ Procedure symbols }

  YPPUSHPROC_NULL = 0;
  {$EXTERNALSYM YPPUSHPROC_NULL}
  YPPUSHPROC_XFRRESP = 1;
  {$EXTERNALSYM YPPUSHPROC_XFRRESP}

{ Status values for yppushresp_xfr.status }
type
  yppush_status =
  (
    YPPUSH_SUCC = 1,             { Success }
    {$EXTERNALSYM YPPUSH_SUCC}
    YPPUSH_AGE = 2,              { Master's version not newer }
    {$EXTERNALSYM YPPUSH_AGE}
    YPPUSH_NOMAP = -1,           { Can't find server for map }
    {$EXTERNALSYM YPPUSH_NOMAP}
    YPPUSH_NODOM = -2,           { Domain not supported }
    {$EXTERNALSYM YPPUSH_NODOM}
    YPPUSH_RSRC = -3,            { Local resouce alloc failure }
    {$EXTERNALSYM YPPUSH_RSRC}
    YPPUSH_RPC = -4,             { RPC failure talking to server }
    {$EXTERNALSYM YPPUSH_RPC}
    YPPUSH_MADDR = -5,           { Can't get master address }
    {$EXTERNALSYM YPPUSH_MADDR}
    YPPUSH_YPERR = -6,           { NIS server/map db error }
    {$EXTERNALSYM YPPUSH_YPERR}
    YPPUSH_BADARGS = -7,         { Request arguments bad }
    {$EXTERNALSYM YPPUSH_BADARGS}
    YPPUSH_DBM = -8,             { Local dbm operation failed }
    {$EXTERNALSYM YPPUSH_DBM}
    YPPUSH_FILE = -9,            { Local file I/O operation failed }
    {$EXTERNALSYM YPPUSH_FILE}
    YPPUSH_SKEW = -10,           { Map version skew during transfer }
    {$EXTERNALSYM YPPUSH_SKEW}
    YPPUSH_CLEAR = -11,          { Can't send "Clear" req to local ypserv }
    {$EXTERNALSYM YPPUSH_CLEAR}
    YPPUSH_FORCE = -12,          { No local order number in map - use -f flag}
    {$EXTERNALSYM YPPUSH_FORCE}
    YPPUSH_XFRERR = -13,         { ypxfr error }
    {$EXTERNALSYM YPPUSH_XFRERR}
    YPPUSH_REFUSED = -14,        { Transfer request refused by ypserv }
    {$EXTERNALSYM YPPUSH_REFUSED}
    YPPUSH_NOALIAS = -15         { Alias not found for map or domain }
    {$EXTERNALSYM YPPUSH_NOALIAS}
  );
  {$EXTERNALSYM yppush_status}

type
  yppushresp_xfr = {packed} record
    transid: u_int;
    status: yppush_status;
  end;
  {$EXTERNALSYM yppushresp_xfr}

  ypresp_all = {packed} record
  more: bool_t;
  ypresp_all_u: {packed} record
                  case Integer of
                    0: (val: ypresp_key_val);
                  end;
  end;
  {$EXTERNALSYM ypresp_all}

function xdr_ypreq_key(__xdrs: PXdr; var __objp: ypreq_key): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_key}
function xdr_ypreq_nokey(__xdrs: PXdr; var __objp: ypreq_nokey): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_nokey}
function xdr_ypreq_xfr(__xdrs: PXdr; var __objp: ypreq_xfr): bool_t; cdecl;
{$EXTERNALSYM xdr_ypreq_xfr}
function xdr_ypresp_val(__xdrs: PXdr; var __objp: ypresp_val): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_val}
function xdr_ypresp_key_val(__xdrs: PXdr; var __objp: ypresp_key_val): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_key_val}
function xdr_ypbind_resp(__xdrs: PXdr; var __objp: ypbind_resp): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_resp}
function xdr_ypbind_setdom(__xdrs: PXdr; var __objp: ypbind_setdom): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_setdom}
function xdr_ypmap_parms(__xdrs: PXdr; var __objp: ypmap_parms): bool_t; cdecl;
{$EXTERNALSYM xdr_ypmap_parms}
function xdr_yppushresp_xfr(__xdrs: PXdr; var __objp: yppushresp_xfr): bool_t; cdecl;
{$EXTERNALSYM xdr_yppushresp_xfr}
function xdr_ypresp_order(__xdrs: PXdr; var __objp: ypresp_order): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_order}
function xdr_ypresp_master(__xdrs: PXdr; var __objp: ypresp_master): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_master}
function xdr_ypall(__xdrs: PXdr; var __objp: ypall_callback): bool_t; cdecl;
{$EXTERNALSYM xdr_ypall}
function xdr_ypresp_maplist(__xdrs: PXdr; var __objp: ypresp_maplist): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_maplist}
function xdr_ypbind_binding(__xdrs: PXdr; var __objp: ypbind_binding): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_binding}
function xdr_ypbind_resptype(__xdrs: PXdr; var __objp: ypbind_resptype): bool_t; cdecl;
{$EXTERNALSYM xdr_ypbind_resptype}
function xdr_ypstat(__xdrs: PXdr; var __objp: ypbind_resptype): bool_t; cdecl;
{$EXTERNALSYM xdr_ypstat}
function xdr_ypresp_all(__xdrs: PXdr; var __objp: ypresp_all): bool_t; cdecl;
{$EXTERNALSYM xdr_ypresp_all}
function xdr_domainname(__xdrs: PXdr; var __objp: PChar): bool_t; cdecl;
{$EXTERNALSYM xdr_domainname}

{$ENDIF NEW_YP_PROTOTYPES}

{$HPPEMIT '#include <rpcsvc/yppasswd.h>}

// Translated from rpcsvc/yppasswd.h

type
  passwd = {packed} record
    pw_name: PChar;
    pw_passwd: PChar;
    pw_uid: Integer;
    pw_gid: Integer;
    pw_gecos: PChar;
    pw_dir: PChar;
    pw_shell: PChar;
  end;
  {$EXTERNALSYM passwd}

  yppasswd = {packed} record
    oldpass: PChar;
    newpw: passwd;
  end;
  {$EXTERNALSYM yppasswd}
  TYpPasswd = yppasswd;
  PYpPasswd = ^TYpPasswd;

const
  YPPASSWDPROG = 100009;
  {$EXTERNALSYM YPPASSWDPROG}
  YPPASSWDVERS = 1;
  {$EXTERNALSYM YPPASSWDVERS}

const
  YPPASSWDPROC_UPDATE = 1;
  {$EXTERNALSYM YPPASSWDPROC_UPDATE}

function yppasswdproc_update_1(p1: PYpPasswd; AClient: PClientRecord): PInteger; cdecl;
{$EXTERNALSYM yppasswdproc_update_1}
function yppasswdproc_update_1_svc(p1: PYpPasswd; ServiceReq: PSvcReq): PInteger; cdecl;
{$EXTERNALSYM yppasswdproc_update_1_svc}

function yppasswdprog_1_freeresult(__xprt: PScvXpRt; p2: xdrproc_t; p3: caddr_t): Integer; cdecl;
{$EXTERNALSYM yppasswdprog_1_freeresult}

{ the xdr functions }

function xdr_passwd(__xdr: PXdr; var __passwd: passwd): bool_t; cdecl;
{$EXTERNALSYM xdr_passwd}
function xdr_yppasswd(__xdr: PXdr; var __yppasswd: yppasswd): bool_t; cdecl;
{$EXTERNALSYM xdr_yppasswd}


{$HPPEMIT '#include <rpcsvc/ypupd.h>}

// Translated from rpcsvc/ypupd.h

const
  MAXMAPNAMELEN = 255;
  {$EXTERNALSYM MAXMAPNAMELEN}
  MAXYPDATALEN = 1023;
  {$EXTERNALSYM MAXYPDATALEN}
  MAXERRMSGLEN = 255;
  {$EXTERNALSYM MAXERRMSGLEN}

type
  yp_buf = {packed} record
    yp_buf_len: u_int;
    yp_buf_val: PChar;
  end;
  {$EXTERNALSYM yp_buf}

function xdr_yp_buf(__xdr: PXdr; var __yp_buf: yp_buf): bool_t; cdecl;
{$EXTERNALSYM xdr_yp_buf}

type
  ypupdate_args = {packed} record
    mapname: PChar;
    key: yp_buf;
    datum: yp_buf;
  end;
  {$EXTERNALSYM ypupdate_args}
  TYpUpdateArgs = ypupdate_args;
  PYpUpdateArgs = ^TYpUpdateArgs;

function xdr_ypupdate_args(__xdr: PXdr; var __ypupdate_args: ypupdate_args): bool_t; cdecl;
{$EXTERNALSYM xdr_ypupdate_args}

type
  ypdelete_args = {packed} record
    mapname: PChar;
    key: yp_buf;
  end;
  {$EXTERNALSYM ypdelete_args}
  TYpDeleteArgs = ypdelete_args;
  PYpDeleteArgs = ^TYpDeleteArgs;

function xdr_ypdelete_args(__xdr: PXdr; var __ypdelete_args: ypdelete_args): bool_t; cdecl;
{$EXTERNALSYM xdr_ypdelete_args}

const
  YPU_PROG = 100028;
  {$EXTERNALSYM YPU_PROG}
  YPU_VERS = 1;
  {$EXTERNALSYM YPU_VERS}

const
  YPU_CHANGE = 1;
  {$EXTERNALSYM YPU_CHANGE}

function ypu_change_1(p1: PYpUpdateArgs; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM ypu_change_1}
function ypu_change_1_svc(p1: PYpUpdateArgs; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM ypu_change_1_svc}

const
  YPU_INSERT = 2;
  {$EXTERNALSYM YPU_INSERT}

function ypu_insert_1(p1: PYpUpdateArgs; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM ypu_insert_1}
function ypu_insert_1_svc(p1: PYpUpdateArgs; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM ypu_insert_1_svc}

const
  YPU_DELETE = 3;
  {$EXTERNALSYM YPU_DELETE}

function ypu_delete_1(p1: PYpDeleteArgs; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM ypu_delete_1}
function ypu_delete_1_svc(p1: PYpDeleteArgs; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM ypu_delete_1_svc}

const
  YPU_STORE = 4;
  {$EXTERNALSYM YPU_STORE}

function ypu_store_1(p1: PYpUpdateArgs; AClient: PClientRecord): Pu_int; cdecl;
{$EXTERNALSYM ypu_store_1}
function ypu_store_1_svc(p1: PYpUpdateArgs; ServiceReq: PSvcReq): Pu_int; cdecl;
{$EXTERNALSYM ypu_store_1_svc}


const
  libnslmodulename = 'libnsl.so.1';
  librpcsvcmodulename = 'librpcsvc.so.1';

implementation

function NIS_WORLD(a, m: Cardinal): Boolean;
begin
  Result := ((a and m) <> 0);
end;

function NIS_GROUP(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 8)) <> 0);
end;

function NIS_OWNER(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 16)) <> 0);
end;

function NIS_NOBODY(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 24)) <> 0);
end;

function WORLD(a, m: Cardinal): Boolean;
begin
  Result := ((a and m) <> 0);
end;

function GROUP(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 8)) <> 0);
end;

function OWNER(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 16)) <> 0);
end;

function NOBODY(a, m: Cardinal): Boolean;
begin
  Result := ((a and (m shl 24)) <> 0);
end;

function OATYPE(d: PDirectoryObj; n: Cardinal): zotypes;
var
  OarMask: POarMask;
begin
  OarMask := d^.do_armask.do_armask_val;
  Inc(OarMask, n);
  Result := OarMask^.oa_otype;
end;

function OARIGHTS(d: PDirectoryObj; n: Cardinal): uint32_t;
var
  OarMask: POarMask;
begin
  OarMask := d^.do_armask.do_armask_val;
  Inc(OarMask, n);
  Result := OarMask^.oa_rights;
end;

function NIS_RES_NUMOBJ(x: PNisResult): u_int;
begin
  Result := x^.objects.objects_len;
end;

function NIS_RES_OBJECT(x: PNisResult): PNisObject;
begin
  Result := x^.objects.objects_val;
end;

function NIS_RES_COOKIE(x: PNisResult): netobj;
begin
  Result := x^.cookie;
end;

function NIS_RES_STATUS(x: PNisResult): nis_error;
begin
  Result := x^.status;
end;

function __type_of(o: PNisObject): zotypes;
begin
  Result := o^.zo_data.zo_type;
end;

function ENTRY_VAL(obj: PNisObject; col: Cardinal): PChar;
var
  EntryCol: PEntryCol;
begin
  EntryCol := obj^.zo_data.objdata_u.en_data.en_cols.en_cols_val;
  Inc(EntryCol, col);
  Result := EntryCol.ec_value.ec_value_val;
end;

function ENTRY_LEN(obj: PNisObject; col: Cardinal): u_int;
var
  EntryCol: PEntryCol;
begin
  EntryCol := obj^.zo_data.objdata_u.en_data.en_cols.en_cols_val;
  Inc(EntryCol, col);
  Result := EntryCol.ec_value.ec_value_len;
end;

function bootparamproc_whoami_1;        external libnslmodulename name 'bootparamproc_whoami_1';
function bootparamproc_whoami_1_svc;    external libnslmodulename name 'bootparamproc_whoami_1_svc';
function bootparamproc_getfile_1;       external libnslmodulename name 'bootparamproc_getfile_1';
function bootparamproc_getfile_1_svc;   external libnslmodulename name 'bootparamproc_getfile_1_svc';
function bootparamprog_1_freeresult;    external libnslmodulename name 'bootparamprog_1_freeresult';

function key_set_1;                     external librpcsvcmodulename name 'key_set_1';
function key_set_1_svc;                 external librpcsvcmodulename name 'key_set_1_svc';
function key_encrypt_1;                 external librpcsvcmodulename name 'key_encrypt_1';
function key_encrypt_1_svc;             external librpcsvcmodulename name 'key_encrypt_1_svc';
function key_decrypt_1;                 external librpcsvcmodulename name 'key_decrypt_1';
function key_decrypt_1_svc;             external librpcsvcmodulename name 'key_decrypt_1_svc';
function key_gen_1;                     external librpcsvcmodulename name 'key_gen_1';
function key_gen_1_svc;                 external librpcsvcmodulename name 'key_gen_1_svc';
function key_getcred_1;                 external librpcsvcmodulename name 'key_getcred_1';
function key_getcred_1_svc;             external librpcsvcmodulename name 'key_getcred_1_svc';
function key_prog_1_freeresult;         external librpcsvcmodulename name 'key_prog_1_freeresult';
function key_set_2;                     external librpcsvcmodulename name 'key_set_2';
function key_set_2_svc;                 external librpcsvcmodulename name 'key_set_2_svc';
function key_encrypt_2;                 external librpcsvcmodulename name 'key_encrypt_2';
function key_encrypt_2_svc;             external librpcsvcmodulename name 'key_encrypt_2_svc';
function key_decrypt_2;                 external librpcsvcmodulename name 'key_decrypt_2';
function key_decrypt_2_svc;             external librpcsvcmodulename name 'key_decrypt_2_svc';
function key_gen_2;                     external librpcsvcmodulename name 'key_gen_2';
function key_gen_2_svc;                 external librpcsvcmodulename name 'key_gen_2_svc';
function key_getcred_2;                 external librpcsvcmodulename name 'key_getcred_2';
function key_getcred_2_svc;             external librpcsvcmodulename name 'key_getcred_2_svc';
function key_encrypt_pk_2;              external librpcsvcmodulename name 'key_encrypt_pk_2';
function key_encrypt_pk_2_svc;          external librpcsvcmodulename name 'key_encrypt_pk_2_svc';
function key_decrypt_pk_2;              external librpcsvcmodulename name 'key_decrypt_pk_2';
function key_decrypt_pk_2_svc;          external librpcsvcmodulename name 'key_decrypt_pk_2_svc';
function key_net_put_2;                 external librpcsvcmodulename name 'key_net_put_2';
function key_net_put_2_svc;             external librpcsvcmodulename name 'key_net_put_2_svc';
function key_net_get_2;                 external librpcsvcmodulename name 'key_net_get_2';
function key_net_get_2_svc;             external librpcsvcmodulename name 'key_net_get_2_svc';
function key_get_conv_2;                external librpcsvcmodulename name 'key_get_conv_2';
function key_get_conv_2_svc;            external librpcsvcmodulename name 'key_get_conv_2_svc';
function key_prog_2_freeresult;         external librpcsvcmodulename name 'key_prog_2_freeresult';
function xdr_keystatus;                 external librpcsvcmodulename name 'xdr_keystatus';
function xdr_keybuf;                    external librpcsvcmodulename name 'xdr_keybuf';
function xdr_netnamestr;                external librpcsvcmodulename name 'xdr_netnamestr';
function xdr_cryptkeyarg;               external librpcsvcmodulename name 'xdr_cryptkeyarg';
function xdr_cryptkeyarg2;              external librpcsvcmodulename name 'xdr_cryptkeyarg2';
function xdr_cryptkeyres;               external librpcsvcmodulename name 'xdr_cryptkeyres';
function xdr_unixcred;                  external librpcsvcmodulename name 'xdr_unixcred';
function xdr_getcredres;                external librpcsvcmodulename name 'xdr_getcredres';
function xdr_key_netstarg;              external librpcsvcmodulename name 'xdr_key_netstarg';
function xdr_key_netstres;              external librpcsvcmodulename name 'xdr_key_netstres';

function klm_test_1;                    external librpcsvcmodulename name 'klm_test_1';
function klm_test_1_svc;                external librpcsvcmodulename name 'klm_test_1_svc';
function klm_lock_1;                    external librpcsvcmodulename name 'klm_lock_1';
function klm_lock_1_svc;                external librpcsvcmodulename name 'klm_lock_1_svc';
function klm_cancel_1;                  external librpcsvcmodulename name 'klm_cancel_1';
function klm_cancel_1_svc;              external librpcsvcmodulename name 'klm_cancel_1_svc';
function klm_unlock_1;                  external librpcsvcmodulename name 'klm_unlock_1';
function klm_unlock_1_svc;              external librpcsvcmodulename name 'klm_unlock_1_svc';
function klm_prog_1_freeresult;         external librpcsvcmodulename name 'klm_prog_1_freeresult';
function xdr_klm_stats;                 external librpcsvcmodulename name 'xdr_klm_stats';
function xdr_klm_lock;                  external librpcsvcmodulename name 'xdr_klm_lock';
function xdr_klm_holder;                external librpcsvcmodulename name 'xdr_klm_holder';
function xdr_klm_stat;                  external librpcsvcmodulename name 'xdr_klm_stat';
function xdr_klm_testrply;              external librpcsvcmodulename name 'xdr_klm_testrply';
function xdr_klm_lockargs;              external librpcsvcmodulename name 'xdr_klm_lockargs';
function xdr_klm_testargs;              external librpcsvcmodulename name 'xdr_klm_testargs';
function xdr_klm_unlockargs;            external librpcsvcmodulename name 'xdr_klm_unlockargs';

function mountproc_null_1;              external librpcsvcmodulename name 'mountproc_null_1';
function mountproc_null_1_svc;          external librpcsvcmodulename name 'mountproc_null_1_svc';
function mountproc_mnt_1;               external librpcsvcmodulename name 'mountproc_mnt_1';
function mountproc_mnt_1_svc;           external librpcsvcmodulename name 'mountproc_mnt_1_svc';
function mountproc_dump_1;              external librpcsvcmodulename name 'mountproc_dump_1';
function mountproc_dump_1_svc;          external librpcsvcmodulename name 'mountproc_dump_1_svc';
function mountproc_umnt_1;              external librpcsvcmodulename name 'mountproc_umnt_1';
function mountproc_umnt_1_svc;          external librpcsvcmodulename name 'mountproc_umnt_1_svc';
function mountproc_umntall_1;           external librpcsvcmodulename name 'mountproc_umntall_1';
function mountproc_umntall_1_svc;       external librpcsvcmodulename name 'mountproc_umntall_1_svc';
function mountproc_export_1;            external librpcsvcmodulename name 'mountproc_export_1';
function mountproc_export_1_svc;        external librpcsvcmodulename name 'mountproc_export_1_svc';
function mountproc_exportall_1;         external librpcsvcmodulename name 'mountproc_exportall_1';
function mountproc_exportall_1_svc;     external librpcsvcmodulename name 'mountproc_exportall_1_svc';
function mountprog_1_freeresult;        external librpcsvcmodulename name 'mountprog_1_freeresult';
function xdr_fhandle;                   external librpcsvcmodulename name 'xdr_fhandle';
function xdr_fhstatus;                  external librpcsvcmodulename name 'xdr_fhstatus';
function xdr_dirpath;                   external librpcsvcmodulename name 'xdr_dirpath';
function xdr_name;                      external librpcsvcmodulename name 'xdr_name';
function xdr_mountlist;                 external librpcsvcmodulename name 'xdr_mountlist';
function xdr_mountbody;                 external librpcsvcmodulename name 'xdr_mountbody';
function xdr_groups;                    external librpcsvcmodulename name 'xdr_groups';
function xdr_groupnode;                 external librpcsvcmodulename name 'xdr_groupnode';
function xdr_exports;                   external librpcsvcmodulename name 'xdr_exports';
function xdr_exportnode;                external librpcsvcmodulename name 'xdr_exportnode';

function nfsproc_null_2;                external librpcsvcmodulename name 'nfsproc_null_2';
function nfsproc_null_2_svc;            external librpcsvcmodulename name 'nfsproc_null_2_svc';
function nfsproc_getattr_2;             external librpcsvcmodulename name 'nfsproc_getattr_2';
function nfsproc_getattr_2_svc;         external librpcsvcmodulename name 'nfsproc_getattr_2_svc';
function nfsproc_setattr_2;             external librpcsvcmodulename name 'nfsproc_setattr_2';
function nfsproc_setattr_2_svc;         external librpcsvcmodulename name 'nfsproc_setattr_2_svc';
function nfsproc_root_2;                external librpcsvcmodulename name 'nfsproc_root_2';
function nfsproc_root_2_svc;            external librpcsvcmodulename name 'nfsproc_root_2_svc';
function nfsproc_lookup_2;              external librpcsvcmodulename name 'nfsproc_lookup_2';
function nfsproc_lookup_2_svc;          external librpcsvcmodulename name 'nfsproc_lookup_2_svc';
function nfsproc_readlink_2;            external librpcsvcmodulename name 'nfsproc_readlink_2';
function nfsproc_readlink_2_svc;        external librpcsvcmodulename name 'nfsproc_readlink_2_svc';
function nfsproc_read_2;                external librpcsvcmodulename name 'nfsproc_read_2';
function nfsproc_read_2_svc;            external librpcsvcmodulename name 'nfsproc_read_2_svc';
function nfsproc_writecache_2;          external librpcsvcmodulename name 'nfsproc_writecache_2';
function nfsproc_writecache_2_svc;      external librpcsvcmodulename name 'nfsproc_writecache_2_svc';
function nfsproc_write_2;               external librpcsvcmodulename name 'nfsproc_write_2';
function nfsproc_write_2_svc;           external librpcsvcmodulename name 'nfsproc_write_2_svc';
function nfsproc_create_2;              external librpcsvcmodulename name 'nfsproc_create_2';
function nfsproc_create_2_svc;          external librpcsvcmodulename name 'nfsproc_create_2_svc';
function nfsproc_remove_2;              external librpcsvcmodulename name 'nfsproc_remove_2';
function nfsproc_remove_2_svc;          external librpcsvcmodulename name 'nfsproc_remove_2_svc';
function nfsproc_rename_2;              external librpcsvcmodulename name 'nfsproc_rename_2';
function nfsproc_rename_2_svc;          external librpcsvcmodulename name 'nfsproc_rename_2_svc';
function nfsproc_link_2;                external librpcsvcmodulename name 'nfsproc_link_2';
function nfsproc_link_2_svc;            external librpcsvcmodulename name 'nfsproc_link_2_svc';
function nfsproc_symlink_2;             external librpcsvcmodulename name 'nfsproc_symlink_2';
function nfsproc_symlink_2_svc;         external librpcsvcmodulename name 'nfsproc_symlink_2_svc';
function nfsproc_mkdir_2;               external librpcsvcmodulename name 'nfsproc_mkdir_2';
function nfsproc_mkdir_2_svc;           external librpcsvcmodulename name 'nfsproc_mkdir_2_svc';
function nfsproc_rmdir_2;               external librpcsvcmodulename name 'nfsproc_rmdir_2';
function nfsproc_rmdir_2_svc;           external librpcsvcmodulename name 'nfsproc_rmdir_2_svc';
function nfsproc_readdir_2;             external librpcsvcmodulename name 'nfsproc_readdir_2';
function nfsproc_readdir_2_svc;         external librpcsvcmodulename name 'nfsproc_readdir_2_svc';
function nfsproc_statfs_2;              external librpcsvcmodulename name 'nfsproc_statfs_2';
function nfsproc_statfs_2_svc;          external librpcsvcmodulename name 'nfsproc_statfs_2_svc';
function nfs_program_2_freeresult;      external librpcsvcmodulename name 'nfs_program_2_freeresult';
function xdr_nfsstat;                   external librpcsvcmodulename name 'xdr_nfsstat';
function xdr_ftype;                     external librpcsvcmodulename name 'xdr_ftype';
function xdr_nfs_fh;                    external librpcsvcmodulename name 'xdr_nfs_fh';
function xdr_nfstime;                   external librpcsvcmodulename name 'xdr_nfstime';
function xdr_fattr;                     external librpcsvcmodulename name 'xdr_fattr';
function xdr_sattr;                     external librpcsvcmodulename name 'xdr_sattr';
function xdr_filename;                  external librpcsvcmodulename name 'xdr_filename';
function xdr_nfspath;                   external librpcsvcmodulename name 'xdr_nfspath';
function xdr_attrstat;                  external librpcsvcmodulename name 'xdr_attrstat';
function xdr_sattrargs;                 external librpcsvcmodulename name 'xdr_sattrargs';
function xdr_diropargs;                 external librpcsvcmodulename name 'xdr_diropargs';
function xdr_diropokres;                external librpcsvcmodulename name 'xdr_diropokres';
function xdr_diropres;                  external librpcsvcmodulename name 'xdr_diropres';
function xdr_readlinkres;               external librpcsvcmodulename name 'xdr_readlinkres';
function xdr_readargs;                  external librpcsvcmodulename name 'xdr_readargs';
function xdr_readokres;                 external librpcsvcmodulename name 'xdr_readokres';
function xdr_readres;                   external librpcsvcmodulename name 'xdr_readres';
function xdr_writeargs;                 external librpcsvcmodulename name 'xdr_writeargs';
function xdr_createargs;                external librpcsvcmodulename name 'xdr_createargs';
function xdr_renameargs;                external librpcsvcmodulename name 'xdr_renameargs';
function xdr_linkargs;                  external librpcsvcmodulename name 'xdr_linkargs';
function xdr_symlinkargs;               external librpcsvcmodulename name 'xdr_symlinkargs';
function xdr_nfscookie;                 external librpcsvcmodulename name 'xdr_nfscookie';
function xdr_readdirargs;               external librpcsvcmodulename name 'xdr_readdirargs';
function xdr_entry;                     external librpcsvcmodulename name 'xdr_entry';
function xdr_dirlist;                   external librpcsvcmodulename name 'xdr_dirlist';
function xdr_readdirres;                external librpcsvcmodulename name 'xdr_readdirres';
function xdr_statfsokres;               external librpcsvcmodulename name 'xdr_statfsokres';
function xdr_statfsres;                 external librpcsvcmodulename name 'xdr_statfsres';

function nis_lookup_3;                  external libnslmodulename name 'nis_lookup_3';
function nis_lookup_3_svc;              external libnslmodulename name 'nis_lookup_3_svc';
function nis_add_3;                     external libnslmodulename name 'nis_add_3';
function nis_add_3_svc;                 external libnslmodulename name 'nis_add_3_svc';
function nis_modify_3;                  external libnslmodulename name 'nis_modify_3';
function nis_modify_3_svc;              external libnslmodulename name 'nis_modify_3_svc';
function nis_remove_3;                  external libnslmodulename name 'nis_remove_3';
function nis_remove_3_svc;              external libnslmodulename name 'nis_remove_3_svc';
function nis_iblist_3;                  external libnslmodulename name 'nis_iblist_3';
function nis_iblist_3_svc;              external libnslmodulename name 'nis_iblist_3_svc';
function nis_ibadd_3;                   external libnslmodulename name 'nis_ibadd_3';
function nis_ibadd_3_svc;               external libnslmodulename name 'nis_ibadd_3_svc';
function nis_ibmodify_3;                external libnslmodulename name 'nis_ibmodify_3';
function nis_ibmodify_3_svc;            external libnslmodulename name 'nis_ibmodify_3_svc';
function nis_ibremove_3;                external libnslmodulename name 'nis_ibremove_3';
function nis_ibremove_3_svc;            external libnslmodulename name 'nis_ibremove_3_svc';
function nis_ibfirst_3;                 external libnslmodulename name 'nis_ibfirst_3';
function nis_ibfirst_3_svc;             external libnslmodulename name 'nis_ibfirst_3_svc';
function nis_ibnext_3;                  external libnslmodulename name 'nis_ibnext_3';
function nis_ibnext_3_svc;              external libnslmodulename name 'nis_ibnext_3_svc';
function nis_finddirectory_3;           external libnslmodulename name 'nis_finddirectory_3';
function nis_finddirectory_3_svc;       external libnslmodulename name 'nis_finddirectory_3_svc';
function nis_status_3;                  external libnslmodulename name 'nis_status_3';
function nis_status_3_svc;              external libnslmodulename name 'nis_status_3_svc';
function nis_dumplog_3;                 external libnslmodulename name 'nis_dumplog_3';
function nis_dumplog_3_svc;             external libnslmodulename name 'nis_dumplog_3_svc';
function nis_dump_3;                    external libnslmodulename name 'nis_dump_3';
function nis_dump_3_svc;                external libnslmodulename name 'nis_dump_3_svc';
function nis_callback_3;                external libnslmodulename name 'nis_callback_3';
function nis_callback_3_svc;            external libnslmodulename name 'nis_callback_3_svc';
function nis_cptime_3;                  external libnslmodulename name 'nis_cptime_3';
function nis_cptime_3_svc;              external libnslmodulename name 'nis_cptime_3_svc';
function nis_checkpoint_3;              external libnslmodulename name 'nis_checkpoint_3';
function nis_checkpoint_3_svc;          external libnslmodulename name 'nis_checkpoint_3_svc';
function nis_ping_3;                    external libnslmodulename name 'nis_ping_3';
function nis_ping_3_svc;                external libnslmodulename name 'nis_ping_3_svc';
function nis_servstate_3;               external libnslmodulename name 'nis_servstate_3';
function nis_servstate_3_svc;           external libnslmodulename name 'nis_servstate_3_svc';
function nis_mkdir_3;                   external libnslmodulename name 'nis_mkdir_3';
function nis_mkdir_3_svc;               external libnslmodulename name 'nis_mkdir_3_svc';
function nis_rmdir_3;                   external libnslmodulename name 'nis_rmdir_3';
function nis_rmdir_3_svc;               external libnslmodulename name 'nis_rmdir_3_svc';
function nis_updkeys_3;                 external libnslmodulename name 'nis_updkeys_3';
function nis_updkeys_3_svc;             external libnslmodulename name 'nis_updkeys_3_svc';

function nis_lookup;                    external libnslmodulename name 'nis_lookup';
function nis_add;                       external libnslmodulename name 'nis_add';
function nis_remove;                    external libnslmodulename name 'nis_remove';
function nis_modify;                    external libnslmodulename name 'nis_modify';
function nis_list;                      external libnslmodulename name 'nis_list';
function nis_add_entry;                 external libnslmodulename name 'nis_add_entry';
function nis_modify_entry;              external libnslmodulename name 'nis_modify_entry';
function nis_remove_entry;              external libnslmodulename name 'nis_remove_entry';
function nis_first_entry;               external libnslmodulename name 'nis_first_entry';
function nis_next_entry;                external libnslmodulename name 'nis_next_entry';
function nis_mkdir;                     external libnslmodulename name 'nis_mkdir';
function nis_rmdir;                     external libnslmodulename name 'nis_rmdir';
function nis_servstate;                 external libnslmodulename name 'nis_servstate';
function nis_stats;                     external libnslmodulename name 'nis_stats';
procedure nis_freetags;                 external libnslmodulename name 'nis_freetags';
function nis_getservlist;               external libnslmodulename name 'nis_getservlist';
procedure nis_freeservlist;             external libnslmodulename name 'nis_freeservlist';
function nis_leaf_of;                   external libnslmodulename name 'nis_leaf_of';
function nis_leaf_of_r;                 external libnslmodulename name 'nis_leaf_of_r';
function nis_name_of;                   external libnslmodulename name 'nis_name_of';
function nis_name_of_r;                 external libnslmodulename name 'nis_name_of_r';
function nis_domain_of;                 external libnslmodulename name 'nis_domain_of';
function nis_domain_of_r;               external libnslmodulename name 'nis_domain_of_r';
function nis_getnames;                  external libnslmodulename name 'nis_getnames';
procedure nis_freenames;                external libnslmodulename name 'nis_freenames';
function nis_dir_cmp;                   external libnslmodulename name 'nis_dir_cmp';
function nis_clone_object;              external libnslmodulename name 'nis_clone_object';
procedure nis_destroy_object;           external libnslmodulename name 'nis_destroy_object';
procedure nis_print_object;             external libnslmodulename name 'nis_print_object';
function nis_local_group;               external libnslmodulename name 'nis_local_group';
function nis_local_directory;           external libnslmodulename name 'nis_local_directory';
function nis_local_principal;           external libnslmodulename name 'nis_local_principal';
function nis_local_host;                external libnslmodulename name 'nis_local_host';
function nis_sperrno;                   external libnslmodulename name 'nis_sperrno';
procedure nis_perror;                   external libnslmodulename name 'nis_perror';
procedure nis_lerror;                   external libnslmodulename name 'nis_lerror';
function nis_sperror;                   external libnslmodulename name 'nis_sperror';
function nis_sperror_r;                 external libnslmodulename name 'nis_sperror_r';
function nis_ismember;                  external libnslmodulename name 'nis_ismember';
function nis_addmember;                 external libnslmodulename name 'nis_addmember';
function nis_removemember;              external libnslmodulename name 'nis_removemember';
function nis_creategroup;               external libnslmodulename name 'nis_creategroup';
function nis_destroygroup;              external libnslmodulename name 'nis_destroygroup';
procedure nis_print_group_entry;        external libnslmodulename name 'nis_print_group_entry';
function nis_verifygroup;               external libnslmodulename name 'nis_verifygroup';
procedure nis_ping;                     external libnslmodulename name 'nis_ping';
function nis_checkpoint;                external libnslmodulename name 'nis_checkpoint';
procedure nis_print_result;             external libnslmodulename name 'nis_print_result';
procedure nis_print_rights;             external libnslmodulename name 'nis_print_rights';
procedure nis_print_directory;          external libnslmodulename name 'nis_print_directory';
procedure nis_print_group;              external libnslmodulename name 'nis_print_group';
procedure nis_print_table;              external libnslmodulename name 'nis_print_table';
procedure nis_print_link;               external libnslmodulename name 'nis_print_link';
procedure nis_print_entry;              external libnslmodulename name 'nis_print_entry';
function readColdStartFile;             external libnslmodulename name 'readColdStartFile';
function writeColdStartFile;            external libnslmodulename name 'writeColdStartFile';
function nis_read_obj;                  external libnslmodulename name 'nis_read_obj';
function nis_write_obj;                 external libnslmodulename name 'nis_write_obj';
function nis_clone_directory;           external libnslmodulename name 'nis_clone_directory';
function nis_clone_result;              external libnslmodulename name 'nis_clone_result';
procedure nis_freeresult;               external libnslmodulename name 'nis_freeresult';
procedure nis_free_request;             external libnslmodulename name 'nis_free_request';
procedure nis_free_directory;           external libnslmodulename name 'nis_free_directory';
procedure nis_free_object;              external libnslmodulename name 'nis_free_object';
function __nis_default_owner;           external libnslmodulename name '__nis_default_owner';
function __nis_default_group;           external libnslmodulename name '__nis_default_group';
function __nis_default_ttl;             external libnslmodulename name '__nis_default_ttl';
function __nis_default_access;          external libnslmodulename name '__nis_default_access';
function __nis_finddirectory;           external libnslmodulename name '__nis_finddirectory';
procedure __free_fdresult;              external libnslmodulename name '__free_fdresult';
function __nis_hash;                    external libnslmodulename name '__nis_hash';
function __nis_lock_cache;              external libnslmodulename name '__nis_lock_cache';
function __nis_unlock_cache;            external libnslmodulename name '__nis_unlock_cache';

function cbproc_receive_1;              external libnslmodulename name 'cbproc_receive_1';
function cbproc_receive_1_svc;          external libnslmodulename name 'cbproc_receive_1_svc';
function cbproc_finish_1;               external libnslmodulename name 'cbproc_finish_1';
function cbproc_finish_1_svc;           external libnslmodulename name 'cbproc_finish_1_svc';
function cbproc_error_1;                external libnslmodulename name 'cbproc_error_1';
function cbproc_error_1_svc;            external libnslmodulename name 'cbproc_error_1_svc';
function cb_prog_1_freeresult;          external libnslmodulename name 'cb_prog_1_freeresult';
function xdr_obj_p;                     external libnslmodulename name 'xdr_obj_p';
function xdr_cback_data;                external libnslmodulename name 'xdr_cback_data';

function nlm_test_1;                    external librpcsvcmodulename name 'nlm_test_1';
function nlm_test_1_svc;                external librpcsvcmodulename name 'nlm_test_1_svc';
function nlm_lock_1;                    external librpcsvcmodulename name 'nlm_lock_1';
function nlm_lock_1_svc;                external librpcsvcmodulename name 'nlm_lock_1_svc';
function nlm_cancel_1;                  external librpcsvcmodulename name 'nlm_cancel_1';
function nlm_cancel_1_svc;              external librpcsvcmodulename name 'nlm_cancel_1_svc';
function nlm_unlock_1;                  external librpcsvcmodulename name 'nlm_unlock_1';
function nlm_unlock_1_svc;              external librpcsvcmodulename name 'nlm_unlock_1_svc';
function nlm_granted_1;                 external librpcsvcmodulename name 'nlm_granted_1';
function nlm_granted_1_svc;             external librpcsvcmodulename name 'nlm_granted_1_svc';
function nlm_test_msg_1;                external librpcsvcmodulename name 'nlm_test_msg_1';
function nlm_test_msg_1_svc;            external librpcsvcmodulename name 'nlm_test_msg_1_svc';
function nlm_lock_msg_1;                external librpcsvcmodulename name 'nlm_lock_msg_1';
function nlm_lock_msg_1_svc;            external librpcsvcmodulename name 'nlm_lock_msg_1_svc';
function nlm_cancel_msg_1;              external librpcsvcmodulename name 'nlm_cancel_msg_1';
function nlm_cancel_msg_1_svc;          external librpcsvcmodulename name 'nlm_cancel_msg_1_svc';
function nlm_unlock_msg_1;              external librpcsvcmodulename name 'nlm_unlock_msg_1';
function nlm_unlock_msg_1_svc;          external librpcsvcmodulename name 'nlm_unlock_msg_1_svc';
function nlm_granted_msg_1;             external librpcsvcmodulename name 'nlm_granted_msg_1';
function nlm_granted_msg_1_svc;         external librpcsvcmodulename name 'nlm_granted_msg_1_svc';
function nlm_test_res_1;                external librpcsvcmodulename name 'nlm_test_res_1';
function nlm_test_res_1_svc;            external librpcsvcmodulename name 'nlm_test_res_1_svc';
function nlm_lock_res_1;                external librpcsvcmodulename name 'nlm_lock_res_1';
function nlm_lock_res_1_svc;            external librpcsvcmodulename name 'nlm_lock_res_1_svc';
function nlm_cancel_res_1;              external librpcsvcmodulename name 'nlm_cancel_res_1';
function nlm_cancel_res_1_svc;          external librpcsvcmodulename name 'nlm_cancel_res_1_svc';
function nlm_unlock_res_1;              external librpcsvcmodulename name 'nlm_unlock_res_1';
function nlm_unlock_res_1_svc;          external librpcsvcmodulename name 'nlm_unlock_res_1_svc';
function nlm_granted_res_1;             external librpcsvcmodulename name 'nlm_granted_res_1';
function nlm_granted_res_1_svc;         external librpcsvcmodulename name 'nlm_granted_res_1_svc';
function nlm_prog_1_freeresult;         external librpcsvcmodulename name 'nlm_prog_1_freeresult';
function nlm_share_3;                   external librpcsvcmodulename name 'nlm_share_3';
function nlm_share_3_svc;               external librpcsvcmodulename name 'nlm_share_3_svc';
function nlm_unshare_3;                 external librpcsvcmodulename name 'nlm_unshare_3';
function nlm_unshare_3_svc;             external librpcsvcmodulename name 'nlm_unshare_3_svc';
function nlm_nm_lock_3;                 external librpcsvcmodulename name 'nlm_nm_lock_3';
function nlm_nm_lock_3_svc;             external librpcsvcmodulename name 'nlm_nm_lock_3_svc';
function nlm_free_all_3;                external librpcsvcmodulename name 'nlm_free_all_3';
function nlm_free_all_3_svc;            external librpcsvcmodulename name 'nlm_free_all_3_svc';
function nlm_prog_3_freeresult;         external librpcsvcmodulename name 'nlm_prog_3_freeresult';
function xdr_nlm_stats;                 external librpcsvcmodulename name 'xdr_nlm_stats';
function xdr_nlm_holder;                external librpcsvcmodulename name 'xdr_nlm_holder';
function xdr_nlm_testrply;              external librpcsvcmodulename name 'xdr_nlm_testrply';
function xdr_nlm_stat;                  external librpcsvcmodulename name 'xdr_nlm_stat';
function xdr_nlm_res;                   external librpcsvcmodulename name 'xdr_nlm_res';
function xdr_nlm_testres;               external librpcsvcmodulename name 'xdr_nlm_testres';
function xdr_nlm_lock;                  external librpcsvcmodulename name 'xdr_nlm_lock';
function xdr_nlm_lockargs;              external librpcsvcmodulename name 'xdr_nlm_lockargs';
function xdr_nlm_cancargs;              external librpcsvcmodulename name 'xdr_nlm_cancargs';
function xdr_nlm_testargs;              external librpcsvcmodulename name 'xdr_nlm_testargs';
function xdr_nlm_unlockargs;            external librpcsvcmodulename name 'xdr_nlm_unlockargs';
function xdr_fsh_mode;                  external librpcsvcmodulename name 'xdr_fsh_mode';
function xdr_fsh_access;                external librpcsvcmodulename name 'xdr_fsh_access';
function xdr_nlm_share;                 external librpcsvcmodulename name 'xdr_nlm_share';
function xdr_nlm_shareargs;             external librpcsvcmodulename name 'xdr_nlm_shareargs';
function xdr_nlm_shareres;              external librpcsvcmodulename name 'xdr_nlm_shareres';
function xdr_nlm_notify;                external librpcsvcmodulename name 'xdr_nlm_notify';

function rexproc_start_1;               external librpcsvcmodulename name 'rexproc_start_1';
function rexproc_start_1_svc;           external librpcsvcmodulename name 'rexproc_start_1_svc';
function rexproc_wait_1;                external librpcsvcmodulename name 'rexproc_wait_1';
function rexproc_wait_1_svc;            external librpcsvcmodulename name 'rexproc_wait_1_svc';
function rexproc_modes_1;               external librpcsvcmodulename name 'rexproc_modes_1';
function rexproc_modes_1_svc;           external librpcsvcmodulename name 'rexproc_modes_1_svc';
function rexproc_winch_1;               external librpcsvcmodulename name 'rexproc_winch_1';
function rexproc_winch_1_svc;           external librpcsvcmodulename name 'rexproc_winch_1_svc';
function rexproc_signal_1;              external librpcsvcmodulename name 'rexproc_signal_1';
function rexproc_signal_1_svc;          external librpcsvcmodulename name 'rexproc_signal_1_svc';
function rexprog_1_freeresult;          external librpcsvcmodulename name 'rexprog_1_freeresult';
function xdr_rexstring;                 external librpcsvcmodulename name 'xdr_rexstring';
function xdr_rex_start;                 external librpcsvcmodulename name 'xdr_rex_start';
function xdr_rex_result;                external librpcsvcmodulename name 'xdr_rex_result';
function xdr_sgttyb;                    external librpcsvcmodulename name 'xdr_sgttyb';
function xdr_tchars;                    external librpcsvcmodulename name 'xdr_tchars';
function xdr_ltchars;                   external librpcsvcmodulename name 'xdr_ltchars';
function xdr_rex_ttysize;               external librpcsvcmodulename name 'xdr_rex_ttysize';
function xdr_rex_ttymode;               external librpcsvcmodulename name 'xdr_rex_ttymode';

function rquotaproc_getquota_1;         external librpcsvcmodulename name 'rquotaproc_getquota_1';
function rquotaproc_getquota_1_svc;     external librpcsvcmodulename name 'rquotaproc_getquota_1_svc';
function rquotaproc_getactivequota_1;   external librpcsvcmodulename name 'rquotaproc_getactivequota_1';
function rquotaproc_getactivequota_1_svc; external librpcsvcmodulename name 'rquotaproc_getactivequota_1_svc';
function rquotaprog_1_freeresult;       external librpcsvcmodulename name 'rquotaprog_1_freeresult';
function xdr_getquota_args;             external librpcsvcmodulename name 'xdr_getquota_args';
function xdr_rquota;                    external librpcsvcmodulename name 'xdr_rquota';
function xdr_gqr_status;                external librpcsvcmodulename name 'xdr_gqr_status';
function xdr_getquota_rslt;             external librpcsvcmodulename name 'xdr_getquota_rslt';

function rstatproc_stats_3;             external librpcsvcmodulename name 'rstatproc_stats_3';
function rstatproc_stats_3_svc;         external librpcsvcmodulename name 'rstatproc_stats_3_svc';
function rstatproc_havedisk_3;          external librpcsvcmodulename name 'rstatproc_havedisk_3';
function rstatproc_havedisk_3_svc;      external librpcsvcmodulename name 'rstatproc_havedisk_3_svc';
function rstatprog_3_freeresult;        external librpcsvcmodulename name 'rstatprog_3_freeresult';
function rstatproc_stats_2;             external librpcsvcmodulename name 'rstatproc_stats_2';
function rstatproc_stats_2_svc;         external librpcsvcmodulename name 'rstatproc_stats_2_svc';
function rstatproc_havedisk_2;          external librpcsvcmodulename name 'rstatproc_havedisk_2';
function rstatproc_havedisk_2_svc;      external librpcsvcmodulename name 'rstatproc_havedisk_2_svc';
function rstatprog_2_freeresult;        external librpcsvcmodulename name 'rstatprog_2_freeresult';
function rstatproc_stats_1;             external librpcsvcmodulename name 'rstatproc_stats_1';
function rstatproc_stats_1_svc;         external librpcsvcmodulename name 'rstatproc_stats_1_svc';
function rstatproc_havedisk_1;          external librpcsvcmodulename name 'rstatproc_havedisk_1';
function rstatproc_havedisk_1_svc;      external librpcsvcmodulename name 'rstatproc_havedisk_1_svc';
function rstatprog_1_freeresult;        external librpcsvcmodulename name 'rstatprog_1_freeresult';
function xdr_rstat_timeval;             external librpcsvcmodulename name 'xdr_rstat_timeval';
function xdr_statstime;                 external librpcsvcmodulename name 'xdr_statstime';
function xdr_statsswtch;                external librpcsvcmodulename name 'xdr_statsswtch';
function xdr_stats;                     external librpcsvcmodulename name 'xdr_stats';

function xdr_utmparr;                   external librpcsvcmodulename name 'xdr_utmparr';
function xdr_utmpidlearr;               external librpcsvcmodulename name 'xdr_utmpidlearr';
function rusersproc_num_3;              external librpcsvcmodulename name 'rusersproc_num_3';
function rusersproc_num_3_svc;          external librpcsvcmodulename name 'rusersproc_num_3_svc';
function rusersproc_names_3;            external librpcsvcmodulename name 'rusersproc_names_3';
function rusersproc_names_3_svc;        external librpcsvcmodulename name 'rusersproc_names_3_svc';
function rusersproc_allnames_3;         external librpcsvcmodulename name 'rusersproc_allnames_3';
function rusersproc_allnames_3_svc;     external librpcsvcmodulename name 'rusersproc_allnames_3_svc';
function rusersprog_3_freeresult;       external librpcsvcmodulename name 'rusersprog_3_freeresult';
function xdr_rusers_utmp;               external librpcsvcmodulename name 'xdr_rusers_utmp';
function xdr_utmp_array;                external librpcsvcmodulename name 'xdr_utmp_array';

function sm_stat_1;                     external librpcsvcmodulename name 'sm_stat_1';
function sm_stat_1_svc;                 external librpcsvcmodulename name 'sm_stat_1_svc';
function sm_mon_1;                      external librpcsvcmodulename name 'sm_mon_1';
function sm_mon_1_svc;                  external librpcsvcmodulename name 'sm_mon_1_svc';
function sm_unmon_1;                    external librpcsvcmodulename name 'sm_unmon_1';
function sm_unmon_1_svc;                external librpcsvcmodulename name 'sm_unmon_1_svc';
function sm_unmon_all_1;                external librpcsvcmodulename name 'sm_unmon_all_1';
function sm_unmon_all_1_svc;            external librpcsvcmodulename name 'sm_unmon_all_1_svc';
function sm_simu_crash_1;               external librpcsvcmodulename name 'sm_simu_crash_1';
function sm_simu_crash_1_svc;           external librpcsvcmodulename name 'sm_simu_crash_1_svc';
function sm_prog_1_freeresult;          external librpcsvcmodulename name 'sm_prog_1_freeresult';
function xdr_sm_name;                   external librpcsvcmodulename name 'xdr_sm_name';
function xdr_my_id;                     external librpcsvcmodulename name 'xdr_my_id';
function xdr_mon_id;                    external librpcsvcmodulename name 'xdr_mon_id';
function xdr_mon;                       external librpcsvcmodulename name 'xdr_mon';
function xdr_sm_stat;                   external librpcsvcmodulename name 'xdr_sm_stat';
function xdr_res;                       external librpcsvcmodulename name 'xdr_res';
function xdr_sm_stat_res;               external librpcsvcmodulename name 'xdr_sm_stat_res';
function xdr_status;                    external librpcsvcmodulename name 'xdr_status';

function sprayproc_spray_1;             external librpcsvcmodulename name 'sprayproc_spray_1';
function sprayproc_spray_1_svc;         external librpcsvcmodulename name 'sprayproc_spray_1_svc';
function sprayproc_get_1;               external librpcsvcmodulename name 'sprayproc_get_1';
function sprayproc_get_1_svc;           external librpcsvcmodulename name 'sprayproc_get_1_svc';
function sprayproc_clear_1;             external librpcsvcmodulename name 'sprayproc_clear_1';
function sprayproc_clear_1_svc;         external librpcsvcmodulename name 'sprayproc_clear_1_svc';
function sprayprog_1_freeresult;        external librpcsvcmodulename name 'sprayprog_1_freeresult';
function xdr_spraytimeval;              external librpcsvcmodulename name 'xdr_spraytimeval';
function xdr_spraycumul;                external librpcsvcmodulename name 'xdr_spraycumul';
function xdr_sprayarr;                  external librpcsvcmodulename name 'xdr_sprayarr';

function yp_bind;                       external libnslmodulename name 'yp_bind';
procedure yp_unbind;                    external libnslmodulename name 'yp_unbind';
function yp_get_default_domain;         external libnslmodulename name 'yp_get_default_domain';
function yp_match;                      external libnslmodulename name 'yp_match';
function yp_first;                      external libnslmodulename name 'yp_first';
function yp_next;                       external libnslmodulename name 'yp_next';
function yp_master;                     external libnslmodulename name 'yp_master';
function yp_order;                      external libnslmodulename name 'yp_order';
function yp_all;                        external libnslmodulename name 'yp_all';
function yperr_string;                  external libnslmodulename name 'yperr_string';
function ypbinderr_string;              external libnslmodulename name 'ypbinderr_string';
function ypprot_err;                    external libnslmodulename name 'ypprot_err';
function yp_update;                     external libnslmodulename name 'yp_update';
function __yp_check;                    external libnslmodulename name '__yp_check';

{$IFDEF OLD_YP_PROTOTYPES}
function ypproc_null_2;                 external libnslmodulename name 'ypproc_null_2';
function ypproc_null_2_svc;             external libnslmodulename name 'ypproc_null_2_svc';
function ypproc_domain_2;               external libnslmodulename name 'ypproc_domain_2';
function ypproc_domain_2_svc;           external libnslmodulename name 'ypproc_domain_2_svc';
function ypproc_domain_nonack_2;        external libnslmodulename name 'ypproc_domain_nonack_2';
function ypproc_domain_nonack_2_svc;    external libnslmodulename name 'ypproc_domain_nonack_2_svc';
function ypproc_match_2;                external libnslmodulename name 'ypproc_match_2';
function ypproc_match_2_svc;            external libnslmodulename name 'ypproc_match_2_svc';
function ypproc_first_2;                external libnslmodulename name 'ypproc_first_2';
function ypproc_first_2_svc;            external libnslmodulename name 'ypproc_first_2_svc';
function ypproc_next_2;                 external libnslmodulename name 'ypproc_next_2';
function ypproc_next_2_svc;             external libnslmodulename name 'ypproc_next_2_svc';
function ypproc_xfr_2;                  external libnslmodulename name 'ypproc_xfr_2';
function ypproc_xfr_2_svc;              external libnslmodulename name 'ypproc_xfr_2_svc';
function ypproc_clear_2;                external libnslmodulename name 'ypproc_clear_2';
function ypproc_clear_2_svc;            external libnslmodulename name 'ypproc_clear_2_svc';
function ypproc_all_2;                  external libnslmodulename name 'ypproc_all_2';
function ypproc_all_2_svc;              external libnslmodulename name 'ypproc_all_2_svc';
function ypproc_master_2;               external libnslmodulename name 'ypproc_master_2';
function ypproc_master_2_svc;           external libnslmodulename name 'ypproc_master_2_svc';
function ypproc_order_2;                external libnslmodulename name 'ypproc_order_2';
function ypproc_order_2_svc;            external libnslmodulename name 'ypproc_order_2_svc';
function ypproc_maplist_2;              external libnslmodulename name 'ypproc_maplist_2';
function ypproc_maplist_2_svc;          external libnslmodulename name 'ypproc_maplist_2_svc';
function ypprog_2_freeresult;           external libnslmodulename name 'ypprog_2_freeresult';
function yppushproc_null_1;             external libnslmodulename name 'yppushproc_null_1';
function yppushproc_null_1_svc;         external libnslmodulename name 'yppushproc_null_1_svc';
function yppushproc_xfrresp_1;          external libnslmodulename name 'yppushproc_xfrresp_1';
function yppushproc_xfrresp_1_svc;      external libnslmodulename name 'yppushproc_xfrresp_1_svc';
function yppush_xfrrespprog_1_freeresult; external libnslmodulename name 'yppush_xfrrespprog_1_freeresult';
function ypbindproc_null_2;             external libnslmodulename name 'ypbindproc_null_2';
function ypbindproc_null_2_svc;         external libnslmodulename name 'ypbindproc_null_2_svc';
function ypbindproc_domain_2;           external libnslmodulename name 'ypbindproc_domain_2';
function ypbindproc_domain_2_svc;       external libnslmodulename name 'ypbindproc_domain_2_svc';
function ypbindproc_setdom_2;           external libnslmodulename name 'ypbindproc_setdom_2';
function ypbindproc_setdom_2_svc;       external libnslmodulename name 'ypbindproc_setdom_2_svc';
function ypbindprog_2_freeresult;       external libnslmodulename name 'ypbindprog_2_freeresult';
function xdr_ypstat;                    external libnslmodulename name 'xdr_ypstat';
function xdr_ypxfrstat;                 external libnslmodulename name 'xdr_ypxfrstat';
function xdr_domainname;                external libnslmodulename name 'xdr_domainname';
function xdr_mapname;                   external libnslmodulename name 'xdr_mapname';
function xdr_peername;                  external libnslmodulename name 'xdr_peername';
function xdr_keydat;                    external libnslmodulename name 'xdr_keydat';
function xdr_valdat;                    external libnslmodulename name 'xdr_valdat';
function xdr_ypmap_parms;               external libnslmodulename name 'xdr_ypmap_parms';
function xdr_ypreq_key;                 external libnslmodulename name 'xdr_ypreq_key';
function xdr_ypreq_nokey;               external libnslmodulename name 'xdr_ypreq_nokey';
function xdr_ypreq_xfr;                 external libnslmodulename name 'xdr_ypreq_xfr';
function xdr_ypresp_val;                external libnslmodulename name 'xdr_ypresp_val';
function xdr_ypresp_key_val;            external libnslmodulename name 'xdr_ypresp_key_val';
function xdr_ypresp_master;             external libnslmodulename name 'xdr_ypresp_master';
function xdr_ypresp_order;              external libnslmodulename name 'xdr_ypresp_order';
function xdr_ypresp_all;                external libnslmodulename name 'xdr_ypresp_all';
function xdr_ypresp_xfr;                external libnslmodulename name 'xdr_ypresp_xfr';
function xdr_ypmaplist;                 external libnslmodulename name 'xdr_ypmaplist';
function xdr_ypresp_maplist;            external libnslmodulename name 'xdr_ypresp_maplist';
function xdr_yppush_status;             external libnslmodulename name 'xdr_yppush_status';
function xdr_yppushresp_xfr;            external libnslmodulename name 'xdr_yppushresp_xfr';
function xdr_ypbind_resptype;           external libnslmodulename name 'xdr_ypbind_resptype';
function xdr_ypbind_binding;            external libnslmodulename name 'xdr_ypbind_binding';
function xdr_ypbind_resp;               external libnslmodulename name 'xdr_ypbind_resp';
function xdr_ypbind_setdom;             external libnslmodulename name 'xdr_ypbind_setdom';
{$ENDIF OLD_YP_PROTOTYPES}

{$IFDEF NEW_YP_PROTOTYPES}
function xdr_ypreq_key;                 external libnslmodulename name 'xdr_ypreq_key';
function xdr_ypreq_nokey;               external libnslmodulename name 'xdr_ypreq_nokey';
function xdr_ypreq_xfr;                 external libnslmodulename name 'xdr_ypreq_xfr';
function xdr_ypresp_val;                external libnslmodulename name 'xdr_ypresp_val';
function xdr_ypresp_key_val;            external libnslmodulename name 'xdr_ypresp_key_val';
function xdr_ypbind_resp;               external libnslmodulename name 'xdr_ypbind_resp';
function xdr_ypbind_setdom;             external libnslmodulename name 'xdr_ypbind_setdom';
function xdr_ypmap_parms;               external libnslmodulename name 'xdr_ypmap_parms';
function xdr_yppushresp_xfr;            external libnslmodulename name 'xdr_yppushresp_xfr';
function xdr_ypresp_order;              external libnslmodulename name 'xdr_ypresp_order';
function xdr_ypresp_master;             external libnslmodulename name 'xdr_ypresp_master';
function xdr_ypall;                     external libnslmodulename name 'xdr_ypall';
function xdr_ypresp_maplist;            external libnslmodulename name 'xdr_ypresp_maplist';
function xdr_ypbind_binding;            external libnslmodulename name 'xdr_ypbind_binding';
function xdr_ypbind_resptype;           external libnslmodulename name 'xdr_ypbind_resptype';
function xdr_ypstat;                    external libnslmodulename name 'xdr_ypstat';
function xdr_ypresp_all;                external libnslmodulename name 'xdr_ypresp_all';
function xdr_domainname;                external libnslmodulename name 'xdr_domainname';
{$ENDIF NEW_YP_PROTOTYPES}

function yppasswdproc_update_1;         external librpcsvcmodulename name 'yppasswdproc_update_1';
function yppasswdproc_update_1_svc;     external librpcsvcmodulename name 'yppasswdproc_update_1_svc';
function yppasswdprog_1_freeresult;     external librpcsvcmodulename name 'yppasswdprog_1_freeresult';
function xdr_passwd;                    external librpcsvcmodulename name 'xdr_passwd';
function xdr_yppasswd;                  external librpcsvcmodulename name 'xdr_yppasswd';

function xdr_yp_buf;                    external libnslmodulename name 'xdr_yp_buf';
function xdr_ypupdate_args;             external libnslmodulename name 'xdr_ypupdate_args';
function xdr_ypdelete_args;             external libnslmodulename name 'xdr_ypdelete_args';
function ypu_change_1;                  external libnslmodulename name 'ypu_change_1';
function ypu_change_1_svc;              external libnslmodulename name 'ypu_change_1_svc';
function ypu_insert_1;                  external libnslmodulename name 'ypu_insert_1';
function ypu_insert_1_svc;              external libnslmodulename name 'ypu_insert_1_svc';
function ypu_delete_1;                  external libnslmodulename name 'ypu_delete_1';
function ypu_delete_1_svc;              external libnslmodulename name 'ypu_delete_1_svc';
function ypu_store_1;                   external libnslmodulename name 'ypu_store_1';
function ypu_store_1_svc;               external libnslmodulename name 'ypu_store_1_svc';


end.

